<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * Core Initialization
 *
 * @package Core
 */

global $zone;
$zone = 'AdminZone';

include( dirname(__FILE__) . '/app_init.php' );

$usr = &$application->getInstance( 'users' );

$usr->loadState();
$usr->setZone($zone);

$session = &$application->getInstance('session');

if ( $usr->isUserSignedIn() == FALSE )
{
    $current_file = basename($_SERVER['PHP_SELF']);
    $request = &new Request();
    switch ($current_file)
    {
        case $application->getPagenameByViewname('AdminPasswordRecovery'):
            if ($usr->isBlocked())
            {
                $request->setView  ( 'AdminZoneBlocked' );
                $application->redirect($request);
            }
            break;
        case $application->getPagenameByViewname('AdminSignIn'):
            if ($usr->isBlocked())
            {
                $request->setView  ( 'AdminZoneBlocked' );
                $application->redirect($request);
            }
            break;
        case $application->getPagenameByViewname('AdminZoneBlocked'):
            if (!$usr->isBlocked())
            {
                $request->setView  ( 'AdminSignIn' );
                $application->redirect($request);
            }
            break;
        default:
            $URL = ($application->getCurrentProtocol() == "https"? "https://":"http://").$_SERVER["HTTP_HOST"];
            if (isset($_SERVER['QUERY_STRING']))
            {
                $URL.= $_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'];
            }
            elseif (isset($_SERVER['REQUEST_URI']))
            {
                $URL.= $_SERVER['REQUEST_URI'];
            }
            else
            {
                $URL.= $_SERVER['PHP_SELF'];
            }
            $session->set('URL', $URL);
            if ($usr->isBlocked())
            {
                $request->setView  ( 'AdminZoneBlocked' );
                $application->redirect($request);
            }
            else
            {
                $request->setView  ( 'AdminSignIn' );
                $application->redirect($request);
            }
            break;
    }
}
else
{
    $current_file = basename($_SERVER['PHP_SELF']);
    if ($usr->getPasswordUpdate())
    {
        if ($current_file != $application->getPagenameByViewname('AdminPasswordUpdate'))
        {
            $request = &new Request();
            $request->setView  ('AdminPasswordUpdate');
            $application->redirect($request);
        }
    }
    else
    {
        $current_user = modApiFunc("Users", "getCurrentUserID");
        $selected_user = modApiFunc("Users", "getSelectedUserID");
        if (!modApiFunc("Users", "havePermission", ADMIN_OPTION_EDIT_ADMINS, $current_user))
        {
            switch ($current_file)
            {
                case $application->getPagenameByViewname('AdminMemberAdd'):
                case $application->getPagenameByViewname('AdminMemberDelete'):
                    $request = &new Request();
                    $request->setView('AdminMembersList');
                    $application->redirect($request);
                    break;
                case $application->getPagenameByViewname('AdminMemberEdit'):
                case $application->getPagenameByViewname('AdminPasswordChange'):
                case $application->getPagenameByViewname('AdminMemberPasswordReset'):
                    if ($current_user != $selected_user)
                    {
                        $request = &new Request();
                        $request->setView('AdminMembersList');
                        $application->redirect($request);
                    }
                    break;
            }
        }
        if ($session->is_Set('URL'))
        {
            $URL = $session->get('URL');
            $session->un_Set('URL');
            $request = new Request($URL);
            $application->redirect($request);
        }
    }
}

$application->processAction();

$application->redirectToAnotherProtocol();

log_debug('Initialization Done, Starting Page Output');

?>