<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>Digital Products/E-Goods</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">Digital Products/E-Goods</span>
        </div>
        <div class="pagecontent">
          <p>The Digital Products/E-Goods mechanism lets you sell electronic products such as software, images, music recordings, videos, and so on.</p>

<p>To create a Digital Product, you create a product and then assign a number of files to it. When the customer orders the product, he or she is granted access to download these files.</p>

<p>The buyer receives a confirmation by e-mail containing the links to file downloads.</p>

<p><b>Note.</b> This confirmation is sent only after the order payment status is changed to <b>Fully Paid</b>.</p>

<p>Typically, the process looks like this:</p>
<ol>
	<li>You create a regular product.</li>
	<li>You click the E-Goods tab.</li>
	<li>On the E-Goods tab, you assign the appropriate files to the product, which your customers will be able to download.</li>
	<li>A customer orders the product.</li>
	<li>In the order, links to all of the product's files are generated with the Locked status, meaning that they cannot be downloaded yet.</li>
	<li>The order payment status is changed to Fully Paid. This happens either automatically, when the customer's payment has been accepted via a payment gateway, or when the administrator changes the status manually.</li>
	<li>Avactis automatically sends the buyer a confirmation e-mail containing the download links for files defined in Step 3. The status of all files is changed to Unlocked, and now the buyer is able to download them by navigating to the links provided.</li>
	<li>You can set limits on file download activity by setting an Expiration date and/or maximum download attempts allowed for a file, or by preventing the file from being downloaded (using the Lock file / Unlock file mechanism). You can also allow repeated downloads by setting the current number of download attempts to zero. All of these options are available on the Link Management page, available on the <em>Order Info</em> page. Default values for the Expiration date and the maximum download attempts are defined on the page <em>Store Settings &#45;&gt; Digital Products/E-Goods</em>.</li>
</ol>


<h2><a name="DigitalProducts%28E-Goods%29-DefiningglobalparametersforlinkstoDigitalProducts%2FEGoods"></a>Defining global parameters for links to Digital Products/E-Goods</h2>

<p>When a Digital Product is ordered, Avactis automatically generates a unique link for each of the corresponding product files.</p>

<p>These links have the following limitations:</p>
<ul>
	<li><b>Link lifetime</b></li>
	<li><b>Maximum download attempts</b> allowed per link</li>
</ul>


<p>These parameters are defined on the page <em>Store Settings &#45;&gt; Digital Products/E-Goods</em>.</p>

<p><div border="0" align="absmiddle"  ><img src="Digital_Products.data/store-settings-e-goods.png"></div></p>

<p>After you click <em>Digital Products/E-Goods</em>, a new window opens.</p>

<p><div border="0" align="absmiddle"  ><img src="Digital_Products.data/store-settings-e-goods-popu.png"></div></p>

<p>Select the required parameters:</p>
<ul>
	<li><b>Link lifetime</b> &#45; the lifetime of the link, in hours, from the moment the order is generated. After this time expires, the link will become inactive.</li>
	<li><b>Maximum download attempts allowed</b> &#45; the number of attempts allowed for downloading a file using the link provided. After these attempts have been used, the link will become inactive</li>
</ul>


<p><b>Note:</b> These link parameters are default values applied globally. In any individual order, you can change any parameter for any link.</p>

<h2><a name="DigitalProducts%28E-Goods%29-CreatinganDigitalProducts%2FEGoods"></a>Creating an Digital Products/E-Goods</h2>

<p>There are two types of Digital Products/E-Goods:</p>
<ol>
	<li><em>A pure Digital Product</em>, which is delivered to the customer via file download. No shipping cost calculations apply to this kind of product. If the shopping cart consists of only such products, the Shipping and Handling Cost will be zero.</li>
	<li><em>A combined product.</em> This is a product that is shipped to the customer as a regular product, but in addition, the customer can also download additional electronic materials related to the product. An example might be a user manual in .pdf format.</li>
</ol>


<p>Avactis lets you create both types of Digital Products/E-Goods.</p>

<p>Here's how you can create a Digital Product:</p>
<ul>
	<li>Go to the Manage Products page.</li>
	<li>Select the appropriate category for your product.</li>
	<li>Click the Add Product button to create a new product.</li>
	<li>Until the product is created, the E-Goods tab is unavailable.</li>
	<li>Enter the required fields for the product.</li>
	<li>If you want to create a "<em>Pure</em> <em>Digital Product</em>", the <b>Need Shipping</b> setting should be set to <b>'No'</b>. This means that the shipping cost calculation will not apply to this product.</li>
	<li>If you want to create a "<em>Combined product</em>", the <b>Need Shipping</b> setting should be set to <b>'Yes'</b>.</li>
	<li>Click Save to finish creating the new product.</li>
</ul>


<p>After the product is created, the E-Goods tab will become available on the Product info page. Click the tab to manage the product files.</p>

<p>Assign all the required files to the product. The number of files you can add is unlimited. When ordering this product, the customer will receive links for every file related to this product.</p>

<p>For every file you can add a short description.</p>

<p>After this, the Digital Product is created.</p>

<h2><a name="DigitalProducts%28E-Goods%29-BuyingDigitalProducts%2FEGoods"></a>Buying Digital Products/E-Goods</h2>

<p>Digital Products/E-Goods are bought the same way as regular products. Your storefront's customers browse their products, add them to cart, go though checkout and pay for the order.</p>

<p>A new order is then created in the system. If the order contains at least one Digital Product, then for each file a unique download link is generated.</p>

<p>The links are generated with the Locked status. This means that files cannot be downloaded via these links just yet.</p>

<p>After the order payment status changes to <b>Fully Paid</b>:</p>
<ul>
	<li>All links in the order are set to <b>Unlocked</b>.</li>
	<li>A confirmation e-mail is sent to the customer, which contains all of the download links.</li>
</ul>


<p><b>Note:</b> The administrator is able to switch the status of any link (<b>Locked/Unlocked</b>) manually regardless of the order payment status.</p>

<p><b>Note:</b> Order payment status may be changed to <b>Fully Paid</b> automatically if the customer has paid for the order via a real-time payment processing system, for example, PayPal. If your store uses an offline processing of payments, then the order status must be changed manually by the administrator.</p>

<p>After receiving the confirmation e-mail, the customer can use the links to download the appropriate files.</p>

<h2><a name="DigitalProducts%28E-Goods%29-ManagingDigitalProducts%2FEGoodsLinksinanOrder"></a>Managing Digital Products/E-Goods Links in an Order</h2>

<p>Go to the Manage orders page (the Orders tab). You will see a list of orders. Click the <b>ID</b> of an order that contains one or more Digital Products.</p>

<p>A new window opens listing detailed information about the order. The Product(s) Ordered section shows the list of products ordered. For each Digital Product in this list there will be a link to "<b>Link Management</b>".</p>

<p><div border="0" align="absmiddle"  ><img src="Digital_Products.data/order-info-links.png"></div></p>

<p>When you click Link Management, a new window opens so you can manage links for downloading this product's files.</p>

<p><div border="0" align="absmiddle"  ><img src="Digital_Products.data/links.png"></div></p>

<p>This windows displays the following information on each product file:</p>
<ul>
	<li>File name</li>
	<li>Link</li>
	<li>Expire Date</li>
	<li>Attempts</li>
	<li>Current link status (Locked/Unlocked)</li>
</ul>


<p>Using this window, you can:</p>
<ul>
	<li>Change the link status</li>
	<li>Change the Expire Date</li>
	<li>Set the current download attempts to zero</li>
</ul>


<h2><a name="DigitalProducts%28E-Goods%29-Notification"></a>Notification</h2>

<p>To customize the notification message that will be sent to the customer after they order an Digital Products/E-Goods, go to <em>Store Settings &#45;&gt; E-mail Notifications</em>.</p>

<p><div border="0" align="absmiddle"  ><img src="Digital_Products.data/store-settings-notification.png"></div></p>

<p>Click <em>E-mail Notifications</em>. A window opens in which you can manage all available notifications.</p>

<p>The default version of the notification sent when an Digital Product is ordered has already been created.</p>

<p><div border="0" align="absmiddle"  ><img src="Digital_Products.data/store-settings-ntf-egoof.png"></div></p>

<p>Click the Digital Products/E-Goods Links notification type to open a new window and then edit the text and links information which will be sent to the customer.</p>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
    </body>
</html>