<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>Edit Product Type</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">Edit Product Type</span>
        </div>
        <div class="pagecontent">
          <p>This section includes attributes that define the parameters of the selected or newly created product type. You can add or delete product attributes as required.<br/>
<div align="center">
<p><div border="0" align="absmiddle"  ><img src="images.data/edit-prod-type.png"></div></p></div></p>


<h3><a name="EditProductType-ProductTypes."></a>Product Types.</h3>

<p>Imagine that you sell DVDsand Books in your store. Each of these products has attributes describing it. In this example, the attribute for Books is the ISBN (International Standard Book Number), which is not used when entering DVD details.<br/>
To facilitate processing of various kinds (types) of products, we introduced 'product types'. In this example we have two product types - DVDs and Books. The product type for the goods is entered only once. This facilitates the process of catalog creation, product search and comparison. The Manage Product Types section describes how to enter a new product type.</p>

<h3><a name="EditProductType-ProductAttributes"></a>Product Attributes</h3>

<p>Product attributes define various characteristics of a product. For instance, attribute Unit Price (Base Price) defines the product price, while attribute Weight defines the product weight.</p>

<p>By default, Avactis suggests attributes common to the majority of products. These attributes are system-defined and cannot be deleted. If you don't need a certain attribute for your product, just make it 'invisible' by removing the checkmark in the Visibility column. To obtain help about an attribute, click the <b>?</b> icon. Information about the attribute and its features will be displayed.</p>

<h3><a name="EditProductType-WhydoweneedtoeditProductTypes%3F"></a>Why do we need to edit Product Types?</h3>

<p>Editing of product types allows us to add new attributes for products. Once a product type has been created, you will only see those product attributes that are relevant to the product type in question when you enter new products.</p>

<p><b>Visibility</b> determines whether the attribute for a given product type is visible or not. If the checkbox for the attribute is selected, then this attribute will be displayed when you enter information about the product. The checkbox should be unselected if the attribute in question does not determine the product's parameters.<br/>
For instance, if the product does not have weight (e.g. software, music and other digital products), you may set the Weight attribute to the Invisible status. In this case you will never be prompted to enter the product's weight when you enter data about a software product.</p>

<p>You may set default parameters when entering a new product type. For instance, if the product type is Taxable, you may set 'Yes' as the default value. Consequently, you will not need to change the 'Taxable' value each time you enter a new product of this type.</p>

<h3><a name="EditProductType-CustomAttributes"></a>Custom Attributes</h3>

<p>When you create a new product type, default attributes may be insufficient for the description of products. For instance, existing default product types do not have the Length field. If your store sells any products characterized by length, you may introduce a new attribute, Length, using the Add button in the New Custom Attributes section.<br/>
<div align="center">
<p><div border="0" align="absmiddle"  ><img src="images.data/custom-attributes.png"></div></p></div></p>

<p>Avactis allows you to enter several types of attributes:</p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <b>Text and Numbers (Single Line).</b> </td>
<td class='confluenceTd'> This attribute type has a number or single-line text as a parameter. For instance, you should use this attribute type for the new attribute, Length, which has a numeric value of the parameter. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Big Text (HTML Text).</b> </td>
<td class='confluenceTd'> This attribute type has some large regular text or HTML as a parameter. This attribute may be useful for displaying large textual product descriptions. </td>
</tr>
</tbody></table>
<p>Using Edit, View or Delete links, you can edit, view or delete custom attributes.</p>

<p>To save the changes, click the Save button. To close the window, click the Cancel button.</p>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
  </body>
</html>