<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>General Settings</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">General Settings</span>
        </div>
        <div class="pagecontent">
<p>The <b>General Settings</b> page allows you to manage the basic store settings.</p>

<p>It includes the following sections:<div align="center">
<div><a href='#GeneralSettings-Close%2FOpentheOnlineStore'>Close/Open the Online Store</a> | <a href='#GeneralSettings-StockLevelSettings'>Stock Level Settings</a> | <a href='#GeneralSettings-StoreTimeSettings'>Store Time Settings</a> | <a href='#GeneralSettings-SettingsforBlockingSignIntoAdminArea'>Settings for Blocking Sign In to Admin Area</a> | <a href='#GeneralSettings-ShoppingCart'>Shopping Cart</a></div></div><br/>
<div border="0" align="center"  ><img src="images.data/store-settings-general.gif"></div></p>

<h3><a name="GeneralSettings-Close%2FOpentheOnlineStore"></a>Close/Open the Online Store</h3>

<p>In this section you can set the status of your store to either CLOSED or ONLINE. A CLOSED store is unavailable to your visitors. In that case, a special webpage is displayed. For details on creating such a page, please refer to Storefront Area documentation.</p>

<p>Administrators can access a CLOSED store by using the keyword identified in the "Key for signing in to a temporarily closed store" box.</p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <b>Store status</b> </td>
<td class='confluenceTd'> To close the store, set the status to <b>CLOSED</b>. Store users will not be able to view the catalog of products or place orders. A webpage specially created for this purpose will be displayed to visitors. For details on creating such a page, please refer to Storefront Area documentation. <br clear="all" />
 To open the store to shoppers, set the store status to <b>ONLINE</b>. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Key for signing in to a temporarily closed store</b> </td>
<td class='confluenceTd'> The keyword for accessing a CLOSED store. The URL for viewing a CLOSED store is displayed below the keyword. </td>
</tr>
</tbody></table>

<h3><a name="GeneralSettings-StockLevelSettings"></a>Stock Level Settings</h3>

<p>This section lets you choose whether items not in stock are displayed to customers and whether they can be ordered.</p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <b>Displaying products not in stock</b> </td>
<td class='confluenceTd'> <b>Enabled</b>: products not in stock ARE displayed when customers browse the catalog. <br clear="all" />
<b>Disabled</b>: products not in stock are NOT displayed when customers browse the catalog. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Ordering of products not in stock</b> </td>
<td class='confluenceTd'> <b>Enabled</b>: products not in stock CAN be ordered. <br clear="all" />
<b>Disabled</b>: products not in stock CAN NOT be ordered. </td>
</tr>
</tbody></table>

<h3><a name="GeneralSettings-StoreTimeSettings"></a>Store Time Settings</h3>

<p>This sets the current store time. The time is used for order placement, in e-mails, and so on.</p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <b>Store Time</b> </td>
<td class='confluenceTd'> Current store time and store date. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Adjust store time</b> </td>
<td class='confluenceTd'> This setting lets you change the current store time. Use positive numbers to increase the time and negative numbers to decrease it. </td>
</tr>
</tbody></table>

<h3><a name="GeneralSettings-SettingsforBlockingSignIntoAdminArea"></a>Settings for Blocking Sign In to Admin Area</h3>

<p>This section lets you customize the conditions for blocking access to Admin Area in case of multiple unsuccessful attempts to sign in. If activated, a block applies only to one user having a particular IP address and does not apply to any other users.</p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <b>Number of unsuccessful attempts to sign in to Admin Area after which the Sign In page is blocked</b> </td>
<td class='confluenceTd'> This setting determines the number of unsuccessful attempts to sign in to Admin Area after which the Sign In page becomes blocked. This allows you to protect your store from unauthorized access. The block applies to only one user that has a particular IP address and does not apply to any other users. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Amount of time the sign in page stays blocked</b> </td>
<td class='confluenceTd'> The amount of time the Sign In page stays blocked for the user who has exceeded the limit of attempts to sign in. The block applies to only one user that has a particular IP address and does not apply to any other users. </td>
</tr>
</tbody></table>

<h3><a name="GeneralSettings-ShoppingCart"></a>Shopping Cart</h3>

<p>In this section you can choose whether the contents of the shopping cart are shown to the customer after he or she has added a product to it.</p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <b>Show customer the shopping cart contents after the product has been added</b> </td>
<td class='confluenceTd'> <b>Enabled</b>: the contents of the shopping cart are displayed after a product is added. Any time a product is added, the customer sees what is currently in the cart. <br clear="all" />
<b>Disabled</b>: the contents of the shopping cart are NOT displayed after a product is added. Adding products to cart is done without the cart's contents being displayed every time, although the customer may view the cart whenever they want. </td>
</tr>
</tbody></table>
<p>For detailed information on any of these settings, click the ? mark.</p>

<p>Click Update to save any changes. To leave the page click Close.</p>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
  </body>
</html>