<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>HTTPS Settings</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">HTTPS Settings</span>
        </div>
        <div class="pagecontent">
          <p>Avactis Shopping Cart implements a very flexible system to support secure connections (SSL). It's the user who chooses which Storefront pages and Admin Area sections to configure as secured. There is also an option to configure all Admin Area pages to be loaded via a secure connection.</p>

<p>Secure connections are disabled in Avactis by default. You have to properly configure SSL connections in order to use SSL.</p>

<p>First, ask your hosting provider for your HTTPS domain name and the URL pointing to Avactis installation folder. Then, configure SSL for your Admin Area and Storefront.</p>

<h2><a name="HTTPSSettings-ConfigureAdminArea."></a>Configure Admin Area.</h2>

<p>Select Admin Area &gt;&gt; Admin &gt;&gt; HTTPS Settings. <div align="center"><div border="0" align="absmiddle"  ><img src="images.data/https.gif"></div> </div><br/>
This page includes the following fields.</p>
<ul>
	<li><b>HTTPS URL</b> : use this field to specify the HTTPS URL pointing to Avactis installation folder. If HTTPS URL and HTTP URL are identical, this field doesn't need to be modified, since it contains the correct value by default. If URL isn't detected automatically, you should enter one yourself. If you don't know the URL, ask your hosting provider. Note that the URL you specify should point to the installation folder. Some Windows hostings provide a "Check" button instead of a "Save" button. See <a href="#HTTPSSettings-Apendix1" title="Apendix 1 on HTTPS Settings">Apendix 1</a> for details.</li>
</ul>


<p>The Secure Admin Area Sections area below helps you choose which Admin Area sections to protect. You can leave all options listed below unchecked, but you must specify an URL to provide full-fledged SSL connections in Storefront.</p>
<ul>
	<li><b>Whole Admin Area (Backend)</b> : selecting this option switches the whole Admin Area to the secure protocol. Keep in mind, though, that secure connection makes pages load substantially longer because additional time is required to encode and decode data being transferred, including images. Selecting this option is not recommended as it hinders the performance of the Catalog.</li>
	<li><b>Sign-In &amp; Admin Members Management</b> : selecting this option secures the following pages: Sign In, Password Update, and Password Recovery, as well as pages associated with the Admin Members section (List, Info, Add, Edit, Password Reset, and Delete).</li>
	<li><b>Orders &amp; Customers</b> : secures Orders (List, Info, Delete) and Customers (List, Info) pages.</li>
	<li><b>Payment &amp; Shipping Modules Settings</b> : secures pages with lists and settings associated with Payment and Shipping Methods.</li>
</ul>


<p>After you have specified the HTTPS URL and selected which Admin Area sections to protect, click Save. If the URL is correct and no errors were encountered, the window closes and the https config.php file is created in the "avactis-system" folder. If the window doesn't close, that means an error has occurred. See <a href="#HTTPSSettings-Apendix2" title="Apendix 2 on HTTPS Settings">Apendix 2</a> for a list of potential errors.</p>

<p>Now that you're finished with Admin Area settings, you can start configuring the Storefront.</p>

<h2><a name="HTTPSSettings-ConfigureStorefront."></a>Configure Storefront.</h2>

<p>Open avactis-layouts/storefront-layout.ini in your favorite plain editor. Uncomment the<br/>
; SiteHTTPSURL = ""<br/>
string by deleting its leftmost symbol (';'). Insert the HTTPS URL that was specified in Admin Area, for example:<br/>
SiteHTTPSURL = "https://www.your_site.com/store/"<br/>
Select Storefront pages that you want to protect by adding the HTTPS = YES directive to corresponding sections. For example, if the Checkout page is to be protected, find the [Checkout] section and insert that directive as follows:</p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> [Checkout] <br clear="all" />
;This section specifies the file name and the path to the file of the checkout page. <br clear="all" />
;The file path is specified relative to SitePath. <br clear="all" />
<b>HTTPS = YES</b> <br clear="all" />
Default = checkout.php </td>
</tr>
</tbody></table>
<p>If required, you can protect other Storefront pages in the same way.</p>

<p>P.S. Avactis releases prior to 1.6.0 use the flowers/flowers-layout.ini file to configure HTTPS (which is true if it wasn't previously renamed or moved to another location). If that's the case, your HTTPS URL should look like this:<br/>
SiteHTTPSURL = "https://www.your_site.com/store/flowers/".</p>

<h2><a name="HTTPSSettings-Appendix1"></a>Appendix 1</h2>


<h3><a name="HTTPSSettings-Usingthe%22Check%22buttontovalidatethespecifiedURL."></a>Using the "Check" button to validate the specified URL.</h3>

<p>Certain Windows hosting spaces replace the "Save" button with the "Check" button. The latter helps make sure that the URL you specified actually exists. If the URL is typed correctly and it exists, the following message displays: <div align="center"><div border="0" align="absmiddle"  ><img src="images.data/https-url-checking.gif"></div> </div><br/>
If a green message appears, select Yes and click "Close", otherwise select No and try typing the URL once again.</p>

<p>P.S. Do NOT select Yes if the green message "The URL you entered is correct" doesn't display. That can lead to system failure. If the failure occurred nonetheless, delete the avactis-system/https_config.php file.</p>

<h2><a name="HTTPSSettings-Appendix2"></a>Appendix 2</h2>


<h3><a name="HTTPSSettings-ListofpotentialerrorswhensavingHTTPSsettings."></a>List of potential errors when saving HTTPS settings.</h3>

<ul>
	<li><b>Please enter the HTTPS URL that points to the root directory of Avactis Shopping Cart.</b></li>
	<li><b>The URL you entered contains syntax error(s).</b></li>
	<li><b>The URL you entered is invalid. A test call to the system returned no response.</b></li>
	<li><b>An error occurred when creating the configuration file due to insufficient rights to write to 'avactis-system' folder.</b></li>
	<li><b>An error occurred when creating a configuration file due to insufficient rights to write to file 'avactis-system/https_config.php'.</b></li>
	<li><b>You have deleted a previously entered URL. This means that secured connections will no longer be applied for Admin Area. This can also cause incorrect functioning of secured connections in Storefront (if they are enabled). If you want to stop using secured connections, click Save; otherwise, click Cancel.</b></li>
	<li><b>Unable to delete the configuration file 'avactis-system/https_config.php', possibly due to insufficient deletion rights. Please change the access rights for this file or delete it manually.</b></li>
</ul>

        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
  </body>
</html>