<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>Import Products</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">Import Products</span>
        </div>
        <div class="pagecontent">
          <p>The Import Products page helps you import the product catalog from a CSV file. Importing as a CSV file is a quick and convenient way to create and update the catalog.</p>

<p>CSV is a file format which lets you store spreadsheet data (such as the product catalog) as text, and is widely supported by editors. See <a href="http://en.wikipedia.org/wiki/Comma-separated_values" title="Visit page outside Confluence">http://en.wikipedia.org/wiki/Comma-separated_values</a> for its detailed description.</p>

<p>In order to create a CSV file for importing, export products from the catalog and then modify the resulting CSV file as appropriate.</p>

<p>Importing the product catalog from a CSV file is a three-step process as described below.</p>

<p><b>Step 1 of 3. Select a file to import.</b></p>

<p>During this step, you should select a CSV file to import from. The file can be located either on your PC or on a server where the shopping cart software is installed.</p>

<p>After selecting a file, click Next.<div align="center"><div border="0" align="absmiddle"  ><img src="images.data/product-import-1-1.png"></div> </div><br/>
<b>Step 2 of 3. Check file, choose actions</b></p>

<p>This purpose of step is to verify the integrity and correctness of the file specified for import. All detected errors are displayed in the Import Log section.</p>

<p>If the CSV file specifies names of images to be imported into the catalog, image locations are requested.</p>

<p>Images can be stored in a single tar archive either on your computer or on a server where the shopping cart software is installed. It's also acceptable to store uncompressed images in a server location.</p>

<p>If images are stored on your local computer, add them to a single tar archive before importing. Tar archives are supported by most compression software. If your compression software doesn't handle tar archives, you can download a free tar archive viewer at <a href="http://www.7-zip.org" title="Visit page outside Confluence">http://www.7-zip.org</a></p>

<p>Click Start to begin importing.<div align="center"><div border="0" align="absmiddle"  ><img src="images.data/product-import-2-2.png"></div> </div><br/>
<b>Step 3 of 3. Import.</b></p>

<p>This step includes importing text data and images (if specified) from a CSV file.</p>

<p>The Import Log section contains additional import-related information.<div align="center"><div border="0" align="absmiddle"  ><img src="images.data/product-import-3-1.png"></div> </div><br/>
<b>Additional import-related information</b></p>

<p>1. Importing from a CSV file can result in either updating or creating new products.<br/>
2. If the ProductID column in a CSV file specifies the correct product identifiers (i.e. a ProductID already exists in catalog), information for these products is updated accordingly.<br/>
3. If a CSV file lacks the ProductID column, then products are created in the category that you specify. If that's the case, note that ProductName is a required column in the CSV file, because it's impossible to create products without names.<br/>
4. If the ProductID column in a CSV file specifies an incorrect product identifier (ProductID doesn't exist in current catalog), the corresponding row is omitted. Therefore, it is essential to delete the ProductID column when importing from a third-party system.<br/>
5. The application analyzes the ProductCategory column while creating new products. Nonexistent categories are created automatically.<br/>
6. All columns should have correct names in order to be imported correctly. You can get column names by exporting a demo catalog to a CSV file.</p>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
  </body>
</html>