<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>Manage Categories</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">Manage Categories</span>
        </div>
        <div class="pagecontent">
          <p>This page allows you to manage categories: add, delete, sort, move to another category, and edit category attributes. To learn additional details, you can launch the Video Tutorial that will show you the category management process.</p>

<h2><a name="ManageCategories-MainConcepts"></a>Main Concepts</h2>




<h3><a name="ManageCategories-Categoriesandproducts."></a>Categories and products.</h3>

<p>Imagine that you own a huge bookstore with thousands of books in stock. The store is divided into departments, e.g. Finance, Small Business, E-Commerce. A book titled "Selling Online: How to Become a Successful E-Commerce Merchant" (ISBN - 0793145171) by Jim Carroll and Rick Broadhead is on sale in the E-Commerce department.<br/>
In the Avactis system this book is a Product. Products are any items that are delivered to a customer, such as books, shirts, software, electronic documents. The store's departments, e.g. Finance, Small Business, and E-Commerce are called categories in the Avactis software.</p>




<h3><a name="ManageCategories-Categoriesandsubcategories.Whatisthecategorytree%3F"></a>Categories and subcategories. What is the category tree?</h3>

<p>For instance, you sell books on Finance, Marketing, Small Business, E-Commerce. The Small Business category contains subcategories Bookkeeping, Franchises, and Mail Order, which may be represented as a category tree:<br/>
<div align="center"><div border="0" align="center"  ><img src="images.data/folders.gif"></div></div></p>

<p>In this example Finance, Small Business, and E-Commerce are 1st level categories in the category tree. Bookkeeping, Franchises, and Mail Order are 2nd level categories. At the same time, Bookkeeping, Franchises and Mail Order are subcategories of the Small Business category.<br/>
Generally, when we mention a category we imply all corresponding subcategories as well.<br/>
'Category' and 'subcategory' are always relative notions. For instance, in the above example we have categories Finance, Small Business, E-Commerce, Bookkeeping, Franchises, and Mail Order, while in the Small Business category we have subcategories Bookkeeping, Franchises, and Mail Order.</p>
<p><div align="center">
<p><div border="0" align="absmiddle"  ><img src="images.data/manage-categ.png"></div></p></div></p>

<h2><a name="ManageCategories-ToolbarDescription"></a>Toolbar Description</h2>

<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <b>Current Category</b> </td>
<td class='confluenceTd'> The Current Category line shows the category you are currently working with, and the complete path to this category on the category tree. Using the links, you can always move to higher-level categories. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Subcategories</b> </td>
<td class='confluenceTd'> Shows the list of subcategories for a given category. By clicking on a category name you can move to lower-level categories. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Subcategory ID</b> </td>
<td class='confluenceTd'> Displays the unique category number. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Products</b> </td>
<td class='confluenceTd'> This column shows the number of products in a given category, including products in the nested subcategories. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Included Categories</b> </td>
<td class='confluenceTd'> Shows the number of lower-level subcategories in a given category. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Add Category</b> </td>
<td class='confluenceTd'> Allows to create a new subcategory in the current category shown in the Current Category line. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Move</b> </td>
<td class='confluenceTd'> Allows to move categories. To move a category, first select the category, then click the Move button. A new window for moving the categories will come up. Follow the instructions in this window. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Edit</b> </td>
<td class='confluenceTd'> Allows to edit the name and other parameters of a category. To edit a category, first select the category, then click the Edit button. A new edit window will come up. Follow the instructions in this window. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Delete</b> </td>
<td class='confluenceTd'> Allows to delete categories. To delete a category, first select the category, then click the Delete button. A category delete window will come up. Follow the instructions in this window. <br clear="all" />
<b>Be careful. When you delete a category, you will also delete all products and lower-level subcategories within this category.</b> </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Info</b> </td>
<td class='confluenceTd'> Allows to view information about the selected category. To view information about a category, first select the category, then click the Info button. A new window showing information about the selected category will come up. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Sort</b> </td>
<td class='confluenceTd'> Allows to sort subcategories in the current category. To sort subcategories, click the Sort button. A new window will come up. Follow the instructions in this window. </td>
</tr>
</tbody></table>

<p>To learn additional details, you can launch the Video Tutorial that will show you the category management process.</p>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
  </body>
</html>