<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>Order Details</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">Order Details</span>
        </div>
        <div class="pagecontent">
          <p>The Order Details page allows you to view and edit order information. It also lets you change order status and payment status.</p>

<p>The Order Details page contains the following sections:<br/>
<div>
<ul>
  <li><a href='#OrderDetails-KeyOrderDetails'>Key Order Details</a></li>
  <li><a href='#OrderDetails-Product%28s%29Ordered'>Product(s) Ordered</a></li>
  <li><a href='#OrderDetails-CustomerInformation'>Customer Information</a></li>
  <li><a href='#OrderDetails-Billing%2FPaymentInformation'>Billing/Payment Information</a></li>
  <li><a href='#OrderDetails-ShippingInformation'>Shipping Information</a></li>
  <li><a href='#OrderDetails-Comments'>Comments</a></li>
  <li><a href='#OrderDetails-OrderHistory'>Order History</a></li>
</ul></div><br clear="all" /></p>

<p><div border="0" align="center"  ><img src="images.data/key-order-details.png"></div></p>

<h3><a name="OrderDetails-KeyOrderDetails"></a>Key Order Details</h3>

<p><b>Key Order Details</b> presents the key data for a particular order as well as its present status and the payment status.</p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <b>Order ID</b> </td>
<td class='confluenceTd'> Represents the unique ID of an order in the <b>Avactis Shopping Cart</b> system. Each order has an order ID and can be positively identified by its order ID. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Payment Processor Order ID</b> </td>
<td class='confluenceTd'> Represents the order ID of an order made through an online payment system. This ID is generated by the online payment system; it can be missing if the payment was made in cash or otherwise without using an online payment system. This ID can also be missing in the event of a glitch that occurred when the payment was processed by an online payment system. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Order Status</b> </td>
<td class='confluenceTd'> Represents the status of the order. <br clear="all" />  <br clear="all" />
 The order statuses used in Avactis Shopping Cart are listed below. After the customer places an order, the order is assigned a <b>New Order</b> status. The status of an order can be changed manually by the system administrator when processing the order. <br clear="all" />  <br clear="all" />
When changing order status, there is an option to automatically notify the customer about the order status change. This is done by selecting the appropriate settings in Store Settings &gt;&gt; Email notification options. Such email notifications let you inform your customers about the progress of their orders and help raise their level of commitment and loyalty to your online store. <br clear="all" />  <br clear="all" />
<b>New Order</b> &#8211; order has been placed but has not been accepted for processing. <br clear="all" />
<b>In Progress</b> &#8211; order has been accepted for processing. <br clear="all" />
<b>Ready to Ship</b> &#8211; order has been processed and is ready to be shipped. <br clear="all" />
<b>Shipped</b> &#45; order has been shipped. <br clear="all" />
<b>Cancelled</b> &#8211; order has been cancelled. <br clear="all" />
<b>Declined</b> &#8211; order has been declined by the online store manager. <br clear="all" />
<b>Completed</b> &#8211; order has been completed in full. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Payment Status</b> </td>
<td class='confluenceTd'> Represents the status of payment. <br clear="all" />  <br clear="all" />
The possible payment statuses are listed below. The status of a payment can be changed manually by the system administrator. Also, payment status can be automatically set to Fully Paid by the system if the payment has been successfully completed through an online payment processing system. <br clear="all" />  <br clear="all" />
<b>Waiting</b> &#8211; payment is pending or has not been made. <br clear="all" />
<b>Fully Paid</b> &#8211; payment has been made in full. <br clear="all" />
<b>Declined</b> &#8211; payment has been declined (for example, because a credit card fraud is suspected). </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Payment Method</b> </td>
<td class='confluenceTd'> Represents the method of payment used to pay for the order. If the payment method is subsequently changed, this field can be edited manually. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Shipping Method</b> </td>
<td class='confluenceTd'> Represents the method used for shipping products to the customer. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Tracking Number</b> </td>
<td class='confluenceTd'> Represents the tracking number for the shipped order. The tracking number can be used to track the progress of order shipment. </td>
</tr>
</tbody></table>

<h3><a name="OrderDetails-Product%28s%29Ordered"></a>Product(s) Ordered</h3>

<p><b>Product(s) Ordered</b> provides full information on all ordered products.</p>

<h3><a name="OrderDetails-CustomerInformation"></a>Customer Information</h3>

<p><b>Customer Information</b> displays customer information.</p>

<h3><a name="OrderDetails-Billing%2FPaymentInformation"></a>Billing/Payment Information</h3>

<p><b>Billing/Payment Information</b> displays the payer information. The payer is the person billed for the order and is not necessarily the customer.</p>

<h3><a name="OrderDetails-ShippingInformation"></a>Shipping Information</h3>

<p><b>Shipping Information</b> displays addressee information. The addressee is the person to whom the order is shipped and is not necessarily the customer or the payer.</p>

<h3><a name="OrderDetails-Comments"></a>Comments</h3>

<p>The <b>Comments</b> section is used to provide any comments about the order while you are processing it.</p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <b>Add Comment</b> </td>
<td class='confluenceTd'> This field lets you enter additional comments about the order. For example, you may include the history of a conversation with the customer which provides more details or terms regarding the order. </td>
</tr>
</tbody></table>

<h3><a name="OrderDetails-OrderHistory"></a>Order History</h3>

<p><b>Order History</b> lets you track the changes made to a placed order.</p>

<p>To get information about the attributes of an order, use the <b>?</b> mark. Information on that particular attribute will be displayed in a new window.</p>

<p>To save any changes made to the data and the statuses, click <em>Save</em>.</p>

<p>Click the <em>Edit</em> button to switch to editing other details of the order. A new page will open letting you edit the other order details.</p>

<p>Click <em>Cancel</em> to close the page.</p>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
  </body>
</html>