<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>Orders</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">Orders</span>
        </div>
        <div class="pagecontent">
          <div class="panel" style="border-style: none; "><div class="panelContent">
<p><b>On this page:</b></p>
<style type='text/css'>/*<![CDATA[*/
div.rbtoc1180356661449 {margin-left: 0px;padding: 0px;}
div.rbtoc1180356661449 ul {list-style: none;margin-left: 0px;}
div.rbtoc1180356661449 li {margin-left: 0px;padding-left: 0px;}

/*]]>*/</style><div class='rbtoc1180356661449'>
<ul>
  <li><a href='#Orders-OrderStatuses'>Order Statuses</a></li>
  <li><a href='#Orders-Paymentstatuses'>Payment statuses</a></li>
  <li><a href='#Orders-Changingorderstatusandpaymentstatus'>Changing order status and payment status</a></li>
  <li><a href='#Orders-Deletingorders'>Deleting orders</a></li>
</ul></div>
</div></div>
<p>The <b>Orders</b> page allows you to manage orders placed by the online store visitors.<br/>
It also lets you search orders by date, status and order ID.<div align='center'>

<p><div border="0" align="center"  ><img src="images.data/orders-page.png"></div></p></div><br/>
The Orders page contains the following sections:</p>
<ul>
	<li>Quick Order Navigation</li>
	<li>Search Orders</li>
	<li>Orders</li>
</ul>


<p>The <b>Quick Order Navigation</b> section lets you quickly access orders having one of these statuses: New, In Progress, Ready to Ship or All. To view all orders having a given status, click the corresponding link. All orders with that status will be displayed in the Orders section.</p>

<p><b>Search Orders</b> is used to search orders by number or order status. When searching by status you can also specify a date interval. To search within a particular date interval, set the starting date and the ending date of your interval.</p>

<h2><a name="Orders-OrderStatuses"></a>Order Statuses</h2>

<p>The order statuses used in Avactis Shopping Cart are listed below. After the customer places an order, the order is assigned a <b>New Order</b> status. The status of an order can be changed manually by the system administrator when processing the order.</p>

<p>When changing order status, there is an option to automatically notify the customer about the order status change. This is done by selecting the appropriate settings in Store Settings &gt;&gt; Store Configuration &gt;&gt; Email Notification options. Such email notifications let you inform your customers about the progress of their orders and help raise their level of commitment and loyalty to your online store.</p>
<ul>
	<li><b>New Order</b> &#45; order has been placed but has not been accepted for processing.</li>
	<li><b>In Progress</b> &#45; order has been accepted for processing.</li>
	<li><b>Ready to Ship</b> &#45; order has been processed and is ready to be shipped.</li>
	<li><b>Shipped</b> &#45; order has been shipped.</li>
	<li><b>Cancelled</b> &#45; order has been cancelled.</li>
	<li><b>Declined</b> &#45; order has been declined by the online store manager.</li>
	<li><b>Completed</b> &#45; order has been completed in full.</li>
</ul>


<h2><a name="Orders-Paymentstatuses"></a>Payment statuses</h2>

<p>The possible payment statuses are listed below. The status of a payment can be changed manually by the system administrator. Also, payment status can be automatically set to <b>Fully Paid</b> by the system if the payment has been successfully completed through an online payment processing system.</p>
<ul>
	<li><b>Waiting</b> &#45; payment is pending or has not been made.</li>
	<li><b>Fully Paid</b> &#45; payment has been made in full.</li>
	<li><b>Declined</b> &#45; payment has been declined (for example, because a credit card fraud is suspected).</li>
</ul>


<h2><a name="Orders-Changingorderstatusandpaymentstatus"></a>Changing order status and payment status</h2>

<p>To change the status of an order or payment:</p>
<ol>
	<li>In the line containing the order name, change the status of payment or order;</li>
	<li>Click the <em>Update</em> button.</li>
</ol>


<p>This will save any changes made to the status(es).</p>

<h2><a name="Orders-Deletingorders"></a>Deleting orders</h2>

<p>To delete one or more orders, select the appropriate orders and click the Delete button.</p>

<p>For information on a particular order, click its number. Order information will be displayed in a new window.</p>

<p>For information on a particular customer, click the link containing the customer's name. Customer information will be displayed in a new window.</p>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
  </body>
</html>