<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>Product Options Combinations</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">Product Options Combinations</span>
        </div>
        <div class="pagecontent">
          <p>Product Options page lets you create option values. For example, T-shirts can have a Color option (Blue, Red, or Green) and a Size option (S, M, L, or XL). These option values make for the following combinations:</p>

<p>Color: Blue<br/>
Size: S</p>

<p>Color: Red<br/>
Size: S</p>

<p>Color: Green<br/>
Size: S</p>

<p>Color: Blue<br/>
Size: M</p>

<p>and so on. It's perfectly possible for certain option combinations to represent nonexistent objects. For instance, Green XL T-shirts may be not available. Providing for that kind of cases, you can disable nonexistent option combinations in the <b>Product Option Combinations</b> section. <div align="center"><div border="0" align="absmiddle"  ><img src="images.data/product-options-general-guidelines-5.png"></div></div><br/>
If you have no restrictions on option combinations (i.e. all option combinations are allowed), you can leave this section empty.<br/>
<b>Important&#33; Combination rules created in the Product Option Combinations section specify the list of various product options which users are able to select. These rules affect the list of products available for selection in the Product Options Inventory Tracking section. For example, if you have set an option combination that rules out T-shirts with color Blue and size XL, this combination becomes unavailable in the Product Options Inventory Tracking section. In addition, users are denied the possibility of choosing this combination.</b><br/>
The Product Options Combinations page has two parts: <b>Current Combination Rules</b> and <b>New Combination Rule</b>.<br/>
The <b>Current Combination Rule</b> section displays all combination rules which are valid for the current product's options.<br/>
In the <b>New Rule</b> section, you can allow or disallow option combinations by using the following rules:<br/>
<b>The [..,..,..] option combination DOES NOT exist. Other combinations do exist.</b></p>

<p><b>[..,..,..] options are unavailable in combination with [..,..,..] options. Other combinations exist and are available.</b></p>

<p>You may select multiple rules.</p>

<p>After you select the appropriate rules, you get the set of option combinations which will be available for customers in the storefront. If an option combination is not available, the customer will be prompted with an appropriate message, which is defined in the <b>Product Options</b> page of the <b>Settings</b> section.</p>

<p>To verify that option combinations have been defined correctly, use the <b>Check</b> button. Clicking the button opens the list of available and unavailable option combinations for the product:</p>

<p><b>The list of option combinations AVAILABLE to be ordered by customers.</b><br/>
<b>The list of option combinations UNAVAILABLE to be ordered by customers.</b> <div align="center"><div border="0" align="absmiddle"  ><img src="images.data/product-options-general-guidelines-6.png"></div></div><br/>
Use these lists to check that the rules you created are working correctly. </p>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
  </body>
</html>