<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>Product Options General Guidelines</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">Product Options General Guidelines</span>
        </div>
        <div class="pagecontent">
          <p>Product Options page allows you to add product options to a basic product description. Using options is advisable if several versions (options) of a single product have nearly identical appearance. You don't have to create new product catalog items in such cases, as it's sufficient to specify the necessary options in the Product Options section.</p>

<p>Avactis provides powerful tools for creating and managing product options. We recommend studying available documentation carefully before you use Product Options.</p>

<p>Consider several examples of product options.</p>

<p><b>Example 1</b>. You sell t-shirts of assorted sizes (S, M, L, XL), which all look the same. It doesn't make sense to create a new product for every single size. All you have to do is enter a description of the general item in Product Details, add the Size option in Product Options, and define parameters S, M, L, and XL for the Size option.</p>

<p><b>Example 2</b>. You sell T-shirts of three colors: Blue, Red and Green, with several sizes available: S, M, L and XL. Prices differ depending on specific color and size, as shown in the table below. For example, if the basic price for a T-shirt is $50, then a red L-sized shirt will cost $70 since the Red option and the L size increase the total price by $7 and $13, respectively. Thus, the final price is $70 = ($50 + $7 + $13).</p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <b>Option</b> </td>
<td class='confluenceTd'> <b>Value</b> </td>
<td class='confluenceTd'> <b>Price</b> </td>
</tr>
<tr>
<td class='confluenceTd'> Color </td>
<td class='confluenceTd'> Blue <br clear="all" />
Red <br clear="all" />
Green </td>
<td class='confluenceTd'> + $5 <br clear="all" />
+ $7 <br clear="all" />
+ $9 </td>
</tr>
<tr>
<td class='confluenceTd'> Size </td>
<td class='confluenceTd'> S <br clear="all" />
M <br clear="all" />
L <br clear="all" />
XL </td>
<td class='confluenceTd'> + $8 <br clear="all" />
+ $12 <br clear="all" />
+ $13 <br clear="all" />
+ $15 </td>
</tr>
</tbody></table>
<p>In this particular case we have two options, Color and Size, with several values for Color (Blue, Red, Green) and Size (S, M, L, XL). Applying one or more of these values affects the basic product price to produce the final price for a combination of options.</p>

<p>After product options have been created, customers are able to choose specific options when viewing a product in the storefront. Speaking of example 2, that can be implemented as shown in the figure below. <div align="center">

<p><div border="0" align="absmiddle"  ><img src="images.data/product-options-general-guidelines-1-storefront.png"></div></p></div></p>

<h2><a name="ProductOptionsGeneralGuidelines-AddProductOptions"></a>Add Product Options</h2>

<p>By default, no options are assigned to a product. Use the Add Option button to add product options. A new window opens where you can add a product option. Depending on specific needs of your online store, Avactis Shopping cart allows adding various options. The number of options is unlimited. See detailed description of available options on the Add/Edit Product Option page in Page Help. Additional useful information about using Avactis product options is available on the Tips and Tricks page of Product Options.</p>

<h2><a name="ProductOptionsGeneralGuidelines-Delete%2FEditProductOptions"></a>Delete/Edit Product Options</h2>

<p>After you've added a product option, its description is displayed on the Product Options page as shown in the following figure. Click Delete to remove or Edit to modify a product option. Clicking Edit opens a new window where you can change option parameters. <div align="center">

<p><div border="0" align="absmiddle"  ><img src="images.data/product-options-general-guidelines-1-marked.png"></div></p></div></p>

<h2><a name="ProductOptionsGeneralGuidelines-SortProductOptions"></a>Sort Product Options</h2>

<p>The Sort button lets you change the order of options in the storefront. Note that customers see options sorted in the storefront exactly the same way as they appear on the Product Options page in Admin Area.</p>

<h2><a name="ProductOptionsGeneralGuidelines-ManageProductOptionCombinations"></a>Manage Product Option Combinations</h2>

<p>The Product Options page lets you create product options. For example, as shown before, T-shirts can have two options, Color (Blue, Red, or Green) and Size (S, M, L, or XL). Several combinations can be made from these options, specifically:</p>

<p>Color: Blue<br/>
Size: S</p>

<p>Color: Red<br/>
Size: S</p>

<p>Color: Green<br/>
Size: S</p>

<p>Color: Blue<br/>
Size: M</p>

<p>and so on. It's perfectly possible for certain option combinations to represent nonexistent objects. For instance, Blue XL T-shirts may be not available. Providing for that kind of cases, you can disable nonexistent option combinations in the Product Option Combinations section.</p>

<p>The Product Option Combinations section helps create various rules for product option combinations. Click the <b>Manage Combinations</b> button to start managing combinations. A new window, Product Option Combinations, displays where you can edit combinations using multiple rules.</p>

<p>See detailed instructions on combination management on the Product Option Combinations page and in the Product Options Tips and Tricks section of Page Help.</p>

<p><b>Important&#33; Combination rules created in the Product Option Combinations section specify the list of various product options which users are able to select. These rules affect the list of products available for selection in the Product Options Inventory Tracking section. For example, if you have set an option combination that rules out T-shirts with color Blue and size XL, this combination becomes unavailable in the Product Options Inventory Tracking section. In addition, users are denied the possibility of choosing this combination.</b></p>

<h2><a name="ProductOptionsGeneralGuidelines-ManageProductOptionsInventoryTracking"></a>Manage Product Options Inventory Tracking</h2>

<p>In the example above, T-shirt options Color and Size make up T-shirt combinations that are actually available in stock in certain quantity and are assigned certain numbers (SKU). The product options inventory tracking section lets you manage the stock of product having defined options.</p>

<p>Click <b>Manage Inventory</b> to start managing product options inventory. A new page, Product Options Inventory Tracking, displays where you can edit the inventory.</p>

<p>Detailed overview of the product options inventory tracking management feature can be found on the Product Options Inventory Tracking page in Page Help.</p>

<p><b>Important&#33; If you have disabled certain option combinations in Product Option Combinations, they will not show up in the Product Options Inventory Tracking section.</b></p>

<h2><a name="ProductOptionsGeneralGuidelines-ProductOptionsSettings"></a>Product Options Settings</h2>

<p>The Product Options page contains several settings which are described below.</p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <b>Do you want to allow adding products to cart without selected options?</b> </td>
<td class='confluenceTd'> This setting determines what happens in the storefront when a customer tries to add a product which has options to the cart. If the customer adds a product from a page which has no options available for selection, then, provided this setting's value is 'Yes', the product will be added with the default set of options. If the setting's value is 'No', the customer will be redirected to a page with product information in order to select a set of options. If that page does not have any options available for selection, the product will be impossible to add to cart. <br clear="all" />
<b>Example</b>: On the products list page, products are displayed with no option selection available. When you click Add to Cart, this setting is checked, and it if it is set to 'Yes', the product will be added with the default set of options. Otherwise, you are redirected to the product information page. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Add product to cart ignoring the combinations specified in Product Options Inventory Tracking?</b> </td>
<td class='confluenceTd'> If Yes is selected, customer can add to cart products having option combinations not defined in the Product Options Inventory Tracking section. Option combinations are only restricted by rules specified in the Product Option Combinations section. <br clear="all" />
If No is selected, customers can only fill their carts with products having the option combinations defined in the Product Options Inventory Tracking section. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Nonselected options message</b> </td>
<td class='confluenceTd'> It is possible that, during the operation of the storefront, a product with defined options is passed to cart without any options selected. If the setting "Do you want to allow adding products to cart without selected options?" is switched to NO, a message specified in the following field is displayed. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Text of message displayed when a product option combination is not defined in Product Option Combinations</b> </td>
<td class='confluenceTd'> This message is displayed if a user attempts to order a combination of options which is not allowed according to the rules specified in the Product Option Combinations section. <br clear="all" />
<br clear="all" />
<b>Default Message</b>: Product option combination does not exist. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Text of the message displayed when a product option combination is either not defined in Product Option Inventory Tracking or not available in stock</b> </td>
<td class='confluenceTd'> The Product Options Inventory Tracking section contains product option combinations available in stock. If a customer attempts to order a combination that doesn't exist or is out of stock, the message specified in this field is displayed. <br clear="all" />
<br clear="all" />
<b>Default Message</b>: Product option combination doesn't exist or is out of stock. </td>
</tr>
</tbody></table>

<h2><a name="ProductOptionsGeneralGuidelines-ProductOptionTipsandTricks"></a>Product Option Tips and Tricks</h2>

<p><b>Question 1</b>. <font color="#0033ff"><em>I sell shirts. Every shirt is assigned a basic price of $50. The final cost of a shirt is determined by its color and size according to the following table.</em></font></p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <font color="#0033ff"><b><em>Option</em></b></font> </td>
<td class='confluenceTd'> <font color="#0033ff"><b><em>Value</em></b></font> </td>
<td class='confluenceTd'> <font color="#0033ff"><b><em>Price</em></b></font> </td>
</tr>
<tr>
<td class='confluenceTd'> <font color="#0033ff"><em>Color</em></font> </td>
<td class='confluenceTd'> <font color="#0033ff"><em>Blue</em></font> <br clear="all" /> <font color="#0033ff"><em>Red</em></font> <br clear="all" /> <font color="#0033ff"><em>Green</em></font> </td>
<td class='confluenceTd'> <font color="#0033ff"><em>+ $5</em></font> <br clear="all" /> <font color="#0033ff"><em>+ $7</em></font> <br clear="all" /> <font color="#0033ff"><em>+ $9</em></font> </td>
</tr>
<tr>
<td class='confluenceTd'> <font color="#0033ff"><em>Size</em></font> </td>
<td class='confluenceTd'> <font color="#0033ff"><em>S</em></font> <br clear="all" /> <font color="#0033ff"><em>M</em></font> <br clear="all" /> <font color="#0033ff"><em>L</em></font> <br clear="all" /> <font color="#0033ff"><em>XL</em></font> </td>
<td class='confluenceTd'> <font color="#0033ff"><em>+ $8</em></font> <br clear="all" /> <font color="#0033ff"><em>+ $12</em></font> <br clear="all" /> <font color="#0033ff"><em>+ $13</em></font> <br clear="all" /> <font color="#0033ff"><em>+ $15</em></font> </td>
</tr>
</tbody></table>
<p><font color="#0033ff"><em>I'd like customers to choose color in a drop-down menu and choose size with radio buttons as shown in the figure. Also I'd like to be able to keep records of shirts available in stock. How do I do that?</em></font> <div align="center"><div border="0" align="absmiddle"  ><img src="images.data/product-options-general-guidelines-2-storefront.png"></div></div><br/>
<b>Answer 1</b>. Click Add Option to add Color. Set Option Type to Single Select, since a single shirt can have only one color (Blue, Red or Green). If you wish to provide a drop-down menu to choose color, set <b>Option Display Type</b> to Drop-Down. Since this option affects inventory tracking, choose Inventory Tracking=YES.<br/>
Set <b>Option may be left unselected</b> to No, since the Color of a shirt should always be required. Click Add in the Add New Value section to display fields for entering Color parameters. Enter Blue in the Name field and &#43;5 in the Price field, since Blue color increases final cost by $5. Set the remaining field to 0, since shirt color doesn't modify other item values specified in Product Details. Enter Red and Green parameters in the same way. The resulting page is shown in the following figure.<br/>
Specify Size option similarly. <div align="center"><div border="0" align="absmiddle"  ><img src="images.data/product-options-general-guidelines-2.png"></div></div><br/>
Since products are accounted for in stock, go to the Product Options Inventory Tracking section and enter SKU and quantity of items in stock for every combination. The resulting Product Options Inventory Tracking page is shown in the following figure. <div align="center"><div border="0" align="absmiddle"  ><img src="images.data/product-options-general-guidelines-3.png"></div></div><br/>
<b>Question 2</b>. <font color="#0033ff"><em>As in Question 1, I have the same shirts and I want to keep records of them in stock. However, my vendor does not ship Green XL shirts. How do I make it so that customers are not given the option to choose this combination of color and size during checkout?</em></font><br/>
<b>Answer 1</b>: To disable a certain combination, go to Product Option Combinations section and specify that Color (Green) does not exist with Size (XL).
<br clear="all" />
<br clear="all" /> <div align="center">
<p><div border="0" align="absmiddle"  ><img src="images.data/product-options-general-guidelines-5.png"></div></p></div><br/>
After this rule is created it appears in the Product Option Combinations section as shown below. <div align="center">
<p><div border="0" align="absmiddle"  ><img src="images.data/product-options-general-guidelines-8.png"></div></p></div></p>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
  </body>
</html>