<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?>   <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>Search Engine Friendly URLs v.2</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">Search Engine Friendly URLs v.2</span>
        </div>
        <div class="pagecontent">
          <p>The Search Engine Optimized URLs page is designed for generating HTML URLs for your online storefront. This functionality is optional, because most modern search engines do a good job of indexing the pages of your online storefront, which are generated as .php pages by default. However, this option will be useful if you want your storefront URLs to have the .html extension.</p>

<h3><a name="SearchEngineFriendlyURLsv.2-Important"></a>Important</h3>

<p>Creating search engine optimized HTML URLs is possible only for online stores with Unix/Linux hosting, with the mod_rewrite function enabled. If mod_rewrite is disabled or not installed on the hosting server, HTML URLs cannot be created. The pages of your online storefront will be available as .php by default, which will in no way affect the operation of your online store and the indexing of phase by most search engines.</p>

<h3><a name="SearchEngineFriendlyURLsv.2-Advice"></a>Advice</h3>

<p>We recommend that you define your HTML URLs only once. If you change them too often, search engines will have several URLs for your online storefront, but only one of them will be operational (others will be invalid).</p>

<h2><a name="SearchEngineFriendlyURLsv.2-Generalinformation"></a>General information</h2>

<p>This section provides the technical details concerning your server settings. It is targeted at technical experts.</p>

<h3><a name="SearchEngineFriendlyURLsv.2-URLSettings"></a>URL Settings</h3>

<p><b>Category links ID</b> &#45; System identifier for categories. Default value is cid. This ID may be changed but cannot be left blank.<br/>
<b>Product links ID</b> &#45; System identifier for products. Default value is pid. This ID may be changed but cannot be left blank.<br/>
<b>URL scheme</b> &#45; Lets you select the URL scheme to be used. Several URL scheme options are provided for your online store. Only one URL scheme is used at any given time; others are inactive.</p>

<p><div border="0" align="center"  ><img src="Search_Engine_Friendly_URLs_vX2.data/seo-1.png"></div></p>

<p><b><ins>Important:</ins></b> You cannot delete numbers and predefined system IDs from a URL. Category IDs and product IDs cannot be empty and cannot be the same. The strings "My-Category-Name" and "My-Product-Name" in actual URLs are replaced by actual strings that you configured when creating categories and products (field "SEO URL prefix" in Search Engine Information section).</p>

<h3><a name="SearchEngineFriendlyURLsv.2-Storefront"></a>Storefront</h3>

<p>In this section you can enable support for HTML URLs (mod_rewrite). To do so, select "Action: enable support for HTML URLs (mod_rewrite)" and click Update. Your storefront will be available via the URL you defined in the settings.</p>

<p>To disable support for HTML URLs, select "Action: disable support for HTML URLs (mod_rewrite)".</p>

<p><div border="0" align="center"  ><img src="Search_Engine_Friendly_URLs_vX2.data/seo-2.png"></div></p>

<p>Click the link with the section name to see how your online store works after enabling support for HTML URLs (mod_rewrite).</p>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
  </body>
</html>