<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>Shipping Methods</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">Shipping Methods</span>
        </div>
        <div class="pagecontent">
          <p>The Shipping Methods page lets you manage the shipping methods that you intend to offer for your store's customers.</p>

<p><div border="0" align="center"  ><img src="images.data/shipping-methods.png"></div></p>

<p><b>General Shipping Settings</b></p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <b>Per Order Shipping Fee</b> </td>
<td class='confluenceTd'> Per <b>Order Shipping Fee</b> is the flat fee associated with shipping an order. This amount is added to the order total before tax calculations. <br clear="all" />
<br clear="all" />
<b>Note</b>: If you have shipping costs for individual products, you can enter them for each individual product as the <b>Per Item Shipping Cost</b> attribute. <br clear="all" />
<b>Note</b>: If you have a shipping cost modifier for some product options, you may enter it as the Shipping Cost Modifier attribute in the <b>Product Options</b> section. The Shipping Cost Modifier for an option affects the <b>Per Item Shipping Cost</b> for the entire product. <br clear="all" />
<br clear="all" />
<b>Example:</b> <br clear="all" />
Per Item Shipping Cost for Product1 = <b>$3.00</b> <br clear="all" />
Per Item Shipping Cost for Product2 = <b>$5.00</b> <br clear="all" />
Per Order Shipping Flat Fee = <b>$5.00</b> <br clear="all" />
<br clear="all" />
The customer ordered 2 items of Product1 and 4 items of Product2. <br clear="all" />
The shipping fee by UPS = <b>$11.00.</b> <br clear="all" />
<br clear="all" />
Then, <br clear="all" />
(Total shipping cost, <b>$42.00</b>) = (Per Order Shipping Flat Fee, <b>$5.00</b>) + (UPS shipping fee, <b>$11.00</b>) + (2 x Per Item Shipping Cost for Product1, 2 x <b>$3.00</b>) + (4 x Per Item Shipping Cost for Product2, 4 x <b>$5.00</b>) </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Per Order Handling Fee</b> </td>
<td class='confluenceTd'> Per <b>Order Handling Fee</b> is the flat fee associated with shipping an order. This amount is added to the order total before tax calculations. <br clear="all" />
<br clear="all" />
<b>Note</b>: If you have handling costs for individual products, you can enter them for each individual product as the <b>Per Item Handling Cost</b> attribute. <br clear="all" />
<b>Note</b>: If you have a handling cost modifier for some product options, you may enter it as the Handling Cost Modifier attribute in the Product Options section. The <b>Handling Cost Modifier</b> for an option affects the <b>Per Item Handling Cost</b> for the entire product. <br clear="all" />
<br clear="all" />
<b>Example</b>: <br clear="all" />
Per Item Handling Cost for Product1 = <b>$1.00</b> <br clear="all" />
Per Item Handling Cost for Product2 = <b>$2.00</b> <br clear="all" />
Per Order Handling Fee = <b>$10.00</b> <br clear="all" />
<br clear="all" />
The customer ordered 2 items of Product1 and 4 items of Product2. <br clear="all" />
<br clear="all" />
Then, <br clear="all" />
(Total handling cost, <b>$20.00</b>) = (Per Order Handling Fee, <b>$10.00</b>) + (2 x Per Item Handling Cost for Product1, 2 x <b>$1.00</b>) + (4 x Per Item Handling Cost for Product2, 4 x <b>$2.00</b>) <br clear="all" /> </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Minimum Shipping Cost</b> </td>
<td class='confluenceTd'> <b>Minimum Shipping Cost</b> is the lowest possible shipping cost. Total shipping cost is calculated as the sum of the shipping cost was calculated by the selected <b>shipping method (UPS, FedEx, USPS, etc.)</b> + <b>Per Order Shipping Fee</b> + <b>Per Item Shipping Cost</b> &#42; <b>number of products</b>. For example, if the total shipping cost is <b>$24</b> and the Minimum Shipping Cost is <b>$30</b>, then the shipping cost will be equal to <b>$30</b> &#45; the minimum. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Free Shipping For Orders Over</b> <br clear="all" />
<br clear="all" />
and <br clear="all" />
<br clear="all" />
<b>Free Handling For Orders Over</b> </td>
<td class='confluenceTd'> Free Shipping For Orders Over and Free Handling For Orders Over enable you to provide free shipping and/or handling for orders with Order Subtotal exceeding the set values. <br clear="all" />
<br clear="all" />
<b>Example 1</b>. <br clear="all" />
Free Shipping For Orders Over = <b>$300.00</b> <br clear="all" />
Free Handling For Orders Over = <b>$400.00</b> <br clear="all" />
<br clear="all" />
Order Subtotal = <b>$270.00</b> <br clear="all" />
Shipping Cost Calculated = <b>$30.00</b> <br clear="all" />
Handling Cost Calculated = <b>$10.00</b> <br clear="all" />
<br clear="all" />
<br clear="all" />
In this case, Free Shipping is not applied because of Order Subtotal is less than <b>$300.00</b>. <br clear="all" />
Free Handling is not applied too because of Order Subtotal is less than <b>$400.00</b>. <br clear="all" />
<br clear="all" />
The total shipping and handling cost is calculated as follows: <br clear="all" />
<b>Shipping and Handling Cost</b>&nbsp;= <b>Shipping Cost Calculated</b> + <b>Handling Cost Calculated</b> = <b>$30.00</b> + <b>$10.00</b> = <b>$40.00</b> <br clear="all" />
<br clear="all" />
The order total is calculated as follows: <br clear="all" />
<br clear="all" />
Order Subtotal: <b>$270.00</b> <br clear="all" />
Shipping and Handling: <b>$40.00</b> <br clear="all" />
Taxes: <b>$31.00</b> <br clear="all" />
&#45;------------------------&#45; <br clear="all" />
Total: <b>$341.00</b> <br clear="all" />
<br clear="all" />
<br clear="all" />
<b>Example 2</b>. <br clear="all" />
Free Shipping For Orders Over = <b>$300.00</b> <br clear="all" />
Free Handling For Orders Over = <b>$400.00</b> <br clear="all" />
<br clear="all" />
Order Subtotal = <b>$320.00</b> <br clear="all" />
Shipping Cost Calculated = <b>$30.00</b> <br clear="all" />
Handling Cost Calculated = <b>$10.00</b> <br clear="all" />
<br clear="all" />
<br clear="all" />
In this case, Free Shipping is applied because of Order Subtotal is greater than <b>$300.00</b>. <br clear="all" />
Free Handling is not applied because of Order Subtotal is less than <b>$400.00</b>. <br clear="all" />
<br clear="all" />
The total shipping and handling cost is calculated as follows: <br clear="all" />
Shipping and Handling Cost = Handling Cost Calculated = <b>$10.00</b> <br clear="all" />
<br clear="all" />
The order total is calculated as follows: <br clear="all" />
<br clear="all" />
Order Subtotal: <b>$320.00</b> <br clear="all" />
Shipping and Handling: <b>$10.00</b> <br clear="all" />
Taxes: <b>$33.00</b> <br clear="all" />
&#45;------------------------&#45; <br clear="all" />
Total: <b>$363.00</b> <br clear="all" />
<br clear="all" />
<br clear="all" />
<br clear="all" />
<b>Example 3</b>. <br clear="all" />
Free Shipping For Orders Over = <b>$300.00</b> <br clear="all" />
Free Handling For Orders Over = <b>$400.00</b> <br clear="all" />
<br clear="all" />
Order Subtotal = <b>$450.00</b> <br clear="all" />
Shipping Cost Calculated = <b>$30.00</b> <br clear="all" />
Handling Cost Calculated = <b>$10.00</b> <br clear="all" />
<br clear="all" />
<br clear="all" />
In this case, Free Shipping is applied because of Order Subtotal is greater than <b>$300.00</b>. <br clear="all" />
Free Handling is applied too because of Order Subtotal is greater than <b>$400.00</b>. <br clear="all" />
<br clear="all" />
The total shipping and handling cost is calculated as follows: <br clear="all" />
Shipping and Handling Cost= <b>$0.00</b> <br clear="all" />
<br clear="all" />
The order total is calculated as follows: <br clear="all" />
<br clear="all" />
Order Subtotal: <b>$450.00</b> <br clear="all" />
Shipping and Handling Cost: <b>$0.00</b> <br clear="all" />
Taxes: <b>$45.00</b> <br clear="all" />
&#45;------------------------&#45; <br clear="all" />
Total: <b>$495.00</b> <br clear="all" /> </td>
</tr>
</tbody></table>
<p><b>A general example of calculating the shipping and handling cost</b>:
<br clear="all" />
<br clear="all" />
The customer ordered 2 items of Product1 and 4 items of Product2.</p>

<p>Sale Price for Product1 = <b>$70.00</b><br/>
Per Item Shipping Cost for Product1 = <b>$3.00</b><br/>
Per Item Handling Cost for Product1 = <b>$1.00</b></p>

<p>Sale Price for Product2 = <b>$30.00</b><br/>
Per Item Shipping Cost for Product2 = <b>$5.00</b><br/>
Per Item Handling Cost for Product2 = <b>$2.00</b></p>

<p>Per Order Shipping Fee = <b>$5.00</b><br/>
Per Order Handling Fee = <b>$10.00</b><br/>
Minimum Shipping Cost = <b>$20.00</b><br/>
Free Shipping For Orders Over = <b>$300.00</b><br/>
Free Handling For Orders Over = <b>$400.00</b></p>

<p>Order Subtotal = $70.00 * 2 + $30.00 * 4 = $140.00 + $120.00 = <b>$260.00</b></p>

<p>In this case, Free Shipping is not applied because Order Subtotal is less than <b>$300.00</b>.</p>

<p>Free Handling is not applied either because Order Subtotal is less than <b>$400.00</b>.</p>

<p><b>Total shipping cost</b> = (Per Order Shipping Fee, $5.00) + (UPS shipping fee, $11.00) + (2 x Per Item Shipping Cost for Product1, 2 x $3.00) + (4 x Per Item Shipping Cost for Product2, 4 x $5.00) = <b>$42.00</b></p>

<p><b>Total handling cost</b> = (Per Order Handling Fee, $10.00) + (2 x Per Item Handling Cost for Product1, 2 x $1.00) + (4 x Per Item Handling Cost for Product2, 4 x $2.00) = <b>$20.00</b></p>

<p><b>Shipping and Handling Cost</b> = <b>Total shipping cost</b> + <b>Total handling cost</b> = $42.00 + $20.00 = <b>$62.00</b></p>

<p>Shipping and Handling:</p>

<p>Order Subtotal: <b>$260.00</b><br/>
Shipping and Handling: <b>$62.00</b><br/>
Taxes: <b>$32.20</b><br/>
&#45;------------------------&#45;<br/>
Total: <b>$354.20</b>
<br clear="all" />
<br clear="all" />
<br clear="all" />
Availability of shipping methods from which you can choose depends on the version of Avactis Shopping Cart software. The full list of shipping methods supported by the system is provided under <b>Available Shipping Methods</b>. To select one or more shipping methods, select them in the list and move them to the <b>Selected Shipping Methods</b> box by clicking the <em>Right Arrow</em> button.</p>

<p>Under <b>Selected Shipping Methods</b>, the order of shipping methods is identical to your customers will see when placing an order for a product. Click the <em>Up</em> and <em>Down</em> arrows to define the order in which these shipping methods will be displayed to customers. To save any changes click Save.<br/>
Once saved, the selected shipping methods will appear in the Shipping Methods section. By default, the selected shipping methods are inactive, that is, they are still unavailable to your customers. To start offering these shipping options, you need to customize the settings and activate the selected shipping methods. To do so, click a shipping method's name. A new window is displayed where you can customize and activate the shipping method.<br/>
To remove a shipping method from the list of available methods, select it in the Selected Shipping Methods column and click the Left button to move it to Available Shipping Methods. Click Save. The selected shipping method will be removed from the list of Shipping Methods.<br/>
For an illustration of how to customize and activate a shipping method, please see the Video Tutorial. </p>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
  </body>
</html>