<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>Shipping Tester</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">Shipping Tester</span>
        </div>
        <div class="pagecontent">
          <p>The Shipping Tester page lets you to test and verify shipping module settings and also view the details of how shipping/handling charges are calculated. You can use this page whenever an error occurs in calculating shipping charges. Errors, if any, are listed per each shipping method. Possible errors include the wrong shipping address, the wrong origination address, or a server connection error due to invalid account details, or no connection to the server.</p>

<p>The Shipping Tester page contains the following parts:</p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <b>Origination address</b> </td>
<td class='confluenceTd'> The address of your store. Products will be shipped from this address. The store address can be set up at Store Settings / Store Configuration / Store Owner's Profile </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Destination address</b> </td>
<td class='confluenceTd'> The address to which the product is shipped. This address is entered by the customer during checkout. Here you can enter shipping addresses to test how shipping charges are calculated. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Shopping Cart</b> </td>
<td class='confluenceTd'> Test cart with test products. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Common Shipping and Handling parameters</b> </td>
<td class='confluenceTd'> The shipping and handling parameters which are common to all shipping methods. These settings are entered at Store Settings / Shipping Methods / Settings. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Active shipping modules</b> </td>
<td class='confluenceTd'> These sections appear after calculations of shipping charges have been performed. Every active shipping module has its own section. This section contains the server query message, the server response, the list of error messages, and the summary table listing the shipping charges for each active shipping module. Shipping modules and shipping methods can be set up at Store Settings / Shipping Settings / Methods. </td>
</tr>
</tbody></table>
<p>Consider the following use case for the Shipping Tester.</p>

<p>Assume your store has the following address:</p>

<p>City: New York<br/>
Country: United States<br/>
State: New York<br/>
Zip/Postal code: 10001 <div align="center"><div border="0" align="absmiddle"  ><img src="images.data/shipping-test-1.png"></div> </div><br/>
You have set up the following shipping modules: U.S. Postal Service and Standard Shipping Rates. <div align="center"><div border="0" align="absmiddle"  ><img src="images.data/shipping-test-2.png"></div> </div><br/>
To perform a test calculation of shipping charges, you should add some items to the shopping cart and then specify a shipping address.</p>

<p>Let's say we've added a test product with the following parameters:</p>

<p>Name: Product #1<br/>
Quantity: 1<br/>
Weight: 2 lb<br/>
Price: 100<br/>
Per Item Shipping Cost: 10<br/>
Per Item Handling Cost: 5<br/>
Free shipping: NO</p>

<p>The shipping address is given as:</p>

<p>City: Washington<br/>
Country: United States<br/>
State: District of Columbia<br/>
Zip/Postal code: 20201<br/>
Now, we click the Test button to perform the calculation.</p>

<p>After the calculation is complete, we will see the following general results (your results may vary):</p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> Subtotal: </td>
<td class='confluenceTd'> $100.00 </td>
</tr>
<tr>
<td class='confluenceTd'> Free Handling For Orders Over: </td>
<td class='confluenceTd'> $400.00 </td>
</tr>
<tr>
<td class='confluenceTd'> Free Shipping For Orders Over: </td>
<td class='confluenceTd'> $300.00 </td>
</tr>
<tr>
<td class='confluenceTd'> Minimum Shipping Cost: </td>
<td class='confluenceTd'> $10.00 </td>
</tr>
<tr>
<td class='confluenceTd'> Per Item Shipping Cost Sum: </td>
<td class='confluenceTd'> $10.00 </td>
</tr>
<tr>
<td class='confluenceTd'> Per Order Shipping Fee: </td>
<td class='confluenceTd'> $5.00 </td>
</tr>
<tr>
<td class='confluenceTd'> Per Item Handling Cost Sum: </td>
<td class='confluenceTd'> $5.00 </td>
</tr>
<tr>
<td class='confluenceTd'> Per Order Handling Fee: </td>
<td class='confluenceTd'> $10.00 </td>
</tr>
<tr>
<td class='confluenceTd'> Total Handling Charge: </td>
<td class='confluenceTd'> $15.00 </td>
</tr>
<tr>
<td class='confluenceTd'> Total Weight: </td>
<td class='confluenceTd'> 2 lb </td>
</tr>
</tbody></table>
<p><br clear="all" />
<div align="center"><div border="0" align="absmiddle"  ><img src="images.data/shipping-test-3.png"></div> </div><br/>
For each active shipping method, several sections will be displayed on the page. In our case, the "U.S. Postal Service" and "Standard Shipping Rates" sections are displayed. </p>

<p>Each section has two subsections: Debug Info and Methods.</p>

<p>Debug Info lets you see calculation details and thus troubleshoot potential problems.</p>

<p>Methods shows the total shipping charges for each shipping method.</p>

<p>The result is the shipping cost for each active shipping method. <br/>
<div align="center"><div border="0" align="absmiddle"  ><img src="images.data/shipping-test-4.png"></div> </div></p>

<p>In our case, we received the following results for the shipping methods of the U.S. Postal Service shipping module:</p>
<table class='confluenceTable'><tbody>
<tr>
<th class='confluenceTh'> Method name </th>
<th class='confluenceTh'> Transit time </th>
<th class='confluenceTh'> Shipping Method Cost </th>
<th class='confluenceTh'> Total Shipping Charge </th>
<th class='confluenceTh'> Total Shipping And Handling cost </th>
</tr>
<tr>
<td class='confluenceTd'> USPS Express Mail PO to Addressee </td>
<td class='confluenceTd'>&nbsp;</td>
<td class='confluenceTd'> $21.40 </td>
<td class='confluenceTd'> $36.40 </td>
<td class='confluenceTd'> $51.40 </td>
</tr>
<tr>
<td class='confluenceTd'> USPS Priority Mail </td>
<td class='confluenceTd'>&nbsp;</td>
<td class='confluenceTd'> $4.90 </td>
<td class='confluenceTd'> $19.90 </td>
<td class='confluenceTd'> $34.90 </td>
</tr>
<tr>
<td class='confluenceTd'> USPS Parcel Post </td>
<td class='confluenceTd'>&nbsp;</td>
<td class='confluenceTd'> $8.69 </td>
<td class='confluenceTd'> $23.69 </td>
<td class='confluenceTd'> $38.69 </td>
</tr>
<tr>
<td class='confluenceTd'> USPS Bound Printed Matter </td>
<td class='confluenceTd'>&nbsp;</td>
<td class='confluenceTd'> $2.27 </td>
<td class='confluenceTd'> $17.27 </td>
<td class='confluenceTd'> $32.27 </td>
</tr>
<tr>
<td class='confluenceTd'> USPS Media Mail </td>
<td class='confluenceTd'>&nbsp;</td>
<td class='confluenceTd'> $2.47 </td>
<td class='confluenceTd'> $17.47 </td>
<td class='confluenceTd'> $32.47 </td>
</tr>
<tr>
<td class='confluenceTd'> USPS Library Mail </td>
<td class='confluenceTd'>&nbsp;</td>
<td class='confluenceTd'> $2.34 </td>
<td class='confluenceTd'> $17.34 </td>
<td class='confluenceTd'> $32.34 </td>
</tr>
</tbody></table>
<p>Calculation table legend:</p>

<p>Shipping Method Cost is calculated based on the product's price and weight and the sender's and recipient's addresses.</p>

<p>Total Shipping Charge is calculated as the following sum: Shipping Method Cost + Per Item Shipping Cost Sum + Per Order Shipping Fee. The values of Per Item Shipping Cost Sum and Per Order Shipping Fee do not depend on the shipping method. In our example, Per Item Shipping Cost Sum + Per Order Shipping Fee = <b>$10.00</b> + <b>$5.00</b> = <b>$15.00</b>. Therefore, all values in the Total Shipping Charge column are <b>$15.00</b> greater than those in the Shipping Method Cost column.</p>

<p>Total Shipping And Handling cost is calculated as the sum of Total Shipping Charge + Total Handling Charge. In our example, Total Handling Charge = <b>$15</b>. Therefore, all values in the Total Shipping And Handling cost column are <b>$15.00</b> greater than those in the Total Shipping Charge column.</p>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
  </body>
</html>