<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>Single Line Attribute</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">Single Line Attribute</span>
        </div>
        <div class="pagecontent">


<p><b>Attribute Format: Single Line Text and Numbers</b></p>

<p>This page is used to create and edit custom attributes having a Single Line Text and Numbers format. This format allows input of both numerical product parameters and short text strings of up to 256 characters.</p>

<p>To create an attribute having this format, enter the appropriate values into the Attribute Tag, Attribute Name and Attribute Description fields. Click the Add button to add the attribute to the product type being created or edited.</p>

<p>To save the added custom attribute and all changes, click the Save button on the New/Edit Product Type page.</p>

<p><b>Field Descriptions:</b></p>
<table class='confluenceTable'><tbody>
<tr>
<td class='confluenceTd'> <b>Attribute Tag.</b> </td>
<td class='confluenceTd'> The store tag name. The tag name distinguishes a given attribute from other attributes created by the user or attributes available in the system by default. The tag name must be entered without any blank spaces. The following letters and digits are allowed: 0&#45;9, A-Z, a-z, &#45;, and &#95;. For example, if you create an attribute describing the size of a flower bouquet, you can name it FlowerDimensions (no black spaces).<br clear="all" />
<br clear="all" />
 <b>Attention: You cannot change or edit Attribute Tags after creation.</b><br clear="all" />
<br clear="all" />
 Note: Functional word Product at the beginning will be automatically appended to the tag name. For instance, if you have created a custom attribute called FlowerDimensions, you need to use the tag <br clear="all" />
<div class="code"><div class="codeContent">
<pre class="code-java">&lt;?phpProductFlowerDimensions() ?&gt;</pre>
</div></div> <br clear="all" />
 in the templates. The tag assigned to the attribute in the system is displayed below the Attribute Tag line. Please refer to the documentation for additional details about Avactis tags. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Attribute Name</b> </td>
<td class='confluenceTd'> Defines the attribute name. For example, you may use "Flower Dimensions" to describe an attribute representing the dimensions of a flower bouquet. An attribute name can contain any characters, including blank spaces. </td>
</tr>
<tr>
<td class='confluenceTd'> <b>Attribute Description</b> </td>
<td class='confluenceTd'> Contains the attribute description. Using the example above you may provide a description such as this: "This attribute describes the physical dimensions of a flower bouquet. Example: 16"H x 12"W." </td>
</tr>
</tbody></table>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
  </body>
</html>