<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>Tax Calculator</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">Tax Calculator</span>
        </div>
        <div class="pagecontent">
<div class="panel" style="border-style: none; "><div class="panelContent">
<p><b>On this page:</b></p>
<style type='text/css'>/*<![CDATA[*/
div.rbtoc1180356661663 {margin-left: 0px;padding: 0px;}
div.rbtoc1180356661663 ul {list-style: none;margin-left: 0px;}
div.rbtoc1180356661663 li {margin-left: 0px;padding-left: 0px;}

/*]]>*/</style><div class='rbtoc1180356661663'>
<ul>
  <li><a href='#TaxCalculator-Overview'>Overview</a></li>
  <li><a href='#TaxCalculator-TaxCalculationResultsexplanation'>Tax Calculation Results explanation</a></li>
</ul></div>
</div></div>

<h2><a name="TaxCalculator-Overview"></a>Overview</h2>

<p>This page is used for verifying the accuracy of tax formulas entered. The top page section lists a hypothetical shopping cart containing one product from each product tax class. Price, quantity, shipping cost per item and tax class properties are displayed for each product. This list of product is shown only for verification purposes and does not reflect the actual contents of your catalog.</p>

<p>The Order-Level Shipping Cost box displays the cost of shipping the order on an order level. The total shipping cost is defined as the sum of shipping costs for each item plus the Order-Level Shipping Cost.</p>

<p><div border="0" align="center"  ><img src="images.data/tax-calc-res.png"></div></p>

<p>Example:</p>
<div class="panel"><div class="panelContent">
<p>Product #1 has a Per Item Shipping Cost = $5;<br/>
Product #2 has a Per Item Shipping Cost = $6.<br/>
The Order-Level Shipping Cost is $10.</p>

<p>The shopping cart contains two items of Product #1 and three items of Product #2.<br/>
Therefore, the total shipping cost is equal to<br/>
$5*2 + $6*3 + 10 = $38.</p>
</div></div>

<h2><a name="TaxCalculator-TaxCalculationResultsexplanation"></a>Tax Calculation Results explanation</h2>

<p>To verify the accuracy of tax calculations regarding shipping, please enter the customer's Address (Billing and Shipping Address) and click the Calculate button. A detailed computation will be laid out in full.</p>

<p>A detailed explanation of tax computations is provided below.</p>

<p><b>Step 1. Preparation Data for Tax Calculation</b><br/>
This is the stage where pieces of data are prepared for final tax calculation.</p>

<p><b>Table 1. Total Sales Price</b><br/>
This table provides computations for the total cost for each product and the total cost of the entire shopping cart. The total cost for each product is calculated as the price per item times the number of items.</p>

<p><b>Table 2. Total Per Item Shipping Cost</b><br/>
This table provides computations for the total shipping cost for each product - Total Per Item Shopping Cost - not accounting for the Order-Level Shipping Cost.</p>

<p>The Per Item Shipping Cost is defined at the time of entering product information in the Manage Products &gt; Add Product section. The Total Per Item Shipping Cost is calculated as the Per Item Shipping Cost times the number if items in the cart.</p>

<p><b>Table 3. Product Price Share</b><br/>
This table provides computations for the proportional share of each product in the shopping cart.</p>

<p>For example, if your cart has two items of Product #1 ($10 each) and three items of Product #2 ($20 each), then the total cost of the shopping cart is $10*2 + $20*3 = $80.</p>

<p>Therefore, Product #1's share of the total = 0.25 (20/80) and Product #2's share = 0.75 (60/80).</p>

<p><b>Table 4. Order-Level Shipping Cost by Product Price Share</b><br/>
This table provides computations for the amount of each Product's proportional share in Order-Level Shipping Cost.</p>

<p>For example, if the Order-Level Shipping Cost (not accounting for per item shipping costs for individual products) is $10, then Product #1's share is $2.5 (0.25*10), while Product #2 is responsible for $7.5 (0.75*10).&nbsp;</p>

<p><b>Table 5. Shipping Cost</b><br/>
This table provides computations for each product's shipping costs by summing Total Per Item Shipping Cost and Order-Level Shipping Cost by Product Share for each product. For the above-mentioned examples the Shipping Cost is composed of the following amounts:</p>

<p>Product #1:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; $12.5 = $10 + $2.5<br/>
Product #2:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; $25.5 = $18 + $7.5</p>

<p><b>Clarification</b>: As explained above (Table 4), if only the Order-Level Shipping Cost is defined, then a product's Shipping Cost is calculated as a proportion of the product's price in the shopping cart. This calculation method is officially permitted in many tax jurisdictions; it allows you to compute the shipping cost for each product for correct tax calculation. If your tax jurisdiction does not permit the use of this method, then you should only use Total Per Item Shipping Cost, which is provided when entering product information in the Manage Products &gt; Add Product section.</p>

<p><b>Table 6. Data for Calculation Taxes</b><br/>
This table provides the final amounts for calculating taxes; they are Sales Price and Shipping Cost for each product.&nbsp;</p>

<p><b>Step 2. Tax Calculation</b><br/>
This step is where the tax amounts are calculated for each product. The applied formulas are shown and all calculated tax amounts are added together. The total tax amount is displayed for the order which will be shipped to the address provided.</p>

<p>Note: The tax amount may be different for a different address.</p>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
  </body>
</html>