<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <link type="text/css" rel="stylesheet" href="styles/pmwiki.css">
    <title>Taxes</title>
  </head>
  <body>
    <div class="logo"><img src="logo.gif" width=146 height=42></div>
    <div class="pagebody">
        <div class="pageheader">
          <span class="pagetitle">Taxes</span>
        </div>
        <div class="pagecontent">

<div class="panel" style="border-style: none; "><div class="panelContent">
<p><b>On this page:</b></p>
<style type='text/css'>/*<![CDATA[*/
div.rbtoc1180356662059 {margin-left: 0px;padding: 0px;}
div.rbtoc1180356662059 ul {list-style: none;margin-left: 0px;}
div.rbtoc1180356662059 li {margin-left: 0px;padding-left: 0px;}

/*]]>*/</style><div class='rbtoc1180356662059'>
<ul>
  <li><a href='#Taxes-Introduction'>Introduction</a></li>
  <li><a href='#Taxes-PrinciplesoftaxassessmentinInternetsales.'>Principles of tax assessment in Internet sales.</a></li>
  <li><a href='#Taxes-AvactisShoppingCartTaxModuleFeatures'>Avactis Shopping Cart Tax Module Features</a></li>
  <li><a href='#Taxes-Taxespagesections'>Taxes page sections</a>
<ul>
  <li><a href='#Taxes-TaxNames'>Tax Names</a></li>
  <li><a href='#Taxes-TaxDisplayOptions'>Tax Display Options</a></li>
  <li><a href='#Taxes-TaxClasses'>Tax Classes</a></li>
  <li><a href='#Taxes-TaxRules%26nbsp%3BonShippingCost'>Tax Rules&nbsp;on Shipping Cost</a></li>
  <li><a href='#Taxes-TaxRates'>Tax Rates</a></li>
  <li><a href='#Taxes-TaxCalculator'>Tax Calculator</a></li>
</ul></li>
</ul></div>
</div></div>
<p>Avactis shopping cart's&nbsp;tax calculation module is used to calculate taxes applied at the time of sale. The general principles of tax assessment and guidelines for customizing the tax calculation module are provided below.</p>

<h2><a name="Taxes-Introduction"></a>Introduction</h2>

<p>In most countries, a sales tax is applied to the sale of a product or service. The sales tax has a different name in each country. It is called a Sales and Use Tax in the United States and a Value Added Tax (VAT) in the European Union. In Canada, the Goods and Services Tax (GST) is levied at the federal level and a Provincial Sales Tax (PST) at the level of provinces. Also, several Canadian provinces use a Harmonized Sales Text (HST) in place of both GST and PST.&nbsp;</p>

<p>The sales tax may have different names in other countries; however, Avactis Shopping Cart software provides support for calculating taxes applied at the time of sale for the majority of world countries.&nbsp;</p>

<h2><a name="Taxes-PrinciplesoftaxassessmentinInternetsales."></a>Principles of tax assessment in Internet sales.</h2>

<p>Avactis Shopping Cart software is designed for selling goods on the Internet. In most countries, Internet sales of goods and services are taxed the same way as store sales or mail-order sales.</p>

<p>Depending on local legislation, the following items sold on the Internet may be subject to taxation:</p>
<ul>
	<li>product being sold</li>
	<li>product packaging</li>
	<li>product shipping services</li>
</ul>


<p>These taxes may also depend on the customer's and merchant's locations. For more information about tax assessment in different countries, please see the discussion on the E-Commerce Law forum at <a href="http://www.avactis.com/forums">http://www.avactis.com/forums</a></p>

<h2><a name="Taxes-AvactisShoppingCartTaxModuleFeatures"></a>Avactis Shopping Cart Tax Module Features</h2>

<p>Avactis Shopping Cart's tax calculation module meets the majority of tax assessment requirements applicable to Internet sales. Its features include the following:</p>
<ul>
	<li>calculation of product sales taxes with regard to the recipient's location (the entity that receives the shipment);</li>
	<li>calculation of product sales taxes with regard to the payer's location (the entity that pays for the order);</li>
	<li>calculation of individual taxes for each product sold with regard to the tax rate;</li>
	<li>support of an unlimited number of taxes;</li>
	<li>support of an unlimited number of tax rates for the same tax;</li>
	<li>calculation of taxes for simultaneous purchase of products spanning several product classes;</li>
	<li>calculation of taxes applied to shipping cost, if applicable;</li>
	<li>calculation of taxes applied to shipping cost with regard to delivery method;</li>
	<li>calculation of interdependent taxes whenever two or more tax amounts depend on each other.</li>
</ul>


<h2><a name="Taxes-Taxespagesections"></a>Taxes page sections</h2>

<p>The Taxes page includes several sections described below.<div align="center">
<div><a href='#Taxes-TaxNames'>Tax Names</a> | <a href='#Taxes-TaxDisplayOptions'>Tax Display Options</a> | <a href='#Taxes-TaxClasses'>Tax Classes</a> | <a href='#Taxes-TaxRules%26nbsp%3BonShippingCost'>Tax Rules&nbsp;on Shipping Cost</a> | <a href='#Taxes-TaxRates'>Tax Rates</a> | <a href='#Taxes-TaxCalculator'>Tax Calculator</a></div></div><br/>
<div border="0" align="center"  ><img src="images.data/taxes-page.png"></div></p>

<h3><a name="Taxes-TaxNames"></a>Tax Names</h3>

<p>This section includes options for creating, editing and deleting taxes. In Tax Names you define only the name and type of address to which the tax applies. Rules for calculating tax amounts for taxes you've created are defined in the Tax Rates section. You can create as many taxes as you like.</p>

<p>Click the Add button to create a new tax. A new dialog is opened in which you can enter the tax name and the type of address to which it will be applied. For example, if the tax applies to Shipping Address, then only the recipient's address will be taken into account for tax calculation purposes - regardless of the payer's address (Billing Address). Shipping Address is entered by the customer at the time of purchase.</p>

<p>If the tax applies to Billing Address, then the tax is calculated only with regard to the payer's address, regardless of the shipping location. Using the Billing or Shipping Addresses for tax calculation depends on the tax jurisdiction where your business is registered. For example, in most of the United States, if an article is shipped outside the state, no tax is charged. If the article is shipped within the state, a tax is charged even if the payer is located in another state. Thus, the example shows how a tax can be applied to Shipping Address.</p>

<p>To edit or delete a previously created tax, click Edit or Delete, respectively.</p>

<h3><a name="Taxes-TaxDisplayOptions"></a>Tax Display Options</h3>

<p>This section defines the rules for displaying taxes for store visitors during checkout.</p>

<p>After a new tax has been added (in the Tax Names section), it appears automatically in the Tax Display Options section. The Tax &amp; Display Rules column shows the tax name and the rules for displaying the tax. The Displayed Text column shows the text regarding this tax that will be displayed to store visitors during checkout.</p>

<p>Click the Add button to add a new displayed text for a tax. Existing taxes can be displayed together, in any order. Use the Edit and Delete buttons to adjust the displayed text for a tax.</p>

<h3><a name="Taxes-TaxClasses"></a>Tax Classes</h3>

<p>A tax can have more than one tax rate defined for it, depending on the type of product to which it applies. If different types of products are taxed at different rates, you should create a Tax Class for each one of them. For example, a class can be Drugs or Gifts. Two default classes are present: Taxable and Nontaxable. You should select a Tax Class for a product from the list of available classes when entering the product description (Catalog &gt; Manage Products &gt; Add Product).</p>

<p>This section provides only the names and descriptions of Tax Classes. To define the rules of tax calculation for each class entered, use the Tax Rates section corresponding to that class.</p>

<p>Use the Add, Edit and Delete buttons to add, edit or delete tax classes, respectively. You may need several tax classes, depending on the type of goods sold at your e-store and your tax jurisdiction's legislation.</p>

<h3><a name="Taxes-TaxRules%26nbsp%3BonShippingCost"></a>Tax Rules&nbsp;on Shipping Cost</h3>

<p>Depending on your tax jurisdiction's legislation, a tax can be charged on the cost of shipping an article to the customer. This section lets you define the rules for calculating tax amounts applied to product shipping with regard to delivery method.</p>

<p>In most states, shipping is taxed if the delivery is made using the merchant's means of transportation. If shipping is done by a third-party (UPS, USPS, DHL, etc), the shipping cost is not taxed.</p>

<p>If shipping cost is not taxed for a given delivery method, use the Edit button to add it to the list of nontaxed delivery methods.</p>

<h3><a name="Taxes-TaxRates"></a>Tax Rates</h3>

<p>For each tax class entered there is a Tax Rates section containing the rule for tax calculation. If more than one tax is defined for the same type of address, the taxes are added together.</p>

<p>The total tax amount is defined as the sum of all tax amounts for each product class.</p>

<p>Use the Add, Edit and Delete buttons to add, edit or delete, respectively, the tax formulas for each product class.</p>

<h3><a name="Taxes-TaxCalculator"></a>Tax Calculator</h3>

<p>Use the Tax Calculator to verify the accuracy of tax formulas entered. Click the button to open a new window and review the tax computations laid out for customers and payers with any addresses.</p>
        </div>
        <div class="pagefooter">
          <A HREF="Table_Of_Contents.php">Table of Contents</A>
        </div>
    </div>
    <div class="copyright">
     <hr noshade style="width: 400px; height: 1px;">
     <B>&copy; 2004-2007 Pentasoft Corp. All Rights Reserved.</B>
    </div>
<?php include('../../stat/stat.php'); ?>
  </body>
</html>