<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * Core Initialization
 *
 * @package Core
 */

list($usec, $sec) = explode(" ", microtime());
$_avactis_start_time = ((float)$usec + (float)$sec);

/*
 *          ,                        .         -                            
 *           "                                       -               -  ,
 *           ,             ,             php       AVACTIS                 
 *        (   html,    php,                                         )"
 *               ,                                                      
 * header' .
 */

/*
 *                            (              php.net):
 *  kamermans at teratechnologies dot net
 *  22-Aug-2006 12:24
 *  If you are using output buffering and you use the flush() command ANYWHERE headers_sent() will return true - even if the buffer is seemingly empty.
 */

/*
 * Note that in IIS (or at least the version that comes with W2K server), the server seems to do some buffering, so even if you output someting or cause a warning, the value of headers_sent() may be false because the headers haven't been sent yet.
 * So it's not a safe way to know if warnings have been encountered in your script.
 */

/*
 * php.ini:
 * output_buffering = Off
 */
if (headers_sent($filename, $linenum))
{
    //ob_start();
    //echo "<br>inside output buffer<br>";
    //flush();
    ob_get_contents();
    ob_get_clean();

    $msg = "To operate properly, Avactis needs its initialization tags, such as &lt;?php include ('path/avactis-system/store.php'); ?&gt;, to be placed at the very beginning of your e-store source files. No empty spaces are allowed in this string (e.g. blank spaces, tabs, carriage returns). Please check the file<br>"
          . $filename
          . "<br>"
          . "at line<br>"
          . $linenum
          . "<br><br>"
          . "In the example given above, \"path\" is the absolute path to the Avactis Shopping Cart installation directory."
          . "<br><br>"
          . "If the error persists, please refer to Avactis Shopping Cart documentation.";

    $template_fname = dirname(__FILE__) . "/" . "cz_headers_sent.tpl.html";
    $text = file_get_contents($template_fname);
    $text = str_replace("___Errors", $msg, $text);
    echo $text;
    flush();
    exit;
}
else
/* php.ini:
 * output_buffering = On
 * headers_sent() returns false even if html is already in the buffer
 */
if(strlen(ob_get_contents()) > 0)
{
    ob_get_clean();
    $msg = "To operate properly, Avactis needs its initialization tags, such as &lt;?php include ('path/avactis-system/store.php'); ?&gt;, to be placed at the very beginning of your e-store source files. No empty spaces are allowed in this string (e.g. blank spaces, tabs, carriage returns)."
          . "<br><br>"
          . "In the example given above, \"path\" is the absolute path to the Avactis Shopping Cart installation directory."
          . "<br><br>"
          . "If the error persists, please refer to Avactis Shopping Cart documentation.";

    $template_fname = dirname(__FILE__) . "/" . "cz_headers_sent.tpl.html";
    $text = file_get_contents($template_fname);
    $text = str_replace("___Errors", $msg, $text);
    echo $text;
    flush();
    exit;
}

@set_time_limit(0);
@error_reporting(E_ALL);
$memory_limit = @(int)ini_get('memory_limit');
if ($memory_limit < 30)
{
    @ini_set('memory_limit', "30M");
}

$_current_path = dirname( dirname(__FILE__) ); #                /system/
$_core_directory = $_current_path.'/avactis-system/core/';
function loadCoreFile($filename)
{
    global $_core_directory;
    include_once($_core_directory.$filename);
}

loadCoreFile('functions.php' );
loadCoreFile('action_message.php');
loadCoreFile('application.php');
loadCoreFile('ccache_file.php');
loadCoreFile('ccache_single_file.php');
loadCoreFile('ccache_interface.php');
loadCoreFile('ccache_memory.php');
loadCoreFile('ccache_null.php');
loadCoreFile('factory.php');
loadCoreFile('message_resources.php');
loadCoreFile('request.php');
loadCoreFile('cz_request.php');
loadCoreFile('session.php');
loadCoreFile('template_filler.php');
loadCoreFile('tmpl_filler.php');
loadCoreFile('version.php');
loadCoreFile('urlm.php');
loadCoreFile('db_delete.php');
loadCoreFile('db_insert.php');
loadCoreFile('db_replace.php');
loadCoreFile('db_mysql.php');
loadCoreFile('db_mysql_lock_tables.php');
loadCoreFile('db_mysql_unlock_tables.php');
loadCoreFile('db_select.php');
loadCoreFile('db_table_clone.php');
loadCoreFile('db_table_create.php');
loadCoreFile('db_table_delete.php');
loadCoreFile('db_table_move.php');
loadCoreFile('db_update.php');
loadCoreFile('dbquery.php');
loadCoreFile('replacer.php');
loadCoreFile('io_disk.php');
loadCoreFile('logger.php');

// TODO:                                                         
loadCoreFile('Blowfish.php');
loadCoreFile('BigInteger.php');
loadCoreFile('RSA.php');
loadCoreFile('RSA/Math/Math_BigInteger.php');

loadCoreFile('layout_configuration_manager.php');

$application = &new Application();

$application->readAppINI();

$log = &new Logger();


_use($_current_path.'/avactis-system/modules/modules_manager/mm_api.php');
_use($_current_path.'/avactis-system/modules/eventsmanager/events_manager_api.php');

if(!is_dir_writable($application->getAppINI('PATH_CACHE_DIR')))
{
    _fatal(array( "CODE" => "CORE_040"), $application->getAppINI('PATH_CACHE_DIR'));
}

$application->init();

modApiFunc('EventsManager','throwEvent','ApplicationStarted');

function __info_tag_output($tag, $arg_list)
{
    global $application, $zone;
        #                       .
        $view = $application->getLatestTag();
        list($entity, $attr) = getTagName($tag);

        if ($view != null && is_callable(array($view, 'getTag')) && empty($arg_list))
        {
            $view_obj = &$application->getInstance($view);
            $output = $view_obj->getTag($tag);
            if ($output !== null)
            {
                return $output;
            }
        }
        if (empty($arg_list))
        {
            #                        .                   ,                  .
            $params = $application->getTemplateParameters();
            $product_id = $params['product_id'];
            $category_id = $params['category_id'];
        }
        else
        {
            $product_id = $arg_list[0];
            $category_id = $arg_list[0];
        }

        $output = "";
        switch ($entity)
        {
            case 'attribute':
                if(empty($arg_list) || !array_key_exists(0, $arg_list) || !array_key_exists(1, $arg_list))
                    break;
                $obj = &$application->getInstance('Catalog');
                $attributeInfo = $obj->getAttributeInfo($arg_list[0], $arg_list[1]);
                $output = $attributeInfo[strtolower($attr)];
                break;

            case 'product':
                if ($product_id == -1)
                    break;
                $prdobj = &new CProductInfo($product_id);
                if ($prdobj !== null) $output = $prdobj->getProductTagValue($attr);
                break;

            case 'category':
                if ($category_id == -1)
                    break;
                $catobj = &new CCategoryInfo($category_id);
                if ($catobj !== null) $output = $catobj->getCategoryTagValue($attr);
                break;

            case 'msg':
                $obj = &$application->getInstance('MessageResources');
                $output = $obj->getMessage( new ActionMessage($arg_list) );
                break;

            case 'xmsg':
                $obj = &$application->getInstance('MessageResources', modApiFunc("Modules_Manager","getResFileByShortName",$arg_list[0]), 'AdminZone');
                array_shift($arg_list);
                $output = $obj->getMessage( new ActionMessage($arg_list) );
                break;

            case 'hintlink':
                $obj = &$application->getInstance('Hint');
                $output = $obj->getHintLink($arg_list);
                break;

            case 'storeowner':
                $obj = &$application->getInstance('Configuration');
                $output = $obj->getTagValue($tag);
                break;

            case 'pagehelplink':
                loadCoreFile('page_help_tutorial_links.php');
                $obj = &$application->getInstance('HelpLinkCreator');
                $output = $obj->getPageHelpLink($arg_list[0]);
                break;

            case 'videotutoriallink':
                loadCoreFile('page_help_tutorial_links.php');
                $obj = &$application->getInstance('HelpLinkCreator');
                $output = $obj->getTutorialLink($arg_list[0]);
                break;

            case 'shoppingcart':
                $obj = &$application->getInstance('Cart');
                $output = $obj->getCartInfo($tag);
                break;
            case 'paypalproexpresscheckout':
                $output = "";
                break;

            case 'pageurl':
                $req = &new Request();
                $req->setView($arg_list[0]);
                if(isset($arg_list[1]) and is_array($arg_list[1]) and !empty($arg_list[1]))
                {
                    foreach($arg_list[1] as $k => $v)
                        $req->setKey($k,$v);
                };
                $output = $req->getURL();
                break;

            case 'customer':
                if($zone == 'CustomerZone')
                {
                    $account_name = modApiFunc('Customer_Account','getCurrentSignedCustomer');
                    if($account_name != null)
                    {
                        preg_match('/^customer(.+)/i',$tag,$m1);
                        if(preg_match('/^(billing|shipping|orders)(.+)/i',$m1[1],$m2))
                        {
                            $group = $m2[1];
                            $attr = $m2[2];
                        }
                        else
                        {
                            if(in_array(strtolower($attr),array('id','status')))
                            {
                                $group = 'base';
                            }
                            else
                            {
                                $group = 'Customer';
                            };
                            $attr = $m1[1];
                        };
                        $obj = &$application->getInstance('CCustomerInfo',$account_name);

                        if(strtolower($attr) == 'accountname')
                        {
                            $output = prepareHTMLDisplay($obj->getDisplayAccountName());
                            break;
                        };

                        if(strtolower($attr) == 'signouturl')
                        {
                            $r = &new Request();
                            $r->setView(CURRENT_REQUEST_URL);
                            $r->setAction('customer_sign_out');
                            $output = $r->getURL();
                            break;
                        };

                        if(strtolower($group) != 'orders')
                        {
                            $attr_value = $obj->getPersonInfo($attr,$group);

                            switch(strtolower($attr))
                            {
                                case 'country':
                                    $output = modApiFunc('Location','getCountry',$attr_value);
                                    break;
                                case 'state':
                                    if(modApiFunc('Location','getStateCode',$attr_value) != '')
                                        $output = modApiFunc('Location','getState',$attr_value);
                                    else
                                        $output = prepareHTMLDisplay($attr_value);
                                    break;
                                default:
                                    $output = prepareHTMLDisplay($attr_value);
                                    break;
                            };
                        }
                        else
                        {
                            $qstat = ORDER_STATUS_ALL;

                            if(isset($arg_list[0]) and is_string($arg_list[0]))
                            {
                                if(defined('ORDER_STATUS_'.strtoupper($arg_list[0])))
                                    $qstat = constant('ORDER_STATUS_'.strtoupper($arg_list[0]));
                            };

                            $filter = array(
                                'type' => 'quick'
                               ,'order_status' => $qstat
                            );

                            $obj->setOrdersHistoryFilter($filter);

                            switch(strtolower($attr))
                            {
                                case 'quantity':
                                    $output = $obj->getOrdersCount();
                                    break;
                                case 'totalamount':
                                    $output = modApiFunc('Localization','currency_format',$obj->getOrdersAmount());
                                    break;
                                case 'totalfullypaidamount':
                                    $output = modApiFunc('Localization','currency_format',$obj->getOrdersFullyPaidAmount());
                                    break;
                            };
                        };
                    };
                };
                break;
        }
        if ($view != null)
        {
            return $output;
        }
        echo $output;
}

function __block_tag_output($tag, $arg_list)
{
    global $application, $zone;

$_start_time = microtime_float();
$_queries_start_number = sizeof($application->db_stat);

    if ($zone == 'AdminZone' and !class_exists($tag))
    {
        $mm = &$application->getInstance( 'Modules_Manager' );
        $mm->includeViewFileOnce($tag);
    }

    if ($zone == 'CustomerZone' and !class_exists($tag))
    {
        $application->prepareStorefrontBlockTag($tag);
    }

        #          ,                                  view.
        $view = $application->getLatestTag();
        if ($view != null && is_callable(array($view, 'getTag')))
        {
            $view_obj = &$application->getInstance($view);
            $application->pushTag($tag);
            $output = $view_obj->getTag($tag, $arg_list);
            $application->popTag();
            if ($output !== null)
            {
                $_time = round(microtime_float() - $_start_time,2);
                $_queries_number = sizeof($application->db_stat) - $_queries_start_number;
                return __add_block_debug_info($tag, $output, $_time, $_queries_number);
            }
        }

        $obj = &$application->getInstance($tag);
        $application->pushTag($tag);
        $output = call_user_func_array( array( &$obj, 'output' ), $arg_list);
        $application->popTag();
        if ($view != null)
        {
            $_time = round(microtime_float() - $_start_time,2);
            $_queries_number = sizeof($application->db_stat) - $_queries_start_number;
            return __add_block_debug_info($tag, $output, $_time, $_queries_number);
        }

    $_time = round(microtime_float() - $_start_time,2);
    $_queries_number = sizeof($application->db_stat) - $_queries_start_number;
    echo __add_block_debug_info($tag, $output, $_time, $_queries_number);
}

function __block_tag_alias($block_name, $alias_name, $args)
{
    global $application, $zone;

    if($zone == 'CustomerZone')
    {
        $application->setBlockOverride($block_name, $alias_name);
        $out = call_user_func_array($block_name, $args);
        $application->resetBlockOverride($block_name);
        return $out;
    };

    return null;
}

function __add_block_debug_info($tag, $html, $time, $sql_qty)
{
    global $application, $zone;
    if (strtolower($application->getAppIni('ADD_BLOCK_DEBUG_INFO')) == 'yes')
    {
        if (strtolower($application->getAppIni('ADD_BLOCK_DEBUG_INFO_ZONE')) == 'all'
            or strtolower($application->getAppIni('ADD_BLOCK_DEBUG_INFO_ZONE')) == strtolower($zone))
        {
            $html = '<div style="border: 1px solid green;"><div style="background-color: #CCFFFF; font-size: 7pt; text-align: left; color: black; font-weight: normal;">'.$tag.' / '.$time.' sec. / '.$sql_qty.' queries.</div>'.$html.'</div>';
        }
    }
    return $html;
}

?>