<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

_use( dirname(__FILE__).'/ccache_file.php' );


class CCacheSingleFile extends CCacheFile
{
    /**
     * Constructor of the class.
     * Constructor has been optimized. It creates object Cache without any
     * values, that means empty. Values are loaded as required.
     * Object saves all its files in folder
     * $application->getAppIni('PATH_CACHE_DIR'),
     * the files have mask names "_cache.{id}", where id is a hashed key.
     *
     * @return CCache
     */
    function CCacheSingleFile($filename)
    {
        parent::CCacheFile('');
        $this->_fCacheFileMask = '_cache.single.'.$filename;
    }


    /**
     * Deletes the value from cache. It removes the key and its value.
     *
     * @param string $key Cache key
     */
    function reset($key)
    {
        if ( array_key_exists($key, $this->_fData) )
        {
            unset($this->_fData[$key]);
            $this->_save_data();
        }
    }

    function clear()
    {
        if (file_exists($this->_getFileName()))
        {
            unlink($this->_getFileName());
        }

        unset($this->_fData);
        $this->_fData = array();
    }

    function _save_data()
    {
        $data = serialize($this->_fData);

        if (!$handle = @fopen($this->_getFileName(), 'w'))
        {
            return false;
        }

        if (@fwrite($handle, $data) === FALSE)
        {
            return false;
        }

        @fclose($handle);
        return true;
    }

    function _load_data()
    {
		if (!file_exists($this->_getFileName()))
		{
			return;
		}

		if (!is_readable($this->_getFileName()))
		{
			return;
        }

        $this->_fData = unserialize(file_get_contents($this->_getFileName()));
    }

    function _getFileName()
    {
        return $this->_fCacheDir.$this->_fCacheFileMask;
    }

}

?>