<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * @copyright Copyright &copy; 2005, Pentasoft Corp.
 * @package Core
 * @author ag
 */

_use( dirname(__FILE__).'/dbquery.php' );


/**
 * DB_Delete class is used to generate SQL request of type Delete .
 *
 * Example of usage DB_Delete, to generate the DELETE query.
 *<code>
 *  $db_delete = &new DB_Delete('categories');
 *  $db_delete->WhereValue('category_id', DB_EQ, 17);
 *  $db_delete->WhereAND();
 *  $db_delete->WhereValue('category_name', DB_NEQ, 'DVD');
 *  $application->db->PrepareSQL($db_delete);
 *  $application->db->DB_Exec();
 *</code>
 *
 * @access  public
 * @author Alexandr Girin
 * @package Core
 */
class DB_Delete extends DBQuery
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * DB_Delete class constructor.
     *
     * @return
     * @param string $table table name
     */
    function DB_Delete($table)
    {
        global $application;
        $table_prefix = $application->getAppIni('DB_TABLE_PREFIX');
        $this->QueryType=DBQUERY_TYPE_DELETE;
        $this->DeleteTable=$table_prefix.$table;
        $this->WhereList = array();
    }

    /**
     * Gets a table name.
     *
     * @return
     */
    function getDeleteTable()
    {
        return $this->DeleteTable;
    }


    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * The table name, from which data are removed.
     *
     * @var  string parameter
     */
    var $DeleteTable;

    /**#@-*/
}
?>