<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * @copyright Copyright &copy; 2005, Pentasoft Corp.
 * @package Core
 * @author ag
 */
_use(dirname(__FILE__).'/dbquery.php');

/**
 *       DB_Replace -                               SQL              Replace
 *
 * @access  public
 * @author Egor V. Derevyankin
 * @package Core
 */
class DB_Replace extends DBQuery
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     *                    DB_Replace
     *
     * @return
     * @param string $table            
     */
    function DB_Replace($table)
    {
        global $application;
        $this->table_prefix = $application->getAppIni('DB_TABLE_PREFIX');
        $this->QueryType=DBQUERY_TYPE_REPLACE;
        $this->ReplaceTable=$this->table_prefix.$table;
        $this->ReplaceFields=array();
        $this->ReplaceValues=array();
        $this->CopyFromTable="";
    }

    /**
     *                         
     *
     * @return
     * @param string $value         
     * @param string $field         
     */
    function addReplaceValue($value, $field='')
    {
        if ($field!='')
        {
            $field = $this->parseFieldName($field);
            array_push($this->ReplaceFields, $field);
        }
        $value = "'".DBQuery::DBAddSlashes($value)."'";
        array_push($this->ReplaceValues, $value);
    }

    /**
     *                                          
     *
     * @return
     * @param string $value         
     * @param string $field         
     */
    function addReplaceExpression($value, $field='')
    {
        if ($field!='')
        {
            $field = $this->parseFieldName($field);
            array_push($this->ReplaceFields, $field);
        }
        $value = DBQuery::DBAddSlashes($value);
        array_push($this->ReplaceValues, $value);
    }

    /**
     *                              
     *
     * @return string            
     */
    function getReplaceTable()
    {
        return $this->ReplaceTable;
    }

    /**
     *                             ,                               
     *
     * @return array             
     */
    function getReplaceFields()
    {
        return $this->ReplaceFields;
    }

    /**
     *                                
     *
     * @return array                
     */
    function getReplaceValues()
    {
        return $this->ReplaceValues;
    }

    /**
     *                              
     *
     * @return array                
     */
    function setCopyFromTable($tableName)
    {
        $this->CopyFromTable = $this->table_prefix.$tableName;
    }

    /**
     *                                                          
     *
     * @return array                
     */
    function getCopyFromTable()
    {
        return $this->CopyFromTable;
    }


    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     *                                         
     *
     * @var  string
     */
    var $ReplaceTable;
    /**
     *                                          
     *
     * @var  array
     */
    var $ReplaceFields;
    /**
     *                            
     *
     * @var  array
     */
    var $ReplaceValues;

    /**
     *                            
     *
     * @var  string
     */
    var $CopyFromTable;
}
?>