<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * @copyright Copyright &copy; 2002, Pentasoft Corp.
 * @package Core
 * @author ag
 */

define('TEMPLATE_FILE_SIMPLE', 1); //   a plain template file
define('TEMPLATE_FILE_PRODUCT_TYPE', 2); // a template file, depending on the product type
define('TEMPLATE_OPTION_REQUIRED', 3); // a required template option
define('TEMPLATE_OPTION_OPTIONAL', 4); // an optional template option

define('PRICE_N_A', -1000000007);

define('FILTERED_IMPLODE_RIGHT',10001);
define('FILTERED_IMPLODE_LEFT',10002);
define('FILTERED_IMPLODE_BOTH',10003);
define('FILTERED_IMPLODE_NOWHERE',10004);



/**
 * Read recursively stated directory and include all files
 * with specified extension form it.
 *
 * @todo Check file errors, we have to use IO class
 * @access  private
 * @param string $directory The path to directory which will be read
 * @param string $file_extension The file extension which will be included
 * @return array List of included files
 */
function DirRead( $directory, $file_extension )
{
    $insertions_list = array();

    if ( $dir = @dir($directory) )
    {
        while ( $file = $dir->read() )
        {
            if ( !is_dir($directory . $file) )
            {
                if ( substr($file, strrpos($file, '.')) == $file_extension )
                {
                    include_once($directory.$file);
                    array_push( $insertions_list, substr($file, 0, strrpos($file, '.')) );
                }
            }
            elseif ( $file != '..' && $file != '.' )
            {
                $insertions_list = array_merge( $insertions_list, DirRead($directory . $file. '/', $file_extension) );
            }
        }
        $dir->close();
    }

    return $insertions_list;
}

/**
 *                   API                                       .
 *                                                       .
 *                        API               ,                               Extended API             .
 */
function loadClass($classname)
{
	global $application;
	//                                 ,             Modules Manager
	//                                
	if ( !class_exists($classname) )
	{
		$mm = &$application->getInstance('Modules_Manager');
		$mm->includeAPIFileOnce($classname);
	}
}

/**
 * This is an alias of Application::Run() method.
 * It is necessary for comfortable usage in customer's web-site pages
 * to output some view.
 *
 * @see Application::output()
 * @access  public
 * @param string $view_name View name
 * @return string Print HTML code of stated $view_name
 */
function _output($view_name)
{
    global $application;
    echo $application->output($view_name);
}

/**
 * Store log information in log file,
 * for debug purpose.
 *
 * This function is an alias of Logger methods. Three parameters are passed in
 * this function:
 * <ol>
 *  <li> $line - any message
 *  <li> $type - the type of log information, 'message' by default <br>
 *       The possible message types are:
 *       <ul>
 *          <li> 'message' - any message, that has several ways of using:<br>
 *               <code>_debug('Some log message');</code> adds the message
 *                      which specifies the time that has past
 *                      from the beginning of the script execution;
 *               <code>
 * _debug('Some log message', 'message', 'BEGIN');
 * .
 * .
 * .
 * _debug('Some log message', 'message', 'END');
 *               </code>
 *              if the third parameter is 'BEGIN', then the message is written
 *              to the log file. This message contains the time
 *              that has past from the beginning of the script execution. If
 *              the third parameter is 'END', then
 *              in the addition to the same information the time that has past
 *              from logging the message is written. And the label
 *              'BEGIN' is added.
 *          <li> 'class' is a list of defined classes<br>
 *               <code>_debug('', 'class');</code>
 *          <li> 'var'Logs to the log file the name and the value of variable<br>
 *               <code>
 * $a = 12;
 * $b = $a +3;
 * _debug($a, 'var', 'a');
 * _debug($b, 'var', 'b');
 *               </code>
 *              A variable name or any message is passed in as the third
 *              parameter. <br>
 *              The whole list of defined variables can be outputted:
 *               <code>_debug(get_defined_vars(), 'var');</code>
 *          <li> 'func' - a list of defined user functions<br>
 *               <code>_debug('', 'func');</code>
 *          <li> 'const' - a list of defined user and standard constants<br>
 *               <code>_debug('', 'const');</code>
 *       </ul>
 *
 *  <li> $mark - an optional parameter. There are 2 ways of using it.
 *   1. If $type = 'message' then 'BEGIN' or 'END' can be used as values.
 *   2. If $type = 'var', then the name of variable, passed in parameter
 *      $line, is used as value
 * </ol>
 *
 * @access  public
 * @param string $line any message
 * @param string $type the type of log information
 * @param string $mark an optional parameter, 'NOMARK' by default
 */
function _debug($line, $type = 'message', $mark='NOMARK')
{
    $write_log = modApiFunc('application', 'getAppIni', 'WRITE_LOG');
    if ($write_log == 'DISABLED')
    {
        return;
    }
    global $log;
    switch ($type)
    {
        case 'message':
            $log->DisplayMessage($line, $mark);
            break;
        case 'class':
            $log->DisplayDeclaredClasses();
            break;
        case 'var':
            $log->DisplayDefinedVars($line, $mark);
            break;
        case 'func':
            $log->DisplayDefinedFunctions();
            break;
        case 'const':
            $log->DisplayDefinedConstants();
            break;
        case 'gettime':
            $log->BlockExecuteTime($line);
            break;
        case 'time':
            $log->DisplayTime();
            break;
        case 'show':
            $log->ShowLog();
            break;
    }
}

function __dump($msg, $filepath = './__dump.txt')
{
    $h=fopen($filepath, 'ab');
    fwrite($h,$msg."\n");
    fclose($h);
}

/**
 * Includes once a file in the modules folder.
 *
 * @access  public
 * @param string $file
 */
function _use($file)
{
    include_once( $file );
}

/**
 * The global function to generate the fatal error.
 *
 * <code>
 * _fatal(string $code [, mixed $var1 [, mixed $var2 [, ...]]])
 * </code>
 * Error code $code and a certain number of variables are passed in
 * the function. They are inserted to the text of the error message,
 * which matches the error code. Error codes and their texts are stored
 * in the resource files templates/resources/<module_name>.ini
 *
 * @see Resource
 * @see _warning()
 * @todo function is not completed
 * @access public
 * @return
 */
function _fatal($msg)
{
    global $application;

    $numargs = func_num_args();
    $listargs = func_get_args();
    $args = array();
    if ($numargs > 1)
    {
        for ($i=1; $i<$numargs; $i++)
        {
            $args['{'.($i-1).'}'] = $listargs[$i];
        }
    }

    $lang = strtolower($application->getAppIni('LANGUAGE'));
    if ( !isset($lang) || $lang=='' )
    {
        $lang = 'eng';
    }
    $path = $application->getAppIni('PATH_ADMIN_RESOURCES');
    $filename = 'system-messages-'.$lang.'.ini';
    $messages_resources = @_parse_ini_file($path . $filename);
    if (is_array($listargs[0]))
    {
        if (isset($messages_resources[$listargs[0]["CODE"]]))
        {
            $header = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"\n";
            $header.= "\"http://www.w3.org/TR/html4/loose.dtd\">\n";
            $header.= "<HTML><HEAD><TITLE>Tags Errors and Warnings</TITLE>";
            $header.= "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=windows-1251\">\n";
            $header.= "<LINK HREF=\"style/style.css\" TYPE=\"text/css\" REL=\"stylesheet\">\n";
            $header.= "<script src=\"javascript/menu.js\" type=\"text/javascript\"></SCRIPT>\n";
            $header.= "</HEAD><BODY>\n";
            $header.= "<style type=\"text/css\">\n";
            $header.= "<!--\n";
            $header.= ".title{background-color: #C0C0C0; font-size: 12px; font-family: verdana; font-weight: bold; \n";
            $header.= "       border-right: solid #505050 1px; border-bottom: solid #505050 1px; \n";
            $header.= "       border-left: solid #FFFFFF 1px; border-top: solid #FFFFFF 1px;}\n";
            $header.= ".subtitle{background-color: #E0E0E0; font-size: 11px; font-family: verdana; font-weight: bold; \n";
            $header.= "       border-right: solid #C0C0C0 1px; border-bottom: solid #C0C0C0 1px; \n";
            $header.= "       border-left: solid #FFFFFF 1px; border-top: solid #FFFFFF 1px;}\n";
            $header.= ".message{background-color: #FAFAFA; font-size: 10px;\n";
            $header.= "       border-right: solid #E0E0E0 1px; border-bottom: solid #E0E0E0 1px; \n";
            $header.= "       border-left: solid #FFFFFF 1px; border-top: solid #FFFFFF 1px;}\n";
            $header.= "-->\n";
            $header.= "</style>\n";
            $header.= "<center>\n";
            $header.= "<TABLE width=\"80%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\" style=\"padding-top: 50px;\">\n";

            $subtitle = "<tr><td width=\"100%%\" class=\"title\">%s</td></tr>\n";
            $subtitle.= "<tr><td>\n<table width=\"100%%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n";
            $subtitle.= "<tr><td class=\"subtitle\"";
            $subtitle.= "width=\"10%%\">Error Code</td>\n";
            $subtitle.= "<td class=\"subtitle\"";
            $subtitle.= "width=\"90%%\">Error Source</td></tr>%s</table></td></tr>\n";

            $tablecontent = "<tr><td class=\"subtitle\" style=\"background-color: #FAFAFA;\">%s</td>\n";
            $tablecontent.= "<td class=\"subtitle\">";
            $tablecontent.= "<table width=\"100%%\" cellpadding=\"5\" cellspacing=\"0\" border=\"0\">%s</table></td></tr>\n";

            $source_line = "<tr><td class=\"message\" width=\"10%%\">%s</td>\n";
            $source_line.= "<td class=\"message\" style=\"font-weight: normal;\" width=\"90%%\">%s</td></tr>\n";

            $output = $header;
            $source = "";
            if (isset($listargs[0]["FILE"]))
            {
                $source.= sprintf($source_line, "File:", $listargs[0]["FILE"]);
            }
            if (isset($listargs[0]["LINE"]))
            {
                $source.= sprintf($source_line, "Line:", $listargs[0]["LINE"]);
            }
            if (isset($listargs[0]["SECTION"]))
            {
                $source.= sprintf($source_line, "Section:", "[".$listargs[0]["SECTION"]."]");
            }
            if (isset($listargs[0]["DIRECTIVE"]))
            {
                $source.= sprintf($source_line, "Directive:", $listargs[0]["DIRECTIVE"]);
            }
            if (isset($listargs[0]["MODULE"]))
            {
                $source.= sprintf($source_line, "Module:", $listargs[0]["MODULE"]);
            }
            $source.= sprintf($source_line, "Message:", strtr($messages_resources[$listargs[0]["CODE"]], $args));
            $content = sprintf($tablecontent, $listargs[0]["CODE"], $source);
            $output.= sprintf($subtitle, "FATAL Core Error", $content);

            $footer = "</table></center></BODY></HTML>";
            $output.= $footer;
            die($output);
        }
        else
        {
            die(print_r($listargs[0],true));
        }
    }
    else
    {
        die('<B><FONT COLOR="red">FATAL ERROR</FONT></B><br> '.$msg);
    }
}

/**
 * Function is used for calling all the API methods
 * of main classes of modules.
 *
 * The first parameter is the class name,
 * the second one is the name of the called method.
 * Then an unlimited number of parameters for called method can follow.
 * An example:
 * <code>
 * // Sets a current category in catalog
 * modApiFunc('Catalog', 'setCurrentCategoryID', $curr_cat_id);
 *
 * // Gets a current category in catalog
 * $cid = modApiFunc('Catalog', 'getCurrentCategoryID');
 *
 * // A general example of using the function
 * $retval = modApiFunc('Class_Name', 'methodName', $par1, $par2, $par3);
 * </code>
 *
 * This function always calles the object of specified class by reference.
 *
 * @todo Use resources for error reporting and add an error handling mechanism.
 * @author Alexey Florinsky
 * @access  public
 * @return mixed The result of API method execution
 * @param string $className Class name
 * @param string $methodName Method name in the class
 */
function modApiFunc($className, $methodName)
{
    global $application;
    # Get a list of passed parameters
    $arg_list = func_get_args();

    # Remove first two parameters from the list
    array_shift($arg_list);
    array_shift($arg_list);

        if ( $className == strtolower('application') )
        {
            $classObj = &$application;
        }
        else
        {
            $classObj = &$application->getInstance( $className );
        }

        if ( method_exists( $classObj, $methodName ) )
        {
            return call_user_func_array( array( &$classObj, $methodName ), $arg_list);
        }
        else
        {
            _fatal(array( "CODE" => "CORE_044"), $className, $methodName);
        }

    return NULL;
}

/**
 *                                      modApiFunc,                    ,    
 *                                               .
 *
 *      ,                                       ,                        .
 */
function modApiStaticFunc($className, $methodName)
{
    global $application;
    # Get a list of passed parameters
    $arg_list = func_get_args();

    # Remove first two parameters from the list
    array_shift($arg_list);
    array_shift($arg_list);

    $mmObj = &$application->getInstance('Modules_Manager');
    $mmObj->includeAPIFileOnce($className);
	return call_user_func_array(array($className, $methodName),$arg_list);
}


/**
 * The global function to generate the warnings.
 *
 * <code>
 * _warning(string $code [, mixed $var1 [, mixed $var2 [, ...]]])
 * </code>
 * Warning code $code and a certain number of variables are passed in
 * the function. They are inserted to the text of the error message,
 * which matches the warning code. Error codes and their texts are stored
 * in the resource files templates/resources/<module_name>.ini
 *
 * @see Resource
 * @see _error()
 *
 * @access public
 * @return
 */
function _warning()
{
    $numargs = func_num_args();
    $listargs = func_get_args();
    $args = array();
    if ($numargs > 1)
    {
        for ($i=1; $i<$numargs; $i++)
        {
            $args['{'.($i-1).'}'] = $listargs[$i];
        }
    }
    global $application;
    $error = &$application->getInstance('Error');
    $error->setErrorCode(func_get_arg(0), $args, 'warning');
}

/**
 * Searches some value in the multidimensional array.
 *
 * @return Array  The array, which describes a path to the found element.
 * FALSE if the element wasn't found.
 */
function multi_array_search($search_value, $the_array)
{
   if (is_array($the_array))
   {
       foreach ($the_array as $key => $value)
       {
           $result = multi_array_search($search_value, $value);
           if (is_array($result))
           {
               $return = $result;
               array_unshift($return, $key);
               return $return;
           }
           elseif ($result == true)
           {
               $return[] = $key;
               return $return;
           }
       }
       return false;
   }
   else
   {
       if ($search_value == $the_array)
       {
           return true;
       }
       else return false;
   }
}

/**
 * Simple function to replicate PHP 5 behaviour.
 */
function microtime_float()
{
   list($usec, $sec) = explode(" ", microtime());
   return ((float)$usec + (float)$sec);
}

/**
 * Checks if the specified key in this array is an empty string.
 *
 * @param $key String the key
 * @param $array Array the array of values
 * @return boolean
 */
function isEmptyKey($key, $array)
{
	if (!array_key_exists($key, $array) || trim($array[$key]) == '')
		return true;
	return false;
}

/**
 * Returns the value from the associative array by the case-insensitive key.
 */
function getKeyIgnoreCase($key, $array)
{
    if (!is_array($array))
    {
    	return null;
    }

	$key = strtolower($key);
	foreach ($array as $_key => $_value)
	{
		if ($key === strtolower($_key))
		{
			return $_value;
		}
	}
	return null;
}

/**
 * ready HTML output
 * <br>
 * Gets a variable, cleaning it up such that the text is
 * shown exactly as expected, except for allowed HTML tags which
 * are allowed through
 *
 * @param var variable to prepare
 * @param ...
 * @returns string/array
 * @return prepared variable if only one variable passed
 * in, otherwise an array of prepared variables
 */
function prepareHTMLDisplay()
{
    // This search and replace finds the text 'x@y' and replaces
    // it with HTML entities, this provides protection against
    // email harvesters
    //
    // Note that the use of \024 and \022 are needed to ensure that
    // this does not break HTML tags that might be around either
    // the username or the domain name
//    static $search = array('/([^\024])@([^\022])/se');
//
//    static $replace = array('"&#" .
//                            sprintf("%03d", ord("\\1")) .
//                            ";&#064;&#" .
//                            sprintf("%03d", ord("\\2")) . ";";');

    $resarray = array();
    foreach (func_get_args() as $ourvar) {
        // Preparse var to mark the HTML that we want
//            $ourvar = preg_replace($allowedhtml, "\022\\1\024", $ourvar);

        // Prepare var
        $ourvar = htmlspecialchars($ourvar);
//        $ourvar = preg_replace($search, $replace, $ourvar);
//
//        // Fix the HTML that we want
//        $ourvar = preg_replace('/\022([^\024]*)\024/e',
//                               "'<' . strtr('\\1', array('&gt;' => '>',
//                                                         '&lt;' => '<',
//                                                         '&quot;' => '\"',
//                                                         '&amp;' => '&'))
//                               . '>';", $ourvar);
//
//        // Fix entities if required
//            if (pnConfigGetVar('htmlentities')) {
//            $ourvar = preg_replace('/&amp;#/', '&#', $ourvar);
//            }

        // Add to array
        array_push($resarray, $ourvar);
    }

    // Return vars
    if (func_num_args() == 1) {
        return $resarray[0];
    } else {
        return $resarray;
    }
}

/**
 * Extracts a tag name from the full name used in the system.
 * Examples: <br/>
 * - input: ProductName output: array('product' => 'name') <br/>
 * - input: CategoryDescr output: array('category' => 'descr') <br/>
 * An input case-insesitive parameter. The result is output in lower case.
 *
 * @return array (entity, tag). entity: 'product', 'category', 'attribute',
 * 'msg', 'group', 'order', 'customer'. tag: the tag name.
 */
function getTagName($full_tag)
{
    $full_tag = strtolower($full_tag);
    $entity = '';
    $tag = '';
    if (preg_match("/^(product)(.+)(custom)$/", $full_tag, $matches))
    {
        $full_tag = substr($full_tag, 0, (strlen($full_tag)-6));
    }
	if (strpos($full_tag, 'product') === 0)
	{
	    $entity = 'product';
	    $tag = substr($full_tag, strlen($entity));
	}
	elseif (strpos($full_tag, 'category') === 0)
	{
	    $entity = 'category';
	    $tag = substr($full_tag, strlen($entity));
	}
	elseif (strpos($full_tag, 'attribute') === 0)
	{
	    $entity = 'attribute';
	    $tag = substr($full_tag, strlen($entity));
	}
	elseif (strpos($full_tag, 'msg') === 0)
	{
	    $entity = 'msg';
	    $tag = substr($full_tag, strlen($entity));
	}
    elseif (strpos($full_tag, 'xmsg') === 0)
    {
        $entity = 'xmsg';
        $tag = substr($full_tag, strlen($entity));
    }
	elseif (strpos($full_tag, 'hintlink') === 0)
	{
	    $entity = 'hintlink';
	    $tag = substr($full_tag, strlen($entity));
	}
	elseif (strpos($full_tag, 'pagehelplink') === 0)
	{
	    $entity = 'pagehelplink';
	    $tag = substr($full_tag, strlen($entity));
	}
	elseif (strpos($full_tag, 'videotutoriallink') === 0)
	{
	    $entity = 'videotutoriallink';
	    $tag = substr($full_tag, strlen($entity));
	}
	elseif (strpos($full_tag, 'group') === 0)
	{
	    $entity = 'group';
	    $tag = substr($full_tag, strlen($entity));
	}
	elseif (strpos($full_tag, 'order') === 0)
	{
	    $entity = 'order';
	    $tag = substr($full_tag, strlen($entity));
	}
	elseif (strpos($full_tag, 'customer') === 0)
	{
	    $entity = 'customer';
	    $tag = substr($full_tag, strlen($entity));
	}
	elseif (strpos($full_tag, 'step') === 0)
	{
	    $entity = 'step';
	    $tag = substr($full_tag, strlen($entity));
	}
	elseif (strpos($full_tag, 'storeowner') === 0)
	{
	    $entity = 'storeowner';
	    $tag = substr($full_tag, strlen($entity));
	}
	elseif (strpos($full_tag, 'shoppingcart') === 0)
	{
	    $entity = 'shoppingcart';
	    $tag = substr($full_tag, strlen($entity));
	}
    elseif (strpos($full_tag, 'pageurl') === 0)
    {
        $entity = 'pageurl';
        $tag = substr($full_tag, strlen($entity));
    }
	else
	{
	    $entity = 'unknown';
		$tag = $full_tag;
	}

	return array($entity, $tag);
}

/**
 * Returns the server's current time, which is updated by the system settings.
 *
 * @return integer timestamp
 */
function getServerTime()
{
	$current_time = time();
	$time_shift = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_TIME_SHIFT);
	$current_time += ($time_shift * 60 * 60);
	return $current_time;
}

function _parse_ini_file($filename, $process_sections = false)
{
    if (phpversion()<5)
    {
        return @parse_ini_file($filename, $process_sections);
    }
    $retval = array();
    if (!file_exists($filename))
    {
        return $retval;
    }
    $section = "";
    $fp = fopen($filename, "r");
    while (!feof($fp))
    {
        $line = trim(fgets($fp));
        if (strlen($line) == 0 || $line[0] == ";")
        {
            continue;
        }
        if ($line[0] == "[")
        {
            if (!$process_sections)
            {
                continue;
            }
            else
            {
                $section = strtr($line, array("["=>"", "]"=>""));
                $retval[$section] = array();
            }
        }
        else
        {
            list($key, $val) = parse_ini_line($line);
            if ($key)
            {
                if (!$process_sections)
                {
                    $retval[$key] = $val;
                }
                else
                {
                    $retval[$section][$key] = $val;
                }
            }
        }
    }
    return $retval;
}

function parse_ini_line($line)
{
    if (strpos($line, "=") === false)
    {
        return array(null, null);
    }
    if (strpos($line, '"') && strpos($line, "=") > strpos($line, '"'))
    {
        return array(null, null);
    }
    $key = trim(substr($line, 0, strpos($line, "=")));
    $val = trim(substr($line, (strpos($line, "=")+1)));
    if (strlen($val) && $val[0] == '"')
    {
        $val = substr($val, 1);
        $val = substr($val, 0, strpos($val, '"'));
    }
    return array($key, $val);
}

/**
 * It equals the php function array_merge_recursive and merges two arrays
 * recursively. It differs from the standard function in that numeral keys of
 * the resulting array are not overidden.
 *
 * @param array $array1 - first array
 * @param array $array2 - second array
 * @return array - merged array
 */
function _array_merge_recursive($array1, $array2)
{
    foreach ($array2 as $key => $val)
    {
        if (is_array($val))
        {
            if (isset($array1[$key]))
            {
                $array1[$key] = _array_merge_recursive($array1[$key], $val);
            }
            else
            {
                $array1[$key] = $val;
            }
        }
        else
        {
            $array1[$key] = $val;
        }
    }
    return $array1;
}

/**
 * bin2hex
 */
function hex2bin($data)
{
    $len = strlen($data);
    return pack("H" . $len, $data);
}

/**
 * Sends a chunk of data, which can be put in one query without loading,
 * as a file.
 *
 */
function _send_data_as_file_in_one_chunk($file_name, $file_content)
{
    if(!empty($file_name))
    {
        header ("HTTP/1.1 200 OK\n");
        header ("Content-Length: ".strlen($file_content));
        header ("Pragma: public");
        header ("Expires: 0");
        header ("Cache-Control: must-revalidate, post-check=0, pre-check=0");
        header ("Cache-Control: private",false);
        header ("Content-Type: text/plain; charset=ISO 8859-1");
        header ("Content-Disposition: attachment; filename=\"".$file_name."\"");
        header ("Content-Transfer-Encoding: binary");
        print $file_content;
    }
}

function clone_db_table_info($APIClassName, $TableName, $NewTableName="")
{
    global $application;

    if (!$NewTableName)
    {
        $NewTableName = $TableName."_copy";
    }
    $tables = modApiFunc($APIClassName, "getTables");
    $table_info_old = $tables[$TableName];
    $table_info_new = $table_info_old;
    foreach($table_info_old['columns'] as $key => $value)
    {
        $table_info_new['columns'][$key] = str_replace
        (
             $TableName . ".",
             $NewTableName . ".",
             $value
        );
    }
    return $table_info_new;
}

/**
 * Appends a new key with the value to the end of the array.
 * That means the key must be the last thing when viewing
 * the array with the foreach.
 */
function asc_assoc_array_push_back(&$array, $key, $value)
{
    $array[$key] = $value;
}

/**
 * Moves the element (if it exists) to the end of the array.
 * That means the key must be the last thing when viewing
 * the array with the foreach.
 */
function asc_assoc_array_move_back(&$array, $key)
{
	if(isset($array[$key]))
	{
		$value = $array[$key];
		unset($array[$key]);
		asc_assoc_array_push_back($array, $key, $value);
	}
}

function asc_file_put_contents($filepath, $contents)
{
    $h=fopen($filepath,"w");
    fwrite($h, $contents);
    fclose($h);
}

/**
 * wrapper for array_combine function.
 */
function asc_array_combine($keys, $values)
{
    if(version_compare(phpversion(),"5.0.0")!=-1)
    {
        return array_combine($keys, $values);
    }
    else
    {
        $ck = reset( $keys );
        $cv = reset( $values );
        $c = array();
        while ( $ck && $cv )
        {
            $c[$ck] = $cv;
            $ck = next( $keys );
            $cv = next( $values );
        }
        return $c;
     };
}

function asc_detect_eol($fpath)
{
    $_eol = "\n";

    $flag = false;
    $fh = fopen($fpath,'rb');
    while(!$flag and !feof($fh))
    {
        $c = fread($fh,1);
        if($c=="\n")
        {
            $_eol = "\n";
            $flag = true;
        }
        elseif($c=="\r")
        {
            $nc = fread($fh,1);
            if($nc == "\n")
                $_eol = "\r\n";
            else
                $_eol = "\r";
            $flag = true;
        }
    };

    return $_eol;
};

function asc_mac2nix($src)
{
    $fh = fopen($src,'r+b');
    while(!feof($fh))
    {
        $c = fread($fh,1);
        if($c=="\r")
        {
            fseek($fh,-1,SEEK_CUR);
            fwrite($fh,"\n");
        };
    };
    fclose($fh);
}

function printNavCell($shortModuleName, $msgKeyHeader,$msgKeyDescription,$onClick)
{
    $tpl =  '<div class="InactiveNavCellBorder" id="NavCell%UID%" '
           .'     onMouseOver="NavCellMouseOver(this.id);" onMouseOut="NavCellMouseOut(this.id);">'
           .'     <div class="InactiveNavCellContent" id="NavCell%UID%_content" '
           .'          onclick="%HREF%"> '
           .'               <B><span id="NavCell%UID%_header" class="InactiveNavCellHeader">%HEADER%</span></B> '
           .'               <BR><BR>%DESCR% '
           .'    </div> '
           .'</div> ';

    static $_uid = 1000;
    $_uid++;

    $_href = $onClick;

    global $application;
    if ($shortModuleName == null)
        $obj = &$application->getInstance('MessageResources');
    else
        $obj = &$application->getInstance('MessageResources', modApiFunc("Modules_Manager","getResFileByShortName",$shortModuleName), 'AdminZone');
    $_header = $obj->getMessage( new ActionMessage(array($msgKeyHeader)) );
    $_descr = $obj->getMessage( new ActionMessage(array($msgKeyDescription)) );

    echo strtr($tpl, array('%UID%'=>$_uid, '%HREF%'=>$_href, '%HEADER%'=>$_header, '%DESCR%'=>$_descr ));
}

function NB_0071() {echo "";}

function str_rev_pad($str,$length,$symbol="...")
{
    if(strlen($str) <= $length)
        return $str;

    $pl = ceil($length / 2) - ceil(strlen($symbol) / 2);

    return substr($str,0,$pl).$symbol.substr($str,(-1)*$pl);
};

function log_info($text)
{
    modApiFunc('SystemLog','addMessage',$text,SYSLOG_INFO);
}

function log_error($text)
{
    modApiFunc('SystemLog','addMessage',$text,SYSLOG_ERROR);
}

function log_warn($text)
{
    modApiFunc('SystemLog','addMessage',$text,SYSLOG_WARNING);
}

function log_debug($text)
{
    modApiFunc('SystemLog','addMessage',$text,SYSLOG_DEBUG);
}

function getip()
{
    static $ip = false;
    if ($ip !== false) return $ip;

    foreach ( array('HTTP_CLIENT_IP', 'HTTP_X_FORWARDED_FOR', 'HTTP_X_FORWARDED',
                    'HTTP_FORWARDED_FOR', 'HTTP_FORWARDED', 'REMOTE_ADDR') as $aah)
    {
        if (!isset($_SERVER[$aah])) continue;
        $curip = $_SERVER[$aah];
        $curip = explode('.', $curip);
        if (count($curip) !== 4) break; // If they've sent at least one invalid IP, break out

        foreach ($curip as $sup) if (($sup = intval($sup)) < 0 or $sup > 255) break 2;

        $curip_bin = $curip[0] << 24 | $curip[1] << 16 | $curip[2] << 8 | $curip[3];
        foreach (array(
            //    hexadecimal ip  ip mask
            array(0x7F000001,     0xFFFF0000), // 127.0.*.*
            array(0x0A000000,     0xFFFF0000), // 10.0.*.*
            array(0xC0A80000,     0xFFFF0000), // 192.168.*.*
            ) as $ipmask)
        {
            if (($curip_bin & $ipmask[1]) === ($ipmask[0] & $ipmask[1])) break 2;
        }
        return $ip = $curip;
    }
    return $ip = $_SERVER['REMOTE_ADDR'];
}

function cz_msg()
{
    global $application;
    $obj = &$application->getInstance('MessageResources','messages','CustomerZone');
    $args = func_get_args();
    return $obj->getMessage(new ActionMessage($args));
}

function getCharset($zone = "CZ")
{
    global $application;
    $charset = "STOREFRONT_CHARSET";
    switch ($zone)
    {
        case "AZ":
            $charset = "ADMIN_ZONE_CHARSET";
            break;
        case "NTFC":
            $charset = "NOTIFICATIONS_CHARSET";
            break;
        default:
            $charset = "STOREFRONT_CHARSET";
            break;
    }
    return $application->getAppIni($charset);
}

function Charset($zone = "CZ")
{
    echo getCharset($zone);
}

/**
 *                                            $list                        $glue.
 *                              implode                    ,    
 *                         $list                                                 
 *         $glue.
 *
 *                               $add_glue_to_end,                              
 *         $glue                              .                   :
 * FILTERED_IMPLODE_NOWHERE -                     $glue         (  -         ),
 * FILTERED_IMPLODE_BOTH -           $glue                   ,
 * FILTERED_IMPLODE_LEFT -           $glue      ,
 * FILTERED_IMPLODE_RIGHT -           $glue       .
 *
 *                                                    isempty($var).
 *
 *       :
 * <code>
 * $list = array(1,2,'',4,null,6);
 * $glue = "|";
 * echo filtered_implode($glue, $list); // 1|2|4|6
 * echo filtered_implode($glue, $list, FILTERED_IMPLODE_BOTH); // |1|2|4|6|
 * </code>
 *
 * @param string $glue                  
 * @param arrau $list                 :       ,      .
 * @param const $add_glue_to_end                  FILTERED_IMPLODE_NOWHERE,
 * FILTERED_IMPLODE_BOTH, FILTERED_IMPLODE_LEFT, FILTERED_IMPLODE_RIGHT.
 */
function filtered_implode($glue, $list, $add_glue_to_end = FILTERED_IMPLODE_NOWHERE)
{
    $str = implode($glue, array_filter($list));
    if (empty($str))
    {
        return $str;
    }
    else
    {
        $_left = '';
        $_right = '';
        switch($add_glue_to_end)
        {
            case FILTERED_IMPLODE_BOTH:
                $_left = $_right = $glue;
                break;
            case FILTERED_IMPLODE_LEFT:
                $_left = $glue;
                break;
            case FILTERED_IMPLODE_RIGHT:
                $_right = $glue;
                break;
        }
        $func = create_function('$var','return !isempty($var);');
        return $_left . implode($glue, array_filter($list, $func)) . $_right;
    }
}

/**
 * From http://www.php.net/manual/en/function.empty.php#74093
 *
 * The following things are considered to be empty:
 * unset variable ($unset)
 * empty string ($var = "")
 * null string ($var = null)
 * single space ($var = " ")
 * several space ($var = "    ")
 * empty array ($var = array())
 */
function isempty($var)
{
    if ( ( (is_null($var) || rtrim($var) == "") && $var !== false )
         or
         ( is_array($var) && empty($var) )
       )
    {
        return true;
    }
    else
    {
        return false;
    }
}

?>