<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
_use( dirname(__FILE__).'/version.php' );
define("VIDEO_TUTORIALS_URL", "http://video.avactis.com/version.".PRODUCT_VERSION_NUMBER."/");

/**
 * Creates references to Page Help and Video Tutorials.
 *
 * @package Core
 * @access public
 * @author Alexey Florinsky
 */
class HelpLinkCreator
{

    /**
     * Creates the HelpLinkCreator object.
     * @access public
     */
	function HelpLinkCreator()
	{
        global $application;

        $this->initCodeList();

        // getting lables from message resources
        $obj = &$application->getInstance('MessageResources');
        $pagehelp_label = $obj->getMessage( new ActionMessage('PAGE_HELP_LABEL') );
        $tutorial_label = $obj->getMessage( new ActionMessage('VIDEO_TUTORIAL_LABEL') );

        // the template variable %HELP_URL% will be replaced by URL
        $this->pagehelp_link_template = '<A HREF="javascript: void(0);" onclick="javascript:openURLinNewWindow(\'%HELP_URL%\');">'.$pagehelp_label.'</A>';
        $this->tutorial_link_template = '<A HREF="javascript: void(0);" onclick="javascript:openURLinNewWindow(\'%HELP_URL%\');">'.$tutorial_label.'</A>';

        // where files located (relative to Admin Zone)
        // the template variable %PAGE_NAME% will be replaced by page name form the code_list
        $this->pagehelp_path_template = 'pagehelp/PHelpEn/%PAGE_HELP_NAME%.php';
        $this->tutorial_path_template = VIDEO_TUTORIALS_URL.'VideoEn%VIDEO_TUTORIAL_NAME%.php';
	}


    /**
     * Creates a list of pairs ('code' => 'page name').
     * By this list the page name will be defined and put to the refence template.
     *
     * @access public
     */
    function initCodeList()
    {
        $this->code_list =
        array(
               'add_custome_attr_big_text'    => array( 'VIDEO_TUTORIAL_NAME'  => 'AddCustomeAttributeBigText',
                                                        'PAGE_HELP_NAME' => 'Big_Text_Attribute',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'add_custome_attr_single_line' => array( 'VIDEO_TUTORIAL_NAME'  => 'AddCustomeAttributeSingleLine',
                                                        'PAGE_HELP_NAME' => 'Single_Line_Attribute',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'admin'                        => array( 'VIDEO_TUTORIAL_NAME'  => 'Admin',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'admin_add_member'             => array( 'VIDEO_TUTORIAL_NAME'  => 'AdminAddMember',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'admin_backup'                 => array( 'VIDEO_TUTORIAL_NAME'  => 'AdminBackup',
                                                        'PAGE_HELP_NAME' => 'Data_Backup_XRestore',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'admin_delete_member'          => array( 'VIDEO_TUTORIAL_NAME'  => 'AdminDeleteMember',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'admin_edit_member'            => array( 'VIDEO_TUTORIAL_NAME'  => 'AdminEditMember',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'admin_member_info'            => array( 'VIDEO_TUTORIAL_NAME'  => 'AdminMemberInfo',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'admin_member_list'            => array( 'VIDEO_TUTORIAL_NAME'  => 'AdminMemberList',
                                                        'PAGE_HELP_NAME' => 'Admin_Members',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'admin_password_update'        => array( 'VIDEO_TUTORIAL_NAME'  => 'AdminPasswordUpdate',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'admin_server_info'            => array( 'VIDEO_TUTORIAL_NAME'  => 'AdminServerInfo',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),


               'campaigns'                    => array( 'VIDEO_TUTORIAL_NAME'  => 'campaigns',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'catalog_add_category'         => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogAddCategory',
                                                        'PAGE_HELP_NAME' => 'Add_Category',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_add_product'          => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogAddProduct',
                                                        'PAGE_HELP_NAME' => 'Add_New_Product',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_category_info'        => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogCategoryInfo',
                                                        'PAGE_HELP_NAME' => 'Category_Info',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'catalog_delete_category'      => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogDeleteCategory',
                                                        'PAGE_HELP_NAME' => 'Delete_Category',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_delete_product_type'  => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogDeleteProductType',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_delete_products'      => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogDeleteProducts',
                                                        'PAGE_HELP_NAME' => 'Delete_Products',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_edit_category'        => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogEditCategory',
                                                        'PAGE_HELP_NAME' => 'Edit_Category',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_edit_product'         => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogEditProduct',
                                                        'PAGE_HELP_NAME' => 'Edit_Product',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_edit_product_type'    => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogEditProductType',
                                                        'PAGE_HELP_NAME' => 'Edit_Product_Type',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_info_product'         => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogInfoProduct',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'catalog_manage_categories'    => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogManageCategories',
                                                        'PAGE_HELP_NAME' => 'Manage_Categories',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_manage_product_types' => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogManageProductTypes',
                                                        'PAGE_HELP_NAME' => 'Manage_Product_Types',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_manage_products'      => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogManageProducts',
                                                        'PAGE_HELP_NAME' => 'Manage_Products',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_move_category'        => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogMoveCategory',
                                                        'PAGE_HELP_NAME' => 'Move_Category',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_move_copy_products'   => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogCopyProducts',
                                                        'PAGE_HELP_NAME' => 'Copy_Products',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'catalog_move_products'        => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogMoveProducts',
                                                        'PAGE_HELP_NAME' => 'Move_Products',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_new_product_type'     => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogNewProductType',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_sort_products'        => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogSortProducts',
                                                        'PAGE_HELP_NAME' => 'Sort_Products',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_sort_subcategories'   => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogSortSubcategories',
                                                        'PAGE_HELP_NAME' => 'Sort_Categories',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'catalog_tab'                  => array( 'VIDEO_TUTORIAL_NAME'  => 'CatalogTab',
                                                        'PAGE_HELP_NAME' => 'Catalog_Management',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'checkout_info'                => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Checkout_Form_Editor',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'checkout_info_sort_group'     => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Sequence_of_checkout_info_attributes_for_Customer_Information',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'config_store_owner_profile'  => array( 'VIDEO_TUTORIAL_NAME'  => 'ConfigStoreOwnerProfile',
                                                        'PAGE_HELP_NAME' => 'Store_Owner',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),


               'customer_care'                => array( 'VIDEO_TUTORIAL_NAME'  => 'CustomerCare',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'customer_info'                => array( 'VIDEO_TUTORIAL_NAME'  => 'CustomerInfo',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'customers_tab'                => array( 'VIDEO_TUTORIAL_NAME'  => 'CustomersTab',
                                                        'PAGE_HELP_NAME' => 'Customers',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),


               'edit_custome_attr_single_line'=> array( 'VIDEO_TUTORIAL_NAME'  => 'EditCustomeAttributeSingleLine',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'edit_custome_attr_big_text'   => array( 'VIDEO_TUTORIAL_NAME'  => 'EditCustomeAttributeBigText',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'general_settings'             => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsGeneralSettings',
                                                        'PAGE_HELP_NAME' => 'General_Settings',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'help'                         => array( 'VIDEO_TUTORIAL_NAME'  => 'help',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'home_tab'                     => array( 'VIDEO_TUTORIAL_NAME'  => 'HomeTab',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),


               'location_countries'           => array( 'VIDEO_TUTORIAL_NAME'  => 'LocationCountries',
                                                        'PAGE_HELP_NAME' => 'Countries',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'location_states'              => array( 'VIDEO_TUTORIAL_NAME'  => 'LocationStates',
                                                        'PAGE_HELP_NAME' => 'States',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'look_and_feel'                => array( 'VIDEO_TUTORIAL_NAME'  => 'LookandFeel',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),


               'my_setup'                     => array( 'VIDEO_TUTORIAL_NAME'  => 'MySetup',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),


               'notification_list'=> array( 'VIDEO_TUTORIAL_NAME'  => 'NotificationInitiallyPlacedOrder',
                                                        'PAGE_HELP_NAME' => 'EXmail_Notifications',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'notification_info'=> array( 'VIDEO_TUTORIAL_NAME'  => 'NotificationInitiallyPlacedOrder',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'order_edit'                  => array( 'VIDEO_TUTORIAL_NAME'  => 'OrderEdit',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'order_info'                  => array( 'VIDEO_TUTORIAL_NAME'  => 'OrderInfo',
                                                        'PAGE_HELP_NAME' => 'Order_Details',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),

               'order_info_before_delete'    => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),


               'orders_delete'               => array( 'VIDEO_TUTORIAL_NAME'  => 'OrderDelete',
                                                        'PAGE_HELP_NAME' => 'OrderDelete',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No'),

               'orders_tab'                   => array( 'VIDEO_TUTORIAL_NAME'  => 'OrdersTab',
                                                        'PAGE_HELP_NAME' => 'Orders',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'Yes' ),


               'reports_tab'                  => array( 'VIDEO_TUTORIAL_NAME'  => 'ReportsTab',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),


               'store_settings'               => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettings',
                                                        'PAGE_HELP_NAME' => 'Store_Settings',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'store_settings_currency'      => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsCurrency',
                                                        'PAGE_HELP_NAME' => 'Currency_Format',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'store_settings_datetime'      => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsDateTime',
                                                        'PAGE_HELP_NAME' => 'Date_and_Time_Format',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'store_settings_number'      => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsNumber',
                                                        'PAGE_HELP_NAME' => 'Number_Format',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'store_settings_payment'       => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsPayment',
                                                        'PAGE_HELP_NAME' => 'Payment_Methods',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'store_settings_product_tax_classes'
                                              => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsProductTaxClasses',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'store_settings_shipping'      => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsShipping',
                                                        'PAGE_HELP_NAME' => 'Shipping_Methods',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'store_settings_taxes'         => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsTaxes',
                                                        'PAGE_HELP_NAME' => 'Taxes',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'store_settings_taxes_add_edit_display'
                                              => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsTaxesAddEditDisplay',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'store_settings_taxes_add_edit_name'
                                              => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsTaxesAddEditName',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'store_settings_taxes_add_edit_class'
                                              => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsTaxesAddEditClass',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'store_settings_taxes_add_edit_rate'
                                              => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsTaxesAddEditRate',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'store_settings_taxes_shipping_taxes'
                                              => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsTaxesShippingTaxes',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'store_settings_taxes_calculator'
                                              => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsTaxesCalculator',
                                                        'PAGE_HELP_NAME' => 'Tax_Calculator',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'store_settings_weight'      => array( 'VIDEO_TUTORIAL_NAME'  => 'StoreSettingsWeight',
                                                        'PAGE_HELP_NAME' => 'Weight_Unit',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'update_system'                => array( 'VIDEO_TUTORIAL_NAME'  => 'UpdateSystem',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'admin_backup_create'          => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'admin_backup_restore'         => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'admin_backup_delete'          => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'admin_backup_info'            => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'catalog_search'               => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => '',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'marketing_tab'                => array( 'VIDEO_TUTORIAL_NAME'  => 'VideoTutorialNameMarketing',
                                                        'PAGE_HELP_NAME' => 'PageHelpNameMarketing',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'marketing_discounts'          => array( 'VIDEO_TUTORIAL_NAME'  => 'VideoTutorialNameMarketingDiscounts',
                                                        'PAGE_HELP_NAME' => 'Global_Discounts',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'marketing_promo_codes'        => array( 'VIDEO_TUTORIAL_NAME'  => 'VideoTutorialNameMarketingPromoCodes',
                                                        'PAGE_HELP_NAME' => 'Manage_Coupons_and_Promo_Codes',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'marketing_add_promo_code'     => array( 'VIDEO_TUTORIAL_NAME'  => 'VideoTutorialNameMarketingAddPromoCode',
                                                        'PAGE_HELP_NAME' => 'PageHelpNameMarketingAddPromoCode',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'marketing_edit_promo_code'    => array( 'VIDEO_TUTORIAL_NAME'  => 'VideoTutorialNameMarketingEditPromoCode',
                                                        'PAGE_HELP_NAME' => 'PageHelpNameMarketingEditPromoCode',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'product_options'              => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Product_Options_General_Guidelines',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'product_options_combinations' => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Product_Options_Combinations',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'product_options_inventory'    => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Product_Options_Inventory_Tracking',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'product_options_add_edit'     => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Add_and_Edit_Product_Option',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'shipping_tester'              => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Shipping_Tester',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'export_products'              => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Export_Products',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'import_products'              => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Import_Products',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'froogle_export'              => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Google_Product_Search_XFroogleX_Export',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'https_settings'              => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'HTTPS_Settings',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'digital_products_egoods'     => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Digital_Products',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'detailed_product_images'     => array( 'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Detailed_Images',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'mod_rewrite_settings'        => array(  'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Search_Engine_Friendly_URLs',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'related_products'           => array(   'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Related_Products',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'bestsellers'                => array(   'VIDEO_TUTORIAL_NAME'  => '',
                                                        'PAGE_HELP_NAME' => 'Bestsellers',
                                                        'DISPLAY_PAGEHELP' => 'Yes',
                                                        'DISPLAY_TUTORIAL' => 'No' ),

               'admin_cz_layouts_info'        => array( 'VIDEO_TUTORIAL_NAME'  => 'VideoTutorialNameAdminCZLayoutsInfo',
                                                        'PAGE_HELP_NAME' => 'PageHelpNameAdminCZLayoutsInfo',
                                                        'DISPLAY_PAGEHELP' => 'No',
                                                        'DISPLAY_TUTORIAL' => 'No' )
        );
    }


    /**
     * @param $pagecode - the page code
     * @return the link (full HTML tag) to the Page Help
     * @access public
     */
    function getPageHelpLink($pagecode)
    {
        $pagename = $this->_getPagenameByCode($pagecode);

        if ($pagename == '') return '<span style="color: red; font-size: 75%">Undefined Page Help Code</span>';

        if ($pagename['DISPLAY_PAGEHELP'] == 'Yes')
        {
            $href = str_replace( '%PAGE_HELP_NAME%', $pagename['PAGE_HELP_NAME'] , $this->pagehelp_path_template );
            $link = str_replace( '%HELP_URL%',  $href,                   $this->pagehelp_link_template );
        }
        else
        {
            $link = '';
        }

        return $link;
    }

    /**
     * @param $pagecode - the page code
     * @return the link (full HTML tag) to the Video Tutorial
     * @access public
     */
    function getTutorialLink($pagecode)
    {
        $pagename = $this->_getPagenameByCode($pagecode);

        if ($pagename == '') return '<span style="color: red; font-size: 75%">Undefined Tutorial Code</span>';

        if ($pagename['DISPLAY_TUTORIAL'] == 'Yes')
        {
            $href = str_replace( '%VIDEO_TUTORIAL_NAME%', $pagename['VIDEO_TUTORIAL_NAME'] , $this->tutorial_path_template );
            $link = str_replace( '%HELP_URL%',  $href,                   $this->tutorial_link_template );
        }
        else
        {
            $link = '';
        }

        return $link;
    }

    function _getPagenameByCode($pagecode)
    {
        // searching Page name
        if ( array_key_exists($pagecode, $this->code_list) )
        {
            $pagename = $this->code_list[$pagecode];
        }
        else
        {
            //  error marker
            $pagename = '';
        }

        return $pagename;
    }



    /**
	 * The message key for this message.
	 * @access private
	 */
	var $code_list = array();

    var $pagehelp_link_template;
    var $tutorial_link_template;

    var $pagehelp_path;
    var $tutorial_path;

}
?>