<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

define("AZ_SESS_LIFETIME", "3600");
define("CZ_SESS_LIFETIME", "0");


/**
 * Session class is intended for storing variable values across multiple
 * web pages. Session data can be stored to database or files. Main public
 * methods are set(), get() and isRegistered(), which allow to set, get session
 * variables values and check, if a variable is registered with the current
 * session. SessionSESSION is a stub class, using the php $_SESSION variable
 * for storing contents.
 *
 * @package Core
 * @author Vadim Lyalikov
 * @access  public
 */
class Session
{

    //Helper function. Just to notice. Not used yet.
    //see http://php.net/manual/en/function.session-unset.php#68738
    function session_clean1($logout=false)
     {
      $v=array();
      foreach($_SESSION as $x=>$y)
       if($x!="redirector"&&($x!="user"||$logout))
        $v[]=$x;

      foreach($v as $x)
       unset($_SESSION[$x]);
      return;
     }

    /**
     * Initializes the session: e.g. retrieves session data from the database.
     */
    function start($sid = "")
    {
        global $zone, $application;
        ini_set("session.cookie_lifetime", 0);
        if ($zone == "AdminZone")
        {
            session_name("AZSESSID");
            $ClientSessionLifetime = AZ_SESS_LIFETIME;
        }
        else
        {
            session_name("CZSESSID");
            $ClientSessionLifetime = CZ_SESS_LIFETIME;
        }
        if ($sid)
        {
            session_id($sid);
        }

        $session_save_handler = $application->getAppIni('SESSION_SAVE_HANDLER');
        if ($session_save_handler != 'PHP_INI')
        {
            ini_set("session.save_handler", $session_save_handler);
        }

        $session_save_path = $application->getAppIni('SESSION_SAVE_PATH');
        if ($session_save_path == 'AVACTIS_CACHE_DIR')
        {
            session_save_path($application->getAppIni("PATH_CACHE_DIR"));
        }
        elseif ($session_save_path != 'PHP_INI')
        {
            session_save_path($session_save_path);
        }

        session_start();

        global $application;
        $HTTP_URL = md5($application->getAppIni('HTTP_URL'));
        if (!isset($_COOKIE['HTTP_URL']))
        {
            setcookie('HTTP_URL', $HTTP_URL, time());
        }
        elseif ($_COOKIE['HTTP_URL']!=$HTTP_URL)
        {
            setcookie('HTTP_URL', $HTTP_URL, time());
            session_destroy();
            session_start();
        }

        //                                                 
        //                                   ,                                   .
        //        ,                   .
        //         ,                                ,                   .
        //                                                                  .
        $CURRENT_PRODUCT_VERSION = PRODUCT_VERSION;

        if(!array_key_exists('PRODUCT_VERSION', $_SESSION) ||
            $_SESSION['PRODUCT_VERSION'] != $CURRENT_PRODUCT_VERSION)
        {
            //see this::session_clean1()
            session_unset();
            session_destroy();
            session_start();
        }
        $_SESSION['PRODUCT_VERSION'] = $CURRENT_PRODUCT_VERSION;
        //                                                       

        foreach($_SESSION as $key => $val)
        {
            $this->keyvalList[$key] = $val;
//            $this->set($key, $val);
        }
        $this->started = TRUE;

        if (!$this->is_Set('ClientSessionLifetime'))
        {
            $this->set('ClientSessionLifetime', time());
        }
        else
        {
            $delta_time = time()-$this->get('ClientSessionLifetime');
            if (($delta_time > $ClientSessionLifetime)&&($ClientSessionLifetime!=0))
            {
                $this->un_Set('currentUserID');
            }
            $this->set('ClientSessionLifetime', time());
        }
    }

    /**
     * Checks if the session is initialized with start().
     *
     * @return boolean TRUE, if the session is initialized, FALSE - otherwise.
     */
    function isStarted()
    {
        return (TRUE == $this->started);
    }

    /**
     * Checks if a variable with the given name is stored in
     * the current session.
     *
     * @param string $key  the variable name
     * @return boolean TRUE, if there is a variable with given name in session
     * contents, FALSE - otherwise.
     */
    function is_Set($key)
    {
        return isset($this->keyvalList[$key]);
    }

    /**
     * Removes a variable from the list of variables which are stored in
     * the session.
     *
     * @param string $key the variable name
     */
    function un_Set($key)
    {
        unset($this->keyvalList[$key]);
        unset($_SESSION[$key]);
    }

    /**
     * Gets the session variable value by name.
     *
     * @param string $key the variable name
     * @return mixed  the value of the variable.
     */
    function get($key)
    {
        if($this->isStarted())
        {
            if(isset($this->keyvalList[$key]))
                return ($this->keyvalList[$key]);
            else
                die("Session::get() !isset(\$this->keyvalList[$key])");
        }
        else
            die("Session::getKey() !\$this->isStarted()");
    }

    /**
     * Sets a session variable value.
     *
     * @param string $key The variable name.
     * @param string $val The variable value.
     */
    function set($key, $val)
    {
        $this->keyvalList[$key] = $val;
        //todo save to DB, or _SESSION[__JC_SESSION] or something
        $_SESSION[$key] = $val;
    }

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A "Session started" flag.
     */
    var $started = FALSE;

    /**
     * A session id.
     */
    var $id = NULL;

    /**
     * Session contents (temporary stub).
     */
    var $keyvalList = array();

    /**#@-*/
}

?>