<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Cart module
 *
 * @package Cart
 * @author Alexander Girin
 */
class Cart
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Module constructor.
     */
    function Cart()
    {
        if(modApiFunc('Session', 'is_Set', 'CartContent'))
        {
            $this->setCartContent(modApiFunc('Session', 'get', 'CartContent'));
            $this->CartSubtotal = modApiFunc('Session', 'get', 'CartSubtotal');
            $this->CartSubtotalExcludingTaxes = modApiFunc('Session', 'get', 'CartSubtotalExcludingTaxes');
            $this->CartSubtotalIncludedTaxesSum = modApiFunc('Session', 'get', 'CartSubtotalIncludedTaxesSum');
            $this->CartProductsWeightNetto = modApiFunc('Session', 'get', 'CartProductsWeightNetto');
            $this->CartProductsQuantity = modApiFunc('Session', 'get', 'CartProductsQuantity');
        }
        else
        {
            $this->CartContent = array();
            $this->CartSubtotal = 0;
            modApiFunc('Session', 'set', 'CartSubtotal', 0);
            $this->CartSubtotalExcludingTaxes = 0;
            modApiFunc('Session', 'set', 'CartSubtotalExcludingTaxes', 0);
            $this->CartSubtotalIncludedTaxesSum = 0;
            modApiFunc('Session', 'set', 'CartSubtotalIncludedTaxesSum', 0);
            $this->CartProductsQuantity = 0;
            modApiFunc('Session', 'set', 'CartProductsQuantity', 0);
            $this->CartProductsWeightNetto = 0.0;
            modApiFunc('Session', 'set', 'CartProductsWeightNetto', 0.0);
        }
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Cart::getTables() instead of $this->getTables()
     */
    function install()
    {
        global $application;

        $tables = Cart::getTables();           #the array of the Cart module tables
        $query = &new DB_Table_Create($tables);
    }

    /**
     * Deinstalls the module.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Cart::getTables() instead of $this->getTables().
     *
     * @todo finish the functions on this page
     */
    function uninstall()
    {
        $query = &new DB_Table_Delete(Cart::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Checks if the module was installed.
     *
     * @todo finish the functions on this page
     * @return
     */
    function isInstalled()
    {
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * @todo May be add more tables
     * @return array - meta description of module tables
     */
    function getTables()
    {
        $tables = array ();
        $table_name = 'customer_basket';
        $tables[$table_name] = array();
        $tables[$table_name]['columns'] = array
        (
            'id'                => 'customer_basket.customer_busket_id'
           ,'c_id'              => 'customer_basket.customer_id'
           ,'p_id'              => 'customer_basket.product_id'
           ,'prod_quan'         => 'customer_basket.customer_busket_product_quantity'
           ,'date_added'        => 'customer_basket.customer_busket_date_added'
        );
        $tables[$table_name]['types'] = array
        (
            'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
           ,'c_id'              => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
           ,'p_id'              => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
           ,'prod_quan'         => DBQUERY_FIELD_TYPE_INT
           ,'date_added'        => DBQUERY_FIELD_TYPE_DATE
        );
        $tables[$table_name]['primary'] = array
        (
            'id'
        );
        $tables[$table_name]['indexes'] = array
        (
            'IDX_ci' => 'c_id'
           ,'IDX_pi' => 'p_id'
        );

        global $application;
        return $application->addTablePrefix($tables);
    }


    function getCartContent()
    {
        $taxes = modApiFunc("Taxes", "getTax");
        return $this->getCartContentExt($taxes);
    }
    /**
     * Gets cart contents.
     *
     * @todo add a user
     * @return array - a product array in the cart
     */
    function getCartContentExt($ComputedTaxes = NULL)
    {
        $TaxNames = modApiFunc("Taxes", "getTaxNames");

        $retval = array();
        $subtotal = 0;
        $CartSubtotalExcludingTaxes = 0;

        $CartProductsWeightNetto = 0.0;
        $quantity = 0;
        $weight = 0;

        if (sizeof($this->CartContent > 0))
        {
            $i=0;
            foreach ($this->CartContent as $key => $val)
            {
                $retval[$i] = modApiFunc('Catalog', 'getProductInfo', $val['product_id']);
                $retval[$i]['CartID'] = $key;
                $retval[$i]['Quantity_In_Cart'] = $val['quantity'];

/*                $retval[$i]['CartItemSalePrice'] = $retval[$i]['attributes']['SalePrice']['value'];
                if(array_key_exists('SalePrice',$flip_mods_map))
                    $retval[$i]['CartItemSalePrice'] += $val['modifiers'][$flip_mods_map['SalePrice']];
                if($retval[$i]['CartItemSalePrice']<0)
                    $retval[$i]['CartItemSalePrice']=0; */

                $retval[$i]['CartItemSalePriceExcludingTaxes'] = $retval[$i]['attributes']['salepriceexcludingtaxes']['value'];
                if($retval[$i]['CartItemSalePriceExcludingTaxes']<0)
                    $retval[$i]['CartItemSalePriceExcludingTaxes']=0;

                $retval[$i]['CartItemSalePriceIncludingTaxes'] = $retval[$i]['attributes']['salepriceincludingtaxes']['value'];
                if($retval[$i]['CartItemSalePriceIncludingTaxes']<0)
                    $retval[$i]['CartItemSalePriceIncludingTaxes']=0;

                //          SalePrice,                               "          "       .
                //     TaxClass             -        ,                     .
                //                         SalePrice                              .       
                //                .
                $display_product_price_including_taxes = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_DISPLAY_TOTALS_INCLUDING_TAXES);
                if($display_product_price_including_taxes === true)
                {
                    $retval[$i]['CartItemSalePrice'] = $retval[$i]['CartItemSalePriceIncludingTaxes'];
                }
                else
                {
                    $retval[$i]['CartItemSalePrice'] = $retval[$i]['CartItemSalePriceExcludingTaxes'];
                }

                $retval[$i]['CartItemWeight'] = isset($retval[$i]['attributes']['Weight']['value'])?$retval[$i]['attributes']['Weight']['value']:0.0;
                if($retval[$i]['CartItemWeight']<0)
                    $retval[$i]['CartItemWeight']=0;

                $retval[$i]['CartItemPerItemShippingCost'] = isset($retval[$i]['attributes']['PerItemShippingCost']['value'])?$retval[$i]['attributes']['PerItemShippingCost']['value']:0.0;
                if($retval[$i]['CartItemPerItemShippingCost']<0)
                    $retval[$i]['CartItemPerItemShippingCost']=0;

                $retval[$i]['CartItemPerItemHandlingCost'] = isset($retval[$i]['attributes']['PerItemHandlingCost']['value'])?$retval[$i]['attributes']['PerItemHandlingCost']['value']:0.0;
                if($retval[$i]['CartItemPerItemHandlingCost']<0)
                    $retval[$i]['CartItemPerItemHandlingCost']=0;

                $retval[$i]['TotalExcludingTaxes'] = ($retval[$i]['CartItemSalePriceExcludingTaxes'])*$val['quantity'];
                if($retval[$i]['TotalExcludingTaxes']<0)
                    $retval[$i]['TotalExcludingTaxes']=0;

/*                //FIXME:         !!!       "          "                         _   _     ,       
                //           ,                                    !                                   
                //          .
                $retval[$i]['TotalIncludingTaxes'] = ($retval[$i]['CartItemSalePriceIncludingTaxes'])*$val['quantity'];
                if($retval[$i]['TotalIncludingTaxes']<0)
                    $retval[$i]['TotalIncludingTaxes']=0; */

                $retval[$i]['Total'] = ($retval[$i]['CartItemSalePrice'])*$val['quantity'];
                if($retval[$i]['Total']<0)
                    $retval[$i]['Total']=0;


                $CartProductsWeightNetto += (($retval[$i]['CartItemWeight'])*$val['quantity']);

                $subtotal +=$retval[$i]['Total'];
                $CartSubtotalExcludingTaxes +=$retval[$i]['TotalExcludingTaxes'];
/*                $CartSubtotalIncludingTaxes +=$retval[$i]['TotalIncludingTaxes']; */

                $quantity +=$val['quantity'];
                $i++;
            }
        }

        //                                              .
        $CartSubtotalIncludedTaxesSum = 0;
        if ($ComputedTaxes !== NULL &&
            sizeof($this->CartContent > 0))
        {
            $i=0;
            foreach ($this->CartContent as $key => $val)
            {
                $retval[$i]['CartItemSalePriceIncludingTaxes'] = $retval[$i]['attributes']['salepriceexcludingtaxes']['value'];
                $IncludedTaxesSum = 0.0;
                //                       :
                if(isset($ComputedTaxes["products"][$key]))
                {
                    foreach($ComputedTaxes["products"][$key] as $tax_id => $tax_amount)
                    {
                        if(is_numeric($tax_id))
                        {
                            if($TaxNames[$tax_id]["included_into_price"] == "true")
                            {
                                $IncludedTaxesSum += $tax_amount;
                            }
                        }
                    }
                    $retval[$i]['CartItemSalePriceIncludingTaxes'] += $IncludedTaxesSum;
                }
                if($retval[$i]['CartItemSalePriceIncludingTaxes']<0)
                    $retval[$i]['CartItemSalePriceIncludingTaxes']=0;

                $retval[$i]['TotalIncludingTaxes'] = ($retval[$i]['CartItemSalePriceIncludingTaxes'])*$val['quantity'];
                if($retval[$i]['TotalIncludingTaxes']<0)
                    $retval[$i]['TotalIncludingTaxes']=0;

                $CartSubtotalIncludedTaxesSum += $IncludedTaxesSum * $val['quantity'];
                $i++;
            }
        }

        $this->CartSubtotal = $subtotal;
        $this->CartSubtotalExcludingTaxes = $CartSubtotalExcludingTaxes;
        $this->CartSubtotalIncludedTaxesSum = $CartSubtotalIncludedTaxesSum;
        $this->CartProductsWeightNetto = $CartProductsWeightNetto;
        $this->CartProductsQuantity = $quantity;
        modApiFunc('Session', 'set', 'CartSubtotal', $this->CartSubtotal);
        modApiFunc('Session', 'set', 'CartSubtotalExcludingTaxes', $this->CartSubtotalExcludingTaxes);
        modApiFunc('Session', 'set', 'CartSubtotalIncludedTaxesSum', $this->CartSubtotalIncludedTaxesSum);
        modApiFunc('Session', 'set', 'CartProductsWeightNetto', $this->CartProductsWeightNetto);
        modApiFunc('Session', 'set', 'CartProductsQuantity', $this->CartProductsQuantity);
        return $retval;
    }

    /**
     * Gets a cart total.
     *
     * @todo add a user
     * @return float - a cart total
     */
    function getCartSubtotal()
    {
        return $this->CartSubtotal;
    }

    /**
     * Gets a cart total.
     *
     * @todo add a user
     * @return float - a cart total
     */
    function getCartSubtotalExcludingTaxes()
    {
        return $this->CartSubtotalExcludingTaxes;
    }

    /**
     * Gets a cart total.
     *
     * @todo add a user
     * @return float - a cart total
     */
    function getCartSubtotalIncludedTaxesSum()
    {
        return $this->CartSubtotalIncludedTaxesSum;
    }

    /**
     * Gets a total weight.
     *
     * @todo
     * @return float - weight
     */
    function getCartProductsWeightNetto()
    {
        return $this->CartProductsWeightNetto;
    }

    /**
     * Gets a total products quantity in the cart.
     *
     * @todo add a user
     * @return float - total cart quantity
     */
    function getCartProductsQuantity()
    {
        return $this->CartProductsQuantity;
    }

    /**
     * Sets up the cart contents.
     *
     * @todo add a user
     * @param array $cart_content cart contents array
     * @return
     */
    function setCartContent($cart_content)
    {
        $this->CartContent = $cart_content;
    }

    /**
     * Adds a product into the cart
     *
     * @todo add a user
     * @param array $prod_data product id a set of options
     * @return
     */
    function addToCart($prod_data)
    {
        global $application;
        if (modApiFunc('Catalog','isCorrectProductId',$prod_data['entity_id']))
        {
            //                 storefront -          ,                  Offline:
            if (modApiFunc('Users', 'getZone') == "CustomerZone")
            {
                $prod = &new CProductInfo($prod_data['entity_id']);

                //         ,                OutOfStock                               .
                $store_show_absent = modApiFunc("Configuration", "getValue", "store_show_absent");

                //             OutOfStock -                       .
                $prodObj = &$application->getInstance('CProductInfo',$prod_data['entity_id']);
                $qty_in_stock = $prodObj->getProductTagValue('QuantityInStock', PRODUCTINFO_NOT_LOCALIZED_DATA);

                if($prod->haveOnlineCategory() &&
                      (
                          (
                              $qty_in_stock === ""
                          )
                          ||
                          (
                              $store_show_absent != STORE_SHOW_ABSENT_SHOW_NOT_BUY &&
                              $store_show_absent != STORE_SHOW_ABSENT_NOT_SHOW_NOT_BUY
                          )
                          ||
                          (
                              $qty_in_stock > 0
                          )
                      )
                  )
                {
                    $cart_id=$prod_data["entity_id"];

                    $qty = $prod_data['qty'];
                    $qty = ( $qty !== NULL && is_numeric($qty) && $qty > 0) ? $qty : 1;

                    if (array_key_exists($cart_id, $this->CartContent))
                    {
                        $add_to_cart_add_not_replace = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_ADD_TO_CART_ADD_NOT_REPLACE);
                        if($add_to_cart_add_not_replace === true)
                        {
                            $this->CartContent[$cart_id]['quantity'] += $qty;
                        }
                        else
                        {
                            $this->CartContent[$cart_id]['quantity'] = $qty;
                        }
                    }
                    else
                    {
                        $this->CartContent[$cart_id] = array(
                            'product_id' => $prod_data['entity_id']
                           ,'quantity' => $qty
                        );
                    }

                    modApiFunc('Session', 'set', 'CartContent', $this->CartContent);
                    $this->getCartContentExt();
                }
                else
                {
                    $query = new Request($application->getAppIni('SITE_URL'));
                    //FIXME:          -           .
                    $application->redirect($query);
                }
            }
        }
    }

    /**
     * Removes the product from the cart.
     *
     * @todo add a user
     * @param string $cart_id id of the cart element
     * @return
     */
    function removeFromCart($cart_id)
    {
        if (array_key_exists($cart_id, $this->CartContent))
        {
            unset($this->CartContent[$cart_id]);
        }

        modApiFunc('Session', 'set', 'CartContent', $this->CartContent);
        $this->getCartContentExt();
    }

    /**
     * Removes all products from the cart.
     *
     * @todo add a user
     * @return
     */
    function removeAllFromCart()
    {
        unset($this->CartContent);
        $this->CartContent = array();
        modApiFunc('Session', 'set', 'CartContent', $this->CartContent);
        $this->CartSubtotal = 0;
        modApiFunc('Session', 'set', 'CartSubtotal', $this->CartSubtotal);
        $this->CartSubtotalExcludingTaxes = 0;
        modApiFunc('Session', 'set', 'CartSubtotalExcludingTaxes', $this->CartSubtotalExcludingTaxes);
        $this->CartSubtotalIncludedTaxesSum = 0;
        modApiFunc('Session', 'set', 'CartSubtotalIncludedTaxesSum', $this->CartSubtotalIncludedTaxesSum);
        $this->CartProductsWeightNetto = 0.0;
        modApiFunc('Session', 'set', 'CartProductsWeightNetto', $this->CartProductsWeightNetto);
        $this->CartProductsQuantity = 0;
        modApiFunc('Session', 'set', 'CartProductsQuantity', $this->CartProductsQuantity);
        $this->getCartContent();
    }

    /**
     * Updates the cart contents.
     *
     * @todo add a user
     * @param string $cart_id id of the cart element
     * @param integer $quantity_in_cart element quantity in the cart
     * @return
     */
    function updateQuantityInCart($cart_id, $quantity_in_cart)
    {
        $quantity_in_cart=intval($quantity_in_cart);
        if (array_key_exists($cart_id, $this->CartContent))
        {
            if($quantity_in_cart>0)
                $this->CartContent[$cart_id]['quantity'] = $quantity_in_cart;
            else
                unset($this->CartContent[$cart_id]);
        }

        modApiFunc('Session', 'set', 'CartContent', $this->CartContent);
        $this->getCartContentExt();
    }

    function getCartInfo($entity)
    {
        switch (strtolower($entity))
        {
            case 'shoppingcartproductsquantity':
                return $this->getCartProductsQuantity();
            case "shoppingcartsubtotal":
            {
                $display_product_price_including_taxes = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_DISPLAY_TOTALS_INCLUDING_TAXES);
                if($display_product_price_including_taxes === true)
                {
                    $price = $this->CartSubtotalExcludingTaxes + $this->CartSubtotalIncludedTaxesSum;
                }
                else
                {
                    $price = $this->CartSubtotalExcludingTaxes;
                }
                //$price = modApiFunc("Checkout", "getOrderPrice", "Subtotal");
                $price_formatted = modApiFunc("Localization", "currency_format", $price);
                return $price_formatted;
            }
            case "shoppingcartdiscountedsubtotal":
            {
                $price = modApiFunc("Checkout", "getOrderPrice", "DiscountedSubtotal");
                $price_formatted = modApiFunc("Localization", "currency_format", $price);
                return $price_formatted;
            }
            case "shoppingcartglobaldiscount":
            {
                $price = modApiFunc("Checkout", "getOrderPrice", "SubtotalGlobalDiscount");
                $price_formatted = modApiFunc("Localization", "currency_format", $price);
                return $price_formatted;
            }
            case "shoppingcartpromocodediscount":
            {
                $price = PRICE_N_A;
                $price_formatted = modApiFunc("Localization", "currency_format", $price);
                return $price_formatted;
            }
            case "shoppingcartquantitydiscount":
            {
                $price = modApiFunc("Checkout", "getOrderPrice", "QuantityDiscount");
                $price_formatted = modApiFunc("Localization", "currency_format", $price);
                return $price_formatted;
            }
        }
    }

    //                                         $product_id.
    //   -                                -                      
    //                                                             cart_item_id.
    function getProductQuantity($product_id)
    {
        //                     .
        //                                                   ProductQuantityOptions,
        //   . .                              -                                      
        //  cart_item' ,      product_id,                                          ,
        //                       ProducInfoCZ                             .
        //                         :                                   AZ::Configuration.
        return modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_ADD_TO_CART_DEFAULT_QUANTITY);

        /* $cart_content = $this->getCartContent();
        $res = 0;
        foreach($cart_content as $cart_item_info)
        {
            if($cart_item_info['ID'] == $product_id)
            {
                $res += $cart_item_info['Quantity_In_Cart'];
            }
        }
        return $res;
        */
    }

    //                                 HTML        "<option></option>",
    //                           
    //  Store Settings::General Settings::AddToCart Quantity Values List
    //     $Quantity_In_Cart              , NULL     0 (                    
    //                              ),                               .
    function getProductQuantityOptions($Quantity_In_Cart, $product_id, $b_cart_view = false)
    {
        global $application;

        $add_to_cart_default_quantity = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_ADD_TO_CART_DEFAULT_QUANTITY);
        $add_to_cart_max_quantity = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_ADD_TO_CART_MAX_QUANTITY);
        $add_to_cart_limit_max_quantity_by_stock = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_ADD_TO_CART_LIMIT_MAX_QUANTITY_BY_STOCK);
        $add_to_cart_add_not_replace = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_ADD_TO_CART_ADD_NOT_REPLACE);

        if($Quantity_In_Cart === NULL ||
           $Quantity_In_Cart === "" ||
           $Quantity_In_Cart === 0)
        {
            //                            .

            $default_quantity = $add_to_cart_default_quantity;
            $selected_quantity = $default_quantity;
        }
        else
        {
            //                                .

            //                                     ,                             
            //                    ,               .
            if($add_to_cart_add_not_replace === false || $b_cart_view === true)
            {
                $selected_quantity = $Quantity_In_Cart;
            }
            else
            {
                $default_quantity = $add_to_cart_default_quantity;
                $selected_quantity = $default_quantity;
            }
        }

        $res = "";
        $max_quantity = $add_to_cart_max_quantity;
        if($add_to_cart_limit_max_quantity_by_stock === true)
        {
            //                          .
            $_Product_Info = &new CProductInfo($product_id);
            $qty_in_stock = $_Product_Info->getProductTagValue('QuantityInStock', PRODUCTINFO_NOT_LOCALIZED_DATA);

            //     $qty_in_stock                              ,                    .
            //                      ,                1 -         ,                   
            //                                  OutOfStock                   
            //                                         .
            if($qty_in_stock !== NULL &&
               $qty_in_stock !== "" &&
               $qty_in_stock >= 1)
            {
                if($qty_in_stock < $max_quantity)
                {
                    $max_quantity = $qty_in_stock;
                }
            }
        }

        for($i = 1; $i <= $max_quantity; $i++)
        {
            $SELECTED = ($i == $selected_quantity ? "SELECTED" : "");
            $res .= "<option value='". $i ."' ". $SELECTED .">". $i ."</option>";
        }

        return $res;
    }

    function getUniqueProductsIDsInCart()
    {
        $res = array();

        if(!empty($this->CartContent))
        {
            foreach($this->CartContent as $cart_id => $cart_item)
            {
                $res[] = $cart_item['product_id'];
            };
        };

        $res = array_unique($res);
        return $res;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /*
     * A cart contents array.
     */
    var $CartContent;

    /*
     * A cart total.
     */
    var $CartSubtotal;
    var $CartSubtotalExcludingTaxes;
    //                      ,               Subtotal       ,         Cart   CheckoutOrder
    //                              .
    var $CartSubtotalIncludedTaxesSum;

    var $CartProductsQuantity;

    /**#@-*/

}
?>