<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Catalog->UpdateProductInfo Action.
 * Saves product info after editing.
 * It checks the input data.
 *
 * @package Catalog
 * @access  public
 * @author Alexey Kolesnikov
 */
class UpdateProductInfo
{

    function uploadImages(&$EditProductInfoForm)
    {
        global $application;

        // not to duplicate the code.
        $large_image_path = null;
        $images = array('SmallImage', 'LargeImage');
        foreach ($images as $image)
        {
            // if the file really exists.
            if (array_key_exists($image,$_FILES) && $_FILES[$image]['size'] > 0 && getimagesize($_FILES[$image]['tmp_name']) != FALSE)
            {
                // define an image type. It should be one of the allowed types.
                if ($application->isAllowedImageType($_FILES[$image]))
                {
                    // define the image file extension
                    $ext = $application->getImageTypeExtension($_FILES[$image]);

                    if($ext != false)
                    {
                        // upload a unique file name.
                        $uploadfile = $application->getUploadImageName($_FILES[$image]['name']);
                        // move the uploaded file to the general catalog.
                        if (move_uploaded_file($_FILES[$image]['tmp_name'], $uploadfile)) {
                        @chmod($uploadfile, 0644);
                            // save the file to view it to the user.
                            $EditProductInfoForm["ViewState"][$image] = basename($uploadfile);
                            if($image == 'LargeImage')
                            {
                                $large_image_path = $uploadfile;
                            }
                        }
                        else
                        {
                            $EditProductInfoForm["ViewState"]["ErrorsArray"][$image] = new ActionMessage(array("PRDADD_006", $image));
                        }
                    }
                    else
                    {
                        $EditProductInfoForm["ViewState"]["ErrorsArray"][$image] = new ActionMessage(array("PRDADD_005", $image));
                    }
                }
                else
                {
                    $EditProductInfoForm["ViewState"]["ErrorsArray"][$image] = new ActionMessage(array("PRDADD_005", $image));
                }
            }
            else
            {
                if(array_key_exists($image,$_FILES) && $_FILES[$image]['size'] > 0)
                {
                    $EditProductInfoForm["ViewState"]["ErrorsArray"][$image] = new ActionMessage(array("PRDADD_005", $image));
                }
            }
        }
    }

    /**
     * Validates the user input. It check "New Product Name".
     */
    function isValidProdName($data)//, &$error_message_text)
    {
        $retval = (is_string($data) &&
                strlen(trim($data)) > 0 &&
                strlen(trim($data)) < 257);
        return $retval;
    }

    /**
     * @todo describe the function SaveProduct->onAction.
     */
    function onAction()
    {
        global $application;
        $request = $application->getInstance('Request');

        $EditProductInfoForm = array();
        if(modApiFunc('Session', 'is_Set', 'EditProductInfoForm'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $EditProductInfoForm = $_POST;
        $EditProductInfoForm["ViewState"]["ErrorsArray"] = array();
        switch ($request->getValueByKey('FormSubmitValue'))
        {
            case 'UploadImages':
            {
                $this->uploadImages($EditProductInfoForm);
            }
            break;

            case 'DeleteImage':
            {
                $image = $EditProductInfoForm['ViewState']['LargeImage'];
                if (strpos(basename($image), 'tmp') === 0)
                {
                    $images_dir = $application->getAppIni('PATH_IMAGES_DIR');
                    @unlink($images_dir . basename($image));
                }
                $EditProductInfoForm['ViewState']['LargeImage'] = '';
            }
            break;

            case 'DeleteSmallImage':
            {
                $image = $EditProductInfoForm['ViewState']['SmallImage'];
                if (strpos(basename($image), 'tmp') === 0)
                {
                    $images_dir = $application->getAppIni('PATH_IMAGES_DIR');
                    @unlink($images_dir . basename($image));
                }
                $EditProductInfoForm['ViewState']['SmallImage'] = '';
            }
            break;

            case 'UploadImagesAndSave':
            {
                $nErrors = 0;

                $this->uploadImages($EditProductInfoForm);
                $product_type_id = $request->getValueByKey('TypeID');
                $product_type = modApiFunc('Catalog', 'getProductType', $product_type_id);
                $product_id = $request->getValueByKey('ID');

                $product_info = array();

                foreach ($product_type['attr'] as $view_tag => $attr)
                {
                    // skip invisible attributes
                    if (!$attr['visible'])
                    {
                    	continue;
                    }
                    $product_info[$view_tag] = $request->getValueByKey($view_tag);
                    // check if it is reqiured
                    if (isEmptyKey($view_tag, $product_info) && $attr['required'])
                    {
                        $EditProductInfoForm["ViewState"]["ErrorsArray"][$view_tag] = new ActionMessage(array("error.required", $attr['name']));
                        $nErrors++;
                    }
                    // validity check
                    if (!isEmptyKey($view_tag, $product_info) && isset($attr['patt']))
                    {
                        $product_info_view_tag_with_new_lines_stripped = str_replace("\n", "", $product_info[$view_tag]);
                        if(!preg_match($attr['patt'], $product_info_view_tag_with_new_lines_stripped))
                        {
                            // @todo use the correct error codes.
                            $EditProductInfoForm["ViewState"]["ErrorsArray"][$view_tag] = new ActionMessage(array('error.wrongPattern', $attr['name'], $attr['patt_type']));
                            $nErrors++;
                        }
                    }
                    $product_info[$view_tag] = modApiFunc("Localization", "FormatStrToFloat", $product_info[$view_tag], $attr['patt_type']);
                    $SessionPost[$view_tag] = modApiFunc("Localization", "FormatStrToFloat", $product_info[$view_tag], $attr['patt_type']);
                }
                $product_info['Name'] = $request->getValueByKey('Name');

                $product_info['Name'] = $request->getValueByKey('Name');
                if (!$this->isValidProdName($product_info['Name']))
                {
                    // an error message comes out if the product name is not displayed
                    $EditProductInfoForm["ViewState"]["ErrorsArray"]['Name'] = new ActionMessage("PRDADD_004");
                    $nErrors++;
                }

                $nErrors = sizeof($EditProductInfoForm["ViewState"]["ErrorsArray"]);
                if ($nErrors == 0)
                {
                    $product_info['LargeImage'] = $EditProductInfoForm['ViewState']['LargeImage'];
                    $product_info['SmallImage'] = $EditProductInfoForm['ViewState']['SmallImage'];
                    modApiFunc('Catalog', 'updateProductInfo', $product_id, $product_type_id, $product_info);
                    //$EditProductInfoForm["ViewState"]["hasCloseScript"] = "true";
                    $redirect_request = &new Request();
                    $redirect_request->setView('Catalog_EditProduct');
                    $redirect_request->setAction('SetCurrentProduct');
                    $redirect_request->setKey('prod_id',$product_id);
                    modApiFunc('Session','set','SavedOk',1);
                    $application->redirect($redirect_request);
                    modApiFunc('Session','set','mustReloadParent',1);
                }
            }
            break;
        }
        if(!modApiFunc('Session','is_set','mustReloadParent'))
            modApiFunc('Session', 'set', 'EditProductInfoForm', $EditProductInfoForm);
        else
            modApiFunc('Session', 'un_set', 'EditProductInfoForm');
    }
}

?>