<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

include_once(dirname(__FILE__) . '/../abstract/product_info.php');

/**
 * Catalog->EditProductInfo View.
 * Views edit product form.
 *
 * @package Catalog
 * @access  public
 * @author Alexey Kolesnikov
 */
class EditProductInfo extends Catalog_ProdInfo_Base
{

    /**
     * A constructor.
     */
    function EditProductInfo()
    {
        $this->product_info_ext = $this->getProductInfo();
        if(modApiFunc("Session", "is_Set", "EditProductInfoForm"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'EditProductInfoForm');
        }
        else
        {
            $this->initFormData();
        }
    }

    /**
     * Copies info, iputted by user in the form and saves it to the local
     * array _POST.
     * It clears the error array.
     */
    function copyFormData()
    {
        //TODO eliminate copying on construction
        $EditProductInfoForm = modApiFunc("Session", "get", "EditProductInfoForm");

        $this->ViewState = $EditProductInfoForm["ViewState"];
        $this->ViewState['LargeImage'] = basename($this->ViewState['LargeImage']);
        $this->ViewState['SmallImage'] = basename($this->ViewState['SmallImage']);

        //Remove some data, that should not be sent to action one more time, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        foreach ($EditProductInfoForm as $key => $value)
        {
        	if (!is_array($value))
        	{
                $this->POST[$key]  = prepareHTMLDisplay($value);
        	}
        	else
        	{
                $this->POST[$key]  = $value;
        	}
        }
        $this->POST['ID'] = $this->product_info['ID'];
        $this->POST['TypeID'] = $this->product_info['TypeID'];
        $this->POST['TypeName'] = $this->product_info['TypeName'];

        //                                                         EditProduct
        if(modApiFunc('Session','is_set','SavedOk'))
        {
            $val = modApiFunc('Session','get','SavedOk');
            if($val == 1)
            {
                $this->SavedOk = 1;
                modApiFunc('Session','un_set','SavedOk');
            }
            else
            {
                $this->SavedOk = 2;
            }
        }
        else
        {
            $this->SavedOk = 2;
        }
    }

    /**
     * Loads product info to the local array _POST.
     * It is used to initialize the editing form at first call of the given view.
     */
    function initFormData()
    {
        //                                                         EditProduct
        if(modApiFunc('Session','is_set','SavedOk'))
        {
            $val = modApiFunc('Session','get','SavedOk');
            if($val == 1)
            {
                $this->SavedOk = 1;
                modApiFunc('Session','un_set','SavedOk');
            }
            else
            {
                $this->SavedOk = 2;
            }
        }
        else
        {
            $this->SavedOk = 2;
        }

        $this->ViewState =
            array(
                "hasCloseScript" => "false",
                "LargeImage" => $this->product_info['attributes']['LargeImage']['value']['exists'] ? basename($this->product_info['attributes']['LargeImage']['value']['url']) : '',
                "SmallImage" => $this->product_info['attributes']['SmallImage']['value']['exists'] ? basename($this->product_info['attributes']['SmallImage']['value']['url']) : ''
                 );

        foreach ($this->product_info_ext as $group)
        {
        	foreach ($group['attr'] as $attr)
        	{
            	$this->POST[$attr['view_tag']] = ($attr['allow_html'] && $attr['visible']) ? prepareHTMLDisplay($attr['value']) : $attr['value'];
        	}
        }
        $this->POST['TypeID'] = $this->product_info['TypeID'];
        $this->POST['TypeName'] = $this->product_info['TypeName'];
    }

    /**
     * Outputs edit product form.
     */
    function output()
    {
        global $application;

        if(isset($this->ViewState["hasCloseScript"]) && $this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        $arr = $this->product_info_ext;

        foreach ($arr as $group_id => $group)
        {
        	foreach ($group['attr'] as $attr_id => $attr)
        	{
        		if (isset($this->POST[$attr['view_tag']]))
        		{
        			$arr[$group_id]['attr'][$attr_id]['value'] = $this->POST[$attr['view_tag']];
        		}
        	}
        }
        $this->groups = $arr;

        $this->MessageResources = &$application->getInstance('MessageResources');
        $this->TemplateFiller = $application->getInstance('TmplFiller');
        $application->registerAttributes(array(
             'ViewStateClose'
            ,'ViewStateLargeImage'
            ,'ViewStateSmallImage'
            ,'ViewStateSmallImageRelativePath'
            ,'AttributePatternType'
            ,'AttributeFormat'
            ,'ErrorIndex'
            ,'Error'
            ,'Error_List'
            ,'SavedOkMessage'
            ,'InputStyleClass'
            ,'UseWYSIWYGFor'
    	    ,'GroupName'
    	    ,'GroupID'
    	    ,'Counter'
    	    ,'AttributeSelectOptions'
    	    ,'AttributeOptionValue'
    	    ,'AttributeOptionSelected'
    	    ,'AttributeOptionName'
            ,'AddLink'
            ,'AddLinkText'
    	    ,'SubmitUploadImagesScript'
            ,'ImagesUploadErrorMessage'
            ,'additionalJS'
            ,'AutoGenSmallImageComment'
            ,'ViewStateLargeImageWidth'
            ,'ViewStateLargeImageHeight'
        ));

        $application->registerAttributes(array('Local_ProductBookmarks','CancelLink'));

        $output = modApiFunc('TmplFiller', 'fill',
                              './../../js/','validate.msgs.js.tpl',
                              array(
                                    "INTEGER" => $this->MessageResources->getMessage( new ActionMessage(array('PRDADD_001')) )
                                   ,"FLOAT"   => $this->MessageResources->getMessage( new ActionMessage(array('PRDADD_002')) )
                                   ,"STRING1024"=> $this->MessageResources->getMessage( new ActionMessage(array('PRDADD_007')) )
                                   ,"STRING128"=> $this->MessageResources->getMessage( new ActionMessage(array('PRDADD_008')) )
                                   ,"STRING256"=> $this->MessageResources->getMessage( new ActionMessage(array('PRDADD_009')) )
                                   ,"STRING512"=> $this->MessageResources->getMessage( new ActionMessage(array('PRDADD_010')) )
                                   ,"CURRENCY"=> addslashes($this->MessageResources->getMessage( new ActionMessage(array('CURRENCY_FIELD',
                                                         modApiFunc("Localization", "FloatToFormatStr", 12.35, "currency"),
                                                         modApiFunc("Localization", "FloatToFormatStr", 34, "currency"),
                                                         modApiFunc("Localization", "FloatToFormatStr", 99.00, "currency")))))
                                   ,"WEIGHT"   => addslashes($this->MessageResources->getMessage( new ActionMessage(array('WEIGHT_FIELD',
                                                         modApiFunc("Localization", "FloatToFormatStr", 23.325, "weight"),
                                                         modApiFunc("Localization", "FloatToFormatStr", 34, "weight"),
                                                         modApiFunc("Localization", "FloatToFormatStr", 99.2, "weight")))))
                                   ,"ITEM"     => $this->MessageResources->getMessage( new ActionMessage(array('ITEM_FIELD')))
                                   )
                            );

        return $output.$this->TemplateFiller->fill("catalog/product_edit/", "container.tpl.html", array());
    }

    function getAttributes()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources');

        $result = "";
        $product_type_has_been_outputed = 0;
    	foreach ($this->groups as $group)
    	{
    	    // output the name of the attribute group
    	    $this->_group = $group;
    		$result .= $this->TemplateFiller->fill("catalog/product_edit/", "group.tpl.html", array());
    		// output the attribute
    		$this->_counter = 0;

    		if($group['id'] == 1 && !$product_type_has_been_outputed)
    		{
    		    $product_type_has_been_outputed = 1;
    		    //Add "ProductType" row to first group.
    		    $this->_counter++;
    		    $this->_attr = array();
   		    	$this->_attr['name'] = '<div class="required">'.$obj->getMessage( new ActionMessage('PRD_PRDTYPE_NAME')).'*</div>';
                $this->_attr['tag'] = 'TypeID';
    		    $this->_attr['unit'] = '';
    		    $this->_attr['pattern_type'] = 'integer';
        		$template = "attr.tpl.html";
                $product_type_desc = modApiFunc('Catalog', 'getProductType', $this->product_info['TypeID']);
        	    $this->_attr['value'] = $product_type_desc['name'];
    		    $result .= $this->TemplateFiller->fill("catalog/product_edit/", $template, array());
    		}

    		foreach ($group['attr'] as $attr)
    		{
    		    if (!$attr['visible']) continue;
    		    $this->_counter++;
    		    $this->_attr = array();
    		    $template = "";
    		    if ($attr['required'])
    		    {
    		    	$this->_attr['name'] = '<div class="required">'.$attr['name'].'*</div>';
    		    }
    		    else
    		    {
    		    	$this->_attr['name'] = $attr['name'];
    		    }
    		    $this->_attr['tag'] = $attr['view_tag'];
    		    $this->_attr['value'] = modApiFunc("Localization", "FloatToFormatStr", $attr['value'], $attr["patt_type"]);
                $this->_attr['unit'] = $attr['unit_type_value'] != null ? $attr['unit_type_value'] : '';
    		    $this->_attr['pattern_type'] = $attr['patt_type'];
                $this->_error = isset($this->ErrorsArray[$attr['view_tag']]) ? $this->MessageResources->getMessage($this->ErrorsArray[$attr['view_tag']]) : '';

                if (isset($attr['additional_link']))
                {
                    $this->_attr['additional_link'] = $attr['additional_link'];
                    $this->_attr['additional_link_text'] = $attr['additional_link_text'];
                }
    		    if ($attr['input_type_name'] == 'text')
    		    {
    		        $this->_attr['size'] = $attr['size'];
    		        $this->_attr['max'] = $attr['max'];
            		$template = "attr-text.tpl.html";
    		    }
    		    elseif ($attr['input_type_name'] == 'textarea')
    		    {
            		$template = "attr-textarea.tpl.html";
    		    }
    		    elseif ($attr['input_type_name'] == 'select')
    		    {
                    $this->_attr_options = array();
    		        foreach ($attr['input_type_values'] as $value => $name)
    		        {
    		        	$this->_attr_options[] = array (
    		        	    'value' => $value,
    		        	    'name' => $name,
    		        	    'selected' => $value == $attr['value']
    		        	    );
    		        }
            		$template = "attr-select.tpl.html";
    		    }
    		    elseif ($attr['input_type_name'] == 'image')
    		    {
                    $imagesUrl = $application->getAppIni('URL_IMAGES_DIR');
                    if ($application->getCurrentProtocol() == "https" && $application->getAppIni('HTTPS_URL_IMAGES_DIR'))
                    {
                        $imagesUrl = $application->getAppIni('HTTPS_URL_IMAGES_DIR');
                    }
    		        $this->_attr['ImageURL'] = $imagesUrl . $attr['value']['url'];
    		        $this->_attr['ImageWidth'] = $attr['value']['width'];
    		        $this->_attr['ImageHeight'] = $attr['value']['height'];
    		    	if ($attr['view_tag'] == 'LargeImage')
    		    	{
    		    	    if ($this->ViewState['LargeImage'] == '')
    		    	    {
    		    	        if(modApiFunc("Catalog", "isImageFolderNotWritable"))
    		    	        {
                                $template = "attr-no-image.error.tpl.html";
    		    	        }
    		    	        else
    		    	        {
                                $template = "attr-no-image.tpl.html";
    		    	        }
    		    	    }
    		    	    else
    		    	    {
                            $template = "attr-large-image.tpl.html";
    		    	    }
    		    	}
    		    	elseif ($attr['view_tag'] == 'SmallImage')
    		    	{
    		    	    if ($this->ViewState['SmallImage'] == '')
    		    	    {
    		    	        if(modApiFunc("Catalog", "isImageFolderNotWritable"))
    		    	        {
                                $template = "attr-no-image.error.tpl.html";
    		    	        }
    		    	        else
    		    	        {
                                $template = "attr-no-image.tpl.html";
    		    	        }
    		    	    }
    		    	    else
    		    	    {
                            $template = "attr-small-image.tpl.html";
    		    	    }
    		    	}
    		    }
    		    else
    		    {
                    $template = "attr.tpl.html";
    		    }
                $result .= $this->TemplateFiller->fill("catalog/product_edit/", $template, array());
    		}

    		//Patch to create "images Upload" button row:
    		if($group['id'] == 2 &&
    		   ($this->ViewState['LargeImage'] == "" ||
    		    $this->ViewState['SmallImage'] == ""))
    		{
    		    $this->_counter++;
    		    if(modApiFunc("Catalog", "isImageFolderNotWritable"))
    		    {
    		        $result .= $this->TemplateFiller->fill("catalog/product_edit/", "upload_ctrl.images.error.tpl.html", array());
    		    }
    		    else
    		    {
    		        $result .= $this->TemplateFiller->fill("catalog/product_edit/", "upload_ctrl.images.tpl.html", array());
    		    }
    		}
    		$result .= $this->TemplateFiller->fill("catalog/product_edit/", "show-state.tpl.html", array());
    	}
    	return $result;
    }

    /**
     *                   "                            "
     */
    function getSavedOkMessage()
    {
        if(!isset($this->TemplateFiller))
        {
            $this->TemplateFiller = $application->getInstance('TmplFiller');
        }
        if($this->SavedOk == 1)
        {
            $res = $this->TemplateFiller->fill("catalog/product_edit/", "saved_ok_msg.tpl.html", array());
            return $res;
        }
        else
        {
            return '';
        }
    }

    /**
     * @todo describe the function EditProductInfo->getErrors.
     */
    function getErrors()
    {
        global $application;
    	if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
    	{
    		return "";
    	}
    	$result = "";

    	$i = 0;
    	foreach ($this->ErrorsArray as $error)
    	{
    	    $i++;
    	    $this->_error_index = $i;
    		$this->_error = $this->MessageResources->getMessage($error);
    		$result .= $this->TemplateFiller->fill("catalog/product_edit/", "error.tpl.html", array());
    	}

        $this->_error_list = $result;
        $result = $this->TemplateFiller->fill("catalog/product_edit/", "error_list.tpl.html", array());
    	return $result;
    }

    /**
     * @todo describe the function EditProductInfo->getTag.
     */
    function getTag($tag)
    {
        global $application;
        $imagesUrl = $application->getAppIni('URL_IMAGES_DIR');
        if ($application->getCurrentProtocol() == "https" && $application->getAppIni('HTTPS_URL_IMAGES_DIR'))
        {
            $imagesUrl = $application->getAppIni('HTTPS_URL_IMAGES_DIR');
        }
    	$value = null;
    	switch ($tag)
    	{
    	    case 'Items':
    	        $value = $this->getAttributes();
    	        break;

    	    case 'Errors':
    	        $value = $this->getErrors();
    	        break;
            case "Error_List":
                $value = $this->_error_list;
                break;
    	    case 'AttributeName':
    	        $value = $this->_attr['name'];
    	        break;

    	    case 'AttributeValue':
    	        $value = $this->_attr['value'];
    	        break;

    	    case 'AttributeTag':
    	        $value = $this->_attr['tag'];
    	        break;

    	    case 'AttributeUnit':
    	        $value = $this->_attr['unit'];
    	        break;

    	    case 'AttributePatternType':
    	        $value = $this->_attr['pattern_type'];
    	        break;

    	    case 'AttributeFormat':
        	        $value = modApiFunc("Localization", "format_settings_for_js", $this->_attr['pattern_type']);
    	        break;

    	    case 'AttributeImageURL':
    	        $value = $this->_attr['ImageURL'];
    	        break;

    	    case 'AttributeImageWidth':
    	        $value = $this->_attr['ImageWidth'];
    	        break;

    	    case 'AttributeImageHeight':
    	        $value = $this->_attr['ImageHeight'];
    	        break;

    	    case 'AttributeSize':
    	        $value = $this->_attr['size'];
    	        break;

    	    case 'AttributeMax':
    	        $value = $this->_attr['max'];
    	        break;

    	    case 'Counter':
    	        $value = $this->_counter;
    	        break;

    	    case 'AttributeSelectOptions':
    	        $value = "";
    	        foreach ($this->_attr_options as $opt_value)
    	        {
    	            $this->_attr_option = $opt_value;
        	        $value .= $this->TemplateFiller->fill("catalog/product_edit/", "attr-select-option.tpl.html", array());;
    	        }
    	        break;

    	    case 'AttributeOptionValue':
    	        $value = $this->_attr_option['value'];
    	        break;

    	    case 'AttributeOptionSelected':
    	        if ($this->_attr_option['selected'])
    	            $value = " selected";
    	        break;

    	    case 'AttributeOptionName':
    	        $value = prepareHTMLDisplay($this->_attr_option['name']);
    	        break;

            case 'AddLink':
                $value = isset($this->_attr['additional_link'])? $this->_attr['additional_link']:"";
                break;

            case 'AddLinkText':
                $value = isset($this->_attr['additional_link_text'])? $this->_attr['additional_link_text']:"";
                break;

    	    case 'ViewStateLargeImage':
    	        $value = '';
    	        if ($this->ViewState['LargeImage'])
    	        {
        	        $value = $imagesUrl . $this->ViewState['LargeImage'];
    	        }
    	        break;

            case 'ViewStateLargeImageWidth':
                $value = '';
                if ($this->ViewState['LargeImage'])
                {
                    $image_path = $application->getAppIni('PATH_IMAGES_DIR') . $this->ViewState['LargeImage'];
                    $sizes = getimagesize($image_path);
                    $value = $sizes[0];
                }
                break;

            case 'ViewStateLargeImageHeight':
                $value = '';
                if ($this->ViewState['LargeImage'])
                {
                    $image_path = $application->getAppIni('PATH_IMAGES_DIR') . $this->ViewState['LargeImage'];
                    $sizes = getimagesize($image_path);
                    $value = $sizes[1];
                }
                break;

    	    case 'ViewStateSmallImage':
    	        $value = '';
    	        if ($this->ViewState['SmallImage'])
    	        {
        	        $value = $imagesUrl . $this->ViewState['SmallImage'];
                    $value = '<img src="' . $value . '">';
    	        }
    	        break;

    	    case 'ViewStateSmallImage':
    	        //Hidden Value
    	        $value = '';
    	        if ($this->ViewState['SmallImage'])
    	        {
        	        $value = $imagesUrl . $this->ViewState['SmallImage'];
    	        }
    	        break;

    	    case 'ViewStateSmallImageRelativePath':
    	        //Hidden Value
    	        $value = '';
    	        if ($this->ViewState['SmallImage'])
    	        {
        	        $value = $imagesUrl . $this->ViewState['SmallImage'];
    	        }
    	        break;

    	    case 'ViewStateClose':
    	        $value = $this->ViewState['hasCloseScript'];
    	        break;

    	    case 'ErrorIndex':
    	        $value = $this->_error_index;
    	        break;

    	    case 'Error':
    	        $value = $this->_error;
    	        break;

            case 'SavedOkMessage':
                $value = $this->getSavedOkMessage();
                break;

    	    case 'InputStyleClass':
    	        $value = $this->_error != '' ? "error" : '';
    	        break;

    	    case 'SubmitUploadImagesScript':
    	        $value = 'onclick="CatalogEditProduct.FormSubmitValue.value = \'UploadImages\';CatalogEditProduct.submit();disableButtons(new Array(\'SaveButton1\', \'SaveButton2\', \'CancelButton1\', \'CancelButton2\', \'UploadButton\'));return true;"';
    	        break;

    	    case 'ImagesUploadErrorMessage':
    	        $value = $this->MessageResources->getMessage("SETUP_WARNING_IMAGE_FOLDER_IS_NOT_WRITABLE", array("0" => modApiFunc("Catalog", "getImagesDir")));
    	        break;

    	    case 'UseWYSIWYGFor':
    	        $value = array();
    	        foreach ($this->product_info['attributes'] as $view_tag => $attr)
    	        {
                    //                                    ,      PriceExcludingTaxes.
                    if(isset($attr['allow_html']))
                    {
        	        	if($attr['allow_html'] && $attr['visible'])
        	        	    $value[] = $view_tag;
                    }
    	        }
    	        $value = implode(', ', $value);
    	        break;

    	    case 'Breadcrumb':
                $obj = &$application->getInstance('Breadcrumb');
                $value = $obj->output(false);
    	        break;

            case 'Local_ProductBookmarks':
                $value = ProductBookmarks('details',$this->prod_id,'edit');
                break;

            case 'CancelLink':
                $req = &new Request();
                $req->setView('Catalog_ProdInfo');
                $req->setAction('SetCurrentProduct');
                $req->setKey('prod_id',$this->prod_id);
                $value = $req->getURL();
                break;

            case 'additionalJS':
                if(modApiFunc('Session','is_set','mustReloadParent'))
                {
                    modApiFunc('Session','un_set','mustReloadParent');
                    $value = "window.opener.location.reload();\n";
                };
                break;

            case 'AutoGenSmallImageComment':
                $is_present_large_image = false;
                foreach($this->_group['attr'] as $attr_info)
                {
                    if($attr_info['view_tag'] == 'LargeImage' and $attr_info['visible'] == 1)
                    {
                        $is_present_large_image = true;
                    };
                };
                if($this->_attr['tag'] == 'SmallImage' and $is_present_large_image and $this->ViewState['LargeImage'] == '')
                {
                    $pi_settings = modApiFunc('Product_Images','getSettings');
                    if($pi_settings['AUTO_GEN_MAIN_SMALL_IMAGE'] == 'Y' and function_exists('gd_info'))
                    {
                        $value = xmsg('PI','COMMENT_AUTO_GEN_SMALL_IMAGE');
                    };
                };
                break;

    	    default:
        	    if (strpos($tag, 'Product') === 0)
        	    {
//                    $tag = preg_replace('/_/', '', $tag);
//                    $tag = preg_replace('/([A-Z]{1,})/', '_$1', $tag);
//                    $arr = preg_split('/_/', $tag, -1, PREG_SPLIT_NO_EMPTY);
//                    $entity = strtolower(array_shift($arr));
//                    $tag = implode('', $arr);
                    $tag = substr($tag, strlen('Product'));
            	    if (array_key_exists($tag, $this->POST)) {
                    	$value = $this->POST[$tag];
            	    }
        	    }
        	    if (strpos($tag, 'Group') === 0)
        	    {
//                    $tag = preg_replace('/_/', '', $tag);
//                    $tag = preg_replace('/([A-Z]{1,})/', '_$1', $tag);
//                    $arr = preg_split('/_/', $tag, -1, PREG_SPLIT_NO_EMPTY);
//                    $entity = strtolower(array_shift($arr));
//                    $tag = strtolower(implode('', $arr));
                    $tag = strtolower(substr($tag, strlen('Group')));
            	    if (array_key_exists($tag, $this->_group)) {
                    	$value = $this->_group[$tag];
            	    }
        	    }
        		break;
    	}
    	return $value;
    }

    /**
     * Pointer to the received from action or prepared FORM data.
     */
    var $POST;

    /**
     * View state structure. It comes from action.
     * $SessionPost["ViewState"] structure example:
     * <br>array
     * <br>(
     * <br>    "hasCloseScript"  = "false"           //true/false
     * <br>    "ErrorsArray"     =  array()          //true/false
     * <br>    "LargeImage"      = "image.jpg"       //
     * <br>    "SmallImage"      = "small_image.jpg" //
     * <br>)
     */
    var $ViewState;

    /**
     * List of error ids. It comes from action.
     */
    var $ErrorsArray;

    var $product_info_ext;
    var $TemplateFiller;
    var $MessageResources;
    var $groups;
    var $_group;
    var $_attr;
    var $_attr_options;
    var $_attr_option;
    var $_counter;
    var $_error_index;
    var $_error;
}
?>