<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

include_once(dirname(__FILE__) . '/../const.php');
/**
 * Catalog module.
 * Catalog Navigator.
 *
 * @package Catalog
 * @access  public
 * @author  Vadim Lyalikov
 */
class NavigationBar
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * The view constructor.
     *
     * @todo finish the functions on this page
     */
    function NavigationBar()
    {
        global $application;

        $this->pCatalog = &$application->getInstance('Catalog');

        $this->mTmplFiller = &$application->getInstance('TmplFiller');
    }

    function getLinkToCatalogNavigator($cid)
    {
        $_request = &new Request();
        $_request->setView  ( 'NavigationBar' );
        $_request->setAction( "SetCurrCat" );
        $_request->setKey   ( "category_id", $cid);

        global $application;
        return $_request->getURL();
        //@todo check, whether last parameter was ever used
        //$application->href($_request, -1, -1, 'AdminZone');
    }

    function getLinkToCatalogAddCategory()
    {
        $_request = &new Request();
        $_request->setView  ( 'AddCategory' );

        global $application;
        return $_request->getURL();
    }

    /**
     * Returns the Catalog Navigator list view.
     *
     * @todo finish the functions on this page
     */
    function outputDirectSubcategoriesList($cid)
    {
        global $application;
        $obj = &$application->getInstance('MessageResources');

        # Get CCategoryInfo object list
        $SubcategoriesList = modApiFunc('Catalog', 'getDirectSubcategoriesListFull', $cid);

        $this->SubcatNumInCat = sizeof($SubcategoriesList);
        $retval = "";
        $count = 0;
        foreach ($SubcategoriesList as $key => $value)
        {
            $checked = "";
            $this->_Current_Category = &$value;
            /*
            if ($value['ID'] == modApiFunc('Catalog', 'getEditableCategoryID'))
            {
                $checked = 'CHECKED';
            }
            $this->_Current_Category['Name'] = $checked == 'CHECKED' ?
                        '<span class="required">'. prepareHTMLDisplay($value["Name"]) .'</span>'
                        : prepareHTMLDisplay($value["Name"]);
            */

            $this->_Current_Category_NOT_LOCALIZED_Status_id = $value->getCategoryTagValue('Status', CATEGORYINFO_NOT_LOCALIZED_DATA);

            $cat_recursive_status_id = $value->getCategoryTagValue('RecursiveStatus', CATEGORYINFO_NOT_LOCALIZED_DATA);

            $this->_Current_Category->setAdditionalCategoryTag('Name', $value->getCategoryTagValue('Name'));
            $this->_Current_Category->setAdditionalCategoryTag('Status', $value->getCategoryTagValue('Status', CATEGORYINFO_LOCALIZED_DATA));
            $this->_Current_Category->setAdditionalCategoryTag('RecursiveStatus', $value->getCategoryTagValue('RecursiveStatus', CATEGORYINFO_LOCALIZED_DATA));

            $this->_Current_Category->setAdditionalCategoryTag('ID', $value->getCategoryTagValue('ID'));
            $this->_Current_Category->setAdditionalCategoryTag('Checked', $checked);
            $this->_Current_Category->setAdditionalCategoryTag('Link', $this->getLinkToCatalogNavigator($value->getCategoryTagValue('ID')));
            $this->_Current_Category->setAdditionalCategoryTag('CategoryOfflineAndOnlineSubcategoriesNumber', $value->getCategoryTagValue('CategoryOfflineAndOnlineSubcategoriesNumber'));

            $application->registerAttributes($this->_Current_Category->getAdditionalCategoryTagList());
            $application->registerAttributes(array("CategoryStatus", "CategoryRecursiveStatus", "CategoryOfflineStatusReason", "CategoryOfflineStatusColor"));

            if($cat_recursive_status_id == CATEGORY_STATUS_ONLINE)//Online
            {
                $retval .= $this->mTmplFiller->fill("catalog/catalog_navigator/", "list_item.tpl.html", array());
            }
            else if($cat_recursive_status_id == CATEGORY_STATUS_OFFLINE)//Offline
            {
                $retval .= $this->mTmplFiller->fill("catalog/catalog_navigator/", "list_item_offline.tpl.html", array());
            }

            $count++;
        }

        $min_list_size = 10;
        if($count== 0)
        {
            $retval .= $this->mTmplFiller->fill("catalog/catalog_navigator/", "list_item_empty_na_values.tpl.html", array());
            $count++;
        }

        for(;$count < $min_list_size; $count++)
        {
            $retval .= $this->mTmplFiller->fill("catalog/catalog_navigator/", $count == $min_list_size -1 ? "list_bottom_item_empty.tpl.html" : "list_item_empty.tpl.html", array());
        }

        modApiFunc('Catalog', 'unsetEditableCategoryID');
        modApiFunc('Catalog', 'unsetMoveToCategoryID');
        return $retval;
    }

    function outputEditCatHomeButton()
    {
        global $application;
        $application->registerAttributes(array(
                    "EditHomeCatHref" => ""
                   ,"EditCurrCatHref" => ""
                   ));
        if(modApiFunc('Catalog','getCurrentCategoryID') == 1)
        {
            $cname = 'home';
        }
        else
        {
            $cname = 'current';
        };
        $retval = $this->mTmplFiller->fill("catalog/catalog_navigator/", "edit_".$cname."_cat_button.tpl.html", array());
        return $retval;
    }

    /**
     * Returns the Catalog Navigator view.
     *
     * @todo finish the functions on this page
     */
    function output()
    {
        global $application;

        $application->registerAttributes(array(
             'Category_CurrentPath'
            ,'AddCatHref'
            ,'DelCatHref'
            ,'MoveCatHref'
            ,'ViewCatHref'
            ,'EditCatHref'
            ,'SortCatHref'
            ,'SortAlertMessage'
            ,'AlertMessage'
            ,'EditHomeCatButton'
        ));
        $retval = $this->mTmplFiller->fill("catalog/catalog_navigator/", "list.tpl.html", array());
        return $retval;
    }

    /**
     * @todo describe the function NavigationBar->getTag.
     */
    function getTag($tag)
    {
        global $application;
        $value = null;
        switch ($tag)
        {
        	case 'Items':
        		$value = $this->outputDirectSubcategoriesList(modApiFunc("Catalog", "getCurrentCategoryID"));
        		break;

            case 'AddCatHref':
                $request = &new Request();
                $request->setView  ( 'AddCategory' );
                $value = $request->getURL();
        	    break;

        	case 'DelCatHref':
                $request=&new Request();
                $request->setView  ( 'DeleteCategory' );
                $request->setAction( 'SetEditableCategory' );
                $request->setKey   ( 'category_id', '');
                $value = $request->getURL();
        	    break;

        	case 'MoveCatHref':
                $request=&new Request();
                $request->setView  ( 'MoveCategory' );
                $request->setAction( 'SetEditableCategory' );
                $request->setKey   ( 'category_id', '');
                $value = $request->getURL();
        	    break;

        	case 'ViewCatHref':
                $request=&new Request();
                $request->setView  ( 'ViewCategory' );
                $request->setAction( 'SetEditableCategory' );
                $request->setKey   ( 'category_id', '');
                $value = $request->getURL();
        	    break;

        	case 'EditCatHref':
                $request=&new Request();
                $request->setView  ( 'EditCategory' );
                $request->setAction( 'SetEditableCategory' );
                $request->setKey   ( 'category_id', '');
                $value = $request->getURL();
        	    break;

            case 'EditHomeCatButton':
                $value = $this->outputEditCatHomeButton();
                break;

            case 'EditHomeCatHref':
                $request=&new Request();
                $request->setView  ( 'EditCategory' );
                $request->setAction( 'SetEditableCategory' );
                $request->setKey   ( 'category_id', '1');
                $value = $request->getURL();
                break;

            case 'EditCurrCatHref':
                $request=&new Request();
                $request->setView  ( 'EditCategory' );
                $request->setAction( 'SetEditableCategory' );
                $request->setKey   ( 'category_id', modApiFunc('Catalog','getCurrentCategoryID'));
                $value = $request->getURL();
                break;

        	case 'SortCatHref':
                $request=&new Request();
                $request->setView  ( 'SortCategories' );
                $value = $request->getURL();
        	    break;

            case 'SortAlertMessage':
                if ($this->SubcatNumInCat==0)
                {
                    $MessageResources = &$application->getInstance('MessageResources');
                    $err_mes = new ActionMessage(array('NB_007'));
                    $value = $MessageResources->getMessage($err_mes);
                }
                elseif ($this->SubcatNumInCat==1)
                {
                    $MessageResources = &$application->getInstance('MessageResources');
                    $err_mes = new ActionMessage(array('NB_008'));
                    $value = $MessageResources->getMessage($err_mes);
                }
                else
                {
                    $value = '';
                }
                break;

            case 'AlertMessage':
                $MessageResources = &$application->getInstance('MessageResources');
                if ($this->SubcatNumInCat==0)
                {
                    $err_mes = new ActionMessage(array('NB_009'));
                }
                else
                {
                    $err_mes = new ActionMessage(array('NB_006'));
                }
                $value = "'".$MessageResources->getMessage($err_mes)."'";
                break;

    	    case 'Breadcrumb':
                $obj = &$application->getInstance('Breadcrumb');
                $value = $obj->output(true);
    	        break;

            case 'CategoryOfflineStatusReason':
                $value = $this->_Current_Category_NOT_LOCALIZED_Status_id == CATEGORY_STATUS_ONLINE ? msg("CATEGORY_PARENT_STATUS_ONLINE") : "";
                break;

            case 'CategoryOfflineStatusColor':
                //                     Offline.
                //                                    Online,                 ,      Offline -        .
                $value = $this->_Current_Category_NOT_LOCALIZED_Status_id == CATEGORY_STATUS_ONLINE ? "rgb(175, 175, 175)" : "#FF0000";
                break;

        	default:
        	    if (strpos($tag, 'Category') === 0)
        	    {
                    $tag = substr($tag, strlen('Category'));
        	    }
                    if(!empty($this->_Current_Category))
                    {
                        if ($this->_Current_Category->isTagExists($tag)) {
                            $value = $this->_Current_Category->getCategoryTagValue($tag);
        	        }
                    }
                    break;
        }
    	return $value;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Pointer to the module object.
     */
    var $pCatalog;

    /**
     * Pointer to the template filler object.
     * It needs to track sequences of identical templates, like lists.
     */
    var $mTmplFiller;

    var $_Current_Category = array();

    /**
     * The number of subcategories in the category.
     */
    var $SubcatNumInCat;
    /**#@-*/

}
?>