<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

include_once(dirname(__FILE__) . '/../const.php');

/**
 * Catalog module.
 * Catalog Products List in current category.
 *
 * @author Alexander Girin
 * @package Catalog
 * @access  public
 */
class ProductList
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * The view constructor.
     *
     * @todo finish the functions on this page
     */
    function ProductList()
    {
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] START');
        $this->CatID = modApiFunc('Catalog', 'getCurrentCategoryID');

        $paginator = modAPIFunc('paginator', 'setCurrentPaginatorName', "Catalog_ProdsList_$this->CatID");

        $this->pl = modApiFunc('Catalog', 'getProdsListInCurrentCategory', true, true);

        $SizeOfList = sizeof($this->pl);

        $this->From = 0; //isset($this->pl[0]) ? $this->pl[0]->getProductTagValue('N') : 0 ;
        $this->To = 0; //isset($this->pl[($SizeOfList-1)]) ? $this->pl[($SizeOfList-1)]->getProductTagValue('N') : 0;

        $this->_Cat_Info = modApiFunc("Catalog", "getCategoryInfo", $this->CatID);
        $this->ProdNumInCat = $this->_Cat_Info['ProductsNumber'];

        $this->_build_cats_paths();

        loadClass('CategoriesBrowser');
        $this->cb_params = array(
            'show_category_path' => true
           ,'category_path_prefix' => ''
           ,'show_products_count' => true
           ,'buttons' => array()
        );
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] END');
    }

    function _build_cats_paths()
    {
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] START');
        $cats = modApiFunc('Catalog','getSubcategoriesFullListWithParent',1,false);

        $paths = array();

        $last_parents_on_levels = array();

        for($i=0;$i<count($cats);$i++)
        {
            $cat = $cats[$i];
            $cpath = '';
            if(isset($last_parents_on_levels[$cat['level']-1]))
                $cpath = $last_parents_on_levels[$cat['level']-1]['path'];
            $cpath.='/'.$cat['name'];

            $last_parents_on_levels[$cat['level']] = array('id'=>$cat['id'],'path'=>$cpath);
            $paths[$cat['id']]=substr($cpath,1);
        };

        $this->_cats_paths = $paths;
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] END');
    }

    /**
     * Returns direct subcategories html-select drop down list.
     *
     * @todo finish the functions on this page
     */

    function getSubcategoriesList()
    {
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] START');
        global $application;
        $obj = &$application->getInstance('MessageResources');
        $a = modApiFunc("Catalog", "getSubcategoriesFullListWithParent", 1, false);
        $pq = modApiFunc("Catalog", "getProductsQuantityByCategories");
        $pr_quan_in_cat = array();
        foreach ($pq as $val)
        {
            $pr_quan_in_cat[$val["c_id"]] = $val["count_p_id"];
        }
        if(count($a) == 0)
        {
            log_debug('['.__CLASS__.'::'.__FUNCTION__.'] END, Empty');
            return "<option>".$obj->getMessage(new ActionMessage('MNG_CTGR_EMPTY'))."</option>";
        }
        else
        {
            $max_len = 0;
            $i = 0;
            foreach ($a as $value)
            {
                $len = strlen($value["name"])+$value["level"]*2;
                if ($len > $max_len)
                {
                    $max_len = $len;
                }
                if (isset($pr_quan_in_cat[$value["id"]]))
                {
                    $a[$i]["count_p_id"] = $pr_quan_in_cat[$value["id"]];
                }
                else
                {
                    $a[$i]["count_p_id"] = 0;
                }
                $i++;
            }

            $select_list = "";
            foreach ($a as $key => $value)
            {
                $spaces = "";
                for ($i=0; $i<$value["level"]; $i++)
                {
                    $spaces .= "&nbsp;&nbsp;";
                }
                $select_list .= "<option value=\"" . $value["id"] . "\"";
                if ($value["id"]==modApiFunc("Catalog", "getCurrentCategoryID"))
                {
                    $select_list .= " SELECTED ";
                }
                $select_list .= ">";
                $select_list .= $spaces.prepareHTMLDisplay($value["name"]);
                $spaces = "";
                for ($i=0; $i<($max_len - (strlen($value["name"])+$value["level"]*2) + 2); $i++)
                {
                    $spaces .= "&nbsp;";
                }
                $select_list.= $spaces."(".$value["count_p_id"]."&nbsp;". $obj->getMessage("MNG_PRD_PRD_LABEL").")";
                $select_list .= "</option>";
            }
            log_debug('['.__CLASS__.'::'.__FUNCTION__.'] END');
            return $select_list;
        }
    }

    /**
     *
     *
     * @return HTML code
     */
    function outputCategoryStatistics()
    {
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] START');
        global $application;
        $obj = &$application->getInstance('MessageResources');
        if ($this->_Cat_Info['SubcategoriesNumber']==1)
        {
            log_debug('['.__CLASS__.'::'.__FUNCTION__.'] END, SubcategoriesNumber == 1');
            return $obj->getMessage(new ActionMessage(array('MNG_PRD_HEADER_002', ($this->_Cat_Info['ProductsNumberRecursively']-$this->_Cat_Info['ProductsNumber']), $this->_Cat_Info['SubcategoriesNumber'])));
        }
        else
        {
            log_debug('['.__CLASS__.'::'.__FUNCTION__.'] END');
            return $obj->getMessage(new ActionMessage(array('MNG_PRD_HEADER_003', ($this->_Cat_Info['ProductsNumberRecursively']-$this->_Cat_Info['ProductsNumber']), $this->_Cat_Info['SubcategoriesNumber'])));
        }

    }

    /**
     * @todo                      ProductList->getProductList.
     */
    function getProductList()
    {
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] START');
        global $application;

        # HTML code for Items() tag
        $result_html = "";

        # Current line number in the Product List
        $current_line_number = 0;

        # Minimal lines number in the Product List,
        # if current Product List will be contain less lines then $min_lines_number,
        # then add empty lines to the Product List
        $min_lines_number = 10;

        $paginator_offset = modApiFunc('paginator', 'getCurrentPaginatorOffset');

        $size_of_pl = count($this->pl);

        $pl = $this->pl;
        unset($this->pl);

        $objCurrentCat = &new CCategoryInfo($this->CatID);
        $prod_parent_recursive_status_id = $objCurrentCat->getCategoryTagValue('RecursiveStatus');

        while(!empty($pl))
        {
            $productInfo_array = array_shift($pl);
            $this->_Current_Product = &new CProductInfo($productInfo_array['product_id']);
            $checked = '';
            /*
            if (in_array($productInfo['ID'], $editableProductsID))
            {
                $checked = 'CHECKED';
            }
            $productInfo['Name'] = $checked=='CHECKED'?
                                                    '<span class="required">'.$productInfo['Name'].'</span>'
                                                    :$productInfo['Name'];
            */

            # Add additional tags
            $this->_Current_Product->setAdditionalProductTag('Checked', $checked);
            $this->_Current_Product->setAdditionalProductTag('i', $current_line_number);
            $this->_Current_Product->setAdditionalProductTag('N', ++$current_line_number + $paginator_offset);
            //$current_line_number++;

            # Redefine InfoLink tag, because CProductInfo generate this link for Customer Zone
            $request=&new Request();
            $request->setView  ( 'Catalog_EditProduct' );
            $request->setAction( 'SetCurrentProduct' );
            $request->setKey   ( 'prod_id', $this->_Current_Product->getProductTagValue('ID') );
            $this->_Current_Product->setAdditionalProductTag('InfoLink', $request->getURL());

            # Setup current product,
            # this will be used in getTag method to get tags value

            # Redefine SmallImage tag, because we need to display
            # all images 50x50 size
            if( $this->_Current_Product->getProductTagValue('SmallImage') != '' )
            {
                $_src = $this->_Current_Product->getProductTagValue('SmallImageSrc');
                $height = $this->_Current_Product->getProductTagValue('SmallImageHeight');
                $width = $this->_Current_Product->getProductTagValue('SmallImageWidth');
                $str_height = "height=50";
                $str_width = "width=50";
                if ($height > 50 || $width > 50)
                {
                    if ($height > $width)
                    {
                        $str_width = ''; //                           ,                             
                    }
                    else
                    {
                        $str_height = ''; //                           ,                             
                    }
                }
                $_img = "<img src='$_src' $str_width $str_height border=0>";
                $this->_Current_Product->setAdditionalProductTag('SmallImage', $_img);
            }

            # Register Additional tags
            $application->registerAttributes( $this->_Current_Product->getAdditionalProductTagList() );
            $application->registerAttributes(array('ProductAvailable', 'ProductOfflineStatusReason', 'ProductOfflineStatusColor','ProductCatsCount','ProductCatsList'));

            # Get HTML code for one product
            //             Offline -                            

            $prod_status_id = $this->_Current_Product->getProductTagValue('Available', PRODUCTINFO_NOT_LOCALIZED_DATA);
            if($prod_status_id == PRODUCT_STATUS_ONLINE &&
               $prod_parent_recursive_status_id == CATEGORY_STATUS_ONLINE)
            {
                $result_html .= modApiFunc('TmplFiller', 'fill', "catalog/prod_list/", ($current_line_number == $size_of_pl && $size_of_pl >= $min_lines_number ) ? "list_bottom_item.tpl.html" : "list_item.tpl.html", array());
            }
            else if($prod_status_id == PRODUCT_STATUS_OFFLINE ||
                    $prod_parent_recursive_status_id == CATEGORY_STATUS_OFFLINE)
            {
                $result_html .= modApiFunc('TmplFiller', 'fill', "catalog/prod_list/", ($current_line_number == $size_of_pl && $size_of_pl >= $min_lines_number ) ? "list_bottom_item_offline.tpl.html" : "list_item_offline.tpl.html", array());
            };

            $this->_Current_Product->_destruct();
            $this->_Current_Product = null;
            unset($productInfo_array);
        }

        # If no product to display, then display one line with NA values
        if($current_line_number== 0)
        {
            $result_html .= modApiFunc('TmplFiller', 'fill', "catalog/prod_list/", "list_item_empty_na_values.tpl.html", array());
            $current_line_number++;
        }

        # Add additional empty lines to the Product List block
        for(;$current_line_number < $min_lines_number; $current_line_number++)
        {
            $result_html .= modApiFunc('TmplFiller', 'fill', "catalog/prod_list/", $current_line_number ==  $min_lines_number - 1 ? "list_bottom_item_empty.tpl.html" : "list_item_empty.tpl.html", array());
        }


        modApiFunc('Catalog', 'unsetEditableProductsID');
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] END');
        return $result_html;
    }

    /**
     * Returns the Product Listing view.
     *
     * @return string the Products List view.
     *
     * @todo finish the functions on this page
     */
    function output()
    {
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] START');
        global $application;
        $application->registerAttributes(array(
             'Add_Product_Link'
            ,'Move_Products_Link'
            ,'Copy_Products_Link'
            ,'Edit_Product_Link'
            ,'Delete_Products_Link'
            ,'SortProdHref'
            ,'SortAlertMessage'
            ,'AlertMessage'
            ,'ProductsNumber'
            ,'ProductsNumberRecursively'
            ,'SubcategoriesNumber'
            ,'From'
            ,'To'
            ,'CategoryStatistics'
            ,'CurrensySign'
            ,'Local_CategoriesBrowser_GoTo'
            ,'Local_CategoriesBrowser_MoveTo'
            ,'Local_CategoriesBrowser_CopyTo'
            ,'CurrentCategoryPath'
        ));

        $retval = modApiFunc('TmplFiller', 'fill', "catalog/prod_list/","list.tpl.html", array());
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] END');
        return $retval;
    }

    /**
     * @todo describe the function ProductList->getTag.
     */
    function getTag($tag)
    {
        global $application;
    	$value = null;
    	$CatID = modApiFunc('Catalog', 'getCurrentCategoryID');
    	switch ($tag)
    	{
            case 'CurrentCategoryPath':
                $value = str_replace("/","&nbsp;&gt;&gt;&nbsp;",$this->_cats_paths[modApiFunc('Catalog','getCurrentCategoryID')]);
                break;
            case 'Local_CategoriesBrowser_GoTo':
                $cb_obj = &new CategoriesBrowser();
                $this->cb_params['category_path_prefix'] = xmsg('CTL','PRFX_TARGET_CATEGORY');
                $this->cb_params['buttons'] =
                    array('go' => array(
                            'label' => 'BTN_GO'
                           ,'callback' => 'OnGoButtonClick(%CID%);'
                           ,'default_state' => 'disabled'
                           ,'enable_condition' => 'category_selected'
                          )
                         ,'cancel' => array(
                            'label' => 'BTN_CANCEL'
                           ,'callback' => 'hideBlock(\'categories_browser_goto\');'
                           ,'default_state' => 'enabled'
                          )
                    );
                $value = $cb_obj->output($this->cb_params);
                break;
            case 'Local_CategoriesBrowser_MoveTo':
                $cb_obj = &new CategoriesBrowser();
                $this->cb_params['category_path_prefix'] = xmsg('CTL','PRFX_TARGET_CATEGORY');
                $this->cb_params['buttons'] =
                    array('move' => array(
                            'label' => 'BTN_MOVE_PRD'
                           ,'callback' => 'OnMoveButtonClick(%CID%);'
                           ,'default_state' => 'disabled'
                           ,'enable_condition' => 'category_selected'
                          )
                         ,'cancel' => array(
                            'label' => 'BTN_CANCEL'
                           ,'callback' => 'hideBlock(\'categories_browser_moveto\');'
                           ,'default_state' => 'enabled'
                          )
                    );
                $value = $cb_obj->output($this->cb_params);
                break;
            case 'Local_CategoriesBrowser_CopyTo':
                $cb_obj = &new CategoriesBrowser();
                $this->cb_params['category_path_prefix'] = xmsg('CTL','PRFX_TARGET_CATEGORY');
                $this->cb_params['buttons'] =
                    array('move' => array(
                            'label' => 'BTN_COPY_PRD'
                           ,'callback' => 'OnCopyButtonClick(%CID%);'
                           ,'default_state' => 'disabled'
                           ,'enable_condition' => 'category_selected'
                          )
                         ,'cancel' => array(
                            'label' => 'BTN_CANCEL'
                           ,'callback' => 'hideBlock(\'categories_browser_copyto\');'
                           ,'default_state' => 'enabled'
                          )
                    );
                $value = $cb_obj->output($this->cb_params);
                break;
            case 'ProductListSubcategories':
                $value = $this->getSubcategoriesList();
                break;

            case 'Breadcrumb':
                $value = modApiFunc("Breadcrumb", "output", true, "ProductList");
                break;

    		case 'Items':
    			$value = $this->getProductList();
    			break;

    		case 'CategoryName':
                $categoryInfo = new CCategoryInfo($CatID);
                $value = $categoryInfo->getCategoryTagValue('name');
    		    break;

    		case 'PaginatorLine':
                $obj = &$application->getInstance($tag);
                $value = $obj->output("Catalog_ProdsList_$CatID", "ProductList");
                break;

            # override the PaginatorRows tag behavior
            case 'PaginatorRows':
                $obj = &$application->getInstance($tag);
                $value = $obj->output("Catalog_ProdsList_$CatID", 'ProductList');
                break;

    	    case 'Add_Product_Link':
                $request=&new Request();
//                $request->setView  ( 'SelectProductType' );
                $request->setView  ( 'Catalog_AddProduct' );
                $request->setKey   ( 'category_id', $CatID );
                $value = $request->getURL();
    	        break;

    	    case 'Move_Products_Link':
                $request=&new Request();
                $request->setView  ( 'MoveProducts' );
                $request->setAction( 'SetEditableProducts' );
                $value = $request->getURL();
    	        break;

    	    case 'Copy_Products_Link':
                $request=&new Request();
                $request->setView  ( 'CopyProducts' );
                $request->setAction( 'SetEditableProducts' );
                $value = $request->getURL();
    	        break;

    	    case 'Edit_Product_Link':
                $request=&new Request();
                $request->setView  ( 'Catalog_EditProduct' );
                $request->setAction( 'SetCurrentProduct' );
                $request->setKey('prod_id', '');
                $value = $request->getURL();
    	        break;

    	    case 'Delete_Products_Link':
                $request=&new Request();
                $request->setView  ( 'DeleteProducts' );
                $request->setAction( 'SetEditableProducts' );
                $value = $request->getURL();
    	        break;

    	    case 'SortProdHref':
                $request=&new Request();
                $request->setView  ( 'SortProducts' );
                $value = $request->getURL();
    	        break;
            case 'ProductsInCatTotal':
                $value = $this->ProdNumInCat;
                break;
            case 'AlertMessage':
                $MessageResources = &$application->getInstance('MessageResources');
                $err_mes = new ActionMessage(array('PRDLST_006'));
                $value = $MessageResources->getMessage($err_mes);
                break;
            case 'SortAlertMessage':
                if ($this->ProdNumInCat==0)
                {
                    $MessageResources = &$application->getInstance('MessageResources');
                    $err_mes = new ActionMessage(array('PRDLST_007'));
                    $value = $MessageResources->getMessage($err_mes);
                }
                elseif ($this->ProdNumInCat==1)
                {
                    $MessageResources = &$application->getInstance('MessageResources');
                    $err_mes = new ActionMessage(array('PRDLST_008'));
                    $value = $MessageResources->getMessage($err_mes);
                }
                else
                {
                    $value = '';
                }
                break;
            case 'ProductsNumber':
                $value = $this->_Cat_Info['ProductsNumber'];
                break;
            case 'ProductsNumberRecursively':
                $value = $this->_Cat_Info['ProductsNumberRecursively'] - $this->_Cat_Info['ProductsNumber'];
                break;
            case 'SubcategoriesNumber':
                $value = $this->_Cat_Info['SubcategoriesNumber'];
                break;
            case 'From':
                $value = $this->From;
                break;
            case 'To':
                $value = $this->To;
                break;
            case 'CategoryStatistics':
                $value = $this->outputCategoryStatistics();
                break;
            case 'CurrensySign':
                $value = modApiFunc("Localization", "getCurrencySign");
                break;

            case 'ProductOfflineStatusReason':
                $prod_status_id = $this->_Current_Product->getProductTagValue('Available', PRODUCTINFO_NOT_LOCALIZED_DATA);
                $value = $prod_status_id == PRODUCT_STATUS_ONLINE ? msg("PRODUCT_PARENT_STATUS_ONLINE") : "";
                break;

            case 'ProductOfflineStatusColor':
                //                   Offline.
                //                                    Online,                 ,      Offline -        .
                $prod_status_id = $this->_Current_Product->getProductTagValue('Available', PRODUCTINFO_NOT_LOCALIZED_DATA);
                $value = $prod_status_id == PRODUCT_STATUS_ONLINE ? "rgb(175, 175, 175)" : "#FF0000";
                break;

            case 'ProductCatsCount':
                $value = count($this->_Current_Product->getCategoriesIDs());
                break;

            case 'ProductCatsList':
                $_ps = array();
                $_cts = $this->_Current_Product->getCategoriesIDs();
                foreach($_cts as $cid)
                    $_ps[] = $this->_cats_paths[$cid];
                asort($_ps);
                $_ps = array_map("addslashes",array_map("htmlentities",$_ps));
                $value = implode("<br>",$_ps);
                break;

    	    default:
        	    if ( strpos($tag, 'Product') === 0 )
        	    {
//                    $tag = preg_replace('/_/', '', $tag);
//                    $tag = preg_replace('/([A-Z]{1,})/', '_$1', $tag);
//                    $arr = preg_split('/_/', $tag, -1, PREG_SPLIT_NO_EMPTY);
//                    $entity = strtolower(array_shift($arr));
//                    $tag = implode('', $arr);
                      $tag = substr($tag, strlen('Product'));
        	    }
        	    if ( is_object($this->_Current_Product) && $this->_Current_Product->isTagExists($tag) )
        	    {
                	$value = $this->_Current_Product->getProductTagValue($tag);
        	    }
        		break;
    	}
    	return $value;
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $_Current_Product = array();
    var $_Cat_Info = array();
    /**#@-*/

    /**
     *                                         
     */
    var $ProdNumInCat;

    /**
     *                                     
     */
    var $pl;

    var $_cats_paths;

    var $cb_params;
}
?>