<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Catalog module.
 * Catalog Products List in current category.
 *
 * @author Alexander Girin
 * @package Catalog
 * @access  public
 */
class ProductList
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Gets a template format for the given view.
     */
    function getTemplateFormat()
    {
    	$format = array(
    	    'layout-file'        => 'product-list-config.ini'
    	   ,'files' => array(
    	        'Container'      => TEMPLATE_FILE_SIMPLE
    	       ,'ContainerEmpty' => TEMPLATE_FILE_SIMPLE
    	       ,'Item'           => TEMPLATE_FILE_PRODUCT_TYPE
               ,'ItemOutOfStock' => TEMPLATE_FILE_PRODUCT_TYPE
    	    )
    	   ,'options' => array(
    	        'Columns'        => TEMPLATE_OPTION_REQUIRED
    	    )
    	);
    	return $format;
    }

    /**
     * The view constructor.
     *
     * @todo finish the functions on this page
     */
    function ProductList()
    {
        global $application;

        #check if fatal errors exist in the block tag
        $this->NoView = false;
        if ($application->issetBlockTagFatalErrors("ProductList"))
        {
            $this->NoView = true;
        }
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] Constructor, Object Created');
    }

    /**
     * Generates the main page conyaining a product list.
     */
    function getProductsList()
    {
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] Start');
        //             OutOfStock -                             .
        //                                   OutOfStock -                      .
        $store_show_absent = modApiFunc("Configuration", "getValue", "store_show_absent");

        global $application;

        $pl = ($this->pl) ? $this->pl : modApiFunc('Catalog', 'getProdsListInCategory', $this->_CatID, true, true);

        $this->pl = null;

        $items = "";
        $col =1;
        $columns = intval($application->getBlockOption($this->template, "Columns"));
        $this->_Product_Info = null;

        reset($pl);

        while(!empty($pl))
        {
            $productInfo_array = array_shift($pl);

            if ($col == 1)
            {
                $items .= '<tr><td>';
                $col++;
            }
            else
            {
                $items .= '<td>';
                $col++;
            }
            if ($col > $columns)
            {
                $col = 1;
            }

            $this->_Product_Info = &new CProductInfo($productInfo_array['product_id']);

            $qty_in_stock = $this->_Product_Info->getProductTagValue('QuantityInStock', PRODUCTINFO_NOT_LOCALIZED_DATA);
            $low_stock_level = $this->_Product_Info->getProductTagValue('LowStockLevel', PRODUCTINFO_NOT_LOCALIZED_DATA);

            $b_out_of_stock = ($qty_in_stock !== "" && $qty_in_stock <1);

            switch($store_show_absent)
            {
                case STORE_SHOW_ABSENT_SHOW_BUY:
                    //                                  ,                     -
                    //                       
                    $template = "Item";
                    break;
                case STORE_SHOW_ABSENT_SHOW_NOT_BUY:
                    //                        ,                       
                    //            LowStock -            Low Stock! Buy Now! 
                    if($b_out_of_stock === true)
                    {
                        $template = "ItemOutOfStock";
                    }
                    else
                    {
                        $template = "Item";
                    }
                    break;
                case STORE_SHOW_ABSENT_NOT_SHOW_NOT_BUY:
                    if($b_out_of_stock === true)
                    {
                        return "";//TODO: check!!!
                    }
                    else
                    {
                        $template = "Item";
                    }
                    break;
                default:
                    //STORE_SHOW_ABSENT_SHOW_BUY
                    $template = "Item";
                    break;
            }
            $__templateFiller = new TemplateFiller();
            $__templateFiller->setTemplate($application->getBlockTemplate('ProductList'));

            $items .= $__templateFiller->fill($template, $this->_Product_Info->getProductTagValue('TypeId'));

            unset($__templateFiller);
            $this->_Product_Info->_destruct();
            $this->_Product_Info = null;
            unset($productInfo_array);
        };

        unset($pl);
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] End');
        return $items;
    }

    /**
     * Returns the Product Listing view.
     *
     * @return string the Products List view.
     */
    function output()
    {
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] Start');
        global $application;

        #define whether to output the view or not
        if ($this->NoView)
        {
            $application->outputTagErrors(true, "ProductList", "Errors");
            return "";
        }
        else
        {
            $application->outputTagErrors(true, "ProductList", "Warnings");
        }

        $this->templateFiller = new TemplateFiller();

        $CatID = @func_get_arg(0);
        if ($CatID === false)
        {
            $CatID = modApiFunc('Catalog', 'getCurrentCategoryID');
        }

        modAPIFunc('paginator', 'setCurrentPaginatorName', "Catalog_ProdsList_$CatID");

        $paginator_pagenumber = modAPIFunc('paginator', 'getPaginatorPage', "Catalog_ProdsList_$CatID");
        $paginator_rowsperpage = modAPIFunc('paginator', 'getPaginatorRowsPerPage', "Catalog_ProdsList_$CatID");

        $this_pl_cache_id = 'c'.$CatID.'_pn'.$paginator_pagenumber.'_pp'.$paginator_rowsperpage;
        $cache = &$application->getInstance('CatalogCacheManager');
        $this_pl_html = $cache->ProductListHTMLCache->get($this_pl_cache_id);
        if ( !($this_pl_html===null))
        {
             log_debug('['.__CLASS__.'::'.__FUNCTION__.'] End, Read HTML Cache');
             return $this_pl_html;
        }

        $application->registerAttributes(array(
                                'ProductOptionsForm'=> ''
                               ,'Local_HiddenFields' => ''
                               ,'Local_JSfuncProductFormSubmit' => ''
                               ,'Local_ProductFormStart' => ''
                               ,'Local_ProductFormEnd' => ''
                               ,'Local_ProductAddToCart' => ''
                               ,'ProductDetailedImages' => ''
                               ,'Local_FormQuantityFieldName' => ''
                               ,'Local_ProductQuantityOptions' => ''
                              ));

        $this->_CatID = $CatID;
        $this->template = $application->getBlockTemplate('ProductList');
        $this->templateFiller->setTemplate($this->template);

        $this->pl = modApiFunc('Catalog', 'getProdsListInCategory', $this->_CatID, true, true);

        if (NULL == $this->pl)
        {
            log_debug('['.__CLASS__.'::'.__FUNCTION__.'] Filling Empty Container');
            $retval = $this->templateFiller->fill("ContainerEmpty");
            log_debug('['.__CLASS__.'::'.__FUNCTION__.'] Empty Container Filled');
        }
        else
        {
            log_debug('['.__CLASS__.'::'.__FUNCTION__.'] Filling Container');
            $retval = $this->templateFiller->fill("Container");
            log_debug('['.__CLASS__.'::'.__FUNCTION__.'] Container Filled');
        }

        $cache->ProductListHTMLCache->save($this_pl_cache_id, $retval );
        log_debug('['.__CLASS__.'::'.__FUNCTION__.'] End');
        return $retval;
    }

    /**
     * Processes tags in the templates for the given view.
     *
     * @return string tag value, if tag has been processed. NULL, otherwise.
     */
    function getTag($tag, $arg_list = array())
    {
        global $application;
        $value = null;
        switch ($tag)
        {
        	case 'Local_Items':
        		$value = $this->getProductsList();
        		break;

            # override the PaginatorRows tag behavior
            case 'PaginatorLine':
                $obj = &$application->getInstance($tag);
                $value = $obj->output("Catalog_ProdsList_$this->_CatID", "ProductList", $this->_CatID);
                break;

            # override the PaginatorRows tag behavior
            case 'PaginatorDropdown':
                $obj = &$application->getInstance($tag);
                $value = $obj->output("Catalog_ProdsList_$this->_CatID", 'ProductList');
                break;

            case 'CategoryName':
                $catobj = &new CCategoryInfo($this->_CatID);
                $value = $catobj->getCategoryTagValue('name');
                break;

            case 'ProductOptionsForm':
                $value = OptionsChoise($this->_Product_Info->getProductTagValue('ID'));
                break;

            case 'Local_JSfuncProductFormSubmit':
                $value = "<script language=\"JavaScript\">".
                         "function ProductFormSubmit_".$this->_Product_Info->getProductTagValue('ID')."()".
                         "{".
                         " document.forms['ProductForm_".$this->_Product_Info->getProductTagValue('ID')."'].submit();".
                         "};".
                         "</script>";
                break;

            case 'Local_ProductFormStart':
                $value = '<FORM action="'.$this->_Product_Info->getProductTagValue('BuyLink').'" name="ProductForm_'.$this->_Product_Info->getProductTagValue('ID').'" id="ProductForm_'.$this->_Product_Info->getProductTagValue('ID').'" method="post">
                        <script language="JavaScript">
                        function ProductFormSubmit_'.$this->_Product_Info->getProductTagValue('ID').'()
                        {
                            document.forms[\'ProductForm_'.$this->_Product_Info->getProductTagValue('ID').'\'].submit();
                        };
                        </script>';
                break;

            case 'Local_ProductFormEnd':
                $value = '</FORM>';
                break;

            case 'Local_ProductAddToCart':
                $value = 'javascript: ProductFormSubmit_'.$this->_Product_Info->getProductTagValue('ID').'();';
                break;

            case 'ProductDetailedImages':
                $value = ProductDetailedImages($this->_Product_Info->getProductTagValue('ID'));
                break;

            case 'Local_FormQuantityFieldName':
                $value = 'quantity_in_cart';
                break;

            case 'Local_ProductQuantityOptions':
                $qty_in_cart = modApiFunc("Cart", "getProductQuantity", $this->_Product_Info->getProductTagValue('ID'));
                $value = modApiFunc("Cart", "getProductQuantityOptions", $qty_in_cart, $this->_Product_Info->getProductTagValue('ID'));
                break;

    	    default:
    	        list($entity, $tag) = getTagName($tag);
        	    if ($entity == 'product' && is_object($this->_Product_Info))
        	    {
        	        $value = $this->_Product_Info->getProductTagValue($tag);
        	    }
        		break;
        }
        return $value;
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * The current catalog id. It is used for internal cycle processing.
     *
     * @var integer
     */
    var $_CatID;

    /**
     * The current selected product info. It is used for internal cycle processing.
     *
     * @var array
     */
    var $_Product_Info;


    /**
     * Reference to the object TemplateFiller.
     *
     * @var TemplateFiller
     */
    var $templateFiller;

    /**
     * The current selected template.
     *
     * @var array
     */
    var $template;

    /**#@-*/
}
?>