<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

include_once(dirname(__FILE__) . '/../const.php');
define('MAX_IMAGE_HEIGHT', 200);
define('MAX_IMAGE_WIDTH', 200);

/**
 * Catalog module.
 * Catalog Category info view.
 *
 * @author Alexander Girin
 * @package Catalog
 * @access  public
 */
class ViewCategory
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * The view constructor.
     *
     * @todo finish the functions on this page
     */
    function ViewCategory()
    {
    }


    /**
     * Returns the Catalog Category Info view.
     *
     * @todo finish the functions on this page
     */
    function output()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources');

        $CatID = modApiFunc('Catalog', 'getEditableCategoryID');

        if ($CatID == NULL)
        {

        }
        else
        {
            $catInfo = modApiFunc('Catalog', 'getCategoryInfo', $CatID);


            $request=&new Request();
            $request->setView  ( 'EditCategory' );
            $request->setAction( 'SetEditableCategory' );
            $request->setKey   ( 'category_id', $CatID);
            $catInfo['EditCatHref'] = $request->getURL();

            if($catInfo['SmallImageShowThatFileIsNotUploaded'] == '1')
            {
                $catInfo['SmallImage'] = $obj->getMessage(new ActionMessage('INFO_CTGR_NO_IMG'));
            }
            else
            {
                $catInfo['SmallImage'] = '<img src="'. $catInfo['SmallImageSrc'] .'" alt="">';
            }

//            $image_size = $application->img_size($catInfo['SmallImage'], MAX_IMAGE_HEIGHT, MAX_IMAGE_WIDTH);
//            $catInfo['ImageSize'] = $image_size[3];

            if($catInfo['LargeImageShowThatFileIsNotUploaded'] == '1')
            {
                $catInfo['LargeImage'] = $obj->getMessage(new ActionMessage('INFO_CTGR_NO_IMG'));
            }
            else
            {
                if ($catInfo['LargeImage']!='')
                {
                    //$catInfo['LargeImage'] = '<a href="javascript: void(0);" onclick="openURLinNewMinimizedWindow(\'popup_image.php?image_filename=' . ($catInfo['LargeImageSrc']) . '\', \'PopupImage\');">Large Image</A>';
                   $this->_attr = $catInfo;


                   $catInfo['LargeImage'] = //print_r($catInfo, true);
                    modApiFunc('TmplFiller', 'fill', "catalog/view_cat/", "attr-large-image.tpl.html", array());
                }
            }

            $cat_status = "";
            switch($catInfo["Status"])
            {
                case CATEGORY_STATUS_ONLINE:
                    $cat_status = msg('CAT_STATUS_ONLINE');
                    break;
                case CATEGORY_STATUS_OFFLINE:
                    $cat_status = msg('CAT_STATUS_OFFLINE');
                    break;
                default:
                    //TODO: report error
                    $cat_status = "";
            }

            $this->_Current_Category = $catInfo;

            $this->_Current_Category['Name'] = prepareHTMLDisplay($this->_Current_Category['Name']); //prepareHTMLDisplay($result[0]['name'])
            $this->_Current_Category['Status'] = prepareHTMLDisplay($cat_status);
            $this->_Current_Category['ImageAltText'] = prepareHTMLDisplay($this->_Current_Category['ImageAltText']); //prepareHTMLDisplay($result[0]['image_descr'])
            $this->_Current_Category['PageTitle'] = prepareHTMLDisplay($this->_Current_Category['PageTitle']); //prepareHTMLDisplay($result[0]['page_title'])
            $this->_Current_Category['MetaKeywords'] = prepareHTMLDisplay($this->_Current_Category['MetaKeywords']); //prepareHTMLDisplay($result[0]['meta_keywords'])
            $this->_Current_Category['MetaDescription'] = prepareHTMLDisplay($this->_Current_Category['MetaDescription']); //prepareHTMLDisplay($result[0]['meta_descr'])
            $this->_Current_Category['SEOURLprefix'] = prepareHTMLDisplay($this->_Current_Category['SEO_URL_prefix']);
            $this->_Current_Category['ShowProductsRecursivelyStatus'] = (
                    $this->_Current_Category['ShowProductsRecursivelyStatus'] == 1 ?
                    $obj->getMessage('CATEGORY_DONOTSHOW_PRODUCTS_RECURSIVELY') :
                    $obj->getMessage('CATEGORY_SHOW_PRODUCTS_RECURSIVELY'));

            $application->registerAttributes($this->_Current_Category);

            $application->registerAttributes(array("CategoryStatus"));

            $retval = modApiFunc('TmplFiller', 'fill', "catalog/view_cat/", "list.tpl.html", array());
        }

        $tpl_content = array(
            "AttributeImageWidth"
            //,"LargeImageSrc"
        );

        $application->registerAttributes($tpl_content);
        return $retval;
    }

    /**
     * @todo describe the function ViewCategory->getTag.
     */
    function getTag($tag)
    {
        global $application;
        $value = null;
        $CatID = $this->_Current_Category['ID'];
        switch ($tag)
        {
    	    case 'Breadcrumb':
                $obj = &$application->getInstance('Breadcrumb');
                $value = $obj->output(false);
    	        break;

    	    case 'AttributeImageWidth':
    	        $value = $this->_attr['LargeImageWidth'];
    	        break;

    	    case 'AttributeImageHeight':
    	        $value = $this->_attr['LargeImageHeight'];
    	        break;

    	    case 'AttributeImageURL':
    	        $value = $this->_attr['LargeImageSrc'];
    	        break;

            default:
                if (strpos($tag, 'Category') === 0)
                {
//                    $tag = preg_replace('/_/', '', $tag);
//                    $tag = preg_replace('/([A-Z]{1,})/', '_$1', $tag);
//                    $arr = preg_split('/_/', $tag, -1, PREG_SPLIT_NO_EMPTY);
//                    $entity = strtolower(array_shift($arr));
//                    $tag = implode('', $arr);
                    $tag = substr($tag, strlen('Category'));
                }
                if (array_key_exists($tag, $this->_Current_Category)) {
                    $value = $this->_Current_Category[$tag];
                };
                break;
        }
        return $value;
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $_attr;
    var $_Current_Category;
    /**#@-*/

}
?>