<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * Checkout module.
 * Action handler on ConfirmOrder.
 *
 * @package Checkout
 * @access  public
 */

class ConfirmOrder
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     *
     * @todo finish the functions on this page
     */
    function ConfirmOrder()
    {
    }


    function placeOrderIntoDB()
    {
        $order_id = modApiFunc("Checkout", "createOrderInDB");

        //Update the product number in the stock
        modApiFunc("Catalog", "updateProductsQuantity", modApiFunc("Cart", "getCartContent"));
        //Change the session.
        //Remove product info
        modApiFunc("Cart", "removeAllFromCart");
        return $order_id;
    }

    function getPMInfo()
    {
        global $application;
        $module_id = modApiFunc("Checkout", "getChosenPaymentModuleIdCZ");
        if($module_id === NULL)
        {
            $module_id = modApiFunc("Checkout", "getAllInactiveModuleId", "payment");
        }
        $pmInfo = modApiFunc("Checkout", "getPaymentModuleInfo", $module_id);
        $pmObject = &$application->getInstance($pmInfo["APIClassName"]);
        return $pmObject;
    }

    /**
     * Saves confirmed data about order in the DB.
     * It changes the data in the session.
     *
     * Action: confirmOrder
     *
     * @todo finish the functions on this page
     */
    function onAction()
    {
        global $application;

        $lastPlacedOrderID = modApiFunc("Checkout", "getLastPlacedOrderID");
        //Must be Empty
        if(empty($lastPlacedOrderID))
        {
            //                        -                      .            
			//                           .                           
			//                              .

            //Trying to start background process
            $pmObject = $this->getPMInfo();

            //Select either Direct Payment mode or Redirect to Payment Gateway mode.
            $mode = method_exists($pmObject, "getPaymentMode")? $pmObject->getPaymentMode() :"redirect";
            switch ($mode)
            {
                case "direct":
                    //invoke the backgroundProcess method of the selected payment gateway
                    //The method performs the following actions:
                    // 1. It prepares and sends data to the payment gateway, using the class bouncer;
                    // 2. It gets and processes data from the payment gataway
                    //    - on success, adds the order to the DB (with the specified payment status), clears the cart, updates
                    //   the product number in the stock.
                    //    - on failure, redirects to specified checkout step, depending on the error, i.e. ( the Info page or Shipping/Payment Select)
                    $pmObject->backgroundProcess();
                    break;
                case "redirect":
                    //Create order
                    $order_id = $this->placeOrderIntoDB();

                    //Display the page, which redirects to
                    // the payment gateway site(if JavaScript is on).
                    $application->prepareStorefrontBlockTag("CheckoutView");
                    echo modApiFunc("CheckoutView", "outputRedirectPage");
                    $application->_exit();
                    break;
                default:
                    $request = new Request();
                    $request->setView('CheckoutView');
                    $application->redirect($request);
                    break;
            }
        }
        else
        {
            //Error: customer has already passed "Confirm Order" page. Redirect to "You cart is empty".
            $request = new Request();
            $request->setView('CheckoutView');
            $application->redirect($request);
        }
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------
    /**#@+
     * @access private
     */

    /**#@-*/
}

?>