<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php


/**
 *        Hook                action checkout 'SetCurrentStep'
 *
 *                                                                 "Credit Card Info",
 * "Bank Account Info"  
 *         Checkout CZ ,                          Checkout                   
 *                         "Credit Card", "Bank Account"                          .
 *                                   -                     .
 *
 * @package Checkout
 * @author Vadim Lyalikov
 */
class AdditionalPersonInfoSetCurrStepHook
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     */
    function AdditionalPersonInfoSetCurrStepHook()
    {
    }

    /**
     *
     */
    function onHook()
    {
        global $application;
        $request = &$application->getInstance("Request");

        #                          ,                                                    CCInfo
        if ($paymentModule = $request->getValueByKey("paymentModule"))
        {
            //                        CCInfo:
            /*                           */
            $pm_id = $paymentModule["method_code"];
            $mmObj = &$application->getInstance('Modules_Manager');
            $moduleInfo = modApiFunc("Checkout", "getPaymentModuleInfo", $pm_id);
            if(!empty($moduleInfo))
            {
                $mmObj->includeAPIFileOnce($moduleInfo['APIClassName']);
                /*                                                      */

                if(is_callable(array($moduleInfo['APIClassName'],"getAdditionalPersonInfoVariantTag")))
                {
                    //TODO:                                                  
                    //                .
                    $addtitional_prerequisite_types = array
                    (
                        "creditCardInfo",
                        "bankAccountInfo"
                    );
                    foreach($addtitional_prerequisite_types as $prerequisite_type)
                    {
                        $variant_tag = call_user_func(array($moduleInfo['APIClassName'], 'getAdditionalPersonInfoVariantTag'), $prerequisite_type);
                        //false                     ,                       Checkout CZ              -         
                        //                                    CCInfo        : AuthorizeNet, PaypalPro.         
                        //            ,                                     CCInfo,        ,                      -
                        //         false.                    CCInfo                        .
                        if($variant_tag !== false)
                        {
                            $prerequisite_name = modApiFunc("Checkout", "getAdditionalPrerequisiteName", $prerequisite_type, $pm_id);
                            modApiFunc("Checkout", "validateInputForPrerequisite", $prerequisite_name);

                            if($prerequisite_type == "creditCardInfo")
                            {
                                modApiFunc("Checkout", "encrypt_prerequisite_with_checkout_cz_blowfish_key", $prerequisite_name);
                            }

                            $res = modApiFunc("Checkout", "getPrerequisiteValidationResults", $prerequisite_name);
                            if($res["isMet"] === false)
                            {
                                /*               ,                  .        ,                               
                                 * payment       .
                                 */
                                switch($prerequisite_type)
                                {
                                    case "creditCardInfo":
                                        $error_code = "PAYMENT_MODULE_INVALID_CC_INFO";
                                        break;
                                    case "bankAccountInfo":
                                        $error_code = "PAYMENT_MODULE_INVALID_BANK_ACCOUNT_INFO";
                                        break;
                                    default:
                                        //FIXME: report error;
                                        break;
                                }

                                $pm_res = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
                                modApiFunc("Checkout", "setPrerequisitesValidationResultsItem",
                                           'paymentModule', // prerequisiteName,
                                           $pm_res["variant_tag"], // variant_tag,
                                           false, // isMet,
                                           $error_code, // error_code,
                                           "", // error_message_parameters,
                                           $pm_res["validatedData"]);

                                //         ,              
                                $step_id = $request->getValueByKey( 'step_id' );
                                $step_id_to_redirect_to = modApiFunc("Checkout", "getStepIDtoRedirectToAfterPrerequisitesValidationErrors", $step_id);

                                //                                 .          PaymentModuleID                             ,
                                //                      PaymentModule.                       .                            .
                                //                     ,                               ,                         
                                // input_view_cz                         .
                                $pm_res = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
                                modApiFunc("Checkout", "setPrerequisitesValidationResultsItem",
                                           'paymentModule', // prerequisiteName,
                                           $pm_res["variant_tag"], // variant_tag,
                                           true, //!!! isMet,
                                           $error_code, // error_code,
                                           "", // error_message_parameters,
                                           $pm_res["validatedData"]);

                                $request = new Request();
                                $request->setView('CheckoutView');
                                $request->setAction("SetCurrStep");
                                $request->setKey   ( 'step_id', $step_id_to_redirect_to);
                                $request = modApiFunc("Checkout", "appendCheckoutCZGETParameters", $request);

                                modApiFunc("Checkout", "saveState");
                                $application->redirect($request);
                            }
                        }
                    }
                }
            }
        }
        modApiFunc("Checkout", "saveState");
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */
    /**#@-*/
}
?>