<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package Checkout
 * @author Vadim Lyalikov
 */
class AutoSelectShippingMethod
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * StepIDIsNotSet constructor.
     */
    function AutoSelectShippingMethod()
    {
    }

    /**
     * If for the selected Shipping address only one shipping method
     * (and one shipping module) is available it returns its module id and
     * method id. It returns false otherwise.
     */
    function getTheOnlyAvailableAndComputableShippingMethodId()
    {
        global $application;
        $groups = NULL;

        $SelectedModules = modApiFunc("Checkout", "getSelectedModules", "shipping");

        $sm_list = modApiFunc("Checkout", "getInstalledAndActiveModulesListData", "shipping", $groups);

        $there_is_a_shipping_module_with_only_one_available_method = false;
        $res = false;

        foreach ($sm_list as $sm_item)
        {
            //FIXME create/use some mm function to convert class names.
            $name = strtolower($sm_item->name);

            $smInfo = modApiFunc($name, "getInfo");

            //FIXME : check if function exists
            $module_uid = $smInfo['GlobalUniqueShippingModuleID'];

            if (array_key_exists($module_uid, $SelectedModules) == true)
            {
               /* Check, if for the current address even one method works.
                  Otherwise output a special template "No shipping method
                  available for the inputted address".
                  What should be outputted, if the address hasn't been inputted yet?
                */

                //$methods_info_list = modApiFunc($smInfo['APIClassName'], "getShippingMethods", "AVAILABLE", true);

                # Added by egor

                $formatted_cart=modApiFunc("Shipping_Cost_Calculator","formatCart",modApiFunc("Cart","getCartContent"));
                modApiFunc("Shipping_Cost_Calculator","setShippingInfo",modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
                modApiFunc("Shipping_Cost_Calculator","setCart",$formatted_cart);

                $calculation_result=modApiFunc("Shipping_Cost_Calculator","calculateShippingCost");

                if(!empty($calculation_result))
                {
                    $first_api_result=array_shift($calculation_result);
                    if(isset($first_api_result['methods']) and is_array($first_api_result['methods']) and !empty($first_api_result['methods']))
                        $methods_info_list=$first_api_result['methods'];
                    else
                        $methods_info_list=array();
                }
                else
                    $methods_info_list=array();

                # end

                if(!empty($methods_info_list))
                {
                    if(count($methods_info_list) == 1)
                    {
                        if($there_is_a_shipping_module_with_only_one_available_method == true)
                        {
                            //This is the SECOND module, which has available methods.
                            return false;
                        }
                        else
                        {
                            $there_is_a_shipping_module_with_only_one_available_method = true;
                            $res = array("module_id" => $module_uid
                                        ,"method_id" => $methods_info_list[0]["id"]);
                        }
                    }
                    else
                    if(count($methods_info_list) > 1)
                    {
                        //Which method has more than one available method.
                        return false;
                    }
                }
            }
        }

        return $res;
    }

    /**
     *
     */
    function onHook()
    {
        global $zone;
        if ($zone == 'CustomerZone')
        {
            //Check if shippingInfo has already been outputted
            $ShippingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo");
            if($ShippingInfo["isMet"]!=false)
            {
                //check if shipping method hasn't been selected yet
                $shippingModuleAndMethod = modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingModuleAndMethod");
                if($shippingModuleAndMethod["isMet"] == false)
                {
                    $the_only_available_shipping_method_info = $this->getTheOnlyAvailableAndComputableShippingMethodId();
                    if($the_only_available_shipping_method_info === false)
                    {
                        return;
                    }
                    else
                    {
                        //Auto-select method
                        modApiFunc("Checkout", "setChosenShippingMethod",
                                   $the_only_available_shipping_method_info["module_id"]
                                  ,$the_only_available_shipping_method_info["method_id"]);
                        //FIXME: check if this method will be ticked off while outputting.
                    }
                }
            }
        }
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */


    /**#@-*/

}
?>