<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

class ManageOrders
{

	function ManageOrders()
	{
            modApiFunc('paginator', 'setCurrentPaginatorName', "Checkout_Orders");
            $this->_orders = modApiFunc('Checkout', 'getOrderList');
	}

	/**
	 * The main function to output the given view.
	 */
	function output()
	{
        global $application;

        $this->MessageResources = &$application->getInstance('MessageResources');
        $this->TemplateFiller = $application->getInstance('TmplFiller');
        $this->_filter = modApiFunc('Checkout', 'getOrderSearchFilter');
        $application->registerAttributes(array(
            'SearchOrders'
           ,'SearchStatusSelector'
           ,'SearchPaymentStatusSelector'
           ,'SearchResults'
           ,'SearchBy'
           ,'CountByStatus0'
           ,'CountByStatus1'
           ,'CountByStatus2'
           ,'CountByStatus3'
           ,'ResultCount'
           ,'ResultDateRange'
           ,'ResultAmount'
           ,'OrderId'
           ,'OrderIdInt'
           ,'OrderPersonId'
           ,'OrderPersonCustomerId'
           ,'OrderCustomerName'
           ,'OrderCustomerInfoName'
           ,'OrderCustomerID'
           ,'OrderDate'
           ,'OrderPriceTotal'
           ,'OrderStatus'
           ,'OrderIdLinkTitle'
           ,'OrderCustomerNameLinkTitle'
           ,'OrderStatusSelector'
           ,'OrderStatusSelectorItems'
           ,'StatusId'
           ,'StatusName'
           ,'StatusSelected'
           ,'OrderPaymentStatus'
           ,'OrderPaymentStatusSelector'
           ,'OrderPaymentStatusSelectorItems'
           ,'PaymentStatusId'
           ,'PaymentStatusName'
           ,'PaymentStatusSelected'
           ,'HighLightNewOrders'
           ,'HighLightInProgress'
           ,'HighLightReadyToShip'
           ,'HighLightAll'
           ,'HighLightDate'
           ,'HighLightOrderId'
           ,'SearchingOrderId'
           ,'SearchFromDaySelector'
           ,'SearchFromMonthSelector'
           ,'SearchFromYearSelector'
           ,'SearchToDaySelector'
           ,'SearchToMonthSelector'
           ,'SearchToYearSelector'
           ,'SimpleSelectorOption'
           ,'DeleteOrdersLink'
           ,'PaginatorLine'
           ,'PaginatorRows'
        ));

        return $this->TemplateFiller->fill("checkout/orders/", "container.tpl.html", array());
	}

	/**
	 * Views an order list.
	 */
	function getOrders()
	{
	    $result = "";
//		foreach ($this->_orders as $order)
        foreach ($this->_orders as $order_id)
		{
            $order = modApiFunc("Checkout", "getOrderInfo", $order_id);
            $order["Date"] = modApiFunc("Localization", "SQL_date_format", $order["Date"]);
            $order["Total"] = modApiFunc("Localization", "currency_format", $order["Total"]);
            $order["IdInt"] = (int)$order["ID"];
		    $this->_order = $order;

		    //Fill customer id
		    //FIXME: is it correct to set customer_id=order_id ?
		    //$this->_order['PersonCustomerId'] = $this->_order['ID'];

            $result .= modApiFunc('TmplFiller', 'fill', "checkout/orders/", "item_result.tpl.html", array());
		}
		$this->_order = null;
		return $result;
	}

	/**
	 * @todo describe the function ManageOrders->.
	 */
	function getTag($tag)
	{
	    global $application;
		$value = null;
		switch ($tag)
		{
		    case 'CountByStatus0':
		        $value = modApiFunc('Checkout', 'getOrderCount', 0);
		        break;

		    case 'CountByStatus1':
		        $value = modApiFunc('Checkout', 'getOrderCount', 1);
		        break;

		    case 'CountByStatus2':
		        $value = modApiFunc('Checkout', 'getOrderCount', 2);
		        break;

		    case 'CountByStatus3':
		        $value = modApiFunc('Checkout', 'getOrderCount', 3);
		        break;

		    case 'SearchStatusSelector':
		        $this->_simple_selector['selected'] = $this->_filter['status_id'];
		        $status_array = modApiFunc('Checkout', 'getOrderStatusList');
		        $this->_simple_selector['options'] = array();
		        foreach ($status_array as $status)
		        {
		            $this->_simple_selector['options'][] = array('value'=>$status['id'], 'name'=>$status['name']);
		        }
		        $value = $this->TemplateFiller->fill("checkout/orders/", "search-status-selector.tpl.html", array());
		        break;

		    case 'SearchPaymentStatusSelector':
		        $this->_simple_selector['selected'] = $this->_filter['payment_status_id'];
		        $status_array = modApiFunc('Checkout', 'getOrderPaymentStatusList');
		        $this->_simple_selector['options'] = array();
		        foreach ($status_array as $status)
		        {
		            $this->_simple_selector['options'][] = array('value'=>$status['id'], 'name'=>$status['name']);
		        }
		        $value = $this->TemplateFiller->fill("checkout/orders/", "search-payment-status-selector.tpl.html", array());
		        break;

		    case 'SearchFromDaySelector':
		        $this->_simple_selector['selected'] = $this->_filter['from_day'];
		        $this->_simple_selector['options'] = array();
		        for ($i = 1; $i <= 31; $i++)
		        {
		            $num = sprintf("%02d", $i);
		            $this->_simple_selector['options'][] = array('value'=>$num, 'name'=>$i);
		        }
		        $value = $this->TemplateFiller->fill("checkout/orders/", "search-from-day-selector.tpl.html", array());
		        break;

		    case 'SearchFromMonthSelector':
		        $this->_simple_selector['selected'] = $this->_filter['from_month'];
		        $this->_simple_selector['options'] = array();
		        for ($i = 1; $i <= 12; $i++)
		        {
		            $num = sprintf("%02d", $i);
		            $this->_simple_selector['options'][] = array('value'=>$num, 'name'=>$this->MessageResources->getMessage("GENERAL_MONTH_".$num));
		        }
		        $value = $this->TemplateFiller->fill("checkout/orders/", "search-from-month-selector.tpl.html", array());
		        break;

		    case 'SearchFromYearSelector':
		        $this->_simple_selector['selected'] = $this->_filter['from_year'];
		        $this->_simple_selector['options'] = array();
		        $curr_year_4digits = date('Y');
                $offset_from = modApiFunc('Configuration', 'getValue', SYSCONFIG_HIDDEN_ORDER_YEAR_FROM_OFFSET);
                $offset_to = modApiFunc('Configuration', 'getValue', SYSCONFIG_HIDDEN_ORDER_YEAR_TO_OFFSET);
		        for ($i = $curr_year_4digits + $offset_from; $i <= $curr_year_4digits + $offset_to; $i++)
		        {
		            $this->_simple_selector['options'][] = array('value'=>$i, 'name'=>$i);
		        }
		        $value = $this->TemplateFiller->fill("checkout/orders/", "search-from-year-selector.tpl.html", array());
		        break;

		    case 'SearchToDaySelector':
		        $this->_simple_selector['selected'] = $this->_filter['to_day'];
		        $this->_simple_selector['options'] = array();
		        for ($i = 1; $i <= 31; $i++)
		        {
		            $num = sprintf("%02d", $i);
		            $this->_simple_selector['options'][] = array('value'=>$num, 'name'=>$i);
		        }
		        $value = $this->TemplateFiller->fill("checkout/orders/", "search-to-day-selector.tpl.html", array());
		        break;

		    case 'SearchToMonthSelector':
		        $this->_simple_selector['selected'] = $this->_filter['to_month'];
		        $this->_simple_selector['options'] = array();
		        for ($i = 1; $i <= 12; $i++)
		        {
		            $num = sprintf("%02d", $i);
		            $this->_simple_selector['options'][] = array('value'=>$num, 'name'=>$this->MessageResources->getMessage("GENERAL_MONTH_".$num));
		        }
		        $value = $this->TemplateFiller->fill("checkout/orders/", "search-to-month-selector.tpl.html", array());
		        break;

		    case 'SearchToYearSelector':
		        $this->_simple_selector['selected'] = $this->_filter['to_year'];
		        $this->_simple_selector['options'] = array();
		        $curr_year_4digits = date('Y');
                $offset_from = modApiFunc('Configuration', 'getValue', SYSCONFIG_HIDDEN_ORDER_YEAR_FROM_OFFSET);
                $offset_to = modApiFunc('Configuration', 'getValue', SYSCONFIG_HIDDEN_ORDER_YEAR_TO_OFFSET);
		        for ($i = $curr_year_4digits + $offset_from; $i <= $curr_year_4digits + $offset_to; $i++)
		        {
		            $this->_simple_selector['options'][] = array('value'=>$i, 'name'=>$i);
		        }
		        $value = $this->TemplateFiller->fill("checkout/orders/", "search-to-year-selector.tpl.html", array());
		        break;

		    case 'SimpleSelectorOption':
		        $selected = $this->_simple_selector['selected'];
		        $value = "";
		        foreach ($this->_simple_selector['options'] as $option)
		        {
		            $sel = $option['value'] == $selected ? " selected" : "";
		        	$value .= "<OPTION value=\"".$option['value']."\"".$sel.">".$option['name']."</OPTION>\n";
		        }
		        break;

            case 'ResultCount':
                $from = modApiFunc("Paginator", "getCurrentPaginatorOffset")+1;
                $to = modApiFunc("Paginator", "getCurrentPaginatorOffset") +  modApiFunc("Paginator", "getPaginatorRowsPerPage", "Checkout_Orders");
                $total = modApiFunc("Paginator", "getCurrentPaginatorTotalRows");
                if ($to > $total)
                {
                    $to = $total;
                }
                if ($total <= modApiFunc("Paginator", "getPaginatorRowsPerPage", "Checkout_Orders"))
                {
                    $value = $this->MessageResources->getMessage(new ActionMessage(array("ORDERS_RESULTS_LESS_THEN_ROWS_PER_PAGE_FOUND", $total)));
                }
                else
                {
                    $value = $this->MessageResources->getMessage(new ActionMessage(array("ORDERS_RESULTS_MORE_THEN_ROWS_PER_PAGE_FOUND", $from, $to, $total)));
                }
                break;

		    case 'ResultDateRange':
		        $count = count($this->_orders);
		        if ($count == 0)
		        {
		        	$value = "";
		        	break;
		        }
		        elseif ($count == 1)
		        {
                    $order_info = modApiFunc("Checkout", "getOrderInfo", $this->_orders[0]);
		            $value = modApiFunc("Localization", "SQL_date_format", $order_info['Date']);
		            break;
		        }
                $first_in_list_order_info = modApiFunc("Checkout", "getOrderInfo", $this->_orders[0]);
                $last_in_list_order_info = modApiFunc("Checkout", "getOrderInfo", $this->_orders[$count-1]);
		        $value = $value = modApiFunc("Localization", "SQL_date_format", $last_in_list_order_info['Date']) . " - " . modApiFunc("Localization", "SQL_date_format", $first_in_list_order_info['Date']);
		        break;

		    case 'ResultAmount':
		        if (count($this->_orders) == 0)
		        {
		        	$value = 0;
		        	break;
		        }
		        $amount = 0;
		        foreach ($this->_orders as $order_id)
		        {
                    $order = modApiFunc("Checkout", "getOrderInfo", $order_id);
		        	$amount += $order['Total'];
		        }
		        $value = modApiFunc("Localization", "currency_format", $amount);
		        break;

		    case 'Items':
		        $value = $this->getOrders();
		        break;

		    case 'OrderStatusSelector':
		        $value = $this->TemplateFiller->fill("checkout/orders/", "status-selector.tpl.html", array());
		        break;

		    case 'OrderStatusSelectorItems':
		        $status_array = modApiFunc('Checkout', 'getOrderStatusList');
		        $value = "";
		        foreach ($status_array as $status)
		        {
		        	$this->_status = $status;
    		        $value .= $this->TemplateFiller->fill("checkout/orders/", "status-selector-item.tpl.html", array());
		        }
		        break;

		    case 'StatusId':
		        $value = $this->_status['id'];
		        break;

		    case 'StatusName':
		        $value = $this->_status['name'];
		        break;

		    case 'StatusSelected':
		        if ($this->_status['id'] == $this->_order['StatusId'])
		        {
		        	$value = " selected";
		        }
		        else
		        {
		            $value = "";
		        }
		        break;

            case 'OrderIdLinkTitle':
                $value = $this->MessageResources->getMessage('ORDERS_RESULTS_ORDER_ID_LINK_TITLE');
                break;

            case 'OrderCustomerNameLinkTitle':
                $value = $this->MessageResources->getMessage('ORDERS_RESULTS_ORDER_CUSTOMER_NAME_LINK_TITLE');
                break;

		    case 'OrderPaymentStatusSelector':
		        $value = $this->TemplateFiller->fill("checkout/orders/", "payment-status-selector.tpl.html", array());
		        break;

		    case 'OrderPaymentStatusSelectorItems':
		        $status_array = modApiFunc('Checkout', 'getOrderPaymentStatusList');
		        $value = "";
		        foreach ($status_array as $status)
		        {
		        	$this->_payment_status = $status;
    		        $value .= $this->TemplateFiller->fill("checkout/orders/", "payment-status-selector-item.tpl.html", array());
		        }
		        break;

		    case 'PaymentStatusId':
		        $value = $this->_payment_status['id'];
		        break;

		    case 'PaymentStatusName':
		        $value = $this->_payment_status['name'];
		        break;

		    case 'PaymentStatusSelected':
		        if ($this->_payment_status['id'] == $this->_order['PaymentStatusId'])
		        {
		        	$value = " selected";
		        }
		        else
		        {
		            $value = "";
		        }
		        break;

		    case 'SearchOrders':
				$value = $this->TemplateFiller->fill("checkout/orders/", "search.tpl.html", array());
				break;

		    case 'SearchBy':
		        if ($this->_filter['search_by'] == 'status')
		        {
		            $msg = "";
		            switch ($this->_filter['filter_status_id'])
		            {
		            	case 0:
	    		            $msg = $this->MessageResources->getMessage('ORDERS_SEARCH_ALL');
		            		break;
		            	case 1:
	    		            $msg = $this->MessageResources->getMessage('ORDERS_SEARCH_NEW_ORDERS');
		            		break;
		            	case 2:
	    		            $msg = $this->MessageResources->getMessage('ORDERS_SEARCH_IN_PROGRESS');
		            		break;
		            	case 3:
	    		            $msg = $this->MessageResources->getMessage('ORDERS_SEARCH_READY_TO_SHIP');
		            		break;
		            }
		        	$value = $msg;
		        }
		        elseif ($this->_filter['search_by'] == 'date')
		        {
    	            $value = $this->MessageResources->getMessage('ORDERS_SEARCH_FILTER');
		        }
		        elseif ($this->_filter['search_by'] == 'id')
		        {
    	            $value = $this->MessageResources->getMessage('ORDERS_SEARCH_ORDER_ID');
		        }
				break;

			case 'SearchResults':
        		if (count($this->_orders) == 0)
        		{
                    $value = modApiFunc('TmplFiller', 'fill', "checkout/orders/", "empty.tpl.html", array());
        		}
        		else
        		{
				    $value = $this->TemplateFiller->fill("checkout/orders/", "results.tpl.html", array());
        		}
				break;

		    case 'HighLightAll':
		        if ($this->_filter['search_by'] == 'status' && $this->_filter['filter_status_id'] == 0)
		        {
		        	$value = "color: blue;";
		        }
		        break;

		    case 'HighLightNewOrders':
		        if ($this->_filter['search_by'] == 'status' && $this->_filter['filter_status_id'] == 1)
		        {
		        	$value = "color: blue;";
		        }
		        break;

		    case 'HighLightInProgress':
		        if ($this->_filter['search_by'] == 'status' && $this->_filter['filter_status_id'] == 2)
		        {
		        	$value = "color: blue;";
		        }
		        break;

		    case 'HighLightReadyToShip':
		        if ($this->_filter['search_by'] == 'status' && $this->_filter['filter_status_id'] == 3)
		        {
		        	$value = "color: blue;";
		        }
		        break;

            case 'HighLightDate':
		        if ($this->_filter['search_by'] == 'date')
		        {
		        	$value = "color: blue;";
		        }
		        break;

            case 'HighLightOrderId':
		        if ($this->_filter['search_by'] == 'id')
		        {
		        	$value = "color: blue;";
		        }
		        break;
            case 'SearchingOrderId':
                $value = "";
                if ($this->_filter['search_by'] == 'id' && !empty($this->_filter['order_id']))
                {
                    $value = $this->_filter['order_id'];
                }
                break;
            case 'DeleteOrdersLink':
                $request=&new Request();
                $request->setView  ('DeleteOrders');
                $request->setAction('SetOrdersForDeleteAction');
                $value = $request->getURL();
                break;

    		case 'PaginatorLine':
                $obj = &$application->getInstance($tag);
                $value = $obj->output("Checkout_Orders", "Orders");
                break;

            #                               PaginatorRows
            case 'PaginatorRows':
                $obj = &$application->getInstance($tag);
                $value = $obj->output("Checkout_Orders", 'Orders', 'PGNTR_ORD_ITEMS');
                break;

		    default:
    	        list($entity, $tag) = getTagName($tag);
        	    if ($entity == 'order')
        	    {
            	    if (strpos($tag, 'price') === 0)
            	    {
            	        $tag = strtolower(substr($tag, strlen('price')));
            	        if ($tag == 'total')
            	        {
            	        	$value = $this->_order['Total'];
            	        }
            	        elseif ($tag == 'subtotal')
            	        {
            	        	$value = $this->_order['Subtotal'];
            	        }
            	        else
            	        {
                	        $prices = getKeyIgnoreCase('price', $this->_order);
                	        $value = $prices[$tag];
            	        }
            	    }
            	    elseif (strpos($tag, 'customer') === 0)
            	    {
            	        $tag = strtolower(substr($tag, strlen('customer')));
                        $customer_account_name = modApiFunc('Customer_Account','getCustomerAccountNameByCustomerID',$this->_order['PersonId']);
                        $obj = &$application->getInstance('CCustomerInfo',$customer_account_name);
                        switch($tag)
                        {
                            case 'name':
                                $value = $obj->getDisplayAccountName();
                                break;
                            case 'id':
                                $value = $this->_order['PersonId'];
                                break;
                            case 'infoname':
                                $value = 'N/A';
                                $search_groups = $obj->getPersonInfoGroupsNames();
                                reset($search_groups);
                                foreach($search_groups as $group)
                                {
                                    $fn = $obj->getPersonInfo('FirstName',$group);
                                    $ln = $obj->getPersonInfo('LastName',$group);
                                    if($fn != null and $ln != null)
                                    {
                                        $value = $fn.' '.$ln;
                                        break;
                                    };
                                };
                                break;
                        };
            	    }
            	    else
            	    {
        	           $value = getKeyIgnoreCase($tag, $this->_order);
            	    }
        	    }
				break;
		}
		return $value;
	}

    var $TemplateFiller;
    var $MessageResources;
    var $_filter;
    var $_orders;
    var $_order;
    var $_status;
    var $_payment_status;
    var $_simple_selector;
}
?>