<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * Checkout
 *
 * @package Checkout
 * @author Girin Alexander
 */
class CheckoutOrder
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Gets a template format for the given view.
     */
    function getTemplateFormat()
    {
        $format = array(
            'layout-file'        => 'checkout-order-output-config.ini'
           ,'files' => array(
                'Container'      => TEMPLATE_FILE_SIMPLE
               ,'Item'           => TEMPLATE_FILE_PRODUCT_TYPE
               ,'ItemTax'        => TEMPLATE_FILE_SIMPLE
            )
           ,'options' => array(
            )
        );
        return $format;
    }

    /**
     *  CheckoutConfirmationInput constructor.
     */
    function CheckoutOrder()
    {
        global $application;

        #check if fatal errors exist in the block tag
        $this->NoView = false;
        if ($application->issetBlockTagFatalErrors("CheckoutOrder"))#FIXME: add check for config errors
        {
            $this->NoView = true;
        }
    }


    function outputCartContent()
    {
        global $application;
        $cc = modApiFunc('Cart', 'getCartContent');

        $items = "";
        $this->_Cart_Item = null;
        $item_number = 1;
        foreach ($cc as $productInfo)
        {
            $productInfo['Local_CartItemNumber'] = $item_number;
            $productInfo['Local_ProductQuantity'] = $productInfo['Quantity_In_Cart'];
            //$productInfo['Local_ProductSubtotal'] = modApiFunc("Localization", "currency_format", $productInfo['Quantity_In_Cart']*$productInfo['attributes']['SalePrice']['value']);
            $productInfo['Local_ProductSubtotal'] = modApiFunc("Localization", "currency_format", $productInfo['Total']);
            $productInfo['Local_ProductSubtotalIncludingTaxes'] = modApiFunc("Localization", "currency_format", $productInfo['TotalIncludingTaxes']);
            $productInfo['Local_ProductSubtotalExcludingTaxes'] = modApiFunc("Localization", "currency_format", $productInfo['TotalExcludingTaxes']);
            $productInfo['Local_CartItemSalePrice']=modApiFunc("Localization", "currency_format", $productInfo['CartItemSalePrice']);
            $productInfo['Local_CartItemSalePriceIncludingTaxes']=modApiFunc("Localization", "currency_format", $productInfo['CartItemSalePriceIncludingTaxes']);
            $productInfo['Local_CartItemSalePriceExcludingTaxes']=modApiFunc("Localization", "currency_format", $productInfo['CartItemSalePriceExcludingTaxes']);
            $productInfo['Local_CartItemWeight']=modApiFunc("Localization", "format", $productInfo['CartItemWeight'],"weight")." ".modApiFunc("Localization","getUnitTypeValue","weight");
            $productInfo['Local_CartItemPerItemShippingCost']=modApiFunc("Localization", "currency_format", $productInfo['CartItemPerItemShippingCost']);
            $productInfo['Local_CartItemPerItemHandlingCost']=modApiFunc("Localization", "currency_format", $productInfo['CartItemPerItemHandlingCost']);

            $this->_Cart_Item = $productInfo;
            $productInfo['SubTotal'] = "";
            $productInfo['ClearCart_Link'] = "";
            $application->registerAttributes($productInfo);
            $items .= $this->templateFiller->fill("Item", $productInfo['TypeID']);
            $item_number++;
        }
        $this->_Cart_Item = null; // clear the loop variable
        return $items;
    }

    function outputTax()
    {
        global $application;
        $retval ="";
        $this->_Tax_Item = array();
        $tax = modApiFunc("Taxes", "getTax");
        foreach ($tax['TaxSubtotalAmountView'] as $taxView)
        {
            $this->_Tax_Item['Local_TaxName'] = prepareHTMLDisplay($taxView['view']);
            $this->_Tax_Item['Local_TaxAmount'] = modApiFunc("Localization", "currency_format", $taxView['value']);
            $application->registerAttributes($this->_Tax_Item);
            $retval .= $this->templateFiller->fill("ItemTax");
        }
        return $retval;
    }

    /**
     * Otputs the view.
     *
     * @todo $request->setView  ( '' ) - define the view name
     */
    function output()
    {
        global $application;

        #Define whether to output the view or not
        if ($this->NoView)
        {
            $application->outputTagErrors(true, "CheckoutConfirmationInput", "Errors");
            return "";
        }

        $application->registerAttributes(array('Local_Subtotal',
                                               'Local_GlobalDiscount',
                                               'Local_PromoCodeDiscount',
                                               'Local_QuantityDiscount',
                                               'Local_ShippingCost', // = Local_TotalShippingAndHandlingCost

                                               'Local_CartItemSalePrice',
                                               'Local_CartItemWeight',
                                               'Local_CartItemPerItemShippingCost',
                                               'Local_CartItemPerItemHandlingCost',

                                               'Local_ProductOptionsSelected',

                                               'Local_FreeHandlingForOrdersOver',
                                               'Local_FreeShippingForOrdersOver',
                                               'Local_MinimumShippingCost',

                                               'Local_PerItemShippingCostSum',
                                               'Local_PerOrderShippingFee',
                                               'Local_ShippingMethodName',
                                               'Local_ShippingMethodCost',
                                               'Local_TotalShippingCharge',
                                               'Local_PerItemHandlingCostSum',
                                               'Local_PerOrderHandlingFee',
                                               'Local_TotalHandlingCharge',
                                               'Local_TotalShippingAndHandlingCost',

                                               'Local_Taxes',
                                               'Local_Total'));

        $this->templateFiller = &$application->getInstance('TemplateFiller');
        $this->template = $application->getBlockTemplate('CheckoutOrder');
        $this->templateFiller->setTemplate($this->template);

        $retval = $this->templateFiller->fill("Container");

        return $retval;
    }

    function getTag($tag)
    {
        global $application;
        $value = null;
        switch ($tag)
        {
            case 'Local_Items':
                $value = $this->outputCartContent();
                break;
            case 'Local_ProductOptionsSelected':
                $value = '';
                break;
            case 'Local_Subtotal':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "Subtotal"));
                break;
            case 'Local_GlobalDiscount':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "SubtotalGlobalDiscount"));
                break;
            case 'Local_PromoCodeDiscount':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "SubtotalPromoCodeDiscount"));
                break;
            case 'Local_QuantityDiscount':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "QuantityDiscount"));
                break;
            case 'Local_ShippingCost':
            case 'Local_TotalShippingAndHandlingCost':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "TotalShippingAndHandlingCost"));
                break;
            case 'Local_FreeHandlingForOrdersOver':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "FreeHandlingForOrdersOver"));
                break;
            case 'Local_PerItemShippingCostSum':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "PerItemShippingCostSum"));
                break;
            case 'Local_ShippingMethodCost':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "ShippingMethodCost"));
                break;
            case 'Local_FreeShippingForOrdersOver':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "FreeShippingForOrdersOver"));
                break;
            case 'Local_MinimumShippingCost':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "MinimumShippingCost"));
                break;
            case 'Local_PerOrderShippingFee':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "PerOrderShippingFee"));
                break;
            case 'Local_TotalShippingCharge':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "TotalShippingCharge"));
                break;
            case 'Local_ShippingMethodName':
                $shipping_module_id = modApiFunc("Checkout","getChosenShippingModuleIdCZ");
                if($shipping_module_id === NULL)
                {
                    // TODO                              ,                           
                    return '---';
                }
                $shipping_method_id = modApiFunc("Checkout","getChosenShippingMethodIdCZ");
                $shipping_module_info = modApiFunc("Checkout","getShippingModuleInfo",$shipping_module_id);

                if($shipping_module_info["GlobalUniqueShippingModuleID"]=="6F82BA03-C5B1-585B-CE2E-B8422A1A19F6")
                {
                    $mRes = &$application->getInstance('MessageResources',"messages");
                    $value=$mRes->getMessage('ALL_SM_ARE_INACTIVE');
                    unset($mRes);
                }
                else
                {
                    $ShippingMethodInfo=modApiFunc("Shipping_Cost_Calculator","getCalculatedMethod",$shipping_module_info["APIClassName"],$shipping_method_id);
                    $value = $ShippingMethodInfo['method_name'];
                }
                break;
            case 'Local_PerItemHandlingCostSum':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "PerItemHandlingCostSum"));
                break;
            case 'Local_PerOrderHandlingFee':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "PerOrderHandlingFee"));
                break;
            case 'Local_TotalHandlingCharge':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "TotalHandlingCharge"));
                break;
            case 'Local_Taxes':
                $value = $this->outputTax();
                break;
            case 'Local_Total':
                $value = modApiFunc("Localization", "currency_format", modApiFunc("Checkout", "getOrderPrice", "Total"));
                break;
            default:
                list($entity, $tag) = getTagName($tag);
                if ($entity == 'product' || $entity == 'unknown')
                {
                    //                        "                             Subtotal",                    
                    //                                                    .
                    if(getKeyIgnoreCase($tag, $this->_Cart_Item))
                    {
                        if($tag == "local_cartitemsaleprice")
                        {
                            $display_totals_including_taxes = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_DISPLAY_TOTALS_INCLUDING_TAXES);
                            if($display_totals_including_taxes === true)
                            {
                                $new_tag = "local_cartitemsalepriceincludingtaxes";
                                $value = getKeyIgnoreCase($new_tag, $this->_Cart_Item) ? getKeyIgnoreCase($new_tag, $this->_Cart_Item) : null;

                            }
                            else
                            {
                                $new_tag = "local_cartitemsalepriceexcludingtaxes";
                                $value = getKeyIgnoreCase($tag, $this->_Cart_Item) ? getKeyIgnoreCase($new_tag, $this->_Cart_Item) : null;
                            }
                        }
                        elseif($tag == "local_productsubtotal")
                        {
                            $display_totals_including_taxes = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_DISPLAY_TOTALS_INCLUDING_TAXES);
                            if($display_totals_including_taxes === true)
                            {
                                $new_tag = "local_productsubtotalincludingtaxes";
                                $value = getKeyIgnoreCase($new_tag, $this->_Cart_Item) ? getKeyIgnoreCase($new_tag, $this->_Cart_Item) : null;
                            }
                            else
                            {
                                $new_tag = "local_productsubtotalexcludingtaxes";
                                $value = getKeyIgnoreCase($tag, $this->_Cart_Item) ? getKeyIgnoreCase($new_tag, $this->_Cart_Item) : null;
                            }
                        }
                        else
                        {
                            $value = getKeyIgnoreCase($tag, $this->_Cart_Item);
                        }
                    }
                    else
                    {
                        $value = (isset($this->_Tax_Item) ? getKeyIgnoreCase($tag, $this->_Tax_Item) : null);
                    }
                }
                break;
        }
        return $value;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Reference to the object TemplateFiller.
     *
     * @var TemplateFiller
     */
    var $templateFiller;

    /**
     * The current selected template.
     *
     * @var array
     */
    var $template;

    /**
     * Payment Module data for online processing.
     */
    var $paymentProcessingData = NULL;

    /**#@-*/
}
?>