<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * Checkout module.
 *
 * @package Checkout
 * @access  public
 */
class OrderInfo
{

	function OrderInfo()
	{
        $this->template_folder = "order-info";

        if(modApiFunc("Session", "is_Set", "EditOrderForm"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'EditOrderForm');
        }
        else
        {
            $this->initFormData();
        }
	}

	/**
	 * Copies data from the user page to view the form.
	 */
	function copyFormData()
	{
        $EditOrderForm = modApiFunc("Session", "get", "EditOrderForm");
		$this->_form_style = $EditOrderForm['style'];
        $this->ViewState = $EditOrderForm["ViewState"];

        $this->order_id = modApiFunc('Checkout', 'getCurrentOrderID');
        $this->_order           = modApiFunc('Checkout', 'getOrderInfo', $this->order_id, false);
        $this->_order_encrypted = modApiFunc('Checkout', 'getOrderInfo', $this->order_id, true);
        # always updated
		$this->_order['StatusId'] = $EditOrderForm['status_id'];
		$this->_order['PaymentStatusId'] = $EditOrderForm['payment_status_id'];
		$this->_order['TrackId'] = $EditOrderForm['track_id'];
		# updated only for advanced view
		if (array_key_exists('processor_order_id', $EditOrderForm))
		{
    		$this->_order['PaymentProcessorOrderId'] = $EditOrderForm['processor_order_id'];
		}
		if (array_key_exists('payment_method', $EditOrderForm))
		{
    		$this->_order['PaymentMethod'] = $EditOrderForm['payment_method'];
		}
		if (array_key_exists('shipping_method', $EditOrderForm))
		{
    		$this->_order['ShippingMethod'] = $EditOrderForm['shipping_method'];
		}

	}

	/**
	 * Initializes data for the first form view.
	 */
	function initFormData()
	{
		$this->_form_style = ORDERS_INFO_SIMPLE_FORM;
        $this->order_id = modApiFunc('Checkout', 'getCurrentOrderID');
        if ($this->order_id == null)
        {
            $this->_order = null;
        	return;
        }
        $this->_order           = modApiFunc('Checkout', 'getOrderInfo', $this->order_id, false);
        $this->_order_encrypted = modApiFunc('Checkout', 'getOrderInfo', $this->order_id, true);
        $this->_order["Date"] = modApiFunc("Localization", "SQL_date_format", $this->_order["Date"]);
        $this->ViewState = array("hasCloseScript" => "false");
	}

	/**
	 * The main function to output the given view.
	 */
	function output()
	{
        global $application;

        if($this->_order == null || isset($this->ViewState["hasCloseScript"]) && $this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        $this->MessageResources = &$application->getInstance('MessageResources');
        $this->TemplateFiller = $application->getInstance('TmplFiller');
        $application->registerAttributes(array(
            'FormStyle'
           ,'OrderId'
           ,'OrderDate'
           ,'OrderPaymentProcessorOrderId'
           ,'OrderPaymentMethod'
           ,'OrderPaymentMethodDetail'
           ,'OrderShippingMethod'
           ,'OrderTrackId'
           ,'OrderPriceSubtotal'
           ,'OrderPriceSubtotalGlobalDiscount'
           ,'OrderPriceSubtotalPromoCodeDiscount'
           ,'OrderPriceSubtotalPromoCodeDiscountInfo'
           ,'OrderPriceQuantityDiscount'
           ,'OrderPriceDiscountedSubtotal'
           ,'OrderPriceShipping'
           ,'OrderPriceTaxes'
           ,'OrderTaxItemTaxName'
           ,'OrderTaxItemTaxAmount'
           ,'OrderPriceTotal'
           ,'OrderStatusSelector'
           ,'OrderStatusSelectorItems'
           ,'StatusId'
           ,'StatusName'
           ,'StatusSelected'
           ,'OrderPaymentStatusSelector'
           ,'OrderPaymentStatusSelectorItems'
           ,'PaymentStatusId'
           ,'PaymentStatusName'
           ,'PaymentStatusSelected'
           ,'PersonInfo'
           ,'OrderComments'
           ,'OrderHistory'
           ,'GroupName'
           ,'GroupId'
           ,'GroupPersonInfoVariantId'
           ,'GroupTag'
           ,'GroupCVVPurged'
           ,'Counter'
           ,'CommentDate'
           ,'CommentValue'
           ,'InputControlName'
           ,'InputControlValue'
           ,'InputControlSize'
           ,'Products'
           ,'ProductQTY'
           ,'ProductAmount'
           ,'Controls'
           ,'PageTutorialHelpLinks'
           ,'Delete'
           ,'AddCommentVisibilityOpen'
           ,'AddCommentVisibilityClose'
           ,'OrderIvoiceHREF'
           ,'OrderPackingSlipHREF'
        ));

        modApiFunc('Checkout', 'getPersonInfo', 1);
        return $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "container.tpl.html", array());
	}

	/**
	 * Generates a product list for the given order.
	 */
	function getProducts()
	{
	    global $application;
	    $application->registerAttributes(array(
                    "ProductStoreProductID" => ""
                   ,"ProductHandpickedOptions" => ""
                   ,"ProductHotlinks" => ""
                   ,"CycleColor" => ""
                 ));
		$result = "";
		$products = $this->_order['Products'];
		if ($products == null || !is_array($products) || count($products) == 0)
		{
			return $result;
		}
		foreach ($products as $pkey => $product)
		{
            $this->_pkey = $pkey;
			$this->_product = $product;
            foreach ($product["custom_attributes"] as $custom_attr_info)
            {
                $this->_product[$custom_attr_info["tag"]] = $custom_attr_info["value"];
            }
			$result .= $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "product.tpl.html", array());
		}
		return $result;
	}

	/**
	 * Generates a tax list for the given order.
	 */
	function getTaxes()
	{
        global $application;
        $retval ="";
        $this->_Tax_Item = array();

        $taxes = array();
        foreach ($this->_order['Price'] as $key => $value)
        {
            $tax_name_patern = "/^Taxes\['(.+)'\]$/";

            $matches = array();
            if(preg_match($tax_name_patern, $key, $matches))
            {
                $taxes[$matches[1]] = $value;
            }
        }

        foreach ($taxes as $name => $value)
        {
            $this->_Tax_Item['TaxName'] = prepareHTMLDisplay($name);
            $this->_Tax_Item['TaxAmount'] = modApiFunc("Localization", "currency_format", $value);
            $application->registerAttributes($this->_Tax_Item);
            $retval .= $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "order-tax-item.tpl.html", array());
        }
        return $retval;
	}

	/**
	 * @todo describe the function OrderInfo->.
	 */
	function getPersonInfo($infoType)
	{
		global $application;
        $info = $this->_order[$infoType];
        if(!isset($info['id']))
        {
            return "";
        }
		$result = "";
		$this->_counter = 0;
		$this->_group = array(
		    'id' => $info['id']
		   ,'name' => $info['name']
		   ,'tag' => $info['tag']
           ,'personinfovariantid' => $info['person_info_variant_id']
		);
		$result .= $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "group.tpl.html", array());
		foreach ($info['attr'] as $attr)
		{
		    if ($attr['id'] === null) continue;
		    $this->_counter++;
			$this->_attr = array(
			    'tag' => $attr['tag']
			   ,'name' => $attr['name']
			   ,'value' => $attr['value']
			);
		    if ($this->_form_style == ORDERS_INFO_SIMPLE_FORM)
	        {
    	        $result .= $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "attr.tpl.html", array());
	        }
	        else
	        {
	            $this->_input_control = array(
	                'name' => strtolower($infoType)."[".$attr['tag']."]"
	               ,'value' => $attr['value']
	               ,'size' => 70
	            );

                switch($attr['input_type_id'])
                {
                    case "1": /* <input type="text"> */
	                    $result .= $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "attr-input.tpl.html", array());
                        break;
                    case "2": /* <textarea> */
	                    $result .= $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "attr-textarea.tpl.html", array());
                        break;
                    default: /* <input type="text"> */
                        //FIXME: investigate this case thoroughly
	                    $result .= $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "attr-input.tpl.html", array());
                        break;
                }
	        }
		}
		$result .= $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "show-state.tpl.html", array());
		return $result;
	}

	/**
	 * Ouptputs a list of comments for the order.
	 */
	function getComments()
	{
		global $application;

		$notes = $this->_order['Comments'];
		$result = "";
		$this->_counter = 0;
		foreach ($notes as $note)
		{
		    $this->_counter++;
			$this->_note = $note;
			$result .= $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "comment.tpl.html", array());
		}
		return $result;
	}

	/**
	 * Outputs a list of changes for the given order.
	 */
	function getHistory()
	{
		global $application;

		$notes = $this->_order['History'];
		$result = "";
		$this->_counter = 0;
		foreach ($notes as $note)
		{
		    $this->_counter++;
			$this->_note = $note;
			$result .= $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "history.tpl.html", array());
		}
		return $result;
	}

	function getTag($tag)
	{
		global $application;
		$value = null;
		switch ($tag)
		{
		    case 'Products':
		        $value = $this->getProducts();
		        break;

            case 'CycleColor':
                $value = (($this->_pkey % 2) == 0 ? '#FFFFFF' : '#EEEEEE');
                break;

		    case 'PersonInfo':
                $value = '';
                if(modApiFunc('Customer_Account','isPersionInfoGroupActive','Billing'))
		          $value .= $this->getPersonInfo('Billing');
                if(modApiFunc('Customer_Account','isPersionInfoGroupActive','Shipping'))
		          $value .= $this->getPersonInfo('Shipping');
		        break;

		    case 'OrderComments':
		        $value = $this->getComments();
		        break;

		    case 'OrderHistory':
		        $value = $this->getHistory();
		        break;

		    case 'Controls':
                if (modApiFunc("Checkout", "getDeleteOrdersFlag") == "true")
                {
                    $value = $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "controls-style3.tpl.html", array());
                }
		        elseif ($this->_form_style == ORDERS_INFO_SIMPLE_FORM)
		        {
    		        $value = $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "controls-style1.tpl.html", array());
		        }
		        elseif ($this->_form_style == ORDERS_INFO_ADVANCED_FORM)
		        {
    		        $value = $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "controls-style2.tpl.html", array());
		        }
		        break;

		    case 'PageTutorialHelpLinks':
                if (modApiFunc("Checkout", "getDeleteOrdersFlag") == "true")
                {
                    $value = $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "pagetutoriallinks-style3.tpl.html", array());
                }
		        elseif ($this->_form_style == ORDERS_INFO_SIMPLE_FORM)
		        {
    		        $value = $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "pagetutoriallinks-style1.tpl.html", array());
		        }
		        elseif ($this->_form_style == ORDERS_INFO_ADVANCED_FORM)
		        {
    		        $value = $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "pagetutoriallinks-style2.tpl.html", array());
		        }
		        break;

		    case 'CommentDate':
		        $value = modApiFunc("Localization", "SQL_date_format", $this->_note['date'])." ".modApiFunc("Localization", "SQL_time_format", $this->_note['date']);
		        break;

		    case 'CommentValue':
		        $value = $this->_note['content'];
		        break;

    	    case 'Counter':
    	        $value = $this->_counter;
    	        break;

    	    ### Status selectors
		    case 'OrderStatusSelector':
                if (modApiFunc("Checkout", "getDeleteOrdersFlag") == "true")
                {
                    $value = $this->_order['Status'];
                }
                else
                {
                    $value = $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "status-selector.tpl.html", array());
                }
		        break;

		    case 'OrderStatusSelectorItems':
		        $status_array = modApiFunc('Checkout', 'getOrderStatusList');
		        $value = "";
		        foreach ($status_array as $status)
		        {
		        	$this->_status = $status;
    		        $value .= $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "status-selector-item.tpl.html", array());
		        }
		        break;

		    case 'StatusId':
		        $value = $this->_status['id'];
		        break;

		    case 'StatusName':
		        $value = $this->_status['name'];
		        break;

		    case 'StatusSelected':
		        if ($this->_status['id'] == $this->_order['StatusId'])
		        {
		        	$value = " selected";
		        }
		        else
		        {
		            $value = "";
		        }
		        break;

		    case 'OrderPaymentStatusSelector':
                if (modApiFunc("Checkout", "getDeleteOrdersFlag") == "true")
                {
                    $value = $this->_order['PaymentStatus'];
                }
                else
                {
                    $value = $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "payment-status-selector.tpl.html", array());
                }
		        break;

		    case 'OrderPaymentStatusSelectorItems':
		        $status_array = modApiFunc('Checkout', 'getOrderPaymentStatusList');
		        $value = "";
		        foreach ($status_array as $status)
		        {
		        	$this->_payment_status = $status;
    		        $value .= $this->TemplateFiller->fill("checkout/orders/", "payment-status-selector-item.tpl.html", array());
		        }
		        break;

		    case 'PaymentStatusId':
		        $value = $this->_payment_status['id'];
		        break;

		    case 'PaymentStatusName':
		        $value = $this->_payment_status['name'];
		        break;

		    case 'PaymentStatusSelected':
		        if ($this->_payment_status['id'] == $this->_order['PaymentStatusId'])
		        {
		        	$value = " selected";
		        }
		        else
		        {
		            $value = "";
		        }
		        break;

            case 'OrderIvoiceHREF':
                $request=&new Request();
                $request->setView  ( 'OrderInvoice' );
                $request->setAction( 'SetCurrentOrder' );
                $request->setKey   ( 'order_id', $this->order_id);
                $value = $request->getURL();
                break;

            case 'OrderPackingSlipHREF':
                $request=&new Request();
                $request->setView  ( 'OrderPackingSlip' );
                $request->setAction( 'SetCurrentOrder' );
                $request->setKey   ( 'order_id', $this->order_id);
                $value = $request->getURL();
                break;

            case 'OrderTrackId':
                if (modApiFunc("Checkout", "getDeleteOrdersFlag") == "true")
                {
                    $value = $this->_order['TrackId'];
                }
                else
                {
                    $value = "<input type=\"text\" name=\"track_id\" value=\"".$this->_order['TrackId']."\" size=\"40\">";
                }
                break;

		    case 'FormStyle':
		        $value = $this->_form_style;
		        break;

		    case 'OrderPaymentMethod':
		        if ($this->_form_style == ORDERS_INFO_SIMPLE_FORM)
		        {
		        	$value = getKeyIgnoreCase('PaymentMethod', $this->_order);
		        }
		        else
		        {
                    $payment_method = getKeyIgnoreCase('PaymentMethod', $this->_order);
		            $this->_input_control = array(
		                'name' => 'payment_method'
		               ,'value' => $payment_method
		               ,'size' => 40
		            );
		            $value = $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "input-control.tpl.html", array());
		        }
		        break;

		    case 'OrderShippingMethod':
		        if ($this->_form_style == ORDERS_INFO_SIMPLE_FORM)
		        {
		        	$value = getKeyIgnoreCase('ShippingMethod', $this->_order);
		        }
		        else
		        {
                    $shipping_method = getKeyIgnoreCase('ShippingMethod', $this->_order);
		            $this->_input_control = array(
		                'name' => 'shipping_method'
		               ,'value' => $shipping_method
		               ,'size' => 40
		            );
		            $value = $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "input-control.tpl.html", array());
		        }
		        break;

		    case 'OrderPaymentProcessorOrderId':
		        if ($this->_form_style == ORDERS_INFO_SIMPLE_FORM)
		        {
		        	$value = getKeyIgnoreCase('PaymentProcessorOrderId', $this->_order);
		        }
		        else
		        {
                    $processor_order_id = getKeyIgnoreCase('PaymentProcessorOrderId', $this->_order);
		            $this->_input_control = array(
		                'name' => 'processor_order_id'
		               ,'value' => $processor_order_id
		               ,'size' => 40
		            );
		            $value = $this->TemplateFiller->fill("checkout/" . $this->template_folder . "/", "input-control.tpl.html", array());
		        }
		        break;

		    case 'InputControlName': $value = $this->_input_control['name']; break;
		    case 'InputControlValue': $value = $this->_input_control['value']; break;
		    case 'InputControlSize': $value = $this->_input_control['size']; break;

		    case 'Delete':
                $value = modApiFunc("Checkout", "getDeleteOrdersFlag");
                break;

            case 'AddCommentVisibilityOpen':
                if (modApiFunc("Checkout", "getDeleteOrdersFlag") == "true")
                {
                    $value = "<!--";
                }
                break;

            case 'AddCommentVisibilityClose':
                if (modApiFunc("Checkout", "getDeleteOrdersFlag") == "true")
                {
                    $value = "-->";
                }
                break;

            case 'CHECKOUT_ORDER_INFO_REMOVE_ENCRYPTED_PERSON_INFO_MSG':
            case 'CHECKOUT_ORDER_INFO_REMOVE_ENCRYPTED_PERSON_INFO_CONFIRM_MSG':
                $value = $this->_msg[$tag];
                break;

		    default:
		        $tag_copy = $tag;
    	        list($entity, $tag) = getTagName($tag);
        	    if ($entity == 'order')
        	    {
            	    if (strpos($tag, 'price') === 0)
            	    {
            	        $tag = strtolower(substr($tag, strlen('price')));
            	        if ($tag == 'total')
            	        {
            	        	$value = modApiFunc("Localization", "currency_format", $this->_order['Total']);
            	        }
            	        elseif ($tag == 'subtotal')
            	        {
            	        	$value = modApiFunc("Localization", "currency_format", $this->_order['Subtotal']);
            	        }
            	        elseif ($tag == 'taxes')
            	        {
            	        	$value = $this->getTaxes();
            	        }
            	        elseif ($tag == 'shipping')
            	        {
                	        $prices = getKeyIgnoreCase('price', $this->_order);

            	            $shipping = getKeyIgnoreCase("TotalShippingAndHandlingCost", $prices);
                            $shipping = $shipping == PRICE_N_A ? 0.0 : $shipping;

                            $value = modApiFunc("Localization", "currency_format", $shipping);
            	        }
                        elseif ($tag == 'subtotalglobaldiscount')
                        {
                	        $prices = getKeyIgnoreCase('price', $this->_order);

            	            $subtotal_global_discount = getKeyIgnoreCase("SubtotalGlobalDiscount", $prices);
                            $subtotal_global_discount = $subtotal_global_discount == PRICE_N_A ? 0.0 : $subtotal_global_discount;

                            $value = modApiFunc("Localization", "currency_format", $subtotal_global_discount);
                        }
                        elseif ($tag == 'subtotalpromocodediscount')
                        {
                	        $prices = getKeyIgnoreCase('price', $this->_order);
            	            $subtotal_promo_code_discount = getKeyIgnoreCase("SubtotalPromoCodeDiscount", $prices);
                            $subtotal_promo_code_discount = $subtotal_promo_code_discount == PRICE_N_A ? 0.0 : $subtotal_promo_code_discount;

                            $value = modApiFunc("Localization", "currency_format", $subtotal_promo_code_discount);
                        }
                        elseif ($tag == 'subtotalpromocodediscountinfo')
                        {
                            $coupon_tag = "";
                            $value = $coupon_tag;
                        }
                        elseif ($tag == 'quantitydiscount')
                        {
                            $prices = getKeyIgnoreCase('price', $this->_order);
                            $quantity_discount = getKeyIgnoreCase("QuantityDiscount", $prices);
                            $quantity_discount = $quantity_discount == PRICE_N_A ? 0.0 : $quantity_discount;

                            $value = modApiFunc("Localization", "currency_format", $quantity_discount);
                        }
                        elseif ($tag == 'discountedsubtotal')
                        {
                	        $prices = getKeyIgnoreCase('price', $this->_order);
            	            $discounted_subtotal = getKeyIgnoreCase("DiscountedSubtotal", $prices);
                            $discounted_subtotal = $discounted_subtotal == PRICE_N_A ? 0.0 : $discounted_subtotal;

                            $value = modApiFunc("Localization", "currency_format", $discounted_subtotal);
                        }
            	        else
            	        {
                	        $prices = getKeyIgnoreCase('price', $this->_order);
                	        $value = modApiFunc("Localization", "currency_format", getKeyIgnoreCase($tag, $prices));
            	        }
            	    }
        	        elseif(strpos($tag, 'taxitem') === 0)
        	        {
            	        $tag = strtolower(substr($tag, strlen('taxitem')));
        	        	$value = getKeyIgnoreCase($tag, $this->_Tax_Item);
        	        }
            	    else
            	    {
        	           $value = getKeyIgnoreCase($tag, $this->_order);
            	    }
        	    }
        	    elseif ($entity == 'product')
        	    {
        	        if ($tag == 'amount')
        	        {
        	            $qty = getKeyIgnoreCase('qty', $this->_product);
        	            $price = getKeyIgnoreCase('SalePrice', $this->_product['attr']);
        	        	$value = modApiFunc("Localization", "currency_format", $qty * $price['value']);
        	        }
                    elseif ($tag == 'saleprice')
                    {
        	            $price = getKeyIgnoreCase('SalePrice', $this->_product['attr']);
        	        	$value = modApiFunc("Localization", "currency_format", $price['value']);
                    }
                    elseif ($tag == 'handpickedoptions')
                    {
                        $value = "";
                    }
                    elseif ($tag == 'hotlinks')
                    {
                        $value = "";
                    }
        	        else
        	        {
            	    	$value = getKeyIgnoreCase($tag, $this->_product);
        	        }
        	    }
        	    elseif ($entity == 'group')
        	    {
        	        $value = getKeyIgnoreCase($tag, $this->_group);
        	    }
        	    elseif ($entity == 'attribute')
        	    {
                    //The code is not correct. Output the warning about CVV.
                    //It would be better to find the id by the tag in the table person_attributes.
                    $cvv_person_attribute_id = 14;
                    if(isset($this->_attr['personattributeid']) &&
                       $this->_attr['personattributeid'] == $cvv_person_attribute_id)
                    {
                        $value = getKeyIgnoreCase($tag, $this->_attr);
                    }
                    else
                    {
        	            $value = nl2br(htmlentities(getKeyIgnoreCase($tag, $this->_attr)));
                    }
        	    }
				break;
		}
		return $value;
	}

    var $TemplateFiller;
    var $MessageResources;
    var $order_id;
    var $_order;
    var $_product;
    var $_group;
    var $_counter;
    var $_attr;
    var $_note;
    var $_status;
    var $_payment_status;
	var $_form_style;
	var $_input_control;
	var $ViewState;

    var $_pkey;
}
?>