<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * Configuration module.
 *
 * @package Configuration
 * @author Alexey Florinsky
 */
class Configuration
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * News constructor.
     */
    function Configuration()
    {
        $this->constant_values = array();
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Configuration::getTables() instead of $this->getTables()
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources');

        $tables = Configuration::getTables();
        $query = &new DB_Table_Create($tables);

        $table = 'store_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];  #the array of field names of the table

        ##### Hidden settings

        # "Search from" year. Orders list.
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_HIDDEN_ORDER_YEAR_FROM_OFFSET, $columns['name']);
        $query->addInsertValue('integer', $columns['type']);
        $query->addInsertValue('-7', $columns['value']);
        $application->db->getDB_Result($query);

        # "Search to" year. Orders list.
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_HIDDEN_ORDER_YEAR_TO_OFFSET, $columns['name']);
        $query->addInsertValue('integer', $columns['type']);
        $query->addInsertValue('+1', $columns['value']);
        $application->db->getDB_Result($query);

        ##### General settings

        # Store Online/Offline
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_ONLINE, $columns['name']);
        $query->addInsertValue('boolean', $columns['type']);
        $query->addInsertValue('0', $columns['value']);
        $application->db->getDB_Result($query);

        # Store offline key
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_OFFLINE_KEY, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('enter', $columns['value']);
        $application->db->getDB_Result($query);

        # Show products absent in store
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_SHOW_ABSENT, $columns['name']);
        $query->addInsertValue('integer', $columns['type']);
        $query->addInsertValue(STORE_SHOW_ABSENT_SHOW_NOT_BUY, $columns['value']);
        $application->db->getDB_Result($query);

//        # Order products absent in store
//        $query = &new DB_Insert($table);
//        $query->addInsertValue(SYSCONFIG_STORE_ORDER_ABSENT, $columns['name']);
//        $query->addInsertValue('boolean', $columns['type']);
//        $query->addInsertValue('1', $columns['value']);
//        $application->db->getDB_Result($query);

        # System time shift
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_TIME_SHIFT, $columns['name']);
        $query->addInsertValue('integer', $columns['type']);
        $query->addInsertValue('0', $columns['value']);
        $application->db->getDB_Result($query);

        # Admin zone signin count
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_SIGNIN_COUNT, $columns['name']);
        $query->addInsertValue('integer', $columns['type']);
        $query->addInsertValue('5', $columns['value']);
        $application->db->getDB_Result($query);

        # Admin zone signin timeout
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_SIGNIN_TIMEOUT, $columns['name']);
        $query->addInsertValue('integer', $columns['type']);
        $query->addInsertValue('600', $columns['value']);
        $application->db->getDB_Result($query);

        # Admin zone signin timeout
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_SHOW_CART, $columns['name']);
        $query->addInsertValue('boolean', $columns['type']);
        $query->addInsertValue('1', $columns['value']);
        $application->db->getDB_Result($query);

        #Paginators settings
        #AZ
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_PAGINATOR_DEFAULT_ROWS_PER_PAGE_AZ, $columns['name']);
        $query->addInsertValue('integer', $columns['type']);
        $query->addInsertValue('10', $columns['value']);
        $application->db->getDB_Result($query);

        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_PAGINATOR_PAGES_PER_LINE_AZ, $columns['name']);
        $query->addInsertValue('integer', $columns['type']);
        $query->addInsertValue('10', $columns['value']);
        $application->db->getDB_Result($query);


        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_PAGINATOR_ROWS_PER_PAGE_VALUES_AZ, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('a:4:{i:0;i:10;i:1;i:20;i:2;i:30;i:3;i:100;}', $columns['value']);
        $application->db->getDB_Result($query);

        #CZ
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_PAGINATOR_DEFAULT_ROWS_PER_PAGE_CZ, $columns['name']);
        $query->addInsertValue('integer', $columns['type']);
        $query->addInsertValue('10', $columns['value']);
        $application->db->getDB_Result($query);

        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_PAGINATOR_PAGES_PER_LINE_CZ, $columns['name']);
        $query->addInsertValue('integer', $columns['type']);
        $query->addInsertValue('10', $columns['value']);
        $application->db->getDB_Result($query);

        #AddToCart Product Quantity settings
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_ADD_TO_CART_DEFAULT_QUANTITY, $columns['name']);
        $query->addInsertValue('integer', $columns['type']);
        $query->addInsertValue('1', $columns['value']);
        $application->db->getDB_Result($query);

        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_ADD_TO_CART_MAX_QUANTITY, $columns['name']);
        $query->addInsertValue('integer', $columns['type']);
        $query->addInsertValue('30', $columns['value']);
        $application->db->getDB_Result($query);

        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_ADD_TO_CART_LIMIT_MAX_QUANTITY_BY_STOCK, $columns['name']);
        $query->addInsertValue('boolean', $columns['type']);
        $query->addInsertValue('1', $columns['value']);
        $application->db->getDB_Result($query);

        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_ADD_TO_CART_ADD_NOT_REPLACE, $columns['name']);
        $query->addInsertValue('boolean', $columns['type']);
        $query->addInsertValue('1', $columns['value']);
        $application->db->getDB_Result($query);
        ##

        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_PAGINATOR_ROWS_PER_PAGE_VALUES_CZ, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('a:4:{i:0;i:10;i:1;i:20;i:2;i:30;i:3;i:100;}', $columns['value']);
        $application->db->getDB_Result($query);

//        $query = &new DB_Insert($table);
//        $query->addInsertValue(SYSCONFIG_STORE_DISPLAY_PRODUCT_PRICE_INCLUDING_TAXES, $columns['name']);
//        $query->addInsertValue('boolean', $columns['type']);
//        $query->addInsertValue('0', $columns['value']);
//        $application->db->getDB_Result($query);

        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_DISPLAY_TOTALS_INCLUDING_TAXES, $columns['name']);
        $query->addInsertValue('boolean', $columns['type']);
        $query->addInsertValue('0', $columns['value']);
        $application->db->getDB_Result($query);

        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_HIDE_STATE_TEXT_INPUT, $columns['name']);
        $query->addInsertValue('boolean', $columns['type']);
        $query->addInsertValue('0', $columns['value']);
        $application->db->getDB_Result($query);
        ##### Store Owner's Profile

        # Name
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_OWNER_NAME, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('enter', $columns['value']);
        $application->db->getDB_Result($query);

        # Website
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_OWNER_WEBSITE, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('enter', $columns['value']);
        $application->db->getDB_Result($query);

        # Phones
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_OWNER_PHONES, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('enter', $columns['value']);
        $application->db->getDB_Result($query);

        # Fax
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_OWNER_FAX, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('enter', $columns['value']);
        $application->db->getDB_Result($query);

        # Street Line 1
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_OWNER_STREET_LINE_1, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('enter', $columns['value']);
        $application->db->getDB_Result($query);

        # Street Line 2
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_OWNER_STREET_LINE_2, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('enter', $columns['value']);
        $application->db->getDB_Result($query);

        # City
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_OWNER_CITY, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('enter', $columns['value']);
        $application->db->getDB_Result($query);

        # State
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_OWNER_STATE, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('406', $columns['value']); // 406 - NY
        $application->db->getDB_Result($query);

        # Zip/Postal code
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_OWNER_POSTCODE, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('10001', $columns['value']); // NY Post Code
        $application->db->getDB_Result($query);

        # Country
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_OWNER_COUNTRY, $columns['name']);
        $query->addInsertValue('integer', $columns['type']);
        //FIXME: select the default country.
        $query->addInsertValue('223', $columns['value']); // 223 - USA
        $application->db->getDB_Result($query);

        # Store e-mail address
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_OWNER_EMAIL, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('enter', $columns['value']);
        $application->db->getDB_Result($query);

        # Site administrator e-mail address
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_OWNER_SITE_ADMINISTRATOR_EMAIL, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('enter', $columns['value']);
        $application->db->getDB_Result($query);

        # Orders department e-mail address
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_STORE_OWNER_ORDERS_DEPARTMENT_EMAIL, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue('enter', $columns['value']);
        $application->db->getDB_Result($query);

        # Cache Level Default Value
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_CACHE_LEVEL, $columns['name']);
        $query->addInsertValue('integer', $columns['type']);
        $query->addInsertValue('2', $columns['value']);
        $application->db->getDB_Result($query);

		# Cache Level Default Value ????????                          :)
        $query = &new DB_Insert($table);
        $query->addInsertValue(SYSCONFIG_DB_VERSION, $columns['name']);
        $query->addInsertValue('string', $columns['type']);
        $query->addInsertValue(PRODUCT_VERSION_NUMBER, $columns['value']);
        $application->db->getDB_Result($query);

        $table = 'credit_card_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];  #the array of field names of the table

        ##### List of credit/debit cards accepted
        $query = &new DB_Insert($table);
        $query->addInsertValue('Visa', $columns['name']);
        $query->addInsertValue('Visa', $columns['tag']);
        $query->addInsertValue('1', $columns['sort_order']);
        $application->db->getDB_Result($query);

        $query = &new DB_Insert($table);
        $query->addInsertValue('MasterCard', $columns['name']);
        $query->addInsertValue('MasterCard', $columns['tag']);
        $query->addInsertValue('2', $columns['sort_order']);
        $application->db->getDB_Result($query);

        $query = &new DB_Insert($table);
        $query->addInsertValue('Discover', $columns['name']);
        $query->addInsertValue('Discover', $columns['tag']);
        $query->addInsertValue('3', $columns['sort_order']);
        $application->db->getDB_Result($query);

        $query = &new DB_Insert($table);
        $query->addInsertValue('American Express', $columns['name']);
        $query->addInsertValue('Amex', $columns['tag']);
        $query->addInsertValue('4', $columns['sort_order']);
        $application->db->getDB_Result($query);

        $query = &new DB_Insert($table);
        $query->addInsertValue('Maestro', $columns['name']);
        $query->addInsertValue('Maestro', $columns['tag']);
        $query->addInsertValue('5', $columns['sort_order']);
        $application->db->getDB_Result($query);

        $query = &new DB_Insert($table);
        $query->addInsertValue('Solo', $columns['name']);
        $query->addInsertValue('Solo', $columns['tag']);
        $query->addInsertValue('6', $columns['sort_order']);
        $application->db->getDB_Result($query);
    }

    /**
     * Installs the specified module in the system.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Configuration::getTables() instead of $this->getTables()
     */
    function uninstall()
    {
        $query = &new DB_Table_Delete(Configuration::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $tables = array ();

        $store_settings = 'store_settings';
        $tables[$store_settings] = array();
        $tables[$store_settings]['columns'] = array
            (
                'id'                => 'store_settings.variable_id'
               ,'name'              => 'store_settings.variable_name'
               ,'type'              => 'store_settings.variable_type'
               ,'value'             => 'store_settings.variable_value'
            );
        $tables[$store_settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'name'              => DBQUERY_FIELD_TYPE_CHAR255 .' NOT NULL'
               ,'type'              => DBQUERY_FIELD_TYPE_CHAR20 .' NOT NULL'
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255 .' NOT NULL'
            );
        $tables[$store_settings]['primary'] = array
            (
                'id'
            );
        $tables[$store_settings]['indexes'] = array
            (
                'IDX_lrl' => 'name'
            );

        $credit_card_settings = 'credit_card_settings';
        $tables[$credit_card_settings] = array();
        $tables[$credit_card_settings]['columns'] = array
            (
                'id'                => 'credit_card_settings.credit_card_type_id'
               ,'name'              => 'credit_card_settings.credit_card_type_name'
               ,'tag'               => 'credit_card_settings.credit_card_type_tag'
               ,'sort_order'        => 'credit_card_settings.credit_card_type_sort_order'
               ,'visible'           => 'credit_card_settings.credit_card_type_visible'
            );
        $tables[$credit_card_settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'name'              => DBQUERY_FIELD_TYPE_CHAR255 .' NOT NULL'
               ,'tag'               => DBQUERY_FIELD_TYPE_CHAR255 .' NOT NULL'
               ,'sort_order'        => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
               ,'visible'           => DBQUERY_FIELD_BOOLEAN_DEFAULT_TRUE
            );
        $tables[$credit_card_settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**
     * Returns a real value of system variable.
     */
    function getValue($constant)
    {
        // $this->constant_values = array ('constant' => 'value', ...);
        global $application;

        if ($this->constant_values == array() || !array_key_exists($constant, $this->constant_values) )
        {
            $tables = $this->getTables();
            $columns = $tables['store_settings']['columns'];

            $query = &new DB_Select();
            $query->addSelectField($columns["type"], "type");
            $query->addSelectField($columns["value"], "value");
            $query->WhereValue($columns["name"], DB_EQ, $constant);
            $result = $application->db->getDB_Result($query);

            switch ($result[0]['type'])
            {
                case 'integer':
                    $this->constant_values[$constant] = intval($result[0]['value']);
                    break;
                case 'boolean':
                    $this->constant_values[$constant] = (boolean)($result[0]['value']);
                    break;
                case 'string':
                    $this->constant_values[$constant] = (string)($result[0]['value']);
                    break;
            }
        }

        return $this->constant_values[$constant];
    }

    function getCreditCardSettings($visible_only = true)
    {
        //                                
        global $application;


        $tables = $this->getTables();
        $columns = $tables['credit_card_settings']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($columns["id"], "id");
        $query->addSelectField($columns["name"], "name");
        $query->addSelectField($columns["tag"], "tag");
        $query->addSelectField($columns["sort_order"], "sort_order");
        $query->addSelectField($columns["visible"], "visible");
        if($visible_only === true)
        {
            $query->WhereValue($columns["visible"], DB_EQ, DB_TRUE);
        }
        $query->SelectOrder($columns['sort_order']);

        $result = $application->db->getDB_Result($query);
        $res = array();
        foreach ($result as $credit_card_info)
        {
            $res[$credit_card_info["tag"]] = array
            (
                "id"         =>          $credit_card_info["id"]
               ,"sort_order" =>          $credit_card_info["sort_order"]
               ,"name"       =>  (string)$credit_card_info["name"]
               ,"tag"        =>  (string)$credit_card_info["tag"]
               ,"visible"    =>  (string)$credit_card_info["visible"]
            );
        }
        return $res;
    }


    /**
     * @todo describe the function Configuration->.
     */
    function setValue($value)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['store_settings']['columns'];

        $values = array();
    	if (is_array($value))
    	{
    	    $values = $value;
    	}
    	else
    	{
    	    list($name, $val) = $value;
    		$values[$name] = $val;
    	}
    	foreach ($values as $name => $value)
    	{
            $query = &new DB_Update('store_settings');
            $query->addUpdateValue($columns["value"], $value);
            $query->WhereValue($columns["name"], DB_EQ, $name);
            $result = $application->db->getDB_Result($query);
            $this->constant_values[$name] = $value;
    	}
    }

    /**
     * @todo describe the function Configuration->.
     */
    function setCreditCardSettings($values)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['credit_card_settings']['columns'];

        foreach ($values as $id => $info)
        {
            $query = &new DB_Update('credit_card_settings');
            if(isset($info["name"]))
            {
                $query->addUpdateValue($columns["name"], $info["name"]);
            }
            if(isset($info["visible"]))
            {
                $query->addUpdateValue($columns["visible"], $info["visible"]);
            }
            $query->WhereValue($columns["id"], DB_EQ, $id);
            $result = $application->db->getDB_Result($query);
        }
    }

    /**
     *        -                                   .  . .           sort_order       
     *                                   .
     *
     */
    function generateCreditCardTypeSortOrder()
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['credit_card_settings']['columns'];
        $query = &new DB_Select();
        $query->addSelectField($query->fMax($columns['sort_order']), 'max');
        $result = $application->db->getDB_Result($query);
        return ($result[0]['max']+1);
    }

    function addCreditCardType($new_credit_card_type_name)
    {
        global $application;
        $short_name = preg_replace("/[^a-zA-Z0-9]/", "", $new_credit_card_type_name);
        //                            .
        $new_credit_card_type_tag = "without_validation_" . $short_name . "_" . time();
        $new_credit_card_type_sort_order = $this->generateCreditCardTypeSortOrder();

        $tables =  $this->getTables();
        $table = 'credit_card_settings';
        $columns = $tables[$table]['columns'];
        $query = &new DB_Insert($table);
        $query->addInsertValue($new_credit_card_type_name, $columns['name']);
        $query->addInsertValue($new_credit_card_type_tag,  $columns['tag']);
        $query->addInsertValue($new_credit_card_type_sort_order,  $columns['sort_order']);

        $application->db->getDB_Result($query);
    }

    /**
     * Saves the sort of credit card types.
     *
     * @return
     */
    function setCreditCardTypesSortOrder($ccTypesSortOrderArray)
    {
        global $application;

        foreach ($ccTypesSortOrderArray as $sort_order => $cc_type_id)
        {
            $tables = $this->getTables();
            $columns = $tables['credit_card_settings']['columns'];
            $query = &new DB_Update('credit_card_settings');
            $query->addUpdateValue($columns['sort_order'], $sort_order);
            $query->WhereValue($columns['id'], DB_EQ, $cc_type_id);
            $application->db->getDB_Result($query);
        }
    }
    /**#@-*/

    /**
     * Returns values for system-wide (including CZ) info tags.
     */
    function getTagValue($tag)
    {
        global $application;
        $value = null;
        switch($tag)
        {
            case "StoreOwnerState":
                //menu_select
                $state_id = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_STATE);
                if((!empty($state_id)) && is_numeric($state_id))
                {
                    if (modApiFunc('Location', 'getCountStatesInCountry', modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_COUNTRY)) > 0)
                    {
                        $value = modApiFunc("Location", "getState", $state_id);
                    }
                    else
                    {
                        $value = $state_id;
                    }
                }
                else
                {
                    $value = $state_id;
                }
                break;
            case "StoreOwnerCountry":
                $country_id = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_COUNTRY);
                $value = modApiFunc("Location", "getCountry", $country_id);
                break;
            case "StoreOwnerName":
                $value = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_NAME);
                break;
            case "StoreOwnerWebsite":
                $value = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_WEBSITE);
                break;
            case "StoreOwnerPhones":
                $value = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_PHONES);
                break;
            case "StoreOwnerFax":
                $value = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_FAX);
                break;
            case "StoreOwnerStreetLine1":
                $value = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_STREET_LINE_1);
                break;
            case "StoreOwnerStreetLine2":
                $value = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_STREET_LINE_2);
                break;
            case "StoreOwnerCity":
                $value = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_CITY);
                break;
            case "StoreOwnerPostcode":
                $value = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_POSTCODE);
                break;
            case "StoreOwnerEmail":
                $value = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_EMAIL);
                break;
            case "StoreOwnerSiteAdministratorEmail":
                $value = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_SITE_ADMINISTRATOR_EMAIL);
                break;
            case "StoreOwnerOrdersDepartmentEmail":
                $value = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_ORDERS_DEPARTMENT_EMAIL);
                break;
            default:
                $value = modApiFunc('Configuration', 'getValue', $tag);
                break;
        }
        return $value;
    }

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */


    /**#@-*/

}
?>