<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Configuration Module, Cache Settings.
 *
 * @package Configuration
 * @author Alexey Florinsky
 */
class CacheSettings
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * CacheSettings constructor.
     */
    function CacheSettings()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources');
    }

    /**
     *
     */
    function output()
    {
        global $application;

        $application->registerAttributes(array(
            'CacheSize', 'CacheLevelSelectControlName',
            'CacheLevelSelectControlOptions','CacheLevelValue',
            'isSelectedCacheLevel','CacheLevelLabel'
        ));

        return modApiFunc('TmplFiller', 'fill', "configuration/cache_settings/","container.tpl.html", array());
    }

    function getDirectorySize()
    {
        global $application;
        $path = $application->getAppINI('PATH_CACHE_DIR');
        $totalsize = 0;
        if ($handle = opendir ($path))
        {
            while (false !== ($file = readdir($handle)))
            {
                $nextpath = $path . '/' . $file;
                if ($file != '.' && $file != '..' && !is_link ($nextpath) &&
                    is_file ($nextpath) && strpos($file, '_cache')===0 )
                {
                    $totalsize += filesize ($nextpath);
                }
            }
      }
      closedir ($handle);
      return $totalsize;
    }

    function sizeFormat($size)
    {
        if($size<1024)
        {
            return $size.' '.$this->MessageResources->getMessage("CACHE_SETTINGS_SIZE_B");
        }
        else if($size<(1024*1024))
        {
            $size=round($size/1024,1);
            return $size.' '.$this->MessageResources->getMessage("CACHE_SETTINGS_SIZE_KB");
        }
        else if($size<(1024*1024*1024))
        {
            $size=round($size/(1024*1024),1);
            return $size.' '.$this->MessageResources->getMessage("CACHE_SETTINGS_SIZE_MB");
        }
        else
        {
            $size=round($size/(1024*1024*1024),1);
            return $size.' '.$this->MessageResources->getMessage("CACHE_SETTINGS_SIZE_GB");
        }
    }

    function getTag($tag)
	{
		global $application;
		$value = null;
		switch ($tag)
		{
            case 'CacheSize':
                $value = $this->sizeFormat($this->getDirectorySize());
                break;

            case 'CacheLevelSelectControlName':
                $value = SYSCONFIG_CACHE_LEVEL;
                break;

            case 'CacheLevelSelectControlOptions':
                $currentCacheLevel = modApiFunc('Configuration','getValue',SYSCONFIG_CACHE_LEVEL);

                $CacheLevelLabels = array(
                    0 => $this->MessageResources->getMessage("CACHE_SETTINGS_LEVEL_DISABLED"),
                    1 => $this->MessageResources->getMessage("CACHE_SETTINGS_LEVEL_MINIMUM"),
                    2 => $this->MessageResources->getMessage("CACHE_SETTINGS_LEVEL_MEDIUM"),
                    3 => $this->MessageResources->getMessage("CACHE_SETTINGS_LEVEL_MAXIMUM")
                );

                for ($i=0; $i<4 ; $i++ )
                {
                    $this->_selectCacheLevelOptionData = array(
                        'CacheLevelValue' => $i,
                        'isSelectedCacheLevel' => ($i == $currentCacheLevel) ? 'SELECTED' : '',
                        'CacheLevelLabel' => $CacheLevelLabels[$i]
                    );
                    $value .= modApiFunc('TmplFiller', 'fill', "configuration/cache_settings/","select_options.tpl.html", array());
                }
                break;

            case 'CacheLevelValue';
                $value = $this->_selectCacheLevelOptionData['CacheLevelValue'];
                break;

            case 'isSelectedCacheLevel';
                $value = $this->_selectCacheLevelOptionData['isSelectedCacheLevel'];
                break;

            case 'CacheLevelLabel';
                $value = $this->_selectCacheLevelOptionData['CacheLevelLabel'];
                break;

		}
		return $value;
	}


    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $MessageResources;
    var $_selectCacheLevelOptionData;

    /**#@-*/

}
?>