<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Configuration Module, GeneralSettings View.
 *
 * @package Configuration
 * @author Alexey Florinsky
 */
class GeneralSettings
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * AvactisHomeNews constructor.
     */
    function GeneralSettings()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources');
    }

    /**
     *
     */
    function output()
    {
        global $application;

        $application->registerAttributes(array(
            'GSOnline'
           ,'GSOfflineKey'
           ,'GSShowAbsent'
//           ,'GSOrderAbsent'
           ,'GSTime'
           ,'GSTimeShift'
           ,'GSSignCount'
           ,'GSSignTimeout'
           ,'GSShowCart'
           ,'GSPaginatorDefaultRowsPerPageAZ'
           ,'GSPaginatorPagesPerLineAZ'
           ,'GSPaginatorRowsPerPageValuesAZ'
           ,'GSPaginatorDefaultRowsPerPageCZ'
           ,'GSPaginatorPagesPerLineCZ'
           ,'GSPaginatorRowsPerPageValuesCZ'
           ,'GSAddToCartDefaultQuantity'
           ,'GSAddToCartMaxQuantity'
           ,'GSAddToCartLimitMaxQuantityByStock'
           ,'GSADisplayProductPriceIncludingTaxes'
           ,'GSHideStateTextInput'
           ,'GSADisplayTotalsIncludingTaxes'
           ,'GSAddToCartAddNotReplace'
           ,'GSNextOrderId'
           ,'InputControlName'
           ,'InputControlValue'
           ,'InputControlSize'
           ,'InputControlLabel'
           ,'InputControlOptions'
           ,'InputControlChecked'
           ,'ElementEvent'
           ,'DependentControl'
        ));

        return modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","container.tpl.html", array());
    }

	function getTag($tag)
	{
		global $application;
		$value = null;
		switch ($tag)
		{
		    case 'GSOnline':
		        $this->_input_control = array(
		            'name' => SYSCONFIG_STORE_ONLINE
		           ,'size' => 1
		           ,'selected' => modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_ONLINE)
		           ,'options' => array(
		                '1' => $this->MessageResources->getMessage("GNRL_SET_ONLINE_LABEL")
		               ,'0' => $this->MessageResources->getMessage("GNRL_SET_CLOSED_LABEL")
		           )
		        );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","select-box.tpl.html", array());
		        break;

		    case 'GSOfflineKey':
		        $this->_input_control = array(
		            'name' => SYSCONFIG_STORE_OFFLINE_KEY
		           ,'value' => modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OFFLINE_KEY)
		           ,'size' => 20
                   ,'event' => "onkeyup=\"javascript: showOfflineKey(this);\" onfocus=\"javascript: showOfflineKey(this);\""
		        );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","text-field.tpl.html", array());
		        break;

		    case 'GSTime':
		        $value = modApiFunc("Localization", "timestamp_time_format", time()).", ".modApiFunc("Localization", "timestamp_date_format", time());
		        break;

		    case 'GSTimeShift':
		        $hours = array();
		        for ($h = -24; $h <= 24; $h++) $hours[$h] = $h;
		        $this->_input_control = array(
		            'name' => SYSCONFIG_STORE_TIME_SHIFT
		           ,'size' => 1
		           ,'selected' => modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_TIME_SHIFT)
		           ,'options' => $hours
		        );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","select-box.tpl.html", array());
		        break;

		    case 'GSSignCount':
                $SignInCount = modApiFunc("Users", "getIncorrectLoginTimeCountArray");
		        $this->_input_control = array(
		            'name' => SYSCONFIG_STORE_SIGNIN_COUNT
		           ,'size' => 1
		           ,'selected' => modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_SIGNIN_COUNT)
		           ,'options' => $SignInCount
		        );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","select-box.tpl.html", array());
		        break;

		    case 'GSSignTimeout':
                $Timeout = modApiFunc("Users", "getLoginBlockTimeArray");
		        $this->_input_control = array(
		            'name' => SYSCONFIG_STORE_SIGNIN_TIMEOUT
		           ,'size' => 1
		           ,'selected' => modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_SIGNIN_TIMEOUT)
		           ,'options' => $Timeout
		        );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","select-box.tpl.html", array());
		        break;

		    case 'GSShowAbsent':
		        $current = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_SHOW_ABSENT);
		        $this->_input_control = array(
		            'name' => SYSCONFIG_STORE_SHOW_ABSENT
		           ,'value' => STORE_SHOW_ABSENT_SHOW_BUY
		           ,'label' => $this->MessageResources->getMessage("GNRL_SET_SHOW_ABSENT_SHOW_BUY_LABEL")
		           ,'checked' => $current == STORE_SHOW_ABSENT_SHOW_BUY
		        );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","radio-box.tpl.html", array());
		        $this->_input_control = array(
		            'name' => SYSCONFIG_STORE_SHOW_ABSENT
		           ,'value' => STORE_SHOW_ABSENT_SHOW_NOT_BUY
		           ,'label' => $this->MessageResources->getMessage("GNRL_SET_SHOW_ABSENT_SHOW_NOT_BUY_LABEL")
		           ,'checked' => $current == STORE_SHOW_ABSENT_SHOW_NOT_BUY
		        );
                $value .= modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","radio-box.tpl.html", array());
                $this->_input_control = array(
                    'name' => SYSCONFIG_STORE_SHOW_ABSENT
                   ,'value' => STORE_SHOW_ABSENT_NOT_SHOW_NOT_BUY
                   ,'label' => $this->MessageResources->getMessage("GNRL_SET_SHOW_ABSENT_NOT_SHOW_NOT_BUY_LABEL")
                   ,'checked' => $current == STORE_SHOW_ABSENT_NOT_SHOW_NOT_BUY
                );
                $value .= modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","radio-box.tpl.html", array());
		        break;

//		    case 'GSOrderAbsent':
//		        $current = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_ORDER_ABSENT);
//		        $this->_input_control = array(
//		            'name' => SYSCONFIG_STORE_ORDER_ABSENT
//		           ,'value' => 1
//		           ,'label' => $this->MessageResources->getMessage("GNRL_SET_ENABLED_LABEL")
//		           ,'checked' => $current
//		        );
//                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","radio-box.tpl.html", array());
//		        $this->_input_control = array(
//		            'name' => SYSCONFIG_STORE_ORDER_ABSENT
//		           ,'value' => 0
//		           ,'label' => $this->MessageResources->getMessage("GNRL_SET_DISABLED_LABEL")
//		           ,'checked' => !$current
//		        );
//                $value .= modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","radio-box.tpl.html", array());
//		        break;

		    case 'GSShowCart':
		        $current = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_SHOW_CART);
		        $this->_input_control = array(
		            'name' => SYSCONFIG_STORE_SHOW_CART
		           ,'value' => 1
		           ,'label' => $this->MessageResources->getMessage("GNRL_SET_ENABLED_LABEL")
		           ,'checked' => $current
		        );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","radio-box.tpl.html", array());
		        $this->_input_control = array(
		            'name' => SYSCONFIG_STORE_SHOW_CART
		           ,'value' => 0
		           ,'label' => $this->MessageResources->getMessage("GNRL_SET_DISABLED_LABEL")
		           ,'checked' => !$current
		        );
                $value .= modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","radio-box.tpl.html", array());
		        break;

            case 'GSPaginatorDefaultRowsPerPageAZ':
            case 'GSPaginatorDefaultRowsPerPageCZ':
                if ($tag == 'GSPaginatorDefaultRowsPerPageAZ')
                {
                    $const_rows_per_page = SYSCONFIG_STORE_PAGINATOR_DEFAULT_ROWS_PER_PAGE_AZ;
                    $const_rows_per_page_values = SYSCONFIG_STORE_PAGINATOR_ROWS_PER_PAGE_VALUES_AZ;
                }
                else
                {
                    $const_rows_per_page = SYSCONFIG_STORE_PAGINATOR_DEFAULT_ROWS_PER_PAGE_CZ;
                    $const_rows_per_page_values = SYSCONFIG_STORE_PAGINATOR_ROWS_PER_PAGE_VALUES_CZ;
                }
                $rows_per_page_values = unserialize(modApiFunc('Configuration', 'getValue', $const_rows_per_page_values));
                $rows_per_page_array = array();
                foreach ($rows_per_page_values as $val)
                {
                    $rows_per_page_array[$val] = $val;
                }
                $this->_input_control = array(
                    'name' => $const_rows_per_page
                   ,'size' => 1
                   ,'selected' => modApiFunc('Configuration', 'getValue', $const_rows_per_page)
                   ,'options' => $rows_per_page_array
                );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","select-box.tpl.html", array());
                break;

            case 'GSPaginatorRowsPerPageValuesAZ':
            case 'GSPaginatorRowsPerPageValuesCZ':
                if ($tag == 'GSPaginatorRowsPerPageValuesAZ')
                {
                    $const_rows_per_page = SYSCONFIG_STORE_PAGINATOR_DEFAULT_ROWS_PER_PAGE_AZ;
                    $const_rows_per_page_values = SYSCONFIG_STORE_PAGINATOR_ROWS_PER_PAGE_VALUES_AZ;
                }
                else
                {
                    $const_rows_per_page = SYSCONFIG_STORE_PAGINATOR_DEFAULT_ROWS_PER_PAGE_CZ;
                    $const_rows_per_page_values = SYSCONFIG_STORE_PAGINATOR_ROWS_PER_PAGE_VALUES_CZ;
                }
                $rows_per_page_values = unserialize(modApiFunc('Configuration', 'getValue', $const_rows_per_page_values));
                $rows_per_page_array = array();
                foreach ($rows_per_page_values as $val)
                {
                    $rows_per_page_array[$val] = $val;
                }
                $this->_input_control = array(
                    'name' => $const_rows_per_page_values
                   ,'size' => sizeof($rows_per_page_array)>3? sizeof($rows_per_page_array):3
                   ,'selected' => ""
                   ,'options' => $rows_per_page_array
                   ,'value' => implode("|", $rows_per_page_array)
                   ,'dependent_cntrol' => $const_rows_per_page
                );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","select-box-and-text-field.tpl.html", array());
                break;

            case 'GSAddToCartDefaultQuantity':
		        $this->_input_control = array(
		            'name' => SYSCONFIG_STORE_ADD_TO_CART_DEFAULT_QUANTITY
		           ,'value' => modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_ADD_TO_CART_DEFAULT_QUANTITY)
		           ,'size' => 5
                   ,'event' => ""
		        );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","text-field.tpl.html", array());
		        break;

            case 'GSAddToCartMaxQuantity':
		        $this->_input_control = array(
		            'name' => SYSCONFIG_STORE_ADD_TO_CART_MAX_QUANTITY
		           ,'value' => modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_ADD_TO_CART_MAX_QUANTITY)
		           ,'size' => 5
                   ,'event' => ""
		        );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","text-field.tpl.html", array());
		        break;

		    case 'GSAddToCartLimitMaxQuantityByStock':
		        $this->_input_control = array(
		            'name' => SYSCONFIG_STORE_ADD_TO_CART_LIMIT_MAX_QUANTITY_BY_STOCK
		           ,'size' => 1
		           ,'selected' => modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_ADD_TO_CART_LIMIT_MAX_QUANTITY_BY_STOCK)
		           ,'options' => array(
		                '1' => $this->MessageResources->getMessage("GNRL_SET_YES_LABEL")
		               ,'0' => $this->MessageResources->getMessage("GNRL_SET_NO_LABEL")
		           )
		        );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","select-box.tpl.html", array());
		        break;

//            case 'GSADisplayProductPriceIncludingTaxes':
//                $this->_input_control = array(
//                    'name' => SYSCONFIG_STORE_DISPLAY_PRODUCT_PRICE_INCLUDING_TAXES
//                   ,'size' => 1
//                   ,'selected' => modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_DISPLAY_PRODUCT_PRICE_INCLUDING_TAXES)
//                   ,'options' => array(
//                        '1' => $this->MessageResources->getMessage("GNRL_SET_YES_LABEL")
//                       ,'0' => $this->MessageResources->getMessage("GNRL_SET_NO_LABEL")
//                   )
//                );
//                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","select-box.tpl.html", array());
//                break;

            case 'GSADisplayTotalsIncludingTaxes':
                $this->_input_control = array(
                    'name' => SYSCONFIG_STORE_DISPLAY_TOTALS_INCLUDING_TAXES
                   ,'size' => 1
                   ,'selected' => modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_DISPLAY_TOTALS_INCLUDING_TAXES)
                   ,'options' => array(
                        '1' => $this->MessageResources->getMessage("GNRL_SET_YES_LABEL")
                       ,'0' => $this->MessageResources->getMessage("GNRL_SET_NO_LABEL")
                   )
                );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","select-box.tpl.html", array());
                break;
            case 'GSHideStateTextInput':
                $this->_input_control = array(
                    'name' => SYSCONFIG_STORE_HIDE_STATE_TEXT_INPUT
                   ,'size' => 1
                   ,'selected' => modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_HIDE_STATE_TEXT_INPUT)
                   ,'options' => array(
                        '1' => $this->MessageResources->getMessage("GNRL_SET_YES_LABEL")
                       ,'0' => $this->MessageResources->getMessage("GNRL_SET_NO_LABEL")
                   )
                );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","select-box.tpl.html", array());
                break;
		    case 'GSAddToCartAddNotReplace':
		        $this->_input_control = array(
		            'name' => SYSCONFIG_STORE_ADD_TO_CART_ADD_NOT_REPLACE
		           ,'size' => 1
		           ,'selected' => modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_ADD_TO_CART_ADD_NOT_REPLACE)
		           ,'options' => array(
		                '1' => $this->MessageResources->getMessage("GNRL_SET_FIELD_017_ADD")
		               ,'0' => $this->MessageResources->getMessage("GNRL_SET_FIELD_017_REPLACE")
		           )
		        );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","select-box.tpl.html", array());
		        break;

            case 'GSNextOrderId':
                $this->_input_control = array(
                    'name' => SYSCONFIG_STORE_NEXT_ORDER_ID
                   ,'value' => modApiFunc('Checkout', 'getNextOrderId')
                   ,'size' => 10
                   ,'event' => ""
                );
                $value = modApiFunc('TmplFiller', 'fill', "configuration/general_settings/","text-field.tpl.html", array());
                break;

		    case 'InputControlName': $value = $this->_input_control['name']; break;
		    case 'InputControlValue': $value = $this->_input_control['value']; break;
		    case 'InputControlLabel': $value = $this->_input_control['label']; break;
		    case 'InputControlSize': $value = $this->_input_control['size']; break;
		    case 'InputControlChecked': $value = ($this->_input_control['checked'] ? " checked" : ""); break;
            case 'ElementEvent': $value = (isset($this->_input_control['event'])? $this->_input_control['event']:"");break;
            case 'DependentControl': $value = (isset($this->_input_control['dependent_cntrol'])? $this->_input_control['dependent_cntrol']:"");break;
		    case 'InputControlOptions':
		        $value = "";
		        foreach ($this->_input_control['options'] as $key => $label)
		        {
		            $selected = "";
		            if (isset($this->_input_control['selected']) && $this->_input_control['selected'] == $key)
		            {
		            	$selected = " selected";
		            }
		        	$value .= "<option value=\"$key\"$selected>$label</option>";
		        }
		        break;
		    default:
				break;
		}
		return $value;
	}

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

	var $_input_control;

    /**#@-*/

}
?>