<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Module "Currency Converter"
 *
 * @package CurrencyConverter
 * @author Egor V. Derevyankin
 */

class Currency_Converter
{
    function Currency_Converter()
    {
    }

    function getInfo()
    {}

    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        };

        $tables = array ();

        $rates_cache = 'cconv_rates_cache';
        $tables[$rates_cache] = array();
        $tables[$rates_cache]['columns'] = array
            (
                'id'                => $rates_cache.'.crate_id'
               ,'from_to'           => $rates_cache.'.crate_from_to'
               ,'rate'              => $rates_cache.'.crate_rate'
               ,'expire'            => $rates_cache.'.crate_expire'
            );
        $tables[$rates_cache]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'from_to'           => DBQUERY_FIELD_TYPE_CHAR10 .' NOT NULL'
               ,'rate'              => DBQUERY_FIELD_TYPE_DECIMAL12_4 .' NOT NULL'
               ,'expire'            => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
            );
        $tables[$rates_cache]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);

    }

    function install()
    {
        $tables = Currency_Converter::getTables();
        $query = &new DB_Table_Create($tables);
    }

    function uninstall()
    {
        $query = &new DB_Table_Delete(Currency_Converter::getTables());
    }

    function convert($from,$to)
    {
        if($from == "" or $to == "")
        {
            return false;
        };

        $RATES_SOURCES = array("Cache", "WebServiceX", "Google");

        reset($RATES_SOURCES);
        foreach($RATES_SOURCES as $source)
        {
            $func_name = "getRateFrom$source";
            $rate = $this->$func_name($from,$to);
            if($rate == false)
            {
                continue;
            }
            else
            {
                if($source != "Cache")
                {
                    $this->saveRateToCache($from,$to,$rate);
                };
                return $rate;
            };
        };

       return false;
    }

    function saveRateToCache($from,$to,$rate)
    {
        $rev_rate = 1/$rate;

        global $application;
        $tables=$this->getTables();
        $rc_table=$tables['cconv_rates_cache']['columns'];

        $query = &new DB_Delete('cconv_rates_cache');
        $query->WhereValue($rc_table['from_to'], DB_EQ, $from."->".$to);
        $query->WhereOR();
        $query->WhereValue($rc_table['from_to'], DB_EQ, $to."->".$from);
        $query->WhereOR();
        $query->Where($rc_table['expire'], DB_LT, time());
        $application->db->getDB_Result($query);

        loadCoreFile('db_multiple_insert.php');
        $query = &new DB_Multiple_Insert('cconv_rates_cache');
        $query->setInsertFields(array($rc_table['from_to'],$rc_table['rate'],$rc_table['expire']));
        $query->addInsertValuesArray(array(
            'from_to' => $from.'->'.$to
           ,'rate'    => $rate
           ,'expire'  => time()+CURRENCY_CONVERTER_RATE_EXPIRE_PERIOD
        ));
        $query->addInsertValuesArray(array(
            'from_to' => $to.'->'.$from
           ,'rate'    => $rev_rate
           ,'expire'  => time()+CURRENCY_CONVERTER_RATE_EXPIRE_PERIOD
        ));
        $application->db->PrepareSQL($query);
        $application->db->DB_Exec();

        return;
    }

    function getRateFromCache($from,$to)
    {
        global $application;
        $tables=$this->getTables();
        $rc_table=$tables['cconv_rates_cache']['columns'];

        $query = &new DB_Select();
        $query->addSelectTable('cconv_rates_cache');
        $query->addSelectField($rc_table['rate'],'rate');
        $query->WhereValue($rc_table['from_to'], DB_EQ, $from."->".$to);
        $query->WhereAND();
        $query->Where($rc_table['expire'], DB_GT, time());

        $cached=$application->db->getDB_Result($query);

        if(isset($cached[0]["rate"]))
            return $cached[0]["rate"]*1;
        else
            return false;
    }

    function getRateFromGoogle($from,$to)
    {
        loadCoreFile('bouncer.php');
        $bnc = &new Bouncer();
        $bnc->setHTTPversion("1.0");
        $bnc->setMethod("GET");
        $bnc->setURL("http://www.google.com/search");
        $get_params=array(
            "q" => $from." in ".$to,
        );
        $bnc->setGETstring($bnc->prepareDATAstring($get_params));
        $res=$bnc->RunRequest();
        if($res != false)
        {
            $responce = $res["body"];
            preg_match("/= ([0-9\.]+)/i",$responce,$matches);
            if(isset($matches[1]))
                return round($matches[1],4);
            else
                return false;
        };

        return false;
    }

    function getRateFromWebServiceX($from,$to)
    {
        loadCoreFile('bouncer.php');
        $bnc = &new Bouncer();
        $bnc->setHTTPversion("1.0");
        $bnc->setMethod("GET");
        $bnc->setURL("http://www.webservicex.net/CurrencyConvertor.asmx/ConversionRate");
        $get_params=array(
            "FromCurrency" => $from
           ,"ToCurrency" => $to
        );
        $bnc->setGETstring($bnc->prepareDATAstring($get_params));
        $res=$bnc->RunRequest();
        if($res != false)
        {
            $xml = $res["body"];
            loadCoreFile('obj_xml.php');
            $parser = &new xml_doc($xml);
            $parser->parse();
            foreach($parser->xml_index as $node)
            {
                if($node->name = "DOUBLE")
                    return $node->contents;
            };
        };

        return false;
    }
};

?>