<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package CustomerAccount
 * @author Egor V. Derevyankin
 *
 */

class CustomerAccountInfo
{
    function CustomerAccountInfo()
    {
        global $application;
        $request = &new Request();
        $customer_id = $request->getValueByKey('customer_id');
        $account_name = modApiFunc('Customer_Account','getCustomerAccountNameByCustomerID',$customer_id);
        $this->customer_obj = &$application->getInstance('CCustomerInfo',$account_name);
        $this->customer_obj->setPersonInfoAttrsType(PERSON_INFO_GROUP_ATTR_VISIBLE);
    }

    function out_AttributesList($group_name)
    {
        global $application;
        $html_code = '';

        $group_info = $this->customer_obj->getPersonInfoGroupInfoByName($group_name);

        foreach($this->customer_obj->getPersonInfoGroupAttrsNames($group_name) as $attr_name)
        {
            if(preg_match("/password/i",$attr_name))
                continue;

            if($attr_name == 'AccountName' and $this->customer_obj->getPersonInfo('Status') == 'B')
                continue;

            $attr_info = $this->customer_obj->getPersonInfoAttrInfoByName($attr_name, $group_name);
            $attr_value = $this->customer_obj->getPersonInfo($attr_name, $group_name);

            if($attr_name == 'Country')
            {
                $attr_value = modApiFunc('Location','getCountry',$attr_value);
            };
            if($attr_name == 'State')
            {
                $state_code = modApiFunc('Location','getStateCode',$attr_value);
                if($state_code != '')
                {
                    $attr_value = modApiFunc('Location','getState',$attr_value);
                };
            };

            $template_contents = array(
                'AttributeName' => $attr_info['visible_name']
               ,'AttributeValue' => $attr_value
               ,'AttributeID' => $attr_info['attr_id']
               ,'GroupID' => $group_info['id']
            );

            $this->_Template_Contents=$template_contents;
            $application->registerAttributes($this->_Template_Contents);
            $this->mTmplFiller = &$application->getInstance('TmplFiller');
            $html_code .= $this->mTmplFiller->fill("customer_account/account_info/", "attribute.tpl.html",array());
        };

        return $html_code;
    }

    function out_GroupsList()
    {
        global $application;
        $html_code = '';

        foreach($this->customer_obj->getPersonInfoGroupsNames() as $group_name)
        {
            if(!modApiFunc('Customer_Account','isPersionInfoGroupActive',$group_name))
                continue;

            $group_info = $this->customer_obj->getPersonInfoGroupInfoByName($group_name);

            $template_contents = array(
                'GroupName' => xmsg('CA',$group_info['lang_code'])
               ,'GroupID' => $group_info['id']
               ,'AttributesList' => $this->out_AttributesList($group_name)
            );

            $this->_Template_Contents=$template_contents;
            $application->registerAttributes($this->_Template_Contents);
            $this->mTmplFiller = &$application->getInstance('TmplFiller');
            $html_code .= $this->mTmplFiller->fill("customer_account/account_info/", "group.tpl.html",array());
        };

        return $html_code;
    }

    function out_OrdersList()
    {
        global $application;
        $html_code = '';

        $orders_filter = array(
            'type' => 'quick'
           ,'order_status' => ORDER_STATUS_ALL
        );

        $this->customer_obj->setOrdersHistoryFilter($orders_filter);

        foreach($this->customer_obj->getOrdersIDs() as $order_id)
        {
            $base_info = $this->customer_obj->getBaseOrderInfo($order_id);

            $template_contents = array(
                'OrderId' => $order_id
               ,'OrderDate' => $this->__format_date($base_info['order_date'])
               ,'OrderPriceTotal' =>  modApiFunc('Localization','currency_format',$base_info['order_total'])
               ,'OrderStatus' => msg('ORDER_STATUS_'.sprintf("%03d",$base_info['order_status_id']))
               ,'OrderPaymentStatus' => msg('ORDER_PAYMENT_STATUS_'.sprintf("%03d",$base_info['order_payment_status_id']))
            );

            $this->_Template_Contents=$template_contents;
            $application->registerAttributes($this->_Template_Contents);
            $this->mTmplFiller = &$application->getInstance('TmplFiller');
            $html_code .= $this->mTmplFiller->fill("customer_account/account_info/", "order.tpl.html",array());
        };

        return $html_code;
    }

    function output()
    {
        global $application;

        $template_contents = array(
            'GroupsList' => $this->out_GroupsList()
           ,'OrdersList' => $this->out_OrdersList()
        );

        $this->_Template_Contents=$template_contents;
        $application->registerAttributes($this->_Template_Contents);
        $this->mTmplFiller = &$application->getInstance('TmplFiller');
        return $this->mTmplFiller->fill("customer_account/account_info/", "container.tpl.html",array());
    }

    function getTag($tag)
    {
        return getKeyIgnoreCase($tag, $this->_Template_Contents);
    }

    function __format_date($date)
    {
        $arr = explode("-",$date);
        $ts = mktime(0,0,0,$arr[1],$arr[2],$arr[0]);
        return modApiFunc('Localization','timestamp_date_format',$ts);
    }

    var $_Template_Contents;
    var $customer_obj;
};

?>