<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package CustomerAccount
 * @author Egor V. Derevyankin
 *
 */

class OrderInfo
{
    function getTemplateFormat()
    {
        $format = array(
            'layout-file'        => 'customer-account-order-info.ini'
           ,'files' => array(
                'Container' => TEMPLATE_FILE_SIMPLE
               ,'AccessDenied' => TEMPLATE_FILE_SIMPLE
               ,'GroupHeader' => TEMPLATE_FILE_SIMPLE
               ,'GroupField' => TEMPLATE_FILE_SIMPLE
               ,'ProductsContainer' => TEMPLATE_FILE_SIMPLE
               ,'OrderedProduct' => TEMPLATE_FILE_SIMPLE
               ,'PriceItem' => TEMPLATE_FILE_SIMPLE
               ,'ProductOptionsContainer' => TEMPLATE_FILE_SIMPLE
               ,'ProductOptionsItem' => TEMPLATE_FILE_SIMPLE
            )
           ,'options' => array(
            )
        );
        return $format;
    }

    function OrderInfo()
    {
        global $application;

        #check if fatal errors of the block tag exist
        $this->NoView = false;

        if ($application->issetBlockTagFatalErrors("OrderInfo"))
        {
            $this->NoView = true;
        }

        $settings = modApiFunc('Customer_Account','getSettings');
        if($settings['CHECKOUT_TYPE'] == CHECKOUT_TYPE_QUICK)
        {
            $this->NoView = true;
        };

        $this->customer_obj = null;
        $this->order_id = null;

        $email = modApiFunc('Customer_Account','getCurrentSignedCustomer');

        if($email != null)
        {
            $this->customer_obj = &$application->getInstance('CCustomerInfo',$email);

            $request = &new Request();
            $this->order_id = $request->getValueByKey('order_id');

            $q_filter = array(
                'type' => 'quick'
               ,'order_status' => ORDER_STATUS_ALL
            );

            $this->customer_obj->setOrdersHistoryFilter($q_filter);

            if(!in_array($this->order_id, $this->customer_obj->getOrdersIDs()))
            {
                $this->order_id = null;
            };
        };
    }

    function out_OrderTaxes()
    {
        $html_code = '';

        foreach($this->order_info['Price'] as $price_tag => $price_value)
        {
            if(preg_match("/^Taxes\['(.*):'\]$/",$price_tag,$matches))
            {
                $this->current_price_info = array(
                    'name' => $matches[1]
                   ,'display_name' => $matches[1]
                   ,'value' => modApiFunc('Localization','currency_format',$price_value)
                );
                $html_code .= $this->templateFiller->fill('PriceItem');
            };
        };

        return $html_code;
    }

    function out_OptionsList()
    {
        $html_code = '';

        foreach($this->current_product_info['options'] as $option_info)
        {
            $this->current_option_info = $option_info;
            $html_code .= $this->templateFiller->fill('ProductOptionsItem');
        };

        return $html_code;
    }

    function out_KeyDetails()
    {
        $html_code = '';

        foreach($this->key_details as $field_name)
        {
            $field_value = null;

            switch($field_name)
            {
                case 'Invoice':
                    $r = &new Request();
                    $r->setView('CustomerOrderInvoice');
                    $r->setKey('order_id',$this->order_id);
                    $field_value = '<a href="'.$r->getURL().'">'.cz_msg('ORDER_INFO_KEY_FIELD_INVOICE_LINK').'</a>';
                    break;
                case 'Date':
                    $field_value = $this->__format_date($this->order_info[$field_name]);
                    break;
                default:
                    $field_value = prepareHTMLDisplay($this->order_info[$field_name]);
                    break;
            };

            $this->current_info_field = array(
                    'name' => $field_name
                   ,'display_name' => cz_msg('ORDER_INFO_KEY_FIELD_'.strtoupper($field_name))
                   ,'value' => $field_value);

            $html_code .= $this->templateFiller->fill('GroupField');
        };

        return $html_code;
    }

    function out_CustomerInfoGroup($group_name)
    {
        $html_code = '';

        if(array_key_exists($group_name, $this->order_info) and !empty($this->order_info[$group_name]['attr']))
        {
            foreach($this->order_info[$group_name]['attr'] as $field_info)
            {
                $this->current_info_field = array(
                    'name' => $field_info['tag']
                   ,'display_name' => $field_info['name']
                   ,'value' => $field_info['value']
                );

                $html_code .= $this->templateFiller->fill('GroupField');
            };
        };

        return $html_code;
    }

    function out_ProductsList()
    {
        $html_code = '';

        foreach($this->order_info['Products'] as $product_info)
        {
            $this->current_product_info = $product_info;
            $html_code .= $this->templateFiller->fill('OrderedProduct');
        };

        return $html_code;
    }

    function out_Prices()
    {
        $html_code = '';

        $prices = array(
            'Subtotal' => 'ORDER_PRICE_SUBTOTAL'
           ,'SubtotalGlobalDiscount' => 'ORDER_PRICE_GLOBAL_DISCOUNT'
           ,'SubtotalPromoCodeDiscount' => 'ORDER_PRICE_PROMO_CODE_DISCOUNT'
           ,'QuantityDiscount' => 'ORDER_PRICE_QUANTITY_DISCOUNT'
           ,'DiscountedSubtotal' => 'ORDER_PRICE_DISCOUNTED_SUBTOTAL'
           ,'TotalShippingAndHandlingCost' => 'ORDER_PRICE_SHIPPING_HANDLING'
           ,'Total' => 'ORDER_PRICE_TOTAL'
        );

        foreach($prices as $price_name => $price_lang_code)
        {
            $this->current_price_info = array(
                'name' => $price_name
               ,'display_name' => cz_msg($price_lang_code)
               ,'value' => null);

            switch($price_name)
            {
                case 'Subtotal':
                    $this->current_price_info['value'] = modApiFunc('Localization','currency_format',$this->order_info['Subtotal']);
                    break;
                case 'Total':
                    $html_code .= $this->out_OrderTaxes();
                    $this->current_price_info = array(
                        'name' => $price_name
                       ,'display_name' => cz_msg($price_lang_code)
                       ,'value' => modApiFunc('Localization','currency_format',$this->order_info['Total']));
                    break;
                default:
                    $this->current_price_info['value'] = modApiFunc('Localization','currency_format',$this->order_info['Price'][$price_name]);
                    break;
            };

            $html_code .= $this->templateFiller->fill('PriceItem');
        };

        return $html_code;
    }

    function out_Items()
    {
        $html_code = '';

        foreach($this->order_info_groups as $group_name => $group_lang_suffix)
        {
            $this->current_info_group = array('name' => $group_name, 'lang_suffix' => $group_lang_suffix);
            switch($group_name)
            {
                case 'key':
                    $html_code .= $this->templateFiller->fill('GroupHeader');
                    $html_code .= $this->out_KeyDetails();
                    break;
                case 'billing':
                case 'shipping':
                    if(modApiFunc('Customer_Account','isPersionInfoGroupActive',ucfirst($group_name)))
                    {
                        $html_code .= $this->templateFiller->fill('GroupHeader');
                        $html_code .= $this->out_CustomerInfoGroup(ucfirst($group_name));
                    };
                    break;
                case 'products':
                    $html_code .= $this->templateFiller->fill('GroupHeader');
                    $html_code .= $this->templateFiller->fill('ProductsContainer');
                    break;
            };
        };

        return $html_code;
    }

    function output()
    {
        if($this->NoView)
        {
            return '';
        };

        global $application;

        $_template_tags = array(
            'Local_OrderID'
           ,'Local_Items'
           ,'Local_GroupName'
           ,'Local_FieldName'
           ,'Local_FieldValue'
           ,'Local_OrderedProducts'
           ,'Local_OrderPrices'
           ,'Local_ProductID'
           ,'Local_ProductSKU'
           ,'Local_ProductName'
           ,'Local_ProductQuantity'
           ,'Local_ProductSalePrice'
           ,'Local_ProductAmount'
           ,'Local_ProductOptions'
           ,'Local_OptionsList'
           ,'Local_OptionName'
           ,'Local_OptionValue'
           ,'Local_ProductFilesLink'
           ,'Local_PriceName'
           ,'Local_PriceValue'
          );

        $application->registerAttributes($_template_tags);
        $this->templateFiller = new TemplateFiller();
        $this->template = $application->getBlockTemplate('OrderInfo');
        $this->templateFiller->setTemplate($this->template);

        if($this->customer_obj != null and $this->order_id != null)
        {
            $this->order_info = modApiFunc('Checkout','getOrderInfo',$this->order_id);
            //print_r($this->order_info);
            return $this->templateFiller->fill('Container');
        }
        else
        {
            return $this->templateFiller->fill('AccessDenied');
        };
    }

    function getTag($tag)
    {
        $value = null;

        if(preg_match("/^local_(.+)$/i",$tag,$matches))
        {
            switch(strtolower($matches[1]))
            {
                case 'orderid':
                    $value = $this->order_info['ID'];
                    break;
                case 'items':
                    $value = $this->out_Items();
                    break;
                case 'groupname':
                    $value = cz_msg('ORDER_INFO_GROUP_'.$this->current_info_group['lang_suffix']);
                    break;
                case 'fieldname':
                    $value = $this->current_info_field['display_name'];
                    break;
                case 'fieldvalue':
                    $value = $this->current_info_field['value'];
                    break;
                case 'orderedproducts':
                    $value = $this->out_ProductsList();
                    break;
                case 'orderprices':
                    $value = $this->out_Prices();
                    break;
                case 'pricename':
                    $value = $this->current_price_info['display_name'];
                    break;
                case 'pricevalue':
                    $value = $this->current_price_info['value'];
                    break;
                case 'productid':
                    $value = $this->current_product_info['storeProductID'];
                    break;
                case 'productsku':
                    $value = array_key_exists('SKU',$this->current_product_info) ? $this->current_product_info['SKU'] : null;
                    break;
                case 'productname':
                    $value = $this->current_product_info['name'];
                    break;
                case 'productquantity':
                    $value = $this->current_product_info['qty'];
                    break;
                case 'productsaleprice':
                    $value = modApiFunc('Localization','currency_format',$this->current_product_info['SalePrice']);
                    break;
                case 'productamount':
                    $value = modApiFunc('Localization','currency_format',$this->current_product_info['SalePrice'] * $this->current_product_info['qty']);
                    break;
                case 'productoptions':
                    if(isset($this->current_product_info['options']) and !empty($this->current_product_info['options']))
                    {
                        $value = $this->templateFiller->fill('ProductOptionsContainer');
                    };
                    break;
                case 'optionslist':
                    $value = $this->out_OptionsList();
                    break;
                case 'optionname':
                    $value = $this->current_option_info['option_name'];
                    break;
                case 'optionvalue':
                    $value = $this->current_option_info['option_value'];
                    break;
                case 'productfileslink':
                    $value = '';
                    break;
            };
        };

        return $value;
    }

    function __format_date($date)
    {
        $arr = explode("-",$date);
        $ts = mktime(0,0,0,$arr[1],$arr[2],$arr[0]);
        return modApiFunc('Localization','timestamp_date_format',$ts);
    }

    var $customer_obj;
    var $order_id;
    var $order_info;

    var $order_info_groups = array(
        'key' => 'KEY_DETAILS'
       ,'products' => 'ORDERED_PRODUCTS'
       ,'billing' => 'BILLING_INFO'
       ,'shipping' => 'SHIPPING_INFO'
    );

    var $key_details = array(
            'ID','Date','Status','PaymentStatus','PaymentMethod','PaymentProcessorOrderId'
           ,'ShippingMethod','TrackId','Invoice'
        );

    var $current_info_group;
    var $current_info_field;
    var $current_product_info;
    var $current_option_info;
    var $current_price_info;
};

?>