<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package CustomerAccount
 * @author Egor V. Derevyankin
 *
 */

class CustomersList
{
    function CustomersList()
    {
        $this->search_filter = array(
            'type' => 'letter'
           ,'search_string' => ''
           ,'use_paginator' => true
           ,'letter_filter_by' => 'account_name'
        );

        $request = &new Request();
        $filter = $request->getValueByKey('filter');
        if($filter != null)
        {
            if($filter == 'letter')
            {
                $this->search_filter['type'] = 'letter';
                $letter = $request->getValueByKey('search_string');
                if($letter != null)
                {
                    $this->search_filter['search_string'] = $letter;
                };
            };
            if($filter == 'custom')
            {
                $this->search_filter['type'] = 'custom';
                $search_string = $request->getValueByKey('search_string');
                if($search_string != null)
                {
                    $this->search_filter['search_string'] = trim($search_string);
                };
            };
        }
        else
        {
            if(modApiFunc('Session','is_set','CustomersListSearchFilter'))
            {
                $this->search_filter = modApiFunc('Session','get','CustomersListSearchFilter');
            };
        };

        $letter_filter_by = $request->getValueByKey('letter_filter_by');
        if($letter_filter_by != null)
        {
            $this->search_filter['letter_filter_by'] = $letter_filter_by;
        }
        else
        {
            if(modApiFunc('Session','is_set','CustomersListSearchFilter'))
            {
                $_tmp = modApiFunc('Session','get','CustomersListSearchFilter');
                $this->search_filter['letter_filter_by'] = $_tmp['letter_filter_by'];
            };
        }

        modApiFunc('Session','set','CustomersListSearchFilter',$this->search_filter);

        modApiFunc('Paginator','setCurrentPaginatorName','CustomersList');

        if($request->getValueByKey('pgnum') == null)
        {
            modApiFunc('Paginator','setPaginatorPage','CustomersList',1);
        };

        modApiFunc('Customer_Account','setCustomersSearchFilter',$this->search_filter);
        $this->customers = modApiFunc('Customer_Account','getSearchCustomersResult');

        loadCoreFile('html_form.php');
    }

    function out_CustomersRows()
    {
        global $application;

        $html_code = '';

        foreach($this->customers as $customer_info)
        {
            $obj = &$application->getInstance('CCustomerInfo', $customer_info['customer_account']);

            $customer_name = 'N/A';

            $search_groups = $obj->getPersonInfoGroupsNames();
            reset($search_groups);
            foreach($search_groups as $group)
            {
                $fn = $obj->getPersonInfo('FirstName',$group);
                $ln = $obj->getPersonInfo('LastName',$group);

                if($fn != null and $ln != null)
                {
                    $customer_name = $fn.' '.$ln;
                    break;
                };
            };

            $orders_filter = array(
                'type' => 'quick'
               ,'order_status' => ORDER_STATUS_ALL
            );

            $obj->setOrdersHistoryFilter($orders_filter);

            $template_contents = array(
                'CustomerIcon' => ($obj->getPersonInfo('Status') == 'B') ? 'not-reg' : ( $obj->getPersonInfo('Status') == 'R' ? 'reg-dp' :($obj->getPersonInfo('Status') == 'A' ? 'reg' : 'reg-na'))
               ,'CustomerID' => $obj->getPersonInfo('ID')
               ,'CustomerAccount' => $obj->getDisplayAccountName()
               ,'CustomerName' => $customer_name
               ,'CustomerOrdersCount' => $obj->getOrdersCount()
               ,'CustomerTotalFullyPaid' => modApiFunc('Localization','currency_format',$obj->getOrdersFullyPaidAmount())
               ,'CustomerTotalAmount' => modApiFunc('Localization','currency_format',$obj->getOrdersAmount())
               ,'CustomerStatusMsg' => xmsg('CA','CUSTOMER_STATUS_'.$obj->getPersonInfo('Status'))
               ,'CustomerStatusLongMsg' => xmsg('CA','CUSTOMER_STATUS_LONG_'.$obj->getPersonInfo('Status'))
            );

            $this->_Template_Contents=$template_contents;
            $application->registerAttributes($this->_Template_Contents);
            $this->mTmplFiller = &$application->getInstance('TmplFiller');
            $html_code .= $this->mTmplFiller->fill("customer_account/customers_list/", "customer-row.tpl.html",array());
        };

        if(count($this->customers) < 10)
        {
            for($i=count($this->customers);$i<10;$i++)
            {
                $html_code .= $this->mTmplFiller->fill("customer_account/customers_list/", "empty-row.tpl.html",array());
            };
        };

        return $html_code;
    }

    function out_CustomersTable()
    {
        global $application;

        $template_contents = array(
            'CustomersRows' => $this->out_CustomersRows()
        );

        $this->_Template_Contents=$template_contents;
        $application->registerAttributes($this->_Template_Contents);
        $this->mTmplFiller = &$application->getInstance('TmplFiller');
        return $this->mTmplFiller->fill("customer_account/customers_list/", "list_container.tpl.html",array());
    }

    function out_SearchLettersList()
    {
        $items = array(
            array('display' => xmsg('CA','LBL_ALL'), 'value' => '')
        );

        for ($i=65; $i<=90; $i++)
        {
            $items[] = array('display' => '<b>'.chr($i).'</b>', 'value' => strtolower(chr($i)));
        };

        $html_code = '';

        foreach($items as $item_info)
        {
            $html_code .= '<td>';

            if($this->search_filter['type'] == 'letter'
                and $this->search_filter['search_string'] == $item_info['value'])
            {
                $html_code .= '<span style="color: #2B7DC7">'.$item_info['display'].'</span>';
            }
            else
            {
                $html_code .= '<a href="customers.php?filter=letter&search_string='.$item_info['value'].'">'.$item_info['display'].'</a>';
            };

            $html_code .= '</td>';
        };

        return $html_code;
    }

    function out_SearchLetterFilterSelect()
    {
        $filter_select = array(
            'select_name' => 'letter_filter_by'
           ,'selected_value' => $this->search_filter['letter_filter_by']
           ,'onChange' => "window.location = 'customers.php?letter_filter_by='+this.value;"
           ,'values' => array(
                array('value' => 'account_name', 'contents' => xmsg('CA','LBL_FILTER_BY_ACCOUNT'))
               ,array('value' => 'customer_name', 'contents' => xmsg('CA','LBL_FILTER_BY_LASTNAME'))
           )
        );

        return HtmlForm::genDropdownSingleChoice($filter_select);
    }

    function out_SearchForm()
    {
        global $application;

        $template_contents = array(
            'SearchLettersList' => $this->out_SearchLettersList()
           ,'SearchLetterFilterSelect' => $this->out_SearchLetterFilterSelect()
           ,'SearchString' => $this->search_filter['type'] == 'custom' ? $this->search_filter['search_string'] : ''
           ,'SearchFormLabelColor' => $this->search_filter['type'] == 'custom' ? '#0000FF' : '#666666'
        );

        $this->_Template_Contents=$template_contents;
        $application->registerAttributes($this->_Template_Contents);
        $this->mTmplFiller = &$application->getInstance('TmplFiller');
        return $this->mTmplFiller->fill("customer_account/customers_list/", "search-form.tpl.html",array());
    }

    function out_ResultMessage()
    {
        global $application;
        if(modApiFunc("Session","is_set","ResultMessage"))
        {
            $msg=modApiFunc("Session","get","ResultMessage");
            modApiFunc("Session","un_set","ResultMessage");
            $template_contents=array(
                "ResultMessage" => xmsg('CA',$msg)
            );
            $this->_Template_Contents=$template_contents;
            $application->registerAttributes($this->_Template_Contents);
            $this->mTmplFiller = &$application->getInstance('TmplFiller');
            return $this->mTmplFiller->fill("customer_account/customers_list/", "result-message.tpl.html",array());
        }
        elseif(modApiFunc("Session","is_set","Errors"))
        {
            $return_html_code="";
            $errors=modApiFunc("Session","get","Errors");
            modApiFunc("Session","un_set","Errors");
            foreach($errors as $ekey => $eval)
            {
                $template_contents=array(
                    "ErrorMessage" => xmsg('CA',$eval)
                );
                $this->_Template_Contents=$template_contents;
                $application->registerAttributes($this->_Template_Contents);
                $this->mTmplFiller = &$application->getInstance('TmplFiller');
                $return_html_code.=$this->mTmplFiller->fill("customer_account/customers_list/", "error-message.tpl.html",array());
            }

            return $return_html_code;
        }
        else
            return "";
    }

    function output()
    {
        global $application;

        $template_contents = array(
            'SearchForm' => $this->out_SearchForm()
           ,'CustomersTable' => $this->out_CustomersTable()
           ,'PaginatorLine' => PaginatorLine('CustomersList','CustomersList')
           ,'PaginatorRows' => PaginatorRows('CustomersList','CustomersList','PGNTR_CUST_ITEMS')
           ,'ResultMessage' => $this->out_ResultMessage()
        );

        $this->_Template_Contents=$template_contents;
        $application->registerAttributes($this->_Template_Contents);
        $this->mTmplFiller = &$application->getInstance('TmplFiller');
        return $this->mTmplFiller->fill("customer_account/customers_list/", "container.tpl.html",array());
    }

    function getTag($tag)
    {
        return getKeyIgnoreCase($tag, $this->_Template_Contents);
    }

    var $_Template_Contents;
    var $customers;
    var $search_filter;
};

?>