<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * HTTPS Settings module meta info.
 *
 * @package HTTPS Settings
 * @author Alexander Girin
 */
class HTTPSSettings
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * HTTPSSettings constructor.
     */
    function HTTPSSettings()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources');

        $this->SSLAvailable = true;
    }


    /**
     *
     */
    function output()
    {
        global $application;

        $request=&new Request();
        $request->setView  ('HTTPSSettings');
        $request->setAction('UpdateHTTPSSettings');
        $formAction = $request->getURL();

        if (modApiFunc("Session", "is_set", "SessionPost"))
        {
            $HTTPSSettings = modApiFunc("Session", "get", "SessionPost");
            modApiFunc("Session", "un_set", "SessionPost");
            if(isset($HTTPSSettings["hasCloseScript"]) && $HTTPSSettings["hasCloseScript"] == "true")
            {
                modApiFunc("application", "closeChild_UpdateParent");
                return;
            }
            if ($HTTPSSettings["Message"] != "")
            {
                $HTTPSSettings["Message"] = $this->MessageResources->getMessage($HTTPSSettings["Message"]);
            }
        }
        else
        {
            $HTTPSSettings = modApiFunc("HTTPS", "getHTTPSSettings");
            $HTTPSSettings["Message"] = "";
            if ($HTTPSSettings["URLS"]["HTTPS_URL"] == "")
            {
                if (($URL = modApiFunc("HTTPS", "tryToFindHttpsUrl")) == "SSL_not_available")
                {
                     $this->SSLAvailable = false;
                }
                else
                {
                    $HTTPSSettings["URLS"]["HTTPS_URL"] = $URL;
                }
                $HTTPSSettings["FirstTimeSettings"] = "true";
            }
            else
            {
                $HTTPSSettings["FirstTimeSettings"] = "false";
            }
        }

        $template_contents = array(
                                   "FormAction"          => $formAction
                                  ,"HTTPSURL"            => strtr($HTTPSSettings["URLS"]["HTTPS_URL"], array("https://" => ""))
                                  ,"All"                 => $HTTPSSettings["SECURE_SECTIONS"]["AllAdminArea"]? "checked":""
                                  ,"SignIn_AdminMembers" => $HTTPSSettings["SECURE_SECTIONS"]["SignIn_AdminMembers"]? "checked":""
                                  ,"Orders_Customers"    => $HTTPSSettings["SECURE_SECTIONS"]["Orders_Customers"]? "checked":""
                                  ,"Payment_Shipping"    => $HTTPSSettings["SECURE_SECTIONS"]["Payment_Shipping"]? "checked":""
                                  ,"Message"             => $HTTPSSettings["Message"]
                                  ,"FirstTimeSettings"   => $HTTPSSettings["FirstTimeSettings"]
                                  ,"SaveButton"          => $this->SSLAvailable? "block":"none"
                                  ,"CheckButton"         => $this->SSLAvailable? "none":"block"
                                  ,"SSLAvailable"        => $this->SSLAvailable? "true":"false"
                                  );
        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return modApiFunc('TmplFiller', 'fill', "https/https_settings/","container.tpl.html", array());
    }


    function getTag($tag)
    {
        global $application;
        $value = null;
        if (array_key_exists($tag, $this->_Template_Contents))
        {
            $value = $this->_Template_Contents[$tag];
        }
        return $value;
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */


    /**#@-*/

}
?>