<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

_use(dirname(__FILE__).'/number_settings_az.php');

/**
 * Localization Module, CurrencySettings View.
 *
 * @package Localization
 * @author Alexey Florinsky
 */
class CurrencySettings extends NumberSettings
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * CurrencySettings constructor.
     */
    function CurrencySettings()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources');

        $this->CurrentCurrency = explode("|", modApiFunc("Localization", "getFormat", "currency"));
        $this->CurrenciesList = modApiFunc("Localization", "getFormatsList", "currency");
    }

    /**
     *
     */
    function outputCurrenciesList()
    {
        $retval = "";

        $i = 1;
        foreach ($this->CurrenciesList as $CurrencyInfo)
        {
            $retval.= "<option value=\"".$i."\"";
            $retval.= (($this->CurrentCurrency[0] == $i)? " SELECTED ":"");
            $retval.= ">".$CurrencyInfo["name"]."</option>";
            $i++;
        }
        return $retval;
    }

    /**
     *
     */
    function outputCurrencySignsArray()
    {
        $retval = "";

        $i = 1;
        foreach ($this->CurrenciesList as $CurrencyInfo)
        {
            $retval.= "CurrencySigns[$i] = '".$CurrencyInfo["sign"]."';\n";
            $i++;
        }
        return $retval;
    }

    /**
     *
     */
    function output()
    {
        global $application;
        loadCoreFile('html_form.php');
        $HtmlForm = new HtmlForm();

        $request=&new Request();
        $request->setView  ('CurrencyFormat');
        $request->setAction('UpdateCurrencyFormat');
        $formAction = $request->getURL();

        $template_contents = array(
                                   "FORM"               => $HtmlForm->genForm($formAction, "POST", "CurrencyForm")
                                  ,"CurrenciesList"     => $this->outputCurrenciesList()
                                  ,"CurrencySign"       => $this->CurrentCurrency[1]
                                  ,"DecimalSeparators"  => $this->outputSelect("separators", 1, "currency_format")
                                  ,"DigitSeparators"    => $this->outputSelect("separators", 2, "currency_format")
                                  ,"Digits"             => $this->outputSelect("currency_digits", "", "currency_format")
                                  ,"PositiveCurrency"   => $this->outputSelect("positive_currency", "", "currency_format")
                                  ,"NegativeCurrency"   => $this->outputSelect("negative_currency", "", "currency_format")
                                  ,"CurrencySignsArray" => $this->outputCurrencySignsArray()
                                  );
        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return modApiFunc('TmplFiller', 'fill', "localization/currency_settings/","container.tpl.html", array());
    }


    function getTag($tag)
    {
        global $application;
        $value = null;
        if (array_key_exists($tag, $this->_Template_Contents))
        {
            $value = $this->_Template_Contents[$tag];
        }
        return $value;
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */


    /**#@-*/

}
?>