<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Location module.
 *
 * @package Location
 * @author Alexander Girin
 */
class Location
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * News constructor.
     */
    function Location()
    {
        $this->constants = array
        (
            "ALL_OTHER_STATES_STATE_ID" => -1
           ,"STATE_UNDEFINED_STATE_ID" => -2
           ,"ALL_OTHER_COUNTRIES_COUNTRY_ID" => -3
           ,"SELECT_COUNTRY_DEFAULT_COUNTRY_ID" => 223 /* USA */
        );
    }

    function get_constant($key)
    {
        if(!isset($this->constants))
        {
            return NULL;
        }
        else
        {
            if(isset($this->constants[$key]))
            {
                return $this->constants[$key];
            }
            else
            {
                return NULL;
            }
        }
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Configuration::getTables() instead of $this->getTables()
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources');

        $tables = Location::getTables();
        $query = &new DB_Table_Create($tables);

        //Add countries
        $table = 'countries';                   #the name of the filled table
        $columns = $tables[$table]['columns'];  #the array of field names of the table

        $active_countries = array(13, 14, 21, 39, 74, 82, 106, 125, 151, 193, 222, 223, 103);
        for ($i=1; $i<=237; $i++)
        {
            $query = &new DB_Insert($table);
            $query->addInsertValue($i, $columns['id']);
            $query->addInsertValue($obj->getMessage(sprintf('COUNTRY_%03d',$i)), $columns['name']);
            $codes = $obj->getMessage(sprintf('COUNTRY_CODE_%03d',$i));
            $code_array = explode("/", $codes);
            $query->addInsertValue($code_array[0], $columns['code']);
            $query->addInsertValue($code_array[1], $columns['code3']);
            if (in_array($i, $active_countries))
            {
                $query->addInsertValue("true", $columns['active']);
            }
            else
            {
                $query->addInsertValue("false", $columns['active']);
            }
            if ($i == 223) // USA as default country
            {
                $query->addInsertValue("true", $columns['default']);
            }
            else
            {
                $query->addInsertValue("false", $columns['default']);
            }
            $application->db->getDB_Result($query);
        }

        //Add states
        $table = 'states';                   # the name of the filled table
        $columns = $tables[$table]['columns'];  # the array of field names of the table

        $states_to_countries = array(array('offset' => 8,   'country_id' => 13), //Australia
                                     array('offset' => 17,  'country_id' => 14), //Austria
                                     array('offset' => 28,  'country_id' => 21), //Belgium
                                     array('offset' => 40,  'country_id' => 39), //Canada
                                     array('offset' => 135, 'country_id' => 74), //France
                                     array('offset' => 151, 'country_id' => 82), //Germany
                                     array('offset' => 171, 'country_id' => 106),//Italy
                                     array('offset' => 174, 'country_id' => 125),//Luxembourg
                                     array('offset' => 186, 'country_id' => 151),//Netherlands
                                     array('offset' => 238, 'country_id' => 193),//Spain
                                     array('offset' => 372, 'country_id' => 222),//United Kingdom (Great Britain)
                                     array('offset' => 426, 'country_id' => 223),//United States
                                     array('offset' => 452, 'country_id' => 103) //United States @todo check this line!!!
                                    );
        $j = 0;

        for ($i=1; $i<=452; $i++)
        {
            if ($i > $states_to_countries[$j]["offset"])
            {
                $j++;
            }
            $query = &new DB_Insert($table);
            $query->addInsertValue($i, $columns['id']);
            $query->addInsertValue($states_to_countries[$j]['country_id'], $columns['c_id']);
            $query->addInsertValue($obj->getMessage(sprintf('STATE_%03d',$i)), $columns['name']);
            $query->addInsertValue($obj->getMessage(sprintf('STATE_CODE_%03d',$i)), $columns['code']);
            $query->addInsertValue("true", $columns['active']);
            $query->addInsertValue("false", $columns['default']); //                        
            $application->db->getDB_Result($query);
        }
    }

    /**
     * Installs the specified module in the system.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Configuration::getTables() instead of $this->getTables()
     */
    function uninstall()
    {
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of the meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        //-----------------------------------
        //  Database meta description for zone
        //-----------------------------------
        $table = 'countries';
        $tables[$table] = array();
        $tables[$table]['columns'] = array
            (
                'id'                => $table.'.country_id'
               ,'name'              => $table.'.country_name'
               ,'code'              => $table.'.country_code'
               ,'code3'             => $table.'.country_code3'
               ,'active'             => $table.'.country_active'
               ,'default'           => $table.'.country_default'
            );
        $tables[$table]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'name'              => DBQUERY_FIELD_TYPE_CHAR50
               ,'code'              => DBQUERY_FIELD_TYPE_CHAR5
               ,'code3'             => DBQUERY_FIELD_TYPE_CHAR5
               ,'active'            => DBQUERY_FIELD_TYPE_BOOL
               ,'default'           => DBQUERY_FIELD_TYPE_BOOL
            );
        $tables[$table]['primary'] = array
            (
                'id'
            );

        $table = 'states';
        $tables[$table] = array();
        $tables[$table]['columns'] = array
            (
                'id'                => $table.'.state_id'
               ,'c_id'              => $table.'.country_id'
               ,'name'              => $table.'.state_name'
               ,'code'              => $table.'.state_code'
               ,'active'            => $table.'.state_active'
               ,'default'           => $table.'.state_default'
            );
        $tables[$table]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'c_id'              => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
               ,'name'              => DBQUERY_FIELD_TYPE_CHAR50
               ,'code'              => DBQUERY_FIELD_TYPE_CHAR5
               ,'active'            => DBQUERY_FIELD_TYPE_BOOL
               ,'default'           => DBQUERY_FIELD_TYPE_BOOL
            );
        $tables[$table]['primary'] = array
            (
                'id'
            );
        $tables[$table]['indexes'] = array
            (
                'IDX_c' => 'c_id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**
     *
     *
     * @todo
     * @param
     * @return
     */
    function getCountriesFullList($use_paginator=true)
    {
        global $application;
        $countriesArray = array();
        $tables = $this->getTables();
        $c  = $tables['countries']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($c["id"], "id");
        $query->addSelectField($c["name"], "name");
        $query->addSelectField($c["code"], "code");
        $query->addSelectField($c["active"], "active");
        $query->addSelectField($c["default"], "dflt");
        if ($use_paginator)
        {
            $query = modApiFunc('paginator', 'setQuery', $query);
        }
        $retval = $application->db->getDB_Result($query);
        foreach ($retval as $key => $countryInfo)
        {
            $retval[$key]["name"] = prepareHTMLDisplay($countryInfo["name"]);
        }
        return $retval;
    }

    /**
     *
     *
     * @todo
     * @param
     * @return
     */
    function getStatesFullList($c_id, $use_paginator=true)
    {
        global $application;
        $statesArray = array();
        $tables = $this->getTables();
        $s  = $tables['states']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($s["id"], "id");
        $query->addSelectField($s["name"], "name");
        $query->addSelectField($s["code"], "code");
        $query->addSelectField($s["active"], "active");
        $query->addSelectField($s["default"], "dflt");
        $query->WhereValue($s["c_id"], DB_EQ, $c_id);
        if ($use_paginator)
        {
            $query = modApiFunc('paginator', 'setQuery', $query);
        }
        $query->SelectOrder($s["id"]);
        $retval = $application->db->getDB_Result($query);
        foreach ($retval as $key => $stateInfo)
        {
            $retval[$key]["name"] = prepareHTMLDisplay($stateInfo["name"]);
        }
        return $retval;
    }


    /**
     * Returns the list of countries.
     *
     * @todo
     * @param
     * @return
     */
    function getCountries($all_data = true, $ExclusionCountries = array(), $with_states_only = false)
    {
        global $application;
        $countriesArray = array();
        $tables = $this->getTables();
        $c  = $tables['countries']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($c["id"], "id");
        $query->addSelectField($c["name"], "name");
        $query->WhereValue($c["active"], DB_EQ, "true");
        if (!$all_data&&sizeof($ExclusionCountries)>0)
        {
            $query->WhereAnd();
            $query->WhereField($c["id"], DB_NOT." ".DB_IN, "(".implode(",", $ExclusionCountries).")");
        }
        if($with_states_only == true)
        {
            $s = $tables['states']['columns'];
            $query->addSelectField($query->fCount("*"), "cnt");
            $query->addLeftJoin('states', $s['c_id'], DB_EQ, $c['id']);
            $query->SelectGroup($c["id"]);
            $query->Having("cnt", DB_GT, "1");
        }
        $Countries = $application->db->getDB_Result($query);
        foreach ($Countries as $country)
        {
            $countriesArray[$country["id"]] = prepareHTMLDisplay($country["name"]);
        }
        return $countriesArray;
    }

    /**
     * Returns the default Country Id
     *
     * @return int country id
     */
    function getDefaultCountryId()
    {
        global $application;
        $tables = $this->getTables();
        $c  = $tables['countries']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($c["id"], "id");
        $query->WhereValue($c["default"], DB_EQ, "true");
        $result = $application->db->getDB_Result($query);

        if (sizeof($result))
        {
            return $result[0]['id'];
        }
        return 0;
    }

    /**
     * Returns the default State Id in country
     *
     * @param int $c_id - country id
     * @return int country id
     */
    function getDefaultStateId($c_id)
    {
        global $application;
        $tables = $this->getTables();
        $s  = $tables['states']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($s["id"], "id");
        $query->WhereValue($s["c_id"], DB_EQ, $c_id);
        $query->WhereAnd();
        $query->WhereValue($s["default"], DB_EQ, "true");
        $result = $application->db->getDB_Result($query);

        if (sizeof($result))
        {
            return $result[0]['id'];
        }
        return 0;
    }

    /**
     * Returns the list of states.
     *
     * @todo
     * @param
     * @return
     */
    function getStates($country_id, $all_data = true, $ExclusionStates = array())
    {
        global $application;

        $tables = $this->getTables();
        $s  = $tables['states']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($s["id"], "id");
        $query->addSelectField($s["name"], "name");
        $query->WhereValue($s["active"], DB_EQ, "true");
        $query->WhereAnd();
        $query->WhereValue($s["c_id"], DB_EQ, $country_id);
        if (!$all_data&&sizeof($ExclusionStates)>0)
        {
            $query->WhereAnd();
            $query->WhereField($s["id"], DB_NOT." ".DB_IN, "(".implode(",", $ExclusionStates).")");
        }
        $States = $application->db->getDB_Result($query);

        $statesArray = array();
        if (sizeof($States)>0)
        {
            foreach ($States as $state)
            {
                $statesArray[$state["id"]] = prepareHTMLDisplay($state["name"]);
            }
        }
        return $statesArray;
    }

    /**
     * Returns the number of the states in the country.
     *
     * @todo
     * @param
     * @return
     */
    function getCountStatesInCountry($country_id)
    {
        global $application;
        $tables = $this->getTables();
        $s  = $tables['states']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($query->fCount($s["id"]), "count");
        $query->WhereValue($s["c_id"], DB_EQ, $country_id);
        $count = $application->db->getDB_Result($query);

        return $count[0]["count"];
    }

    /**
     * Returns javascript arrays, initialized with the data from the countries,
     * states table.
     *
     * @todo
     * @param
     * @return
     */
    function getJavascriptCountriesStatesArrays($all_data = true, $ExclusionCountries = array(), $ExclusionStates = array(), $bWithAllOtherState = false, $bWithAllOtherCountry = false)
    {
        $retval = "<SCRIPT LANGUAGE=\"JavaScript\">\n";
        $retval.= "<!--\n";

        $countriesArray = "countriesArray = new Array();\n";
        $statesArray = "statesArray = new Array();\n";
        $countryIdToStatesIdArray = "countryIdToStatesIdArray = new Array();\n";
        $defaultStatesIdArray = "defaultStatesIdArray = new Array();\n";
        global $application;
        $tables = $this->getTables();
        $s  = $tables['states']['columns'];
        $c  = $tables['countries']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($c["id"], "id");
        $query->addSelectField($c["name"], "name");
        $query->WhereValue($c["active"], DB_EQ, "true");
        if (!$all_data&&sizeof($ExclusionCountries)>0)
        {
            $query->WhereAnd();
            $query->WhereField($c["id"], DB_NOT." ".DB_IN, "(".implode(",", $ExclusionCountries).")");
        }
        $Countries = $application->db->getDB_Result($query);
        if($bWithAllOtherCountry === true)
        {
            array_unshift
            (
                $Countries
               ,array
                (
                    "id" => $this->get_constant("ALL_OTHER_COUNTRIES_COUNTRY_ID")
                   ,"name" => msg("COUNTRY_ALL_LABEL")
                )
            );
        }

        foreach ($Countries as $country)
        {
            if($country["id"] == $this->get_constant("ALL_OTHER_COUNTRIES_COUNTRY_ID"))
            {
                $States = array
                (
                    array
                    (
                        "id" => $this->get_constant("STATE_UNDEFINED_STATE_ID")
                       ,"name" => msg("STATE_UNDEFINED_LABEL")
                    )
                );
            }
            else
            {
                if ($defaultStateId = $this->getDefaultStateId($country["id"]))
                {
                    $defaultStatesIdArray.= "defaultStatesIdArray['".$country["id"]."'] = '".$defaultStateId."';\n";
                }
                $countriesArray.= "countriesArray['".$country["id"]."'] = '".addslashes($country["name"])."';\n";
                $query = &new DB_Select();
                $query->addSelectField($s["id"], "id");
                $query->addSelectField($s["name"], "name");
                $query->WhereValue($s["active"], DB_EQ, "true");
                $query->WhereAnd();
                $query->WhereValue($s["c_id"], DB_EQ, $country["id"]);
                if (!$all_data&&sizeof($ExclusionStates)>0)
                {
                    $query->WhereAnd();
                    $query->WhereField($s["id"], DB_NOT." ".DB_IN, "(".implode(",", $ExclusionStates).")");
                }
                $States = $application->db->getDB_Result($query);
                if($bWithAllOtherState === true)
                {
                    array_unshift
                    (
                        $States
                       ,array
                        (
                            "id" => $this->get_constant("ALL_OTHER_STATES_STATE_ID")
                           ,"name" => msg("STATE_ALL_LABEL")
                        )
                    );
                }
            }

            if (sizeof($States)>0)
            {
                $countryIdToStatesIdArray.= "countryIdToStatesIdArray['".$country["id"]."'] = new Array(";
                foreach ($States as $state)
                {
                    $statesArray.= "statesArray['".$state["id"]."'] = '".addslashes($state["name"])."';\n";
                    $countryIdToStatesIdArray.= "'".$state["id"]."', ";
                }
                $countryIdToStatesIdArray = substr($countryIdToStatesIdArray, 0, (strlen($countryIdToStatesIdArray)-2)).");\n";
            }
        }

        $defaultCountryId = "var defaultCountryId = ".$this->getDefaultCountryId().";\n";

        $retval.= $countriesArray;
        $retval.= $statesArray;
        $retval.= $countryIdToStatesIdArray;
        $retval.= $defaultCountryId;
        $retval.= $defaultStatesIdArray;
        $retval.= "//-->\n";
        $retval.= "</SCRIPT>";
        return $retval;
    }

    /**
     * Returns the country name by id.
     *
     * @todo
     * @param
     * @return
     */
    function getCountry($cId)
    {
        global $application;
        if($cId == $this->constants["ALL_OTHER_COUNTRIES_COUNTRY_ID"])
        {
            return msg("COUNTRY_ALL_LABEL");
        }
        else
        {
            $tables = $this->getTables();
            $c  = $tables['countries']['columns'];

            $query = &new DB_Select();
            $query->addSelectField($c["name"], "name");
            $query->WhereValue($c["id"], DB_EQ, $cId);
            $country = $application->db->getDB_Result($query);

            return isset($country[0]["name"])? prepareHTMLDisplay($country[0]["name"]):"";
        }
    }

    /**
     * Returns the state name by id.
     *
     * @todo
     * @param
     * @return
     */
    function getState($sId)
    {
        global $application;

        if($sId == $this->constants["ALL_OTHER_STATES_STATE_ID"])
        {
            return msg("STATE_ALL_LABEL");
        }
        else
        if($sId == $this->constants["STATE_UNDEFINED_STATE_ID"])
        {
            return msg("STATE_UNDEFINED_LABEL");
        }
        else
        {
            $tables = $this->getTables();
            $s  = $tables['states']['columns'];

            $query = &new DB_Select();
            $query->addSelectField($s["name"], "name");
            $query->WhereValue($s["id"], DB_EQ, $sId);
            $state = $application->db->getDB_Result($query);

            $obj = &$application->getInstance('MessageResources');
            return isset($state[0]["name"])? prepareHTMLDisplay($state[0]["name"]):$obj->getMessage('STATE_ALL_OTHER');
        }
    }

    /**
     * Updates the country in the database.
     *
     * @todo
     * @param
     * @return
     */
    function updateCountry($c_id, $c_name, $c_active, $c_default)
    {
        global $application;
        $tables = $this->getTables();
        $c  = $tables['countries']['columns'];

        $query = &new DB_Update("countries");
        $query->addUpdateValue($c["active"], $c_active);
        $query->addUpdateValue($c["default"], $c_default);
        if ($c_name)
        {
            $query->addUpdateValue($c["name"], $c_name);
        }
        $query->WhereValue($c["id"], DB_EQ, $c_id);
        $application->db->getDB_Result($query);
    }

    /**
     * Updates the state in the database.
     *
     * @todo
     * @param
     * @return
     */
    function updateState($s_id, $s_name, $s_active, $s_default)
    {
        global $application;
        $tables = $this->getTables();
        $s  = $tables['states']['columns'];

        $query = &new DB_Update("states");
        $query->addUpdateValue($s["active"], $s_active);
        $query->addUpdateValue($s["default"], $s_default);
        if ($s_name)
        {
            $query->addUpdateValue($s["name"], $s_name);
        }
        $query->WhereValue($s["id"], DB_EQ, $s_id);
        $application->db->getDB_Result($query);
    }

    function getCountryCode($cId, $code="ISO2")
    {
        global $application;
        $tables = $this->getTables();
        $c  = $tables['countries']['columns'];

        $query = &new DB_Select();
        if ($code=="ISO2")
        {
        	$query->addSelectField($c["code"], "code");
        }
        else
        {
        	$query->addSelectField($c["code3"], "code");
        }
        $query->WhereValue($c["id"], DB_EQ, $cId);
        $country = $application->db->getDB_Result($query);

        return isset($country[0]["code"])?($country[0]["code"]):"";
    }

    function getStateCode($sId)
    {
        global $application;
        $tables = $this->getTables();
        $s  = $tables['states']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($s["code"], "code");
        $query->WhereValue($s["id"], DB_EQ, $sId);
        $state = $application->db->getDB_Result($query);

        $obj = &$application->getInstance('MessageResources');
        return isset($state[0]["code"])?($state[0]["code"]):"";
    }

    function getCountryCodeByCountryName($cName, $code="ISO2")
    {
        global $application;
        $tables = $this->getTables();
        $c  = $tables['countries']['columns'];

        $query = &new DB_Select();
        if ($code=="ISO2")
        {
        	$query->addSelectField($c["code"], "code");
        }
        else
        {
        	$query->addSelectField($c["code3"], "code");
        }
        //$query->addSelectField($c["code"], "code");
        $query->WhereValue($c["name"], DB_EQ, $cName);
        $country = $application->db->getDB_Result($query);

        return isset($country[0]["code"])?($country[0]["code"]):"";
    }

    function getStateCodeByStateName($sName)
    {
        global $application;
        $tables = $this->getTables();
        $s  = $tables['states']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($s["code"], "code");
        $query->WhereValue($s["name"], DB_EQ, $sName);
        $state = $application->db->getDB_Result($query);

        $obj = &$application->getInstance('MessageResources');
        return isset($state[0]["code"])?($state[0]["code"]):"";
    }

    function getCountryIdByCountryCode($cCode)
    {
        global $application;
        $tables = $this->getTables();
        $c  = $tables['countries']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($c["id"], "id");
        $query->WhereValue($c["code"], DB_EQ, $cCode);
        $country = $application->db->getDB_Result($query);

        return isset($country[0]["id"])?($country[0]["id"]):"";
    }

    function getStateIdByStateCode($sCode)
    {
        global $application;
        $tables = $this->getTables();
        $s  = $tables['states']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($s["id"], "id");
        $query->WhereValue($s["code"], DB_EQ, $sCode);
        $state = $application->db->getDB_Result($query);

        $obj = &$application->getInstance('MessageResources');
        return isset($state[0]["id"])?($state[0]["id"]):"";
    }


    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */
    var $constants = NULL;
    /**#@-*/

}
?>