<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
/**
 * Ancillary class to use module info.
 *
 * @package Modules_Manager
 * @access  public
 * @author Alexey Kolesnikov
 */
class ModuleInfo
{
    /**#@+
     * @access public
     */

    /**
     * Loads module info from the associative array.
     */
    function loadFromArray($moduleInfo)
    {
    	$this->name         = $moduleInfo['name'];
        $this->shortName    = isset($moduleInfo['shortName']) ? $moduleInfo['shortName'] : null;
    	$this->groups       = $moduleInfo['groups'];
    	$this->directory    = strtolower($this->name) . '/';
        $this->description  = $moduleInfo['description'];
        $this->version      = $moduleInfo['version'];
        $this->author       = $moduleInfo['author'];
        $this->contact      = $moduleInfo['contact'];
        $this->systemModule = $moduleInfo['systemModule'];
        $this->mainFile     = $this->directory . $moduleInfo['mainFile'];
        $this->constantsFile= isset($moduleInfo['constantsFile']) ? $this->directory.$moduleInfo['constantsFile'] : null;
        $this->extraAPIFiles= null;
        $this->resFile      = isset($moduleInfo['resFile']) ? $moduleInfo['resFile'] : null;

        // get extraAPIFiles
        if (isset($moduleInfo['extraAPIFiles']))
        {
            $this->extraAPIFiles = array();
            foreach ($moduleInfo['extraAPIFiles'] as $class=>$file)
            {
                $this->extraAPIFiles[$class] = $this->directory . $file;
            }
        }

        // get actions and store file names if any
        if (array_key_exists('actions', $moduleInfo))
        {
            foreach (array_keys($moduleInfo['actions']) as $action)
            {
                $this->actionFiles[$action] = $this->directory . 'actions/' . $moduleInfo['actions'][$action];
            }
        }

        // load hooks list and save file names
        if (array_key_exists('hooks', $moduleInfo))
        {
            foreach ($moduleInfo['hooks'] as $hook => $hookInfo)
            {
                $hookActions = split(",", $hookInfo['onAction']);
                if ($hookActions)
                {
            	   $this->hookFiles[$hook] = $this->directory . 'hooks/' . $hookInfo['Hook_File'];
        	       $this->hookMap[$hook] = $hookActions;
                }
            }
        }

        // get views and store file names if any
        if (array_key_exists('views', $moduleInfo))
        {
            foreach (array_keys($moduleInfo['views']['AdminZone']) as $view)
            {
                $this->azViewFiles[$view] = $this->directory . 'views/' . $moduleInfo['views']['AdminZone'][$view];
            }
            foreach (array_keys($moduleInfo['views']['CustomerZone']) as $view)
            {
                $this->czViewFiles[$view] = $this->directory . 'views/' . $moduleInfo['views']['CustomerZone'][$view];
            }
            //                           
            if(array_key_exists('Aliases',$moduleInfo['views']))
            {
                foreach($moduleInfo['views']['Aliases'] as $alias_name => $view_name)
                {
                    $this->czAliases[$alias_name] = $view_name;
                }
            }
        }
    }

    var $id;
    var $directory;
    var $name;
    var $shortName;
    var $description;
    var $version;
    var $author;
    var $contact;
    var $systemModule;
    var $mainFile;
    var $installed;
    var $extraAPIFiles;
    var $constantsFile;
    var $resFile;
    var $actionFiles = array();
    var $czViewFiles = array();
    var $azViewFiles = array();
    var $czAliases = array();
    var $hookFiles = array();
    var $hookMap = array();
    /**#@-*/

    /**#@+
     * @access private
     */
    /**#@-*/

}
?>