<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package Notifications
 * @author Alexander Girin
 */
class NotificationContent
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * A constructor.
     */
    function NotificationContent($condition = array())
    {
        global $application;

        $this->notificationId = $condition['notification_id'];
        $this->orderId = isset($condition['order_id'])? $condition['order_id']:NULL;
        $this->actionId = $condition['action_id'];
        $this->MessageResources = &$application->getInstance('MessageResources');
        $this->customerAccount = null;

        $this->haveToSend = $this->getNotificationInfo($this->notificationId);
        if (!$this->haveToSend)
        {
            return;
        }
        if (isset($condition['status']))
        {
            if ($condition['status'] == 'order')
            {
                $orderNewStatus = modApiFunc("Checkout", "getOrderStatusList", $condition['statuses']['new_status']);
                $orderNewStatus = $orderNewStatus[$condition['statuses']['new_status']]['id'];

                $tables = Notifications::getTables();
                $naov = $tables['notification_action_option_values']['columns'];
                $ov2n = $tables['option_values_to_notification']['columns'];

                $query = &new DB_Select();
                $query->addSelectField($ov2n['value'], 'value');
                $query->WhereValue($naov['nao_id'], DB_EQ, 1);
                $query->WhereAnd();
                $query->WhereValue($ov2n['n_id'], DB_EQ, $this->notificationId);
                $query->WhereAnd();
                $query->WhereField($ov2n['naov_id'], DB_EQ, $naov['id']);
                $query->WhereAnd();
                $query->WhereValue($naov['key'], DB_EQ, $orderNewStatus);
                $result = $application->db->getDB_Result($query);

                if (isset($result[0]['value']) && $result[0]['value'] == 'true')
                {
                    $this->haveToSend = true;
                    $orderOldStatus = modApiFunc("Checkout", "getOrderStatusList", $condition['statuses']['old_status']);
                    $this->OrderOldStatus = $orderOldStatus[$condition['statuses']['old_status']]['name'];
                }
                else
                {
                    $this->haveToSend = false;
                }
            }
            if ($condition['status'] == 'payment')
            {
                $orderNewPaymentStatus = modApiFunc("Checkout", "getOrderPaymentStatusList", $condition['statuses']['new_status']);
                $orderNewPaymentStatus = $orderNewPaymentStatus[$condition['statuses']['new_status']]['id'];

                $tables = Notifications::getTables();
                $naov = $tables['notification_action_option_values']['columns'];
                $ov2n = $tables['option_values_to_notification']['columns'];

                $query = &new DB_Select();
                $query->addSelectField($ov2n['value'], 'value');
                $query->WhereValue($naov['nao_id'], DB_EQ, 2);
                $query->WhereAnd();
                $query->WhereValue($ov2n['n_id'], DB_EQ, $this->notificationId);
                $query->WhereAnd();
                $query->WhereField($ov2n['naov_id'], DB_EQ, $naov['id']);
                $query->WhereAnd();
                $query->WhereValue($naov['key'], DB_EQ, $orderNewPaymentStatus);
                $result = $application->db->getDB_Result($query);

                if (isset($result[0]['value']) && $result[0]['value'] == 'true')
                {
                    $this->haveToSend = true;
                    $orderOldStatus = modApiFunc("Checkout", "getOrderPaymentStatusList", $condition['statuses']['old_status']);
                    $this->OrderOldPaymentStatus = $orderOldStatus[$condition['statuses']['old_status']]['name'];
                }
                else
                {
                    $this->haveToSend = false;
                }
            }
        }
        if ($this->actionId == 4)
        {
            $this->haveToSend = false;
            $orderInfo = modApiFunc("Checkout", "getOrderInfo", $this->orderId);
            foreach ($orderInfo['Products'] as $productInfo)
            {
                //check if the attribute of the product QuantityInStock is visible
                if (!modApiFunc("Catalog", "isProductAttributeVisible", $productInfo['storeProductID'], 3))
                {
                    continue;
                }
                $_productInfo = &new CProductInfo($productInfo['storeProductID']);
                $productQuantityInStock = $_productInfo->getProductTagValue('QuantityInStock', PRODUCTINFO_NOT_LOCALIZED_DATA);
                $productLowLevelInStock = $_productInfo->getProductTagValue('LowStockLevel', PRODUCTINFO_NOT_LOCALIZED_DATA);
                if ($productLowLevelInStock)
                {
                    if ($productQuantityInStock <= $productLowLevelInStock)
                    {
                        $this->haveToSend = true;
                    }
                }
                else
                {
                    if ($productQuantityInStock <= 0)
                    {
                        $this->haveToSend = true;
                    }
                }
            }
        }
        if ($this->actionId == 5)
        {
            $this->haveToSend = false;
        }
        if($this->actionId == 6)
        {
            $this->haveToSend = true;
            $this->customerRegData = $condition['reg_data'];
            $this->customerAccount = $this->customerRegData['account'];
        }
        if($this->actionId >= 7 and $this->actionId <= 13)
        {
            $this->haveToSend = true;
            $this->customerAccount = $condition['account_name'];
        }
        if($this->actionId == 14) //Inventory Low Level
        {
            $this->haveToSend = true;
            $this->inventory_info = $condition['inventory_info'];
        }
    }

    /**
     * Sends a notification to each of the receiver.
     */
    function send()
    {
        loadCoreFile('htmlMimeMail.php');
        if (!$this->haveToSend)
        {
            return;
        }

        if (modApiFunc("Session", "is_Set", "disable_notifications"))
        {
            return;
        }

        $this->prepareEmailTextAndSubject();

        $mail = new htmlMimeMail();
        $mail->setText($this->EmailText);
        $mail->setSubject($this->EmailSubject);
        $from = $this->getSendFrom();
        $mail->setFrom($from);
//        $mail->setCc($from);
        $to = $this->getSendTo();
        foreach ($to as $address)
        {
            $mail->send(array($address));
        }
    }

    /**
     * Prepares an email text and the subject to send.
     */
    function prepareEmailTextAndSubject()
    {
        global $application;
        $this->customerEmail = null;
        $this->product_obj = null;

        switch($this->actionId)
        {
            case '1':
            case '2':
            case '3':
            case '4':
            case '5':
                $orderInfo = modApiFunc("Checkout", "getOrderInfo", $this->orderId);
                $customer_id = $orderInfo['PersonId'];
                $account_name = modApiFunc('Customer_Account','getCustomerAccountNameByCustomerID',$customer_id);
                $this->customer_obj = &$application->getInstance('CCustomerInfo',$account_name);
                $this->customerEmail = $this->customer_obj->getPersonInfo('Email','Customer');
                break;
            case '6':
                if(array_key_exists('Email',$this->customerRegData['info']))
                    $this->customerEmail = $this->customerRegData['info']['Email'];
                $this->customer_obj = &$application->getInstance('CCustomerInfo',$this->customerRegData['account']);
                break;
            case '7':
            case '8':
            case '9':
            case '10':
            case '11':
            case '12':
            case '13':
                $this->customer_obj = &$application->getInstance('CCustomerInfo',$this->customerAccount);
                $this->customerEmail = $this->customer_obj->getPersonInfo('Email','Customer');
                break;
            case '14':
                $this->product_obj = &$application->getInstance('CProductInfo',$this->inventory_info['entity_id']);
                break;
        };

        $tagsList = modApiFunc("Notifications", "getAvailableTagsList", array('0' => array('Id' => $this->actionId)));

        //initialize infotags
        $infotags = array();
        foreach ($tagsList[$this->actionId]['InfoTags'] as $infotag)
        {
            if (strpos($infotag, "Order") == 1)
            {
                $tag = substr($infotag, 6, strlen($infotag)-7);
                switch ($tag)
                {
                    case 'Date':
                        $infotags[$infotag] = modApiFunc("Localization", "date_format", $orderInfo[$tag]);
                        break;
                    case 'GlobalDiscount':
                        $infotags[$infotag] = modApiFunc("Localization", "currency_format", $orderInfo['Price']['SubtotalGlobalDiscount']);
                        break;
                    case 'PromoCodeDiscount':
                        $infotags[$infotag] = modApiFunc("Localization", "currency_format", $orderInfo['Price']['SubtotalPromoCodeDiscount']);
                        break;
                    case 'QuantityDiscount':
                        $infotags[$infotag] = modApiFunc("Localization", "currency_format", $orderInfo['Price']['QuantityDiscount']);
                        break;
                    case 'DiscountedSubtotal':
                        $infotags[$infotag] = modApiFunc("Localization", "currency_format", $orderInfo['Price']['DiscountedSubtotal']);
                        break;
                    case 'TotalShippingAndHandlingCost':
                        $ShippingCost = ($orderInfo['Price']['TotalShippingAndHandlingCost'] == PRICE_N_A) ? 0.0 : $orderInfo['Price']['TotalShippingAndHandlingCost'];
                        $infotags[$infotag] = modApiFunc("Localization", "currency_format", ($ShippingCost));
                        break;
                    case 'Tax':
                        $infotags[$infotag] = "";
                        $taxes = array();
                        foreach ($orderInfo['Price'] as $key => $value)
                        {
                            $tax_name_patern = "/^Taxes\['(.+)'\]$/";
                            $matches = array();
                            if(preg_match($tax_name_patern, $key, $matches))
                            {
                                $taxes[$matches[1]] = $value;
                            }
                        }

                        foreach ($taxes as $name => $value)
                        {
                            $infotags[$infotag].= $name." ".modApiFunc("Localization", "currency_format", $value)."\n";
                        }
                        break;
                    case 'OldStatus':
                        if ($this->actionId == '2')
                        {
                            $infotags[$infotag] = $this->OrderOldStatus;
                        }
                        break;
                    case 'OldPaymentStatus':
                        if ($this->actionId == '3')
                        {
                            $infotags[$infotag] = $this->OrderOldPaymentStatus;
                        }
                        break;
                    case 'Total':
                    case 'Subtotal':
                        $infotags[$infotag] = modApiFunc("Localization", "currency_format", $orderInfo[$tag]);
                        break;
                    case 'PaymentMethodText':
                    {
                        $pm_uid = $orderInfo['PaymentModuleId'];
                        $infotags[$infotag] = modApiFunc("Checkout", "getPaymentMethodText", $pm_uid);
                        break;
                    }
                    default:
                        $infotags[$infotag] = $orderInfo[$tag];
                        break;
                }
            }
            elseif (strpos($infotag, "Customer") == 1)
            {
                $tag = substr($infotag, 9, strlen($infotag)-10);
                $infotags[$infotag] = $this->customer_obj->getPersonInfo($tag,'Customer');
                switch(strtolower($tag))
                {
                    case 'country':
                        $infotags[$infotag] = modApiFunc('Location','getCountry',$infotags[$infotag]);
                        break;
                    case 'state':
                        if(modApiFunc('Location','getStateCode',$infotags[$infotag]) != '')
                            $infotags[$infotag] = modApiFunc('Location','getState',$infotags[$infotag]);
                        else
                            $infotags[$infotag] = $infotags[$infotag];
                        break;
                };
            }
            elseif (strpos($infotag, "Shipping") == 1)
            {
                $tag = substr($infotag, 9, strlen($infotag)-10);
                $infotags[$infotag] = isset($orderInfo['Shipping']['attr'][$tag]['value'])? $orderInfo['Shipping']['attr'][$tag]['value']:(isset($orderInfo['Shipping']['attr'][$tag."NULL"]['value'])? $orderInfo['Shipping']['attr'][$tag."NULL"]['value']:"");
            }
            elseif (strpos($infotag, "Billing") == 1)
            {
                $tag = substr($infotag, 8, strlen($infotag)-9);
                $infotags[$infotag] = isset($orderInfo['Billing']['attr'][$tag]['value'])? $orderInfo['Billing']['attr'][$tag]['value']:"";
            }
            elseif (strpos($infotag, "StoreOwner") == 1)
            {
                $tag = substr($infotag, 11, strlen($infotag)-12);
                switch ($tag)
                {
                    case "StreetLine1":
                        $infotags[$infotag] = modApiFunc("Configuration", "getValue", "store_owner_street_line_1");
                        break;
                    case "StreetLine2":
                        $infotags[$infotag] = modApiFunc("Configuration", "getValue", "store_owner_street_line_2");
                        break;
                    case "SiteAdministratorEmail":
                        $infotags[$infotag] = modApiFunc("Configuration", "getValue", "store_owner_site_administrator_email");
                        break;
                    case "OrdersDepartmentEmail":
                        $infotags[$infotag] = modApiFunc("Configuration", "getValue", "store_owner_orders_department_email");
                        break;
                    case "Country":
                        $infotags[$infotag] = modApiFunc("Location", "getCountry", modApiFunc("Configuration", "getValue", "store_owner_country"));
                        break;
                    case "State":
                        $state = modApiFunc("Configuration", "getValue", "store_owner_state");
                        $states_in_country = modApiFunc("Location", "getStates", modApiFunc("Configuration", "getValue", "store_owner_country"));
                        if (array_key_exists($state, $states_in_country))
                        {
                            $infotags[$infotag] = modApiFunc("Location", "getState", $state);
                        }
                        else
                        {
                            $infotags[$infotag] = $state;
                        }
                        break;
                    default:
                        $infotags[$infotag] = modApiFunc("Configuration", "getValue", "store_owner_".strtolower($tag));
                        break;
                }
            }
            elseif (strpos($infotag, "TrackingNumber") == 1)
            {
                $infotags[$infotag] = $orderInfo["TrackId"];
            }
            elseif(strpos($infotag, 'AccountActivationLink') == 1)
            {
                $r = &new Request();
                $r->setView('AccountActivation');
                $r->setAction('activate_account');
                $r->setKey('key',modApiFunc('Customer_Account','getActivationKey',$this->customerAccount));
                $infotags[$infotag] = $r->getURL();
            }
            elseif(strpos($infotag, 'AccountName') == 1)
            {
                $infotags[$infotag] = $this->customerAccount;
            }
            elseif(strpos($infotag, 'AccountNewPasswordLink') == 1)
            {
                $cz_layouts = LayoutConfigurationManager::static_get_cz_layouts_list();
                LayoutConfigurationManager::static_activate_cz_layout(array_shift(array_keys($cz_layouts)));
                $r = &new CZRequest();
                $r->setView('CustomerNewPassword');
                $r->setKey('key',modApiFunc('Customer_Account','getActivationKey',$this->customerAccount));
                $infotags[$infotag] = $r->getURL();
            }
            elseif(preg_match('/^\{combination(.+)\}$/i',$infotag,$matches))
            {
                $tag_value = '';

                switch(strtolower($matches[1]))
                {
                    case 'sku':
                        $tag_value = $this->inventory_info['sku'];
                        break;
                    case 'quantityinstock':
                        $tag_value = $this->inventory_info['quantity'];
                        break;
                    case 'description':
                        $tag_value = modApiFunc('Product_Options','convertCombinationToString',modApiFunc('Product_Options','_unserialize_combination',$this->inventory_info['combination']),'; ');
                        break;
                    default:
                        $tag_value = '';
                        break;
                };

                $infotags[$infotag] = $tag_value;
            }
            elseif(preg_match('/^\{product(.+)\}$/i',$infotag,$matches) and $this->product_obj != null)
            {
                $infotags[$infotag] = $this->product_obj->getProductTagValue($matches[1],PRODUCTINFO_LOCALIZED_DATA);
            }
        }

        //initialize blocktags
        foreach ($tagsList[$this->actionId]['BlockTags'] as $blocktagId => $blocktagInfo)
        {
            $infotags[$blocktagInfo['BlockTag']] = "";
            switch ($blocktagInfo['BlockTag'])
            {
                case '{OrderContentBlock}':
                    foreach ($orderInfo['Products'] as $productInfo)
                    {
                        $productInfoTags = array(
                            "\{ProductID\}" => $productInfo['storeProductID'],
                            "\{ProductName\}" => $productInfo['name'],
                            "\{ProductQuantity\}" => $productInfo['qty'],
                            "\{ProductPrice\}" => modApiFunc("Localization", "currency_format", $productInfo['SalePrice']),
                            "\{ProductAmount\}" => modApiFunc("Localization", "currency_format", ($productInfo['qty']*$productInfo['SalePrice'])),
                            "\{ProductOptions\}" => ''
                        );
                        foreach ($productInfo['attr'] as $attr => $attr_value)
                        {
                            if (
                                $attr == "SalePrice" ||
                                $attr == "ListPrice" ||
                                $attr == "PerItemShippingCost" ||
                                $attr == "PerItemHandlingCost"
                               )
                            {
                                $productInfoTags["\{Product".$attr."\}"] = modApiFunc("Localization", "currency_format", $attr_value["value"]);
                            }
                            elseif (
                                    $attr == "FreeShipping" ||
                                    $attr == "NeedShipping"
                                   )
                            {
                                $productInfoTags["\{Product".$attr."\}"] = ($attr_value["value"] == PRODUCT_FREESHIPPING_YES)? $this->MessageResources->getMessage("NTFCTN_INFO_YES_LABEL"):$this->MessageResources->getMessage("NTFCTN_INFO_NO_LABEL");
                            }
                            else
                            {
                                $productInfoTags["\{Product".$attr."\}"] = $attr_value["value"];
                            }
                        }
                        foreach ($productInfo['custom_attributes'] as $custom_attr_info)
                        {
                            $productInfoTags["\{Product".$custom_attr_info["tag"]."Custom\}"] = $custom_attr_info["value"];
                        }

                        $blocktag_body = $this->getNotificationBlockBody($blocktagId);
                        foreach ($productInfoTags as $tag => $val)
                        {
                            $blocktag_body = eregi_replace($tag, $val, $blocktag_body);
                        }
                        $infotags[$blocktagInfo['BlockTag']].= $blocktag_body."\n";
//                                $infotags[$blocktagInfo['BlockTag']].= strtr($this->getNotificationBlockBody($blocktagId), $productInfoTags)."\n";
                    }
                    break;
                case '{LowLevelProductsBlock}':
                    foreach ($orderInfo['Products'] as $productInfo)
                    {
                        $addToList = false;
                        $_productInfo = &new CProductInfo($productInfo['storeProductID']);
                        $productQuantityInStock = $_productInfo->getProductTagValue('QuantityInStock', PRODUCTINFO_NOT_LOCALIZED_DATA);
                        $productLowLevelInStock = $_productInfo->getProductTagValue('LowStockLevel', PRODUCTINFO_NOT_LOCALIZED_DATA);
                        if ($productLowLevelInStock)
                        {
                            if ($productQuantityInStock <= $productLowLevelInStock)
                            {
                                $addToList = true;
                            }
                        }
                        else
                        {
                            if ($productQuantityInStock <= 0)
                            {
                                $addToList = true;
                            }
                        }
                        if (!$addToList) continue;
                        $productInfoTags = array(
                            "\{ProductID\}" => $productInfo['storeProductID'],
                            "\{ProductName\}" => $productInfo['name'],
//                                    "\{ProductQuantity\}" => $productInfo['qty'],
                            "\{ProductPrice\}" => modApiFunc("Localization", "currency_format", $productInfo['SalePrice']),
//                                    "\{ProductAmount\}" => modApiFunc("Localization", "currency_format", ($productInfo['qty']*$productInfo['SalePrice'])),
                            "\{ProductQuantityInStock\}" => $productQuantityInStock? $productQuantityInStock:'0'
                        );
                        foreach ($productInfo['attr'] as $attr => $attr_value)
                        {
                            if (
                                $attr == "SalePrice" ||
                                $attr == "ListPrice" ||
                                $attr == "PerItemShippingCost" ||
                                $attr == "PerItemHandlingCost"
                               )
                            {
                                $productInfoTags["\{Product".$attr."\}"] = modApiFunc("Localization", "currency_format", $attr_value["value"]);
                            }
                            elseif (
                                    $attr == "FreeShipping" ||
                                    $attr == "NeedShipping"
                                   )
                            {
                                $productInfoTags["\{Product".$attr."\}"] = ($attr_value["value"] == PRODUCT_FREESHIPPING_YES)? $this->MessageResources->getMessage("NTFCTN_INFO_YES_LABEL"):$this->MessageResources->getMessage("NTFCTN_INFO_NO_LABEL");
                            }
                            else
                            {
                                $productInfoTags["\{Product".$attr."\}"] = $attr_value["value"];
                            }
                        }
                        foreach ($productInfo['custom_attributes'] as $custom_attr_info)
                        {
                            $productInfoTags["\{Product".$custom_attr_info["tag"]."Custom\}"] = $custom_attr_info["value"];
                        }

                        $blocktag_body = $this->getNotificationBlockBody($blocktagId);
                        foreach ($productInfoTags as $tag => $val)
                        {
                            $blocktag_body = eregi_replace($tag, $val, $blocktag_body);
                        }
                        $infotags[$blocktagInfo['BlockTag']].= $blocktag_body."\n";
//                                $infotags[$blocktagInfo['BlockTag']].= strtr($this->getNotificationBlockBody($blocktagId), $productInfoTags)."\n";
                    }
                    break;
                case '{OrderDiscountsBlock}':
                    $discountsInfoTags = array(
                            "\{OrderGlobalDiscount\}"     => modApiFunc("Localization", "currency_format", $orderInfo['Price']['SubtotalGlobalDiscount']),
                            "\{OrderPromoCodeDiscount\}"  => modApiFunc("Localization", "currency_format", $orderInfo['Price']['SubtotalPromoCodeDiscount']),
                            "\{OrderQuantityDiscount\}"  => modApiFunc("Localization", "currency_format", $orderInfo['Price']['QuantityDiscount']),
                            "\{OrderDiscountedSubtotal\}" => modApiFunc("Localization", "currency_format", $orderInfo['Price']['DiscountedSubtotal'])
                    );
                    $blocktag_body = $this->getNotificationBlockBody($blocktagId);
                    foreach ($discountsInfoTags as $tag => $val)
                    {
                        $blocktag_body = eregi_replace($tag, $val, $blocktag_body);
                    }
                    $infotags[$blocktagInfo['BlockTag']].= $blocktag_body;
                    break;
                case '{OrderDownloadLinksBlock}':
                    $hotlinks = modApiFunc('Product_Files','getHotlinksListForOrder',$this->orderId);
                    foreach($hotlinks as $k => $hotlink_info)
                    {
                        $file_info = modApiFunc('Product_Files','getPFileInfo',$hotlink_info['file_id']);
                        $HotlinkInfoTags = array(
                                "\{DownloadLink\}" => $hotlink_info['hotlink_value']
                               ,"\{DownloadLinkExpiryDate\}" => date("d M Y, H:i", $hotlink_info['expire_date'])
                               ,"\{DownloadLinkAttempts\}" => $hotlink_info['max_try']
                               ,"\{DownloadFilename\}" => $file_info['file_name']
                               ,"\{DownloadFileDescription\}" => $file_info['file_descr']
                        );
                        $blocktag_body = $this->getNotificationBlockBody($blocktagId);
                        foreach ($HotlinkInfoTags as $tag => $val)
                        {
                            $blocktag_body = eregi_replace($tag, $val, $blocktag_body);
                        }
                        $infotags[$blocktagInfo['BlockTag']].= $blocktag_body;
                    }
                    break;
            }
        };

        $this->EmailText = $this->getNotificationBody();
        $this->EmailSubject = $this->subject;

        foreach ($infotags as $tag => $val)
        {
            $this->EmailText = eregi_replace(strtr($tag, array('{'=>'\{','}'=>'\}')), $val, $this->EmailText);
            $this->EmailSubject = eregi_replace(strtr($tag, array('{'=>'\{','}'=>'\}')), $val, $this->EmailSubject);
        };

        $this->EmailText = $this->html_replace($this->EmailText);
        $this->EmailSubject = $this->html_replace($this->EmailSubject);
    }

    /**
     * Gets notification info.
     *
     * @param integer $n_id - notification id
     */
    function getNotificationInfo($n_id)
    {
        global $application;

        $tables = Notifications::getTables();
        $n  = $tables['notifications']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($n['subject'], 'Subject');
        $query->addSelectField($n['body'], 'Body');
        $query->addSelectField($n['from_email'], 'From_addr');
        $query->addSelectField($n['from_email_code'], 'Email_Code');
        $query->WhereValue($n['id'], DB_EQ, $n_id);
        $query->WhereAnd();
        $query->WhereValue($n['active'], DB_EQ, 'checked');
        $result = $application->db->getDB_Result($query);
        if (sizeof($result))
        {
            $this->subject = $result[0]['Subject'];
            $this->body = $result[0]['Body'];
            $this->from = $result[0]['From_addr'];
            $this->from_code = $result[0]['Email_Code'];
            return true;
        }
        else
        {
            return false;
        }
    }


    /**
     * Gets a notification body.
     *
     */
    function getNotificationBody()
    {
        return $this->body;
    }

    /**
     * Gets a blocktag body.
     *
     *@param integer $b_id - id blocktag-a
     */
    function getNotificationBlockBody($b_id)
    {
        $body = "";
        global $application;

        $tables = Notifications::getTables();
        $nbb = $tables['notification_blocktag_bodies']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($nbb['body'], 'Body');
        $query->WhereValue($nbb['n_id'], DB_EQ, $this->notificationId);
        $query->WhereAnd();
        $query->WhereValue($nbb['nb_id'], DB_EQ, $b_id);
        $result = $application->db->getDB_Result($query);

        if (sizeof($result) != 0)
        {
            $body = $result[0]['Body'];
        }

        return $body;
    }

    /**
     * Gets a sender address.
     *
     */
    function getSendFrom()
    {
        return modApiFunc("Notifications", "getExtendedEmail", $this->from, $this->from_code, true);
    }

    /**
     * Gets a list of receiver addesses.
     *
     */
    function getSendTo()
    {
        global $application;

        $tables = Notifications::getTables();
        $nst = $tables['notification_send_to']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($nst['email'], 'Email');
        $query->addSelectField($nst['code'], 'Email_Code');
        $query->WhereValue($nst['n_id'], DB_EQ, $this->notificationId);
        $result = $application->db->getDB_Result($query);

        $to = array();
        foreach ($result as $ToEmail)
        {
            if ($ToEmail['Email_Code'] == 'EMAIL_CUSTOMER' and $this->customerEmail != null)
            {
                $to[] = $this->customerEmail;
            }
            else
            {
                $email = modApiFunc("Notifications", "getExtendedEmail", $ToEmail['Email'], $ToEmail['Email_Code'], true);
                if ($email)
                {
                    $to[] = $email;
                }
            }
        }

        return $to;
    }

    /**
     *
     */
    function html_replace($text)
    {
        $search = array ("'<script[^>]*?>.*?</script>'si",  //          javaScript
                         "'<[\/\!]*?[^<>]*?>'si",          //          HTML-    
//                         "'([\r\n])[\s]+'",                //                            
                         "'&(quot|#34);'i",                //          HTML-        
                         "'&(amp|#38);'i",
                         "'&(lt|#60);'i",
                         "'&(gt|#62);'i",
                         "'&(nbsp|#160);'i",
                         "'&(iexcl|#161);'i",
                         "'&(cent|#162);'i",
                         "'&(pound|#163);'i",
                         "'&(copy|#169);'i",
                         "'&#(\d+);'e");                    //                      php-   

        $replace = array ("",
                         "",
//                         "\\1",
                         "\"",
                         "&",
                         "<",
                         ">",
                         " ",
                         chr(161),
                         chr(162),
                         chr(163),
                         chr(169),
                         "chr(\\1)");

        return preg_replace($search, $replace, $text);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */


    /**#@-*/

}
?>