<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package ProductOptions
 * @author Egor V. Derevyankin
 *
 */

class PO_OptionsList
{
    function PO_OptionsList()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"product-options-messages", "AdminZone");
    }

    function outputActualHeader()
    {
        global $application;

        if($this->parent_entity=='product')
        {
            $request_to_no = &new Request();
            $request_to_no->setView('PO_AddOption');
            $request_to_no->setKey('parent_entity',$this->parent_entity);
            $request_to_no->setKey('entity_id',$this->entity_id);

            $prdobj = &$application->getInstance('CProductInfo',$this->entity_id);

            $template_contents=array(
                "ProductName" => $prdobj->getProductTagValue("Name")
               ,"Local_ProductBookmarks" => ProductBookmarks('options', $this->entity_id)
            );

            $this->_Template_Contents=$template_contents;
            $application->registerAttributes($this->_Template_Contents);
            $this->mTmplFiller = &$application->getInstance('TmplFiller');
            return $this->mTmplFiller->fill("product_options/", "header-for-product-on-options-list.tpl.html",array());
        }
        elseif($this->parent_entity=='ptype')
        {
            $ptinfo = modApiFunc("Catalog","getProductType",$this->entity_id);
            $template_contents=array(
                "ProductTypeName" => $ptinfo['name']
            );
            $this->_Template_Contents=$template_contents;
            $application->registerAttributes($this->_Template_Contents);
            $this->mTmplFiller = &$application->getInstance('TmplFiller');
            return $this->mTmplFiller->fill("product_options/", "header-for-ptype-on-options-list.tpl.html",array());
        };
    }

    function output()
    {
        global $application;
        $request = &$application->getInstance('Request');
        $this->parent_entity=$request->getValueByKey("parent_entity");
        $this->entity_id=$request->getValueByKey("entity_id");

        $template_contents = array(
                "ActualHeader" => $this->outputActualHeader()
        );

        $this->_Template_Contents=$template_contents;
        $application->registerAttributes($this->_Template_Contents);
        $this->mTmplFiller = &$application->getInstance('TmplFiller');
        return $this->mTmplFiller->fill("product_options/", "options-list-container.tpl.html",array());
    }

    function getTag($tag)
    {
        return getKeyIgnoreCase($tag, $this->_Template_Contents);
    }

    var $_Template_Contents;
    var $MessageResources;
    var $parent_entity;
    var $entity_id;
};

?>