<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

class ShippingCostCalculatorSettings
{
    function ShippingCostCalculatorSettings()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"shipping-cost-calculator-messages", "AdminZone");
        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }

        loadCoreFile('html_form.php');
    }

    function initFormData()
    {
        $this->POST = modApiFunc("Shipping_Cost_Calculator","getSettings");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
            );

    }

    /**
     * Copies data from the global POST to the local POST array.
     */
    function copyFormData()
    {
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST =
            array(
                "PO_SC"      => $SessionPost["PO_SC"],
                "PO_SC_TYPE" => $SessionPost["PO_SC_TYPE"],
                "PO_HC"      => $SessionPost["PO_HC"],
                "MIN_SC"     => $SessionPost["MIN_SC"],
                "FS_OO"      => $SessionPost["FS_OO"],
                "FH_OO"      => $SessionPost["FH_OO"]
            );

    }


    /**
     * @return String Return html code for hidden form fields representing
     * @var $this->ViewState array.
     */
    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    /**
     * @return HTML code for the errors
     */
    function outputErrors()
    {

        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }
        global $application;

        $return_html_code="";
        foreach($this->ErrorsArray as $index => $value)
        {
            $this->_Template_Contents = array(
                                            "ErrorIndex"    => $index+1,
                                            "Error"            => $this->MessageResources->getMessage($value)
                                        );
            $application->registerAttributes($this->_Template_Contents);
            $return_html_code.=$this->mTmplFiller->fill("shipping_cost_calculator/", "error.tpl.html", array());
        };
        return $return_html_code;
    }

    function output()
    {
        global $application;

        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        # Per order shipping fee types
        $po_sc_types = array (
            "select_name" => "PO_SC_TYPE",
            "selected_value" => $this->POST["PO_SC_TYPE"],
            "values" => array(
                array (
                    "value" => "A",
                    "contents" => modApiFunc("Localization","getCurrencySign")
                ),
                array (
                    "value" => "P",
                    "contents" => "%"
                ),
            )
        );

        $template_contents = array(
                "HiddenArrayViewState"  => $this->outputViewState()
               ,"Errors"                => $this->outputErrors()
               ,"SSC_Header"      => $this->MessageResources->getMessage("SSC_HEADER")
               ,"LabelSettings"   => $this->MessageResources->getMessage("LABEL_SETTINGS")
               ,"POSC_FiledName"  => $this->MessageResources->getMessage("PER_ORDER_SHIPPING_COST")
               ,"POSC_FiledValue" => $this->POST["PO_SC"]
               ,"POSC_Type"       => HtmlForm::genDropdownSingleChoice($po_sc_types)
               ,"POHC_FiledName"  => $this->MessageResources->getMessage("PER_ORDER_HANDLING_COST")
               ,"POHC_FiledValue" => $this->POST["PO_HC"]
               ,"MINSC_FiledName"  => $this->MessageResources->getMessage("MINIMUM_SHIPPING_COST")
               ,"MINSC_FiledValue" => $this->POST["MIN_SC"]
               ,"FSOO_FiledName"  => $this->MessageResources->getMessage("FREE_SHIPPING")
               ,"FSOO_FiledValue" => $this->POST["FS_OO"]
               ,"FHOO_FiledName"  => $this->MessageResources->getMessage("FREE_HANDLING")
               ,"FHOO_FiledValue" => $this->POST["FH_OO"]
               ,"Alert_001" => $this->MessageResources->getMessage("ALERT_001")
               ,"Alert_002" => $this->MessageResources->getMessage("ALERT_002")
               ,"Alert_003" => $this->MessageResources->getMessage("ALERT_003")
               ,"Alert_004" => $this->MessageResources->getMessage("ALERT_004")
               ,"Alert_005" => $this->MessageResources->getMessage("ALERT_005")
               ,"CurrecySign" => modApiFunc("Localization","getCurrencySign")
        );

        $this->_Template_Contents=$template_contents;
        $application->registerAttributes($this->_Template_Contents);

        $mainMessageResources = &$application->getInstance('MessageResources');

        $output = modApiFunc('TmplFiller', 'fill',
                              './../../js/','validate.msgs.js.tpl',
                              array(
                                    "INTEGER" => $mainMessageResources->getMessage( new ActionMessage(array('PRDADD_001')) )
                                   ,"FLOAT"   => $mainMessageResources->getMessage( new ActionMessage(array('PRDADD_002')) )
                                   ,"STRING1024"=> $mainMessageResources->getMessage( new ActionMessage(array('CATADD_001')) )
                                   ,"STRING128"=> $mainMessageResources->getMessage( new ActionMessage(array('CATADD_002')) )
                                   ,"STRING256"=> $mainMessageResources->getMessage( new ActionMessage(array('CATADD_003')) )
                                   ,"STRING512"=> $mainMessageResources->getMessage( new ActionMessage(array('CATADD_004')) )
                                   ,"CURRENCY"=> addslashes($mainMessageResources->getMessage( new ActionMessage(array('CURRENCY_FIELD',
                                                         modApiFunc("Localization", "FloatToFormatStr", 12.35, "currency"),
                                                         modApiFunc("Localization", "FloatToFormatStr", 34, "currency"),
                                                         modApiFunc("Localization", "FloatToFormatStr", 99.00, "currency")))))
                                   ,"WEIGHT"   => addslashes($mainMessageResources->getMessage( new ActionMessage(array('WEIGHT_FIELD',
                                                         modApiFunc("Localization", "FloatToFormatStr", 23.325, "weight"),
                                                         modApiFunc("Localization", "FloatToFormatStr", 34, "weight"),
                                                         modApiFunc("Localization", "FloatToFormatStr", 99.2, "weight")))))
                                   ,"ITEM"     => $mainMessageResources->getMessage( new ActionMessage(array('ITEM_FIELD')))
                                   )
                            );
        return $output.$this->mTmplFiller->fill("shipping_cost_calculator/", "settings.tpl.html",array());
    }

    function getTag($tag)
    {
        global $application;
        $value = getKeyIgnoreCase($tag, $this->_Template_Contents);
        return $value;
    }

    var $_Template_Contents;
    var $MessageResources;
    var $POST;

    var $ViewState;

    var $ErrorsArray;
    var $ErrorMessages;

    var $_error_index;
    var $_error;

}


?>