<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Catalog module.
 * This action is responsible for adding new category.
 *
 * @package ShippingModuleFlatShippingRates
 * @access  public
 * @author Girin Alexander
 */
class update_flat_shipping_rates
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function update_flat_shipping_rates()
    {
    }

    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Shipping_Module_Flat_Shipping_Rates", "getUid")), ($SessionPost["status"]=="active")? true:false);

        $Settings = array(
                          "MODULE_NAME"  => $SessionPost["ModuleName"]
//                         ,"MODULE_DESCR" => $SessionPost["ModuleDescr"]
                         ,"MODULE_RATE_UNIT_ID" => $SessionPost["ModuleRateUnitId"]
//                         ,"MODULE_COST_TYPE_ID" => $SessionPost["ModuleCostTypeId"]
                         );
        modApiFunc("Shipping_Module_Flat_Shipping_Rates", "updateSettings", $Settings);
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        $request = $application->getInstance('Request');

        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

//        $SessionPost = array();
        $SessionPost = $_POST;

        $SessionPost["ViewState"]["ErrorsArray"] = array();

        if($SessionPost["status"] == "active")
        {
            //         ,       CheckoutFormEditor'                           
            //         PersonInfo     : ShippingInfo.
            if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("shippingInfo")) === true)
            {
            }
            else
            {
                $SessionPost["status"]= "inactive";
                $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
            }
        }

        switch($request->getValueByKey('FormSubmitValue'))
        {
            case "AddRow" :
            {
                $this->EPS = 0.01;
                //Get the required fields.
                $c_id = $SessionPost["c_id"];
                if($c_id == modApiFunc("Location", "get_constant", "ALL_OTHER_COUNTRIES_COUNTRY_ID"))
                {
                    //Set up the state obligatory just to be sure.
                    $s_id = modApiFunc("Location", "get_constant", "STATE_UNDEFINED_STATE_ID");
                }
                else
                {
                    $s_id = $SessionPost["s_id"];
                }
                $rate_value_from = modApiFunc("Localization", "FormatStrToFloat", $SessionPost["rv_from"], $SessionPost["UnitType"]);
                $rate_value_to = modApiFunc("Localization", "FormatStrToFloat", $SessionPost["rv_to"], $SessionPost["UnitType"]);
                if((!is_numeric($rate_value_from)) || (!is_numeric($rate_value_to)))
                {
                    break;
                }
                $rate_unit_id = $SessionPost["ModuleRateUnitId"];
                //percentage or absolute:
//                $cost_type_id = $SessionPost["ModuleCostTypeId"];
                $rate_cost = modApiFunc("Localization", "FormatStrToFloat", $SessionPost["cost"], $SessionPost["UnitType"]);

                //Check if $to is greater than $from
                if($rate_value_to <= $rate_value_from)
                {
                    $SessionPost["ViewState"]["ErrorsArray"]["TO_LTE_FROM"] = "TO_LTE_FROM";
                }
                else
                {
                    //Check if rate unit intervals don't intersect (even in single point)
                    //  and do form contiguous sequence.
                    $ret_struct = modApiFunc("Shipping_Module_Flat_Shipping_Rates", "doesAddingShippingRateCreateRateUnitIntervalsIntersection", $this->EPS, $c_id, $s_id, $rate_value_from, $rate_value_to, $rate_unit_id, 1 /*$cost_type_id*/, $rate_cost);
                    if($ret_struct["ret_val"] == false)
                    {
                        //There are no intersections.
//                        if(modApiFunc("Shipping_Module_Flat_Shipping_Rates", "areShippingRatesIntervalsContiguous"))
//                        {
//                        }
                    }
                    else
                    {
                        $SessionPost["ViewState"]["ErrorsArray"]["INTERSECTION_RATE_ID"] = $ret_struct["id"];
                        $SessionPost["ViewState"]["ErrorsArray"]["INTERSECTION_COORD"] = $ret_struct["intersection_coord"];
                        //if($ret_struct["intersection_coord"] !== NULL)
                        ////There is an intersection exactly at one point.
                        //else
                        ////There are intersections at more than one point.
                    }
                }

                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);
                if($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    modApiFunc("Shipping_Module_Flat_Shipping_Rates", "insertFlatShippingRates", $c_id, $s_id, $rate_value_from, $rate_value_to, $rate_unit_id, 1 /*$cost_type_id*/, $rate_cost);
                    //$SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }

            case "DelRows" :
            {
                if(isset($SessionPost["selected_rates"]))
                {
                    $selected_rates_array = $SessionPost["selected_rates"];

                    $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);
                    if($nErrors == 0)
                    {
                        unset($SessionPost["ViewState"]["ErrorsArray"]);
                        modApiFunc("Shipping_Module_Flat_Shipping_Rates", "deleteRowsFromFlatShippingRates", $selected_rates_array);
                        //$SessionPost["ViewState"]["hasCloseScript"] = "true";
                    }
                }
                break;
            }

            case "Save" :
            {
                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);
                if($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }
            case "ChangeRateUnit":
            {
                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);
                if($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $Settings = array(
                         "MODULE_RATE_UNIT_ID" => $SessionPost["ModuleRateUnitId"]
                         );
                    modApiFunc("Shipping_Module_Flat_Shipping_Rates", "updateSettings", $Settings);
//                    $this->saveDataToDB($SessionPost);
//                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }
            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        //TODO get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>