<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Shipping Module "Flat Shipping Rates".
 *
 * @package ShippingModuleFlatShippingRates
 * @author Girin Alexander
 */
class Shipping_Module_Flat_Shipping_Rates
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * ShippingModuleFlatShippingRates  constructor.
     */
    function Shipping_Module_Flat_Shipping_Rates()
    {
        $this->selectedCountries = array();
        $this->selectedStates = array();
        $this->selectedStatesAllOther = array();
    }

    function getUID()
    {
        return "8C262EF4-5E9B-DE1D-94CB-30EEC93F002E";
    }

    /**
     *                              
     */
    /**
     * Returns module info.
     */
    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"shipping-module-flat-shipping-rates-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniqueShippingModuleID" => $this->getUID(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "flat_shipping_rates_input_az",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Flat_Shipping_Rates::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"shipping-module-flat-shipping-rates-messages", "AdminZone");

        $tables = Shipping_Module_Flat_Shipping_Rates::getTables();
        $query = &new DB_Table_Create($tables);

        $table = 'sm_flat_shipping_rates_rate_units';            #the name of the filled table
        $columns = $tables[$table]['columns'];  #the array of field names of the table

        for ($i=1; $i<=3; $i++)
        {
            $query = &new DB_Insert($table);
            $query->addInsertValue($i, $columns['id']);
            $query->addInsertValue($obj->getMessage('SM_TBL_RTS_RU_00'.$i), $columns['name']);
            $query->addInsertValue($obj->getMessage('SM_TBL_RTS_RU_TYPE_00'.$i), $columns['type']);
            $query->addInsertValue($obj->getMessage('SM_TBL_RTS_RU_DESCR_00'.$i), $columns['descr']);
            $application->db->getDB_Result($query);
        }

        $table = 'sm_flat_shipping_rates_settings';            #  the name of the filled table
        $columns = $tables[$table]['columns'];  #  the array of field names of the table

        $query = &new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'.strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);
        $query = &new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_RATE_UNIT_ID", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor                
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (  
        //             ), ShippingMethodInfo (              ).
        //       ShippingModule'                                                 ,
        //                                     .                                  
        //                    ,                 PersonInfoType          .      
        //                                                                   
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Shipping_Module_Flat_Shipping_Rates',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor                
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (  
     *            ), ShippingMethodInfo (              ).
     *      ShippingModule'                                                 ,
     *                                    .                                  
     *                   ,                 PersonInfoType          .      
     *                                                                  
     * PersonInfoType.
     *
     *        Standard Shipping Rates                         PersonInfoType:
     * shippingInfo
     *
     * @param string $person_info_type_tag - tag      person info type' ,        
     *                      (turn off)   CheckoutFormEditor' .
     *
     * @return mixed - NULL,                       - "          ",       -         
     *                                     ,            ,                      
     *        (                                   ).
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"shipping-module-flat-shipping-rates-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_SHIPPING_FLAT_SHIPPING_RATES_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }


    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules", "shipping");
        return array_key_exists($this->getUid(), $active_modules);
    }

    /**
     * This method is invoked by Checkout. It returns the cost of the selected
     * shipping method. Some shipping modules can have several shipping methods
     * (e.g. by airplane, by train etc.), the other have only one.
     * 'All Inactive' has one method. The result is always the same
     * "the cost is not defined" ("N/A").
     */
    function getShippingCost($method_id="")
    {
        //$ShippingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo");
        ////FIXME: remove stuff after finishing taxes.
        //return PRICE_N_A;

        $ShippingInfo = modApiFunc("Shipping_Cost_Calculator","getShippingInfo");
        $orderCost = modApiFunc("Shipping_Cost_Calculator","getCartSubtotal");

        if($ShippingInfo["isMet"] == false)
        {
            return PRICE_N_A;
        }

        $this->getSettings();

        global $application;
        $tables = $this->getTables();

        //$orderCost = modApiFunc("Checkout", "getOrderPrice", "Subtotal");
        switch ($this->Settings["MODULE_RATE_UNIT_ID"])
        {
            case 2: /*$orderRateUnit = modApiFunc("Checkout", "getOrderWeight", "brutto");*/
                    $orderRateUnit = modApiFunc("Shipping_Cost_Calculator","getPackWeight");
                    break;
            case 3: /*$orderRateUnit = modApiFunc("Checkout", "getOrderProductsNumber");*/
                    $orderRateUnit=modApiFunc("Shipping_Cost_Calculator","getItemsCount");
                    break;
            case 1:
            default: $orderRateUnit = $orderCost; break;
        }

/*        $i = 0;
        $rate_id = $result[0]["id"];
        while ($orderRateUnit >= $result[$i]["value"])
        {
            $i++;
        }
        $rate_id = $result[$i]["id"]; */

        $countryId = $ShippingInfo["validatedData"]["Country"]["value"];
        $stateId = modApiFunc("Checkout", "getPrAttr", "shippingInfo", "Statemenu");
        //$stateId = $ShippingInfo["validatedData"]["Statemenu"]["value"];

/*        $addr_id = $this->getZone($countryId, $stateId, $this->Settings["MODULE_RATE_UNIT_ID"]); */

        $tr = $tables['sm_flat_shipping_rates_rates_table']['columns'];
        $query = &new DB_Select();
        $query->addSelectField($tr["cost"], "cost");
        $query->WhereValue($tr["c_id"], DB_EQ, $countryId);

        $query->WhereAND();
        $STATE_ID_ALL = modApiFunc("Taxes", "getConst", "STATE_ID_ALL");
        if($stateId === NULL)
        {
        	$query->WhereValue($tr["s_id"], DB_EQ, $STATE_ID_ALL);
        }
        else
        {
        $query->WhereValue($tr["s_id"], DB_EQ, $stateId);
        }

        $query->WhereAND();
        $query->WhereValue($tr["rv_from"], DB_LTE, $orderRateUnit);
        $query->WhereAND();
        $query->WhereValue($tr["rv_to"], DB_GTE, $orderRateUnit);
        $query->WhereAND();
        $query->WhereValue($tr["ru_id"], DB_EQ, $this->Settings["MODULE_RATE_UNIT_ID"]);
        $result = $application->db->getDB_Result($query);
        if (sizeof($result)==1)
        {
            $cost = $result[0]["cost"];
//            if ($this->Settings["MODULE_COST_TYPE_ID"] == 2)
//            {
//                $cost = sprintf("%.2f", (float)($orderCost*$cost/100));
//            }
        }
        else
        {
            //Try "ALL STATES" cost for chosen country.
            $query = &new DB_Select();
            $query->addSelectField($tr["cost"], "cost");
            $query->WhereValue($tr["c_id"], DB_EQ, $countryId);
            $query->WhereAND();
            $query->WhereValue($tr["s_id"], DB_EQ, modApiFunc("Location", "get_constant", "ALL_OTHER_STATES_STATE_ID"));
            $query->WhereAND();
            $query->WhereValue($tr["rv_from"], DB_LTE, $orderRateUnit);
            $query->WhereAND();
            $query->WhereValue($tr["rv_to"], DB_GTE, $orderRateUnit);
            $query->WhereAND();
            $query->WhereValue($tr["ru_id"], DB_EQ, $this->Settings["MODULE_RATE_UNIT_ID"]);
            $result = $application->db->getDB_Result($query);
            if(sizeof($result)==1)
            {
                $cost = $result[0]["cost"];
//                if ($this->Settings["MODULE_COST_TYPE_ID"] == 2)
//                {
//                    $cost = sprintf("%.2f", (float)($orderCost*$cost/100));
//                }
            }
            else
            {
                //Try "ALL COUNTRIES" cost.
                $query = &new DB_Select();
                $query->addSelectField($tr["cost"], "cost");
                $query->WhereValue($tr["c_id"], DB_EQ, modApiFunc("Location", "get_constant", "ALL_OTHER_COUNTRIES_COUNTRY_ID"));
                /* Query shortened for speed optimization, though result must be the same:
                   if country_id = ALL_COUNTRIES, then corresponding
                      state_id MUST be STATE_UNDEFINED_STATE_ID
                */
                //$query->WhereAND();
                //$query->WhereValue($tr["s_id"], DB_EQ, modApiFunc("Location", "get_constant", "STATE_UNDEFINED_STATE_ID"));
                $query->WhereAND();
                $query->WhereValue($tr["rv_from"], DB_LTE, $orderRateUnit);
                $query->WhereAND();
                $query->WhereValue($tr["rv_to"], DB_GTE, $orderRateUnit);
                $query->WhereAND();
                $query->WhereValue($tr["ru_id"], DB_EQ, $this->Settings["MODULE_RATE_UNIT_ID"]);
                $result = $application->db->getDB_Result($query);
                if(sizeof($result)==1)
                {
                    $cost = $result[0]["cost"];
    //                if ($this->Settings["MODULE_COST_TYPE_ID"] == 2)
    //                {
    //                    $cost = sprintf("%.2f", (float)($orderCost*$cost/100));
    //                }
                }
                else
                {
                    $cost = PRICE_N_A;
                    //$cost = 0;
                }
            }
        }

        return $cost;
    }

    function getShippingMethodInfo($method_id, $and_calc=false)
    {
        if(!isset($this->Settings))
            $this->Settings=$this->getSettings();
        if($method_id == $this->single_available_method_id)
        {
            return array(
                        'id' => $this->single_available_method_id,
                        //@todo                                             
                        'method_name' => $this->Settings["MODULE_NAME"],
                        'method_code' => '',
                        'destination' => 'UNDEFINED',
                        'available' => $this->IsActive() ? 'Y' : 'N',
                        'days' => 0,
                        'cost' => ( $and_calc ? $this->getShippingCost() : PRICE_N_A )
                        );
        }
        else
        {
            return array();
        }
    }

    /**
     *
     */
    function getShippingMethods($type="ALL", $and_calc = false)
    {
        global $application;

       /* The $type="AVAILABLE" condition in this module equals the whole
           module, which is isActive.
        */
        if($type == "AVAILABLE" &&
           $this->isActive() === false)
        {
            return array();
        }

        if($this->is_debug==true)
            $this->_debug_info[]=array("Calculation type","Offline");

        $info = $this->getShippingMethodInfo($this->single_available_method_id, $and_calc);

       /* If the parameter $and_calc == true, the shipping cost should be
           determined.
        */
        if($and_calc === true &&
           $info["cost"] == PRICE_N_A)
        {
            if($this->is_debug==true)
                $this->_debug_info[]=array("Result","Delivery is not available");
            return array();
        }

        if($this->is_debug==true)
            $this->_debug_info[]=array("Result",modApiFunc('Localization','currency_format',$info["cost"]));

        return array($info);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Flat_Shipping_Rates::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = &new DB_Table_Delete(Shipping_Module_Flat_Shipping_Rates::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Returns true if in this shipping module the shipping method with the
     * specified id exists, false otherwise.
     */
    function isValidShippingMethodId($method_id)
    {
        if($method_id == 1)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $rate_units = 'sm_flat_shipping_rates_rate_units';
        $tables[$rate_units] = array();
        $tables[$rate_units]['columns'] = array
            (
                'id'                => $rate_units.'.sm_flat_shipping_rates_rate_unit_id'
               ,'name'              => $rate_units.'.sm_flat_shipping_rates_rate_unit_name'
               ,'type'              => $rate_units.'.sm_flat_shipping_rates_rate_unit_type'
               ,'descr'             => $rate_units.'.sm_flat_shipping_rates_rate_unit_descr'
            );
        $tables[$rate_units]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'name'              => DBQUERY_FIELD_TYPE_CHAR50
               ,'type'              => DBQUERY_FIELD_TYPE_CHAR20
               ,'descr'             => DBQUERY_FIELD_TYPE_TEXT
            );
        $tables[$rate_units]['primary'] = array
            (
                'id'
            );

        $table_rates = 'sm_flat_shipping_rates_rates_table';
        $tables[$table_rates] = array();
        $tables[$table_rates]['columns'] = array
            (
                'id'                => $table_rates.'.sm_flat_shipping_rates_table_rate_id'
               ,'c_id'              => $table_rates.'.sm_flat_shipping_rates_country_id'
               ,'s_id'              => $table_rates.'.sm_flat_shipping_rates_state_id'
               ,'rv_from'           => $table_rates.'.sm_flat_shipping_rates_rate_value_from'
               ,'rv_to'             => $table_rates.'.sm_flat_shipping_rates_rate_value_to'
               ,'ru_id'             => $table_rates.'.sm_flat_shipping_rates_rate_unit_id'
               ,'cost_type_id'      => $table_rates.'.sm_flat_shipping_rates_rate_cost_type_id'
               ,'cost'              => $table_rates.'.sm_flat_shipping_rates_rate_cost'
            );
        $tables[$table_rates]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'c_id'              => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
               ,'s_id'              => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
               ,'rv_from'           => DBQUERY_FIELD_TYPE_FLOAT
               ,'rv_to'             => DBQUERY_FIELD_TYPE_FLOAT
               ,'ru_id'             => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
               ,'cost_type_id'      => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
               ,'cost'              => DBQUERY_FIELD_TYPE_FLOAT
            );
        $tables[$table_rates]['primary'] = array
            (
                'id'
            );
        $tables[$table_rates]['indexes'] = array
            (
                'IDX_c' => 'c_id'
               ,'IDX_s' => 's_id'
               ,'IDX_rv_from' => 'rv_from'
               ,'IDX_rv_to' => 'rv_to'
            );

        $settings = 'sm_flat_shipping_rates_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.sm_flat_shipping_rates_setting_id'
               ,'key'               => $settings.'.sm_flat_shipping_rates_setting_key'
               ,'value'             => $settings.'.sm_flat_shipping_rates_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = &new DB_Delete('sm_flat_shipping_rates_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['sm_flat_shipping_rates_settings']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($columns["key"], "set_key");
        $query->addSelectField($columns["value"], "set_value");
        $result = $application->db->getDB_Result($query);
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settins array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['sm_flat_shipping_rates_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = &new DB_Insert('sm_flat_shipping_rates_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['sm_flat_shipping_rates_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = &new DB_Update('sm_flat_shipping_rates_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * Gets rate units.
     *
     * @return array - the result array
     */
    function getRateUnits()
    {
        global $application;
        $tables = $this->getTables();
        $ru = $tables['sm_flat_shipping_rates_rate_units']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($ru["id"], "id");
        $query->addSelectField($ru["name"], "name");
        $query->addSelectField($ru["type"], "type");
        $query->addSelectField($ru["descr"], "descr");
        $result = $application->db->getDB_Result($query);
        return $result;
    }

    /**
     * Gets a unit of rate units from the Localization module.
     *
     * @param integer $ru_type - unit type
     *
     * @return array - the array of results
     */
    function getRateUnitUnitsValue($ru_type)
    {
        return modApiFunc("Localization", "getUnitTypeValue", $ru_type);
    }

    /**
     * Gets strings from the table of the shipping cost values.
     *
     * @param integer $regionId - address id
     * @param array $rate_unit_values_array - the array of rate units interval
     *        values
     * @return array - the array of rates, ordered by c_id, s_id, rv_from.
     */
    function getFlatShippingRates($ru_id = NULL, $cost_type_id = NULL/*$countryId, $stateId, $rate_unit_values_array*/)
    {
        global $application;
        $tables = $this->getTables();
        $tr = $tables['sm_flat_shipping_rates_rates_table']['columns'];

        $result_array = array();
////        foreach ($rate_unit_values_array as $rate_unit_value)
////        {
            $query = &new DB_Select();
            $query->addSelectField($tr["id"], "id");
            $query->addSelectField($tr["c_id"], "c_id");
            $query->addSelectField($tr["s_id"], "s_id");
            $query->addSelectField($tr["rv_from"], "rv_from");
            $query->addSelectField($tr["rv_to"], "rv_to");
            $query->addSelectField($tr["ru_id"], "ru_id");
            $query->addSelectField($tr["cost_type_id"], "cost_type_id");
            $query->addSelectField($tr["cost"], "cost");

            $query->WhereValue('', '', '1');
            if($ru_id !== NULL)
            {
                $query->WhereAnd();
                $query->WhereValue($tr["ru_id"], DB_EQ, $ru_id);
            }
            if($cost_type_id !== NULL)
            {
                $query->WhereAnd();
                $query->WhereValue($tr["cost_type_id"], DB_EQ, $cost_type_id);
            }
            $query->SelectOrder($tr['c_id']);
            $query->SelectOrder($tr['s_id']);
            $query->SelectOrder($tr['rv_from']);

            $result_rows = $application->db->getDB_Result($query);
//            if (sizeof($result)>0)
            foreach($result_rows as $row)
            {
                $result_array[$row["ru_id"]][$row["cost_type_id"]][$row["c_id"]][$row["s_id"]][] = $row;
            }
////        }
        return $result_array;
    }

    /**
     * Deletes the strings from the table.
     *
     * @param array $address_id_array - the array of address ids
     * @param $rate_unit_id - id of rate unit
     */
    function deleteRowsFromFlatShippingRates($rate_id_array)
    {
        global $application;
        $tables = $this->getTables();
        $tr = $tables['sm_flat_shipping_rates_rates_table']['columns'];

        $query = &new DB_Delete('sm_flat_shipping_rates_rates_table');
        $query->WhereField( $tr['id'], DB_IN, "(".implode(", ", $rate_id_array).") ");
        $application->db->getDB_Result($query);
    }

    /**
     * Checks if two intervals are intersected. The boundaries are real numbers.
     * If they are intersected (even at a single point), returns true, false otherwise.
     */
    function doTwoIntervalsIntersect($from1, $to1, $from2, $to2)
    {
        return !(($to1 < $from2) || ($to2 < $from1));
    }

    /**
     * Checks if two intervals are intersected at exactly one point.
     *
     * @param $EPS the accuracy of comparison of two real numbers.
     * @return false if two intervals are intersected at more than two points,
     * or are not injtersected at all, returns a real number - the coordinate
     * of a singular intersection point, otherwise.
     */
    function doTwoIntervalsIntersectInSinglePoint($EPS, $from1, $to1, $from2, $to2)
    {
        $ret_struct = array("ret_val" => false,
                            "intersection_coord" => NULL);
        if(!$this->doTwoIntervalsIntersect($from1, $to1, $from2, $to2))
        {
        }
        else
        {
            if(($from1 < $from2) &&
               (abs($to1 - $from2) < 0.5 * $EPS))
            {
                $ret_struct["ret_val"] = true;
                $ret_struct["intersection_coord"] = $to1;
            }
            else
            if(($from2 < $from1) &&
               (abs($to2 - $from1) < 0.5 * $EPS))
            {
                $ret_struct["ret_val"] = true;
                $ret_struct["intersection_coord"] = $to2;
            }
            else
            {
            }
        }
        return $ret_struct;
    }

    /**
     * Checks if a newly added interval intersects with any of already added ones.
     * If it intersects with even one interval, returns true, false otherwise.
     */
    function doesAddingShippingRateCreateRateUnitIntervalsIntersection($EPS,
                                                                       $c_id,
                                                                       $s_id,
                                                                       $rate_value_from,
                                                                       $rate_value_to,
                                                                       $rate_unit_id,
                                                                       $cost_type_id,
                                                                       $rate_cost)
    {
        $ret_struct = array("ret_val" => false,
                            "rate_id" => NULL,
                            "intersection_coord" => NULL);
        //Fetch all rates with same $rate_unit_id and $cost_type_id
        $rates = $this->getFlatShippingRates($rate_unit_id, $cost_type_id);
        if(isset($rates[$rate_unit_id][$cost_type_id][$c_id][$s_id]))
        {
            foreach($rates[$rate_unit_id][$cost_type_id][$c_id][$s_id] as $rate)
            {
                if($this->doTwoIntervalsIntersect($rate["rv_from"], $rate["rv_to"], $rate_value_from, $rate_value_to))
                {
                    $ret_struct["ret_val"] = true;
                    $ret_struct["id"] = $rate["id"];
                    $_ret_struct = $this->doTwoIntervalsIntersectInSinglePoint($EPS, $rate["rv_from"], $rate["rv_to"], $rate_value_from, $rate_value_to);
                    if($_ret_struct["ret_val"] === true)
                    {
                        $ret_struct["intersection_coord"] = $_ret_struct["intersection_coord"];
                    }
                }
            }
        }
        return $ret_struct;
    }

    /**
     * Checks if intervals of cost/weight/...
     * (shipping rate units) make a contiguous one.
     *
     * @param $eps the comparison accuracy. If $eps = 0.1,
     * then intervals [0.0; 0.9] and [1.0; 2.0] amount to the contiguous
     * interval [0.0; 2.0].If $eps = 0.0.1, then there will be an empty
     * interval [0.91; 0.99] between these two intervals.
     * @return true, if intervals make a contiguous one. Otherwise, the array
     * consists of empty intervals.
     * WARNING: the array should be classified by $rv_from!
     */
    function areShippingRatesIntervalsContiguous($EPS, $rates_for_c_id_s_id)//$rate_unit_id, $cost_type_id)
    {
//        $rates = $this->getFlatShippingRates($rate_unit_id, $cost_type_id);

        if(empty($rates_for_c_id_s_id))
        {
            return true;
        }

//        if (!function_exists('rate_cmp'))
//        {
//            function rate_cmp($rate1, $rate2)
//            {
//                if($rate1["rv_from"] == $rate2["rv_from"])
//                {
//                    return 0;
//                }
//                return ($rate1["rv_from"] < $rate2["rv_from"]) ? -1 : 1;
//            }
//        }
//        usort($rates, "rate_cmp");

        $x = $rates_for_c_id_s_id[0]["rv_from"] - $EPS;
        $not_defined_intervals = array();
        foreach($rates_for_c_id_s_id as $rate)
        {
            //FIXME:change the accuracy of $rate["rv_from"] and $rate["rv_to"] to $EPS!
            //  The excessive accuracy may lead to fals results.
            if(abs($x - $rate["rv_from"]) <= 1.5 * $EPS)
            {
                //The current interval follows the previous one at distance of $EPS.
                //Go on.
            }
            else
            {
                $not_defined_interval = $rate;
                $not_defined_interval['id'] = NULL;
                $not_defined_interval['cost'] = NULL;
                $not_defined_interval['rv_from'] = $x + $EPS;
                $not_defined_interval['rv_to'] = $rate["rv_from"] - $EPS;
                $not_defined_intervals[] = $not_defined_interval;
            }
            $x = $rate["rv_to"];
        }
        if(empty($not_defined_intervals))
        {
            return true;
        }
        else
        {
            return $not_defined_intervals;
        }
    }

    /**
     * Changes the cost values in the rate list.
     *
     * @param array $address_id_array - address id array
     * @param array $rate_unit_value_id_array - the array of interval id values
     *        of the rate unit
     * @param array $cost_array - the cost array
     */
    function insertFlatShippingRates($countryId, $stateId, $rate_value_from, $rate_value_to, $rate_unit_id, $rate_cost_type_id, $rate_cost)
    {
        global $application;
        $tables = $this->getTables();
        $tr = $tables['sm_flat_shipping_rates_rates_table']['columns'];

        $query = &new DB_Insert('sm_flat_shipping_rates_rates_table');
        $query->addInsertValue($countryId, $tr['c_id']);
        $query->addInsertValue($stateId, $tr['s_id']);
        $query->addInsertValue($rate_value_from, $tr['rv_from']);
        $query->addInsertValue($rate_value_to, $tr['rv_to']);
        $query->addInsertValue($rate_unit_id, $tr['ru_id']);
        $query->addInsertValue($rate_cost_type_id, $tr['cost_type_id']);
        $query->addInsertValue($rate_cost, $tr['cost']);

        $result = $application->db->getDB_Result($query);
    }

    function setDebugFlag($flag=true)
    {
        if(is_bool($flag))
            $this->is_debug=$flag;
    }

    function getDebugInfo()
    {
        return $this->_debug_info;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    //The ID of the single available method in this module.
    var $single_available_method_id = 1;

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $is_debug;
    var $_debug_info;


    /**#@-*/
}
?>