<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * flat_shipping_rates_input_az view
 *
 * @package ShippingModuleTableRates
 * @author Girin Alexander
 */
class flat_shipping_rates_input_az
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Modules_Manager constructor.
     */
    function flat_shipping_rates_input_az()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"shipping-module-flat-shipping-rates-messages", "AdminZone");

        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }
    }

    /**
     * Initializes data from the POST array.
     */
    function copyFormData()
    {
        //TODO eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST =
            array(
                "ModuleName" => $SessionPost["ModuleName"]
//               ,"ModuleDescr" => $SessionPost["ModuleDescr"]
               ,"ModuleRateUnitId" => $SessionPost["ModuleRateUnitId"]
               ,"status" => ($SessionPost["status"]=="active")? true:false
               ,"c_id" => $SessionPost["c_id"]
               ,"s_id" => $SessionPost["s_id"]
               ,"rv_from" => $SessionPost["rv_from"]
               ,"rv_to" => $SessionPost["rv_to"]
               ,"cost" => $SessionPost["cost"]
            );
    }

    /**
     * Initializes data from the database.
     */
    function initFormData()
    {
        $this->POST = array();
        $settings = modApiFunc("Shipping_Module_Flat_Shipping_Rates", "getSettings");
        foreach ($settings as $key => $value)
        {
            switch($key)
            {
                case "MODULE_NAME": $this->POST["ModuleName"] = $value; break;
                case "MODULE_DESCR": $this->POST["ModuleDescr"] = $value; break;
                case "MODULE_RATE_UNIT_ID": $this->POST["ModuleRateUnitId"] = $value; break;
            }
        }
        $this->POST["status"] = modApiFunc("Shipping_Module_Flat_Shipping_Rates", "isActive");
        $this->POST["c_id"] = modApiFunc("Location", "get_constant", "SELECT_COUNTRY_DEFAULT_COUNTRY_ID");
        $this->POST["s_id"] = 1;
        $this->POST["rv_from"] = "";
        $this->POST["rv_to"] = "";
        $this->POST["cost"] = "";
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );
    }


    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    /**
     * Outputs errors.
     */
    function outputErrors()
    {
        //TODO: output errors to the cost table, where they really occurred.

        //FIXME: check if the error handling schemes match in Action update_flat_shipping_rates
        //  and in the given View (flat_shipping_rates_input_az).
        global $application;
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }
        $result = "";
        $application->registerAttributes(array('ErrorIndex', 'Error'));
        $this->_error_index = 0;
        foreach ($this->ErrorsArray as $key => $value)
        {
            $vars = array();
            //Handle and output these two errors in special way.
            if($key == "INTERSECTION_COORD")
            {
                continue;
            }
            if($key == "INTERSECTION_RATE_ID")
            {
               if(isset($this->ErrorsArray["INTERSECTION_COORD"]) &&
                 !empty($this->ErrorsArray["INTERSECTION_COORD"]))
               {
                   $error = "INTERSECTION_IN_SINGLE_POINT";
               }
               else
               {
                   $error = "INTERSECTION_IN_MORE_THAN_ONE_POINT";
               }
            }
            else
            {
                $error = $key;
            }

            $this->_error_index++;
            $this->_error = $this->MessageResources->getMessage($error);
            $result .= $this->mTmplFiller->fill("shipping_module_flat_shipping_rates/", "error.tpl.html", array());
        }
        return $result;
    }

    /**
     * Outputs the module status.
     */
    function outputStatus()
    {
        global $application;
        $retval = "";
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked":""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "":"checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("shipping_module_flat_shipping_rates/", "status.tpl.html", array());
        return $retval;
    }

    /**
     * Output a list of rate units.
     */
    function outputRateUnits()
    {
        $retval = "";
        $rate_units = modApiFunc("Shipping_Module_Flat_Shipping_Rates", "getRateUnits");
        foreach ($rate_units as $rate_unit)
        {
            $retval.= "<option value=\"".$rate_unit["id"]."\"";
            if ($rate_unit["id"]==$this->POST["ModuleRateUnitId"])
            {
                $retval.= "SELECTED";
                $this->CurrentRateUnit = $rate_unit["name"];
                $this->CurrentRateUnitValue = $rate_unit["type"];
                $this->CurrentRateUnitValueId = $rate_unit["id"];
            }
            $retval.= ">".$rate_unit["name"]."</option>";
        }
        return $retval;
    }

    /**
     * Outputs the cost type: absolute/percentage.
     */
    function outputCostType()
    {
        $USD = "";
        $PROC = "";
        if ($this->POST["ModuleCostTypeId"] == 1)
        {
            $USD = "SELECTED";
        }
        else
        {
            $PROC = "SELECTED";
        }
        $retval = "<option value=\"1\" ".$USD.">".modApiFunc("Localization", "getCurrencySign")."</option>";
        $retval.= "<option value=\"2\" ".$PROC.">%</option>";
        return $retval;
    }

    /**
     * Outputs the rate list.
     */
    function outputFlatShippingRates()
    {
        global$application;
        $ratesTable = modApiFunc("Shipping_Module_Flat_Shipping_Rates", "getFlatShippingRates", $this->CurrentRateUnitValueId);

        $retval = "";
        if(isset($ratesTable[$this->CurrentRateUnitValueId][1])) //"absolute value"
        {
            $CostRatesTable = $ratesTable[$this->CurrentRateUnitValueId][1];
            if(!empty($ratesTable[$this->CurrentRateUnitValueId][1]))
            {
                $precision = modApiFunc("Localization", "getPrecision", $this->CurrentRateUnitValue);
                $EPS = $precision;
                $rate_unit_id = $this->CurrentRateUnitValueId;
                $cost_type_id = 1;

                foreach($ratesTable[$this->CurrentRateUnitValueId][1] as $c_id => $rates_by_states)
                {
                    $rates_by_states = &$ratesTable[$this->CurrentRateUnitValueId][1][$c_id];
                    foreach($rates_by_states as $s_id => $rates_for_c_id_s_id)
                    {
                        $rates_for_c_id_s_id = &$rates_by_states[$s_id];

                        //$c_id = $ratesTable[$rate_unit_id][$cost_type_id][0]["c_id"];
                        //$s_id = $ratesTable[$rate_unit_id][$cost_type_id][0]["s_id"];
                        $not_entered_intervals = modApiFunc("Shipping_Module_Flat_Shipping_Rates","areShippingRatesIntervalsContiguous", $EPS, $rates_for_c_id_s_id);//$rate_unit_id, $cost_type_id);
                        if($not_entered_intervals === true)
                        {
                        }
                        else
                        {
                            $rates_for_c_id_s_id = array_merge($rates_for_c_id_s_id, $not_entered_intervals);
                            //Order by 'rv_from' after merge.
                            if (!function_exists('rate_cmp'))
                            {
                                function rate_cmp($rate1, $rate2)
                                {
                                    if($rate1["rv_from"] > $rate2["rv_from"])
                                    {
                                        return 1;
                                    }
                                    else
                                    if($rate1["rv_from"] < $rate2["rv_from"])
                                    {
                                       return -1;
                                    }
                                    else
                                    {
                                        return 0;
                                    }
                                }
                            }
                            usort($rates_for_c_id_s_id, "rate_cmp");
                        }

                        //output rates for some "Country-State" pair.
                        foreach($rates_for_c_id_s_id as $rate)
                        {
                            $RateCssClass ="";
                            $FromCssClass = "";
                            $ToCssClass = "";


                            if(isset($this->ErrorsArray["INTERSECTION_RATE_ID"]))
                            {
                                if($rate["id"] == $this->ErrorsArray["INTERSECTION_RATE_ID"])
                                {
                                    //The added interval intersects with the current outputted one.
                                    $RateCssClass = "rate_intervals_intersection_error";
                                    if(isset($this->ErrorsArray["INTERSECTION_COORD"]) &&
                                             $this->ErrorsArray["INTERSECTION_COORD"] != NULL)
                                    {
                                        //The intervals are intersected exactly at one point.
                                        $val = $this->ErrorsArray["INTERSECTION_COORD"];
                                        if($rate["rv_from"] == $val)
                                        {
                                            $FromCssClass = "rate_value_single_point_intersecion_coord_class";
                                        }
                                        if($rate["rv_to"] == $val)
                                        {
                                            $ToCssClass = "rate_value_single_point_intersecion_coord_class";
                                        }
                                    }
                                }
                            }

                            $this->_Rate = array("RateID" => ($rate["id"] === NULL) ? "" : $rate["id"]
                                          ,"RateCssClass" => ($rate["id"] === NULL) ? "virtual_rate_class" : $RateCssClass
                                          ,"Country" => modApiFunc("Location", "getCountry", $rate["c_id"])

                                          ,"State" => modApiFunc("Location", "getState", $rate["s_id"])

                                          ,"FromCssClass" => $FromCssClass
                                          ,"RateValueFrom" =>  modApiFunc("Localization", "FloatToFormatStr", $rate["rv_from"], $this->CurrentRateUnitValue) . " " . $this->CurrentRateUnitUnitValue
                                          ,"ToCssClass" => $ToCssClass
                                          ,"RateValueTo" =>  modApiFunc("Localization", "FloatToFormatStr", $rate["rv_to"], $this->CurrentRateUnitValue) . " " . $this->CurrentRateUnitUnitValue

                                          ,"Cost" => ($rate["cost"] === NULL) ? $this->MessageResources->getMessage('COST_N_A_TEXT') : modApiFunc("Localization", "currency_format", $rate["cost"])

                                          ,"LABEL_005"             => $this->MessageResources->getMessage('LABEL_005')
                                          ,"LABEL_006"             => $this->MessageResources->getMessage('LABEL_006')
                                          ,"LABEL_007"             => $this->MessageResources->getMessage('LABEL_007')
                                          ,"DelCheckboxCssClass" => ($rate["id"] === NULL) ? "display_none" : ""

                                          );
                            $application->registerAttributes($this->_Rate);
                            $retval .= $this->mTmplFiller->fill("shipping_module_flat_shipping_rates/", "list_item.tpl.html", array());

                        }
                        //end output rates for some "Country-State" pair.
                        unset($rates_for_c_id_s_id);
                    }
                    unset($rates_by_states);
                }
            }
        }
        return $retval;
    }

    /**
     * The Javascript array.
     */
    function outputAllOtherStatesArray()
    {
        $retval = "";

        $retval.= "<SCRIPT LANGUAGE=\"JavaScript\">\n";
        $retval.= "<!--\n";

        $retval.= "allOtherStatesArray = new Array();\n";
        $all_other_states = modApiFunc("Shipping_Module_Flat_Shipping_Rates", "getSelectedStatesAllOther");
        foreach ($all_other_states as $val)
        {
            $retval.= "allOtherStatesArray[$val] = true;\n";
        }
        $retval.= "//-->\n";
        $retval.= "</SCRIPT>";

        return $retval;
    }

    /**
     * Outputs the view of editing the module attributes.
     */
    function output()
    {
        global $application;
        //It is called first, before others, to define $this->CurrentRateUnitValue
        $outputed_rate_units = $this->outputRateUnits();

        //Output the list of units the of rate unit
        $this->CurrentRateUnitUnitValue = modApiFunc("Shipping_Module_Flat_Shipping_Rates", "getRateUnitUnitsValue", $this->CurrentRateUnitValue);

        loadCoreFile('html_form.php');
        $HtmlForm1 = new HtmlForm();
        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        $request = &new Request();
        $request->setView('CheckoutShippingModuleSettings');
        $request->setAction("update_flat_shipping_rates");
        $form_action = $request->getURL();
        $settings = modApiFunc("Shipping_Module_Flat_Shipping_Rates", "getSettings");
        $template_contents = array(
                                    "EditFlatShippingRatesForm"    => $HtmlForm1->genForm($form_action, "POST", "EditFlatShippingRatesForm")
                                   ,"HiddenArrayViewState"  => $this->outputViewState()
                                   ,"ModuleType"            => $this->MessageResources->getMessage('MODULE_TYPE')
                                   ,"ModuleName"            => $this->MessageResources->getMessage('MODULE_NAME')
                                   ,"Subtitle"              => $this->MessageResources->getMessage('FORM_SUBTITLE')
                                   ,"Errors"                => $this->outputErrors()
                                   ,"ModuleStatusFieldName" => $this->MessageResources->getMessage('MODULE_STATUS_FIELD_NAME')
                                   ,"ModuleStatusField"     => $this->outputStatus()
                                   ,"ModuleMethodNameFieldName"   => $this->MessageResources->getMessage('MODULE_METHOD_NAME_FIELD_NAME')
                                   ,"ModuleNameField"       => $HtmlForm1->genInputTextField("128", "ModuleName", "75", prepareHTMLDisplay($this->POST["ModuleName"]))
                                   ,"ModuleDescrFieldName"  => $this->MessageResources->getMessage('MODULE_DESCR_FIELD_NAME')
                                   ,"ModuleDescrField"      => $HtmlForm1->genInputTextAreaField("75", "ModuleDescr", "5")
                                   ,"ModuleDescrFieldValue" => $this->MessageResources->getMessage('MODULE_DESCR')
                                   ,"ModuleRateUnitFieldName"=> $this->MessageResources->getMessage('MODULE_RATE_UNIT_FIELD_NAME')
                                   ,"RateUnits"             => $outputed_rate_units
                                   ,"RateUnitUnitsValue"    => $this->CurrentRateUnitUnitValue
                                   ,"UnitType"              => $this->CurrentRateUnitValue
                                   ,"Items"                 => $this->outputFlatShippingRates()
                                   ,"CountriesOptions"      => modApiFunc("Checkout", "genCountrySelectList", $this->POST["c_id"], false, true)
                                   ,"StatesOptions"         => modApiFunc("Checkout", "genStateSelectList", $this->POST["s_id"], $this->POST["c_id"], true)
                                   ,"JavascriptSynchronizeCountriesAndStatesLists" => modApiFunc("Location", "getJavascriptCountriesStatesArrays", true, array(), array(), true, true) . modApiFunc("Checkout", "getJavascriptSynchronizeCountriesAndStatesLists") .
                                    //Combine all the OnChange instructions and add them to body.onload()
                                    "<SCRIPT LANGUAGE=\"JavaScript\">" . "\n" .
                                    "<!--\n" . "\n" .
                                    "var onload_bak = window.onload;" . "\n" .
                                    "window.onload = function()" . "\n" .
                                    "{" . "\n" .
                                    "    if(onload_bak){onload_bak();}" . "\n" .
                                    "    refreshStatesList('c_id', 's_id', 'stub_state_text_input');" . //$onChangeStatements
                                    "}" . "\n" .
                                    "//-->" . "\n" .
                                    "</SCRIPT>" . "\n"

                                   ,"BTN_ADD_ROW"           => $this->MessageResources->getMessage('BTN_ADD_ROW')
                                   ,"BTN_DEL_ROWS"           => $this->MessageResources->getMessage('BTN_DEL_ROWS')
                                   ,"Alert_001"             => $this->MessageResources->getMessage('ALERT_001')
                                   ,"Alert_002"             => $this->MessageResources->getMessage('ALERT_002')
                                   ,"Alert_003"             => $this->MessageResources->getMessage('ALERT_003')
                                   ,"Alert_004"             => $this->MessageResources->getMessage('ALERT_004')
                                   ,"Alert_005"             => $this->MessageResources->getMessage('ALERT_005')
                                   ,"Alert_006"             => $this->MessageResources->getMessage('ALERT_006')
                                   ,"Alert_007"             => $this->MessageResources->getMessage('ALERT_007')

                                   ,"RvPatternType"         => $this->CurrentRateUnitValue
                                   ,"RvFormat"              => modApiFunc("Localization", "format_settings_for_js", $this->CurrentRateUnitValue)

//                                      "ElementValue"=> modApiFunc("Localization", "FloatToFormatStr", $rate_unit_value["value"], $this->CurrentRateUnitValue)
//                                      "PatternType" => $this->CurrentRateUnitValue
//                                      "Format" => modApiFunc("Localization", "format_settings_for_js", $this->CurrentRateUnitValue)
                                   ,"RvFromValue"           => modApiFunc("Localization", "FloatToFormatStr", $this->POST["rv_from"], $this->CurrentRateUnitValue)
                                   ,"RvToValue"             => modApiFunc("Localization", "FloatToFormatStr", $this->POST["rv_to"], $this->CurrentRateUnitValue)

                                   ,"CostPatternType"         => "currency"
                                   ,"CostFormat"              => modApiFunc("Localization", "format_settings_for_js", "currency")
                                   ,"CostValue"             => modApiFunc("Localization", "FloatToFormatStr", $this->POST["cost"], "currency")
                                   ,"LABEL_005"             => $this->MessageResources->getMessage('LABEL_005')
                                   ,"LABEL_006"             => $this->MessageResources->getMessage('LABEL_006')
                                   ,"LABEL_007"             => $this->MessageResources->getMessage('LABEL_007')
                                   ,"LABEL_SHIP_TO"         => $this->MessageResources->getMessage('LABEL_SHIP_TO')
                                   ,"LABEL_ORDER_SUBTOTAL_RANGE" => $this->MessageResources->getMessage('LABEL_ORDER_SUBTOTAL_RANGE')
                                   ,"LABEL_ORDER_SHIPPING_COST" => $this->MessageResources->getMessage('LABEL_ORDER_SHIPPING_COST')
                                   ,"LABEL_SHIP_TO"         => $this->MessageResources->getMessage('LABEL_SHIP_TO')
                                   ,"LABEL_ORDER_SHIPPING_COST" => $this->MessageResources->getMessage('LABEL_ORDER_SHIPPING_COST')
                                   ,"RangeColumnTitle"      => $this->MessageResources->getMessage('LABEL_ORDER_SUBTOTAL_RANGE_1')
                                  . $this->CurrentRateUnit
                                  . $this->MessageResources->getMessage('LABEL_ORDER_SUBTOTAL_RANGE_2')
                                  );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        $obj = &$application->getInstance('MessageResources');
        $output = modApiFunc('TmplFiller', 'fill',
                              './../../js/','validate.msgs.js.tpl',
                              array(
                                    "INTEGER" => $obj->getMessage( new ActionMessage(array('PRDADD_001')) )
                                   ,"FLOAT"   => $obj->getMessage( new ActionMessage(array('PRDADD_002')) )
                                   ,"STRING1024"=> $obj->getMessage( new ActionMessage(array('PRDADD_007')) )
                                   ,"STRING128"=> $obj->getMessage( new ActionMessage(array('PRDADD_008')) )
                                   ,"STRING256"=> $obj->getMessage( new ActionMessage(array('PRDADD_009')) )
                                   ,"STRING512"=> $obj->getMessage( new ActionMessage(array('PRDADD_010')) )
                                   ,"CURRENCY"=> addslashes($obj->getMessage( new ActionMessage(array('CURRENCY_FIELD',
                                                         modApiFunc("Localization", "FloatToFormatStr", 12.35, "currency"),
                                                         modApiFunc("Localization", "FloatToFormatStr", 34, "currency"),
                                                         modApiFunc("Localization", "FloatToFormatStr", 99.00, "currency")))))
                                   ,"WEIGHT"   => addslashes($obj->getMessage( new ActionMessage(array('WEIGHT_FIELD',
                                                         modApiFunc("Localization", "FloatToFormatStr", 23.325, "weight"),
                                                         modApiFunc("Localization", "FloatToFormatStr", 34, "weight"),
                                                         modApiFunc("Localization", "FloatToFormatStr", 99.2, "weight")))))
                                   ,"ITEM"     => $obj->getMessage( new ActionMessage(array('ITEM_FIELD')))
                                   )
                            );
        return $output.$this->mTmplFiller->fill("shipping_module_flat_shipping_rates/", "list.tpl.html",array());
    }

    function getTag($tag)
    {
        global $application;
        switch($tag)
        {
            case "ErrorIndex":
                $value = $this->_error_index;
                break;
            case "Error":
                $value = $this->_error;
                break;
            default:
                $value = getKeyIgnoreCase($tag, $this->_Template_Contents);
                if($value === NULL)
                {
                    $value = getKeyIgnoreCase($tag, $this->_Rate);
                }
                break;
        }

        return $value;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $POST;

    /**
     * View state structure. It comes from action.
     * $SessionPost["ViewState"] structure example:
     * <br>array
     * <br>(
     * <br>    "hasCloseScript"  = "false"           //true/false
     * <br>    "ErrorsArray"     =  array()          //true/false
     * <br>    "LargeImage"      = "image.jpg"       //
     * <br>    "SmallImage"      = "image_small.jpg" //
     * <br>)
     */
    var $ViewState;

    /**
     * List of error ids. It comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;
    var $_Rate;

    var $MessageResources;
    var $_error_index;
    var $_error;

    /**#@-*/
}
?>