<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Module SystemLog
 *
 * @package SystemLog
 * @author Alexey Florinsky
 */
class SystemLog
{
    function SystemLog()
    {
    }

    function install()
    {
        $tables = SystemLog::getTables();
        $query = &new DB_Table_Create($tables);
    }

    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $tbl_log_info = 'log_info';
        $tables[$tbl_log_info] = array();
        $tables[$tbl_log_info]['columns'] = array
            (
                'id'                   => $tbl_log_info.'.id',
                'time'                 => $tbl_log_info.'.time',
                'memory'               => $tbl_log_info.'.memory',
                'URL'                  => $tbl_log_info.'.URL',
                'sess_name'            => $tbl_log_info.'.sess_name',
                'sess_id'              => $tbl_log_info.'.sess_id',
                'get_data'             => $tbl_log_info.'.get_data',
                'post_data'            => $tbl_log_info.'.post_data',
                'session_data'         => $tbl_log_info.'.session_data',
                'cookie_data'          => $tbl_log_info.'.cookie_data',
                'remote_host'          => $tbl_log_info.'.remote_host',
                'remote_addr'          => $tbl_log_info.'.remote_addr',
            );
        $tables[$tbl_log_info]['types'] = array
            (
                'id'                   => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment',
                'time'                 => DBQUERY_FIELD_TYPE_DOUBLE,
                'memory'               => DBQUERY_FIELD_TYPE_DOUBLE,
                'URL'                  => DBQUERY_FIELD_TYPE_TEXT,
                'sess_name'            => DBQUERY_FIELD_TYPE_CHAR255,
                'sess_id'              => DBQUERY_FIELD_TYPE_CHAR255,
                'get_data'             => DBQUERY_FIELD_TYPE_TEXT,
                'post_data'            => DBQUERY_FIELD_TYPE_TEXT,
                'session_data'         => DBQUERY_FIELD_TYPE_TEXT,
                'cookie_data'          => DBQUERY_FIELD_TYPE_TEXT,
                'remote_host'          => DBQUERY_FIELD_TYPE_CHAR255,
                'remote_addr'          => DBQUERY_FIELD_TYPE_CHAR255,
            );
        $tables[$tbl_log_info]['primary'] = array
            (
                'id'
            );
        $tables[$tbl_log_info]['indexes'] = array
            (
            );

        $tbl_log_messages = 'log_messages';
        $tables[$tbl_log_messages] = array();
        $tables[$tbl_log_messages]['columns'] = array
            (
                'id'                   => $tbl_log_messages.'.id',
                'info_id'              => $tbl_log_messages.'.info_id',
                'time'                 => $tbl_log_messages.'.time',
                'status'               => $tbl_log_messages.'.status',
                'memory'               => $tbl_log_messages.'.memory',
                'text'                 => $tbl_log_messages.'.text',
                'prev_id'              => $tbl_log_messages.'.prev_id',
            );
        $tables[$tbl_log_messages]['types'] = array
            (
                'id'                   => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment',
                'info_id'              => DBQUERY_FIELD_TYPE_INT,
                'time'                 => DBQUERY_FIELD_TYPE_DOUBLE .' NOT NULL',
                'status'               => DBQUERY_FIELD_TYPE_CHAR50,
                'memory'               => DBQUERY_FIELD_TYPE_INT,
                'text'                 => DBQUERY_FIELD_TYPE_TEXT,
                'prev_id'              => DBQUERY_FIELD_TYPE_INT,
            );
        $tables[$tbl_log_messages]['primary'] = array
            (
                'id'
            );
        $tables[$tbl_log_messages]['indexes'] = array
            (
                'IDX_prev_id' => 'prev_id',
                'IDX_status'  => 'status',
                'IDX_info_id' => 'info_id',
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    function uninstall()
    {
        $query = &new DB_Table_Delete(SystemLog::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     *            true                id                     id    -         .
     */
    function isLogIdCorrect($id)
    {
        global $application;

        $tables = SystemLog::getTables();
        $tbl_log = $tables['log_messages']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($tbl_log['id'], 'id');
        $query->WhereValue($tbl_log['id'], DB_EQ, $id);
        $res = $application->db->getDB_Result($query);

        if (isset($res[0]) && isset($res[0]['id']) && $res[0]['id'] == $id)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    /**
     *                                      PHP                        info_id.
     */
    function getLogInfo($info_id)
    {
        global $application;
        $tables = SystemLog::getTables();
        $tbl_log_info = $tables['log_info']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($tbl_log_info['id'],          'id');
        $query->addSelectField($tbl_log_info['time'],        'time');
        $query->addSelectField($tbl_log_info['memory'],      'memory');
        $query->addSelectField($tbl_log_info['URL'],         'URL');
        $query->addSelectField($tbl_log_info['sess_name'],   'sess_name');
        $query->addSelectField($tbl_log_info['sess_id'],     'sess_id');
        $query->addSelectField($tbl_log_info['get_data'],    'get_data');
        $query->addSelectField($tbl_log_info['post_data'],   'post_data');
        $query->addSelectField($tbl_log_info['session_data'],'session_data');
        $query->addSelectField($tbl_log_info['cookie_data'], 'cookie_data');
        $query->addSelectField($tbl_log_info['remote_host'], 'remote_host');
        $query->addSelectField($tbl_log_info['remote_addr'], 'remote_addr');
        $query->Where($tbl_log_info['id'], DB_EQ, $info_id);
        return $application->db->getDB_Result($query);
    }

    /**
     *                                               PHP                                    
     *         .
     */
    function getLogInfoList()
    {
        global $application;
        $tables = SystemLog::getTables();
        $tbl_log_info = $tables['log_info']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($tbl_log_info['id'],          'id');
        $query->addSelectField($tbl_log_info['time'],        'time');
        $query->addSelectField($tbl_log_info['memory'],      'memory');
        $query->addSelectField($tbl_log_info['URL'],         'URL');
        $query->addSelectField($tbl_log_info['sess_name'],   'sess_name');
        $query->addSelectField($tbl_log_info['sess_id'],     'sess_id');
        $query->addSelectField($tbl_log_info['get_data'],    'get_data');
        $query->addSelectField($tbl_log_info['post_data'],   'post_data');
        $query->addSelectField($tbl_log_info['session_data'],'session_data');
        $query->addSelectField($tbl_log_info['cookie_data'], 'cookie_data');
        $query->addSelectField($tbl_log_info['remote_host'], 'remote_host');
        $query->addSelectField($tbl_log_info['remote_addr'], 'remote_addr');
        $query->SelectOrder($tbl_log_info['time'], 'DESC');

        return $application->db->getDB_Result($query);
    }

    /**
     *                                       .
     *  . .              -         ,                                       PHP         .
     *                                                       -         ,             
     *                 PHP         .
     */
    function getLogList()
    {
        global $application;
        $tables = SystemLog::getTables();
        $tbl_log_msg = $tables['log_messages']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($tbl_log_msg['id'],      'id');
        $query->addSelectField($tbl_log_msg['info_id'], 'info_id');
        $query->addSelectField($tbl_log_msg['time'],    'time');
        $query->addSelectField($tbl_log_msg['status'],  'status');
        $query->addSelectField($tbl_log_msg['memory'],  'memory');
        $query->addSelectField($tbl_log_msg['text'],    'text');
        $query->addSelectField($tbl_log_msg['prev_id'], 'prev_id');
        $query->Where($tbl_log_msg['prev_id'], DB_EQ, 0);
        return $application->db->getDB_Result($query);
    }

    /**
     *                                   -                         info_id.
     *                ,                                                     
     *         PHP         .
     */
    function getLogsChain($info_id)
    {
        global $application;
        $tables = SystemLog::getTables();
        $tbl_log_msg = $tables['log_messages']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($tbl_log_msg['id'],      'id');
        $query->addSelectField($tbl_log_msg['info_id'], 'info_id');
        $query->addSelectField($tbl_log_msg['time'],    'time');
        $query->addSelectField($tbl_log_msg['status'],  'status');
        $query->addSelectField($tbl_log_msg['memory'],  'memory');
        $query->addSelectField($tbl_log_msg['text'],    'text');
        $query->addSelectField($tbl_log_msg['prev_id'], 'prev_id');
        $query->Where($tbl_log_msg['info_id'], DB_EQ, $info_id);
        $query->SelectOrder($tbl_log_msg['prev_id']);
        return $application->db->getDB_Result($query);
    }

    /**
     *              -                             .
     *                    -                    PHP         ,                       
     *                              PHP                   -                         
     *                  .
     *                ,        -         ,                        PHP                     
     *            info_id.
     *            id    -         .
     *
     * @param string $text Log message
     * @param const $status Log message status
     * @return mixed Return ID of the created log message or NULL if log message have not been created
     */
    function addMessage($text, $status = SYSLOG_INFO)
    {
        global $application;
        static $status_filter = null;
        static $url_excluded_filter = null;

        //                      
        if ($status_filter === null)
        {
            $status_filter = array_map('trim',explode(',',$application->getAppIni('SYSLOG_STATUSES_TO_LOG')));
        }
        if ($url_excluded_filter === null)
        {
        	$url_excluded_filter = $application->getAppIni('SYSLOG_EXCLUDED_URL_FILTER');
        }

        //         ,                             URL
        if (preg_match($url_excluded_filter,modApiFunc('Request','selfURL')))
        {
            return null;
        }

        //                         PHP                                                  ,
        //                   .                  -                                           
        if ($this->_currentInfoId == 0)
        {
            $this->_currentInfoId = $this->_addInfo();
        }

        //                    ,                                           .
        if (!in_array($status, $status_filter))
        {
            //                                                           
            return null;
        }

        $tables = SystemLog::getTables();
        $tbl_log_msg = $tables['log_messages']['columns'];

        if (function_exists('memory_get_usage') == true)
        {
            $memory = memory_get_usage();
        }
        else
        {
            $memory = 0;
        }

        $db_insert = new DB_Insert('log_messages');
        $db_insert->addInsertValue($this->_currentInfoId, $tbl_log_msg['info_id']);
        $db_insert->addInsertValue(microtime_float(),     $tbl_log_msg['time']);
        $db_insert->addInsertValue($status,               $tbl_log_msg['status']);
        $db_insert->addInsertValue($memory,               $tbl_log_msg['memory']);
        $db_insert->addInsertValue($text,                 $tbl_log_msg['text']);
        $db_insert->addInsertValue($this->_previousLogId, $tbl_log_msg['prev_id']);

        $application->db->PrepareSQL($db_insert);
        $application->db->DB_Exec();
        $this->_previousLogId = $application->db->DB_Insert_Id();
        return $this->_previousLogId;
    }


    /**
     *                              PHP         .
     *            id       .
     *                  -                 PHP                                       .
     */
    function _addInfo()
    {
        global $application;
        $tables = SystemLog::getTables();
        $tbl_log_info = $tables['log_info']['columns'];

        //                              
        $this->_deleteOldLogs();

        if (function_exists('memory_get_usage') == true)
        {
            $memory = memory_get_usage();
        }
        else
        {
            $memory = 0;
        }

        $remote_host = isset($_SERVER['REMOTE_HOST']) ? $_SERVER['REMOTE_HOST'] : '';

        $db_insert = new DB_Insert('log_info');
        $db_insert->addInsertValue(microtime_float(),        $tbl_log_info['time']);
        $db_insert->addInsertValue($memory,                  $tbl_log_info['memory']);
        $db_insert->addInsertValue(modApiFunc('Request','selfURL'), $tbl_log_info['URL']);
        $db_insert->addInsertValue(session_name(),           $tbl_log_info['sess_name']);
        $db_insert->addInsertValue(session_id(),             $tbl_log_info['sess_id']);
        $db_insert->addInsertValue(print_r($_GET, true),     $tbl_log_info['get_data']);
        $db_insert->addInsertValue(print_r($_POST, true),    $tbl_log_info['post_data']);
        $db_insert->addInsertValue(print_r($_SESSION, true), $tbl_log_info['session_data']);
        $db_insert->addInsertValue(print_r($_COOKIE, true),  $tbl_log_info['cookie_data']);
        $db_insert->addInsertValue($remote_host,             $tbl_log_info['remote_host']);
        $db_insert->addInsertValue(getip(),                  $tbl_log_info['remote_addr']);

        $application->db->PrepareSQL($db_insert);
        $application->db->DB_Exec();
        return $application->db->DB_Insert_Id();
    }

    /**
     *                                      .
     *   config.def.php        ,                           .
     *
     */
    function _deleteOldLogs()
    {
        global $application;
        $tables = SystemLog::getTables();
        $tbl_log_info = $tables['log_info']['columns'];
        $tbl_log_msgs = $tables['log_messages']['columns'];

        //                                    
        $query = &new DB_Select();
        $query->addSelectField($tbl_log_info['id'], 'id');
        $query->CountRows();
        $result = $application->db->getDB_Result($query);

        $info_logs_records_qty = (int)$result[0]['count'];
        $max_info_logs = (int)trim($application->getAppIni('SYSLOG_MAX_INFOLOGS_QTY')) - 1;

        if ($info_logs_records_qty <= $max_info_logs)
        {
            return;
        }

        //         id'     ,                     
        $query = &new DB_Select();
        $query->addSelectField($tbl_log_info['id'], 'id');
        $query->SelectOrder($tbl_log_info['time'], 'ASC');
        $query->SelectLimit(0, $info_logs_records_qty - $max_info_logs);
        $result = $application->db->getDB_Result($query);

        //                    id'                
        $info_logs_to_delete = array();
        foreach($result as $item)
        {
            $info_logs_to_delete[] = $item['id'];
        }

        //                   log_info
        $query = &new DB_Delete('log_info');
        $query->WhereField($tbl_log_info['id'], DB_IN,"('" . implode("','", $info_logs_to_delete) . "')");
        $application->db->getDB_Result($query);

        //                   log_messages
        $query = &new DB_Delete('log_messages');
        $query->WhereField($tbl_log_msgs['info_id'], DB_IN,"('" . implode("','", $info_logs_to_delete) . "')");
        $application->db->getDB_Result($query);
    }




    /**
     *          id                -         .
     *                ,                   -                 .
     */
    var $_previousLogId = 0;


    /**
     *                  id                                      PHP         .
     *        -                                  id.
     */
    var $_currentInfoId = 0;
}

?>