<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

define('TAX_CLASS_ID_ANY', 0);
define('TAX_CLASS_ID_NOT_TAXABLE', 1);
define('TAX_FORMULA_ID_UNKNOWN', -1);

/**
 * Taxes module.
 *
 * @package Taxes
 * @author Alexander Girin
 */
class Taxes
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * News  constructor.
     */
    function Taxes()
    {
        $this->TaxDebug = null;
        $this->TraceInfo = "";
    }

    /**
     * Sets up data for tax debugging. The data structure is similar to one
     * of cart contents and to Checkout data.
     */
    function setTaxDebug($products, $OrderLevelShippingCost, $ShippingMethod, $addresses)
    {
        $ProductsList = array();
        $i = 1;
        $CartSubtotal = 0;
        foreach ($products as $productInfo)
        {
            $CartSubtotal += $productInfo["Quantity_In_Cart"]*$productInfo["CartItemSalePrice"];
            $ProductsList[] = array(
                                    "CartID" => $i,
                                    "Quantity_In_Cart" => $productInfo["Quantity_In_Cart"],
                                    "attributes" => array(
                                                          "SalePrice"     => array(
                                                                             "value"=>$productInfo["CartItemSalePrice"]
                                                                                  ),
                                                          "CartItemSalePriceExcludingTaxes" => array(
                                                                             "value"=>$productInfo["CartItemSalePriceExcludingTaxes"]
                                                                                  ),
                                                          "PerItemShippingCost" => array(
                                                                             "value"=>$productInfo["ShippingPrice"]
                                                                                  ),
                                                          "PerItemHandlingCost" => array(
                                                                             "value"=>0 //$productInfo["HandlingPrice"] //NOT SUPPORTED in this version
                                                                                  ),
                                                          "TaxClass"      => array(
                                                                             "value"=>$productInfo["TaxClass"]
                                                                                  ),
                                                         ),
                                    "CartItemSalePrice" => $productInfo["CartItemSalePrice"],
                                    "CartItemSalePriceExcludingTaxes" => $productInfo["CartItemSalePriceExcludingTaxes"]

                                   );
            $i++;
        }
        $this->TaxDebug = array(
                               "ProductsList" => $ProductsList,
                               "CartSubtotal" => $CartSubtotal,
                               "OrderLevelShippingCost" => $OrderLevelShippingCost,
                               "ShippingMethod" => $ShippingMethod,
                               "AddressesList"=> array(
                                                       "0" => array(//DefaultAddress
                                                                                  "CountryId" => $addresses["Default"]["CountryId"],
                                                                                  "StateId"   => $addresses["Default"]["StateId"]
                                                                                 ),
                                                       "1" => array(//ShippingAddress
                                                                                  "CountryId" => $addresses["Shipping"]["CountryId"],
                                                                                  "StateId"   => $addresses["Shipping"]["StateId"]
                                                                                 ),
                                                       "2" => array(//BillingAddress
                                                                                  "CountryId" => $addresses["Billing"]["CountryId"],
                                                                                  "StateId"   => $addresses["Billing"]["StateId"]
                                                                                 ),
                                                       TAXES_STORE_OWNER_ADDRESS_ID => array(//StoreOwnerAddress
                                                                                  "CountryId" => $addresses["StoreOwner"]["CountryId"],
                                                                                  "StateId"   => $addresses["StoreOwner"]["StateId"]
                                                                                 )

/*
                                                                                 ,
                                                        => array(//CustomerAddress
                                                                                  "CountryId" => $addresses["Customer"]["CountryId"],
                                                                                  "StateId"   => $addresses["Customer"]["StateId"]
                                                                                 )*/
                                                      )
                             );
    }

    function unsetTaxDebug()
    {
        $this->TaxDebug = null;
    }


    /**
     * Restores the session module state.
     */
    function loadState()
    {
        if(modApiFunc('Session', 'is_Set', 'TaxClassId'))
        {
            $this->TaxClassId = modApiFunc('Session', 'get', 'TaxClassId');
        }
        else
        {
            $this->TaxClassId = 0;
        }

        if(modApiFunc('Session', 'is_Set', 'editableTaxName'))
        {
            $this->editableTaxName = modApiFunc('Session', 'get', 'editableTaxName');
        }
        else
        {
            $this->editableTaxName = 0;
        }

        if(modApiFunc('Session', 'is_Set', 'editableTaxDisplayOption'))
        {
            $this->editableTaxDisplayOption = modApiFunc('Session', 'get', 'editableTaxDisplayOption');
        }
        else
        {
            $this->editableTaxDisplayOption = 0;
        }

        if(modApiFunc('Session', 'is_Set', 'editableTaxClass'))
        {
            $this->editableTaxClass = modApiFunc('Session', 'get', 'editableTaxClass');
        }
        else
        {
            $this->editableTaxClass = 0;
        }

        if(modApiFunc('Session', 'is_Set', 'editableTaxRate'))
        {
            $this->editableTaxRate = modApiFunc('Session', 'get', 'editableTaxRate');
        }
        else
        {
            $this->editableTaxRate = 0;
        }

        if(modApiFunc('Session', 'is_Set', 'CountryId'))
        {
            $this->country_id = modApiFunc('Session', 'get', 'CountryId');
        }
        else
        {
            $this->country_id = 0;
        }
        if (modApiFunc('Session', 'is_set', 'TaxDebug'))
        {
            $this->TaxDebug = modApiFunc('Session', 'get', 'TaxDebug');
            modApiFunc('Session', 'un_set', 'TaxDebug');
        }
        else
        {
            $this->TaxDebug = null;
        }

        if(modApiFunc('Session', 'is_Set', 'ErrorData'))
        {
            $this->ErrorData = modApiFunc('Session', 'get', 'ErrorData');
        }
        else
        {
            $this->ErrorData = array();
        }
    }

    /**
     * Saves the module state.
     */
    function saveState()
    {
        modApiFunc('Session', 'set', 'editableTaxName', $this->editableTaxName);
        modApiFunc('Session', 'set', 'editableTaxDisplayOption', $this->editableTaxDisplayOption);
        modApiFunc('Session', 'set', 'editableTaxRate', $this->editableTaxRate);
        modApiFunc('Session', 'set', 'editableTaxClass', $this->editableTaxClass);
        modApiFunc('Session', 'set', 'CountryId', $this->country_id);
        modApiFunc('Session', 'set', 'TaxClassId', $this->TaxClassId);
        if ($this->TaxDebug)
        {
            modApiFunc('Session', 'set', 'TaxDebug', $this->TaxDebug);
        }
        else
        {
            if (modApiFunc('Session', 'is_set', 'TaxDebug'))
            {
                modApiFunc('Session', 'un_set', 'TaxDebug');
            }
        }
        modApiFunc('Session', 'set', 'ErrorData', $this->ErrorData);
    }

    function setTaxClassId($tc_id)
    {
        $this->TaxClassId = $tc_id;
    }

    function getTaxClassId()
    {
        return $this->TaxClassId;
    }

    function unsetTaxClassId()
    {
        $this->TaxClassId = 0;
    }

    function setEditableTaxId($entity, $id)
    {
        eval('$this->editable'.$entity.' = $id;');
    }

    function getEditableTaxId($entity)
    {
        return eval('return $this->editable'.$entity.';');
    }

    function unsetEditableTaxId($entity)
    {
        return eval('$this->editable'.$entity.' = 0;');
    }

    function setCountryId($c_id)
    {
        $this->country_id = $c_id;
    }

    function getCountryId()
    {
        return $this->country_id;
    }

    function unsetCountryId()
    {
        $this->country_id = 0;
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * News::getTables() instead of $this->getTables()
     */
    function install()
    {
        global $application;
        $MessageResources = &$application->getInstance('MessageResources');

        $tables = Taxes::getTables(); #the array of meta description of tables
        $query = &new DB_Table_Create($tables); #create tables, based on meta discription

        $columns = $tables['product_tax_classes']['columns'];
        for ($i=1; $i<=2; $i++)
        {
            $query = &new DB_Insert('product_tax_classes');
            $query->addInsertValue($i, $columns['id']);
            $query->addInsertValue($MessageResources->getMessage(sprintf('PRD_TAX_CLS_NAME_%03d', $i)), $columns['name']);
            $query->addInsertValue($MessageResources->getMessage(sprintf('PRD_TAX_CLS_DESCR_%03d', $i)), $columns['descr']);
            if ($i == 1)
            {
                $query->addInsertValue('standard', $columns['type']);
            }
            else
            {
                $query->addInsertValue('custom', $columns['type']);
            }
            $application->db->getDB_Result($query);
        }

        $columns = $tables['tax_addresses']['columns'];
        for ($i=1; $i<=2; $i++)
        {
            $query = &new DB_Insert('tax_addresses');
            $query->addInsertValue($i, $columns['id']);
            $query->addInsertValue($i, $columns['pit_id']);
            $query->addInsertValue(sprintf('TAX_ADDRESS_NAME_%03d', $i), $columns['name']);
            $application->db->getDB_Result($query);
        }
        $query = &new DB_Insert('tax_addresses');
        $query->addInsertValue(TAXES_STORE_OWNER_ADDRESS_ID, $columns['id']);
        $query->addInsertValue(PERSON_INFO_TYPE_STORE_OWNER_INFO_ID, $columns['pit_id']);
        $query->addInsertValue(sprintf('TAX_ADDRESS_NAME_003', $i), $columns['name']);
        $application->db->getDB_Result($query);

        $columns = $tables['tax_display_options']['columns'];
        for ($i=1; $i<=3; $i++)
        {
            $query = &new DB_Insert('tax_display_options');
            $query->addInsertValue($i, $columns['id']);
            $query->addInsertValue(sprintf('TAX_DISPLAY_OPTION_%03d', $i), $columns['name']);
            $application->db->getDB_Result($query);
        }

        $columns = $tables['tax_costs']['columns'];
        for ($i=1; $i<=2; $i++)
        {
            $query = &new DB_Insert('tax_costs');
            $query->addInsertValue($i, $columns['id']);
            $query->addInsertValue(sprintf('TAX_COST_NAME_%03d', $i), $columns['name']);
            $application->db->getDB_Result($query);
        }

        $columns = $tables['tax_settings']['columns'];
        $query = &new DB_Insert('tax_settings');
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue('SELECTED_SHIPPING_MODULES_LIST', $columns['key']);
        $query->addInsertValue(serialize(array()), $columns['val']);
        $application->db->getDB_Result($query);
    }

    /**
     * Installs the specified module in the system.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * News::getTables() instead of $this->getTables()
     */
    function uninstall()
    {
        global $application;
        $query = &new DB_Table_Delete(Taxes::getTables());
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index- 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array - the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $prod_tax_classes = 'product_tax_classes';
        $tables[$prod_tax_classes] = array();
        $tables[$prod_tax_classes]['columns'] = array
            (
                'id'                => $prod_tax_classes.'.product_tax_class_id'
               ,'name'              => $prod_tax_classes.'.product_tax_class_name'
               ,'descr'             => $prod_tax_classes.'.product_tax_class_descr'
               ,'type'              => $prod_tax_classes.'.product_tax_class_type'
            );
        $tables[$prod_tax_classes]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'name'              => DBQUERY_FIELD_TYPE_CHAR255
               ,'descr'             => DBQUERY_FIELD_TYPE_TEXT
               ,'type'              => DBQUERY_FIELD_TYPE_CHAR10
            );
        $tables[$prod_tax_classes]['primary'] = array
            (
                'id'
            );

        $tax_names = 'tax_names';
        $tables[$tax_names] = array();
        $tables[$tax_names]['columns'] = array
            (
                'id'                  => $tax_names.'.tax_name_id'
               ,'included_into_price' => $tax_names.'.included_into_price'
               ,'ta_id'               => $tax_names.'.tax_address_id'
               ,'name'                => $tax_names.'.tax_name'
               ,'needs_address'       => $tax_names.'.tax_needs_address'
            );
        $tables[$tax_names]['types'] = array
            (
                'id'                  => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'included_into_price' => DBQUERY_FIELD_TYPE_CHAR5
               ,'ta_id'               => DBQUERY_FIELD_TYPE_INT
               ,'name'                => DBQUERY_FIELD_TYPE_CHAR255
               ,'needs_address'       => DBQUERY_FIELD_BOOLEAN_DEFAULT_TRUE
            );
        $tables[$tax_names]['primary'] = array
            (
                'id'
            );
        $tables[$tax_names]['indexes'] = array
            (
                'IDX_tai' => 'ta_id'
            );

        $tax_addresses = 'tax_addresses';
        $tables[$tax_addresses] = array();
        $tables[$tax_addresses]['columns'] = array
            (
                'id'                => $tax_addresses.'.tax_address_id'
               ,'pit_id'            => $tax_addresses.'.person_info_type_id'
               ,'name'              => $tax_addresses.'.tax_address_name'
            );
        $tables[$tax_addresses]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'pit_id'            => DBQUERY_FIELD_TYPE_INT
               ,'name'              => DBQUERY_FIELD_TYPE_CHAR50
            );
        $tables[$tax_addresses]['primary'] = array
            (
                'id'
            );
        $tables[$tax_addresses]['indexes'] = array
            (
                'IDX_piti' => 'pit_id'
            );

        $tax_display = 'tax_display';
        $tables[$tax_display] = array();
        $tables[$tax_display]['columns'] = array
            (
                'id'                => $tax_display.'.tax_display_id'
               ,'tdo_id'            => $tax_display.'.tax_display_option_id'
               ,'formula'           => $tax_display.'.tax_display_formula'
               ,'view'              => $tax_display.'.tax_display_view'
            );
        $tables[$tax_display]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'tdo_id'            => DBQUERY_FIELD_TYPE_INT
               ,'formula'           => DBQUERY_FIELD_TYPE_CHAR255
               ,'view'              => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$tax_display]['primary'] = array
            (
                'id'
            );
        $tables[$tax_display]['indexes'] = array
            (
                'IDX_tdoi' => 'tdo_id'
            );

        $tax_display_options = 'tax_display_options';
        $tables[$tax_display_options] = array();
        $tables[$tax_display_options]['columns'] = array
            (
                'id'                => $tax_display_options.'.tax_display_option_id'
               ,'name'              => $tax_display_options.'.tax_display_option_name'
            );
        $tables[$tax_display_options]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'name'              => DBQUERY_FIELD_TYPE_CHAR50
            );
        $tables[$tax_display_options]['primary'] = array
            (
                'id'
            );

        $tax_rates = 'tax_rates';
        $tables[$tax_rates] = array();
        $tables[$tax_rates]['columns'] = array
            (
                'id'                => $tax_rates.'.tax_rate_id'
               ,'c_id'              => $tax_rates.'.country_id'
               ,'s_id'              => $tax_rates.'.state_id'
               ,'ptc_id'            => $tax_rates.'.product_tax_class_id'
               ,'tn_id'             => $tax_rates.'.tax_name_id'
               ,'rate'              => $tax_rates.'.tax_rate'
               ,'formula'           => $tax_rates.'.tax_formula'
               ,'applicable'        => $tax_rates.'.tax_applicable'
            );
        $tables[$tax_rates]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'c_id'              => DBQUERY_FIELD_TYPE_INT
               ,'s_id'              => DBQUERY_FIELD_TYPE_INT
               ,'ptc_id'            => DBQUERY_FIELD_TYPE_INT
               ,'tn_id'             => DBQUERY_FIELD_TYPE_INT
               ,'rate'              => DBQUERY_FIELD_TYPE_FLOAT
               ,'formula'           => DBQUERY_FIELD_TYPE_CHAR255
               ,'applicable'        => DBQUERY_FIELD_TYPE_CHAR5
            );
        $tables[$tax_rates]['primary'] = array
            (
                'id'
            );
        $tables[$tax_rates]['indexes'] = array
            (
                'IDX_ci'   => 'c_id'
               ,'IDX_si'   => 's_id'
               ,'IDX_ptci' => 'ptc_id'
               ,'IDX_tni'  => 'tn_id'
            );

        $tax_costs = 'tax_costs';
        $tables[$tax_costs] = array();
        $tables[$tax_costs]['columns'] = array
            (
                'id'                => $tax_costs.'.tax_cost_id'
               ,'name'              => $tax_costs.'.tax_cost_name'
            );
        $tables[$tax_costs]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'name'              => DBQUERY_FIELD_TYPE_CHAR50
            );
        $tables[$tax_costs]['primary'] = array
            (
                'id'
            );

        $tax_settings = 'tax_settings';
        $tables[$tax_settings] = array();
        $tables[$tax_settings]['columns'] = array
            (
                'id'                => $tax_settings.'.tax_setting_id'
               ,'key'               => $tax_settings.'.tax_setting_key'
               ,'val'               => $tax_settings.'.tax_setting_value'
            );
        $tables[$tax_settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'val'               => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$tax_settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**
     * Gets a Product Tax Classes list.
     *
     * @param
     * @return
     */
    function getClassesList()
    {
        global$application;

        $tables = $this->getTables();
        $ptc = $tables['product_tax_classes']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($ptc['id'],    'Id');
        $query->addSelectField($ptc['name'],  'Name');
        $query->addSelectField($ptc['descr'], 'Descr');
        $query->addSelectField($ptc['type'],  'Type');
        return $application->db->getDB_Result($query);
    }

    /**
     * Adds Product Tax Class.
     *
     * @param string $name - class name
     * @param string $descr - class description
     * @return
     */
    function addProdTaxClass($name, $descr)
    {
        global$application;

        $tables = $this->getTables();
        $ptc = $tables['product_tax_classes']['columns'];

        $query = &new DB_Insert('product_tax_classes');
        $query->addInsertValue($name, $ptc['name']);
        $query->addInsertValue($descr, $ptc['descr']);
        $query->addInsertValue('custom', $ptc['type']);
        $application->db->getDB_Result($query);
    }

    /**
     * Updates Product Tax Class.
     *
     * @param integer $id - class id
     * @param string $name - class name
     * @param string $descr - class description
     * @return
     */
    function updateProdTaxClass($id, $name, $descr)
    {
        global$application;

        $tables = $this->getTables();
        $ptc = $tables['product_tax_classes']['columns'];

        $query = &new DB_Update('product_tax_classes');
        $query->addUpdateValue($ptc['name'], $name);
        $query->addUpdateValue($ptc['descr'], $descr);
        $query->WhereValue($ptc['id'], DB_EQ, $id);
        $application->db->getDB_Result($query);
    }

    /**
     * Deletes the Product Tax Class.
     *
     * @param integer $id - class id
     * @return
     */
    function deleteProdTaxClass($id)
    {
        global$application;

        $tables = $this->getTables();
        $ptc = $tables['product_tax_classes']['columns'];

        $query = &new DB_Delete('product_tax_classes');
        $query->WhereValue($ptc['id'], DB_EQ, $id);
        $application->db->getDB_Result($query);

        $tr = $tables['tax_rates']['columns'];

        $query = &new DB_Delete('tax_rates');
        $query->WhereValue($tr['ptc_id'], DB_EQ, $id);
        $application->db->getDB_Result($query);

        modApiFunc("Catalog", "changeAttributeValueForAllProducts", 8, $id, 1);
    }

    /**
     * Gets a Product Tax Classes list.
     *
     * FIXME:  wouldn't it be better to make NOT_TAXABLE one of
     * Taxes class data and store it somewhere in the table Settings?
     *
     * @param
     * @return
     */
    function getProductTaxClasses($with_nottaxable = true)
    {
       global$application;

       $tables = $this->getTables();
       $ptc = $tables['product_tax_classes']['columns'];

       $query = &new DB_Select();
       $query->addSelectField($ptc['id'],    'id');
       $query->addSelectField($ptc['name'],  'value');
       if (!$with_nottaxable)
       {
           $query->WhereValue($ptc['id'], DB_NEQ, TAX_CLASS_ID_NOT_TAXABLE);
       }
       return $application->db->getDB_Result($query);
    }

    /**
     * Gets information about Tax Classes.
     */
    function getProductTaxClassInfo($ptc_id)
    {
        global$application;
        $MessageResources = &$application->getInstance('MessageResources');

        $tables = $this->getTables();
        $ptc = $tables['product_tax_classes']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($ptc['id'],    'id');
        $query->addSelectField($ptc['name'],  'value');
        $query->WhereValue($ptc['id'], DB_EQ, $ptc_id);
        $result = $application->db->getDB_Result($query);
        return (sizeof($result) == 1)? $result[0]:array('id' => '0', 'value' => $MessageResources->getMessage("PRODUCT_TAX_CLASS_ANY_LABEL"));
    }

    /**
     *  Gets information about Tax Classes.
     */
    function getTaxClassInfo($ptc_id)
    {
        global$application;

        $tables = $this->getTables();
        $ptc = $tables['product_tax_classes']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($ptc['id'],    'id');
        $query->addSelectField($ptc['name'],  'name');
        $query->addSelectField($ptc['descr'],  'descr');
        $query->WhereValue($ptc['id'], DB_EQ, $ptc_id);
        $result = $application->db->getDB_Result($query);
        return (sizeof($result) == 1)? $result[0]:array('id' => '0', 'name' => "", 'descr' => "");
    }

    /**
     *
     */
    function setAddProdTaxClassFromCatalog()
    {
        global $application;
        $session = $application->getInstance('Session');
        $session->set('AddProdTaxClassFromCatalog', '1');
    }

    /**
     *
     */
    function getAddProdTaxClassFromCatalog()
    {
        global $application;
        $session = $application->getInstance('Session');
        if ($session->is_set('AddProdTaxClassFromCatalog'))
        {
            return $session->get('AddProdTaxClassFromCatalog');
        }
        return '0';
    }

    /**
     *
     */
    function unsetAddProdTaxClassFromCatalog()
    {
        global $application;
        $session = $application->getInstance('Session');
        return $session->un_set('AddProdTaxClassFromCatalog');
    }

    /**
     * Gets a taxes names list.
     *
     * @param
     * @return
     */
    function getTaxNamesList()
    {
        global$application;

        $tables = $this->getTables();
        $tn = $tables['tax_names']['columns'];
        $ta = $tables['tax_addresses']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($tn['id'],    'Id');
        $query->addSelectField($tn['included_into_price'],  'included_into_price');
        $query->addSelectField($tn['name'],  'Name');
        $query->addSelectField($tn['ta_id'],  'AddressId');
        $query->addSelectField($ta['name'],  'Address');
        $query->addSelectField($tn['needs_address'],  'NeedsAddress');

        $query->addLeftJoin('tax_addresses', $ta['id'], DB_EQ, $tn['ta_id']);
        return $application->db->getDB_Result($query);
    }


    /**
     * Gets a taxes names list indexed by TaxId.
     *
     * @param
     * @return
     */
    function getTaxNames()
    {
        $TaxNamesRow = modApiFunc("Taxes", "getTaxNamesList");
        $TaxNames = array();
        foreach($TaxNamesRow as $tax)
        {
            $TaxNames[$tax['Id']] = $tax;
        }
        return $TaxNames;
    }

    /**
     * Gets an addresses type list (Shipping and Billing).
     *
     * @param
     * @return
     */
    function getAddressesList()
    {
        global$application;

        $tables = $this->getTables();
        $ta = $tables['tax_addresses']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($ta['id'],    'id');
        $query->addSelectField($ta['name'],  'name');
        return $application->db->getDB_Result($query);
    }

    /**
     * Adds tax.
     *
     * @param
     * @return
     */
    function addTaxName($included_into_price, $name, $address_id, $need_address)
    {
        global$application;

        if($address_id == TAXES_TAX_NAME_DOES_NOT_NEED_ADDRESS_ID)
        {
            $address_id = ''; //                       NULL
        }

        $tables = $this->getTables();
        $tn = $tables['tax_names']['columns'];

        $query = &new DB_Insert('tax_names');
        $query->addInsertValue($included_into_price, $tn['included_into_price']);
        $query->addInsertValue($name, $tn['name']);
        $query->addInsertValue($address_id, $tn['ta_id']);
        $query->addInsertValue($need_address === true ? "true" : "false", $tn['needs_address']);
        $application->db->getDB_Result($query);
        return $application->db->DB_Insert_Id();
    }

    /**
     * Updates tax information.
     *
     * @param
     * @return
     */
    function updateTaxName($id, $included_into_price, $name, $address_id, $need_address)
    {
        global $application;

        $tables = $this->getTables();
        $tn = $tables['tax_names']['columns'];

        $query = &new DB_Update('tax_names');
        $query->addUpdateValue($tn['included_into_price'], $included_into_price);
        $query->addUpdateValue($tn['name'], $name);
        $query->addUpdateValue($tn['ta_id'], $address_id);
        $query->addUpdateValue($tn['needs_address'], $need_address === true ? "true" : "false");
        $query->WhereValue($tn['id'], DB_EQ, $id);
        $application->db->getDB_Result($query);
    }

    /**
     * Deletes tax.
     *
     * @param
     * @return
     */
    function deleteTaxName($id)
    {
        global$application;

        $tables = $this->getTables();
        $tn = $tables['tax_names']['columns'];

        $query = &new DB_Delete('tax_names');
        $query->WhereValue($tn['id'], DB_EQ, $id);
        $application->db->getDB_Result($query);

        $td = $tables['tax_display']['columns'];

        $query = &new DB_Delete('tax_display');
        $query->WhereValue($td['formula'], DB_LIKE, '%{'.$id.'}%');
        $application->db->getDB_Result($query);

        $tr = $tables['tax_rates']['columns'];

        $query = &new DB_Delete('tax_rates');
        $query->WhereValue($tr['tn_id'], DB_EQ, $id);
        $query->WhereOr();
        $query->WhereValue($tr['formula'], DB_LIKE, '%{t_'.$id.'}%');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets tax information.
     *
     * @param
     * @return
     */
    function getTaxNameInfo($id)
    {
        global$application;

        $tables = $this->getTables();
        $tn = $tables['tax_names']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($tn['id'],    'Id');
        $query->addSelectField($tn['included_into_price'],  'included_into_price');
        $query->addSelectField($tn['name'],  'Name');
        $query->addSelectField($tn['needs_address'],  'needs_address');
        $query->addSelectField($tn['ta_id'],  'AddressId');
        $query->WhereValue($tn['id'], DB_EQ, $id);
        $result = $application->db->getDB_Result($query);
        if (sizeof($result))
        {
            $result = $result[0];
        }
        else
        {
            $result = array(
                            "included_into_price"=> "false"
                           ,"Name"               => ""
                           ,"Id"                 => ""
                           ,"needs_address"      => "true"
                           ,"AddressId"          => "1"
                           );
        }
        return $result;
    }

    /**
     * Gets a Display Options list.
     *
     * @param
     * @return
     */
    function getTaxDisplayOptionsList()
    {
        global$application;

        $tables = $this->getTables();
        $td = $tables['tax_display']['columns'];
        $tdo = $tables['tax_display_options']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($td['id'], 'Id');
        $query->addSelectField($td['formula'], 'Formula');
        $query->addSelectField($td['view'], 'View');
        $query->addSelectField($tdo['id'], 'tdoId');
        $query->addSelectField($tdo['name'], 'OptionName');
        $query->addLeftJoin('tax_display_options', $tdo['id'], DB_EQ, $td['tdo_id']);
        return $application->db->getDB_Result($query);
    }

    /**
     * Gets a Display Options list.
     *
     * @param
     * @return
     */
    function getDisplayOptionsList()
    {
        global$application;

        $tables = $this->getTables();
        $tdo = $tables['tax_display_options']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($tdo['id'], 'id');
        $query->addSelectField($tdo['name'],  'name');
        return $application->db->getDB_Result($query);
    }

    /**
     * Adds Display Option.
     *
     * @param
     * @return
     */
    function addTaxDisplayOption($formula, $option_id, $display_view)
    {
        global$application;

        $tables = $this->getTables();
        $td = $tables['tax_display']['columns'];

        $query = &new DB_Insert('tax_display');
        $query->addInsertValue($formula, $td['formula']);
        $query->addInsertValue($option_id, $td['tdo_id']);
        $query->addInsertValue($display_view, $td['view']);
        return $application->db->getDB_Result($query);
    }

    /**
     * Updates Display Option.
     *
     * @param
     * @return
     */
    function updateTaxDisplayOption($id, $formula, $option_id, $display_view)
    {
        global $application;

        $tables = $this->getTables();
        $td = $tables['tax_display']['columns'];

        $query = &new DB_Update('tax_display');
        $query->addUpdateValue($td['formula'], $formula);
        $query->addUpdateValue($td['tdo_id'], $option_id);
        $query->addUpdateValue($td['view'], $display_view);
        $query->WhereValue($td['id'], DB_EQ, $id);
        $application->db->getDB_Result($query);
    }

    /**
     * Deletes Display Option.
     *
     * @param
     * @return
     */
    function deleteTaxDisplayOption($id)
    {
        global$application;

        $tables = $this->getTables();
        $td = $tables['tax_display']['columns'];

        $query = &new DB_Delete('tax_display');
        $query->WhereValue($td['id'], DB_EQ, $id);
        $application->db->getDB_Result($query);
    }

    /**
     * Gets Display Option information.
     *
     * @param
     * @return
     */
    function getTaxDisplayOptionInfo($id)
    {
        global$application;

        $tables = $this->getTables();
        $td = $tables['tax_display']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($td['id'],    'Id');
        $query->addSelectField($td['formula'],  'Formula');
        $query->addSelectField($td['tdo_id'],  'OptionId');
        $query->addSelectField($td['view'],  'Display');
        $query->WhereValue($td['id'], DB_EQ, $id);
        $result = $application->db->getDB_Result($query);
        if (sizeof($result))
        {
            $result = $result[0];
        }
        else
        {
            $result = array(
                            "Formula"               => ""
                           ,"Id"                    => ""
                           ,"OptionId"              => "1"
                           ,"Display"               => ""
                           );
        }
        return $result;
    }

    /**
     * Gets a Shipping Modules list to calculate a shipping tax for.
     *
     * @param
     * @return
     */
    function getShippingModulesList($full = true)
    {
        global $application;

        $ShippingModulesList = array();

        $selected_sm_list = array();

        $tables = $this->getTables();
        $ts = $tables['tax_settings']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($ts['val'], 'SelectedSM');
        $query->WhereValue($ts['key'], DB_EQ, 'SELECTED_SHIPPING_MODULES_LIST');
        $result = $application->db->getDB_Result($query);
        $selected_sm_list = unserialize($result[0]['SelectedSM']);
//$sm_list = modApiFunc("Checkout", "getInstalledAndActiveModulesListData", "shipping");
        $sm_list = modApiFunc("Modules_Manager", "getActiveModules", array("ShippingModule"));
        foreach ($sm_list as $sm_item)
        {
            $smInfo = modApiFunc($sm_item->name, "getInfo");
            if ($smInfo['GlobalUniqueShippingModuleID'] == modApiFunc("Checkout", "getAllInactiveModuleId", "shipping"))
            {
                continue;
            }
            if ($full)
            {
                $ShippingModulesList[$smInfo['GlobalUniqueShippingModuleID']] = array("Name" => $smInfo['Name'],
                                    "Checked" => (in_array($smInfo['GlobalUniqueShippingModuleID'], $selected_sm_list))? true:false);
            }
            elseif (in_array($smInfo['GlobalUniqueShippingModuleID'], $selected_sm_list))
            {
                $ShippingModulesList[$smInfo['GlobalUniqueShippingModuleID']] = $smInfo['Name'];
            }
        }
        return $ShippingModulesList;
    }

    function setTaxSetting($key, $val)
    {
        global $application;

        $tables = $this->getTables();
        $ts = $tables['tax_settings']['columns'];

        $query = &new DB_Update('tax_settings');
        $query->addUpdateValue($ts['val'], $val);
        $query->WhereValue($ts['key'], DB_EQ, $key);
        $application->db->getDB_Result($query);
    }

    function getTaxSetting($key)
    {
        global $application;

        $tables = $this->getTables();
        $ts = $tables['tax_settings']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($ts['val'], 'val');
        $query->WhereValue($ts['key'], DB_EQ, $key);
        $result = $application->db->getDB_Result($query);
        if (sizeof($result))
        {
            return $result[0]['val'];
        }
        else
        {
            return null;
        }
    }

    /**
     * Gets a price list to calculate taxes for.
     *
     * @return
     */
    function getTaxCostsList()
    {
        global$application;

        $tables = $this->getTables();
        $tc = $tables['tax_costs']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($tc['id'],    'id');
        $query->addSelectField($tc['name'],  'name');
        return $application->db->getDB_Result($query);
    }

    /**
     * Returns a tax formulas/rates list for given country, state and
     * tax class.
     * Warning: the entries from
     * state_id = STATE_ID_ALL
     * and
     * tax_class_id = TAX_CLASS_ID_ANY
     * will be returned independently of $state_id and $tax_class_id.
     */
    function getTaxRatesList($country_id = -1, $state_id = -1, $tax_class_id = -1, $tax_name_id = -1)
    {
        global$application;

        $tables = $this->getTables();
        $tr = $tables['tax_rates']['columns'];
        $ptc = $tables['product_tax_classes']['columns'];
        $tn = $tables['tax_names']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($tr['id'], 'Id');
        $query->addSelectField($tr['c_id'], 'c_id');
        $query->addSelectField($tr['s_id'], 's_id');
        $query->addSelectField($ptc['name'], 'ProductTaxClass');
        $query->addSelectField($ptc['id'], 'tax_class_id');
        $query->addSelectField($tn['name'], 'TaxName');
        $query->addSelectField($tn['id'], 'tax_name_id');
        $query->addSelectField($tr['rate'], 'Rate');
        $query->addSelectField($tr['formula'], 'Formula');
        $query->addSelectField($tr['applicable'], 'Applicable');
        $query->addLeftJoin('product_tax_classes', $ptc['id'], DB_EQ, $tr['ptc_id']);
        $query->addLeftJoin('tax_names', $tn['id'], DB_EQ, $tr['tn_id']);

        $query->WhereValue('', '', '1');
        if($country_id != -1 &&
           $country_id != TAXES_COUNTRY_NOT_NEEDED_ID)
        {
            $query->WhereAnd();
            $query->addWhereOpenSection();
            $query->WhereValue($tr['c_id'], DB_EQ, $country_id);
            $query->WhereOR();
            $query->WhereValue($tr['c_id'], DB_EQ, TAXES_COUNTRY_NOT_NEEDED_ID);
            $query->addWhereCloseSection();
        }
        if($state_id != -1 &&
           $state_id != TAXES_STATE_NOT_NEEDED_ID)
        {
            $query->WhereAnd();
            $query->addWhereOpenSection();
            $query->WhereValue($tr['s_id'], DB_EQ, $state_id);
            $query->WhereOR();
            $query->WhereValue($tr['s_id'], DB_EQ, STATE_ID_ALL);
            $query->WhereOR();
            $query->WhereValue($tr['s_id'], DB_EQ, TAXES_STATE_NOT_NEEDED_ID);
            $query->addWhereCloseSection();
        }
        if($tax_class_id != -1)
        {
            $query->WhereAnd();
            $query->addWhereOpenSection();
            $query->WhereValue($tr['ptc_id'], DB_EQ, $tax_class_id);
            $query->WhereOR();
            $query->WhereValue($tr['ptc_id'], DB_EQ, TAX_CLASS_ID_ANY);
            $query->addWhereCloseSection();
        }
        if($tax_name_id != -1)
        {
            $query->WhereAnd();
            $query->WhereValue($tr['tn_id'], DB_EQ, $tax_name_id);
        }
        return $application->db->getDB_Result($query);
    }

    /**
     *
     *
     * @param
     * @return
     */
    function getTaxRateInfo($id)
    {
        global$application;

        $tables = $this->getTables();
        $tr = $tables['tax_rates']['columns'];
        $ptc = $tables['product_tax_classes']['columns'];
        $tn = $tables['tax_names']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($tr['id'],     'Id');
        $query->addSelectField($tr['c_id'],   'CountryId');
        $query->addSelectField($tr['s_id'],   'StateId');
        $query->addSelectField($tr['ptc_id'], 'ProductTaxClassId');
        $query->addSelectField($tr['tn_id'],  'TaxNameId');
        $query->addSelectField($tr['rate'],   'Rate');
        $query->addSelectField($tr['formula'],'Formula');
        $query->addSelectField($tr['applicable'], 'Applicable');
        $query->addSelectField($tn['name'], 'TaxName');
        $query->addSelectField($ptc['name'], 'ProductTaxClass');
        $query->addLeftJoin('product_tax_classes', $ptc['id'], DB_EQ, $tr['ptc_id']);
        $query->addLeftJoin('tax_names', $tn['id'], DB_EQ, $tr['tn_id']);
        $query->WhereValue($tr['id'], DB_EQ, $id);
        $result = $application->db->getDB_Result($query);
        if (sizeof($result))
        {
            $result = $result[0];
        }
        else
        {
            $result = array(
                            "Id"                    => ""
                           ,"CountryId"             => "0"
                           ,"StateId"               => "-1"
                           ,"ProductTaxClassId"     => "1"
                           ,"TaxNameId"             => "0"
                           ,"Rate"                  => ""
                           ,"Formula"               => ""
                           ,"Applicable"            => "true"
                           );
        }
        return $result;
    }

    /**
     *
     *
     * @param
     * @return
     */
    function addTaxRate($c_id, $s_id, $ptc_id, $tn_id, $rate, $formula, $applicable)
    {
        global$application;

        $tables = $this->getTables();
        $tr = $tables['tax_rates']['columns'];

        $query = &new DB_Insert('tax_rates');
        $query->addInsertValue($c_id, $tr['c_id']);
        $query->addInsertValue($s_id, $tr['s_id']);
        $query->addInsertValue($ptc_id, $tr['ptc_id']);
        $query->addInsertValue($tn_id, $tr['tn_id']);
        $query->addInsertValue($rate, $tr['rate']);
        $query->addInsertValue($formula, $tr['formula']);
        $query->addInsertValue($applicable, $tr['applicable']);
        $application->db->getDB_Result($query);
    }

    /**
     *
     *
     * @param
     * @return
     */
    function updateTaxRate($id, $c_id, $s_id, $ptc_id, $tn_id, $rate, $formula, $applicable)
    {
        global$application;

        $tables = $this->getTables();
        $tr = $tables['tax_rates']['columns'];

        $query = &new DB_Update('tax_rates');
        $query->addUpdateValue($tr['c_id'], $c_id);
        $query->addUpdateValue($tr['s_id'], $s_id);
        $query->addUpdateValue($tr['ptc_id'], $ptc_id);
        $query->addUpdateValue($tr['tn_id'], $tn_id);
        $query->addUpdateValue($tr['rate'], $rate);
        $query->addUpdateValue($tr['formula'], $formula);
        $query->addUpdateValue($tr['applicable'], $applicable);
        $query->WhereValue($tr['id'], DB_EQ, $id);
        $application->db->getDB_Result($query);
    }

    function deleteTaxRate($id)
    {
        global$application;

        $tables = $this->getTables();
        $tr = $tables['tax_rates']['columns'];

        $query = &new DB_Delete('tax_rates');
        $query->WhereValue($tr['id'], DB_EQ, $id);
        $application->db->getDB_Result($query);
    }

    function getTaxFormula($tax_rate_id)
    {
        if (!$tax_rate_id||$tax_rate_id==0)
        {
            return "";
        }

        global$application;

        $tables = $this->getTables();
        $tr = $tables['tax_rates']['columns'];
        $query = &new DB_Select();
        $query->addSelectField($tr['rate'],   'Rate');
        $query->addSelectField($tr['formula'],'Formula');
        $query->WhereValue($tr['id'], DB_EQ, $tax_rate_id);
        $result = $application->db->getDB_Result($query);

        if (sizeof($result) == 0)
        {
            return "";
        }
        return $result[0];
    }

    function getTaxFormulaViewFull($tax_rate_id)
    {
        if (!$tax_rate_id||$tax_rate_id==0)
        {
            return "";
        }

        global$application;
        $MessageResources = &$application->getInstance('MessageResources');

        $tables = $this->getTables();
        $tr = $tables['tax_rates']['columns'];
        $tn = $tables['tax_names']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($tr['rate'],   'Rate');
        $query->addSelectField($tr['formula'],'Formula');
        $query->addSelectField($tr['applicable'],'Applicable');
        $query->addSelectField($tn['name'], 'TaxName');
        $query->addLeftJoin('tax_names', $tn['id'], DB_EQ, $tr['tn_id']);
        $query->WhereValue($tr['id'], DB_EQ, $tax_rate_id);
        $result = $application->db->getDB_Result($query);

        if (sizeof($result) == 0)
        {
            return "";
        }
        $result = $result[0];
        if ($result["Applicable"] == "false")
        {
            return prepareHTMLDisplay($result['TaxName'])." = ".$MessageResources->getMessage('TAX_RATE_NOT_APPLICABLE_LABEL');
        }
        $replace = array();
        foreach ($this->getTaxNamesList() as $taxNameInfo)
        {
            $replace['{t_'.$taxNameInfo['Id'].'}'] = prepareHTMLDisplay($taxNameInfo['Name']);
        }
        foreach ($this->getTaxCostsList() as $cost)
        {
            $replace['{p_'.$cost['id'].'}'] = $MessageResources->getMessage($cost['name']);
        }
        preg_match_all("/([0-9]+\.?[0-9]+)/", $result['Formula'], $numbers);
        for ($j=0; $j<sizeof($numbers[0]); $j++)
        {
            $replace[$numbers[0][$j]] = modApiFunc("Localization", "num_format", $numbers[0][$j]);
        }
        $result['Formula'] = strtr($result['Formula'], $replace);
        return prepareHTMLDisplay($result['TaxName'])." = ".$result['Rate']."% * (".$result['Formula'].")";
    }

    /**
     *                   $this->TaxDebug:
     * $this->TaxDebug = array(
     *                          "ProductsList" => array(
     *                                                  "0" => array(
     *                                                               "ID" => 1,
     *                                                               "Quantity_In_Cart" => 1,
     *                                                               "attributes" => array(
     *                                                                                     "SalePrice"     => array(
     *                                                                                                        "value"=>$CartItemSalePrice
     *                                                                                                             ),
     *                                                                                     "ShippingPrice" => array(
     *                                                                                                        "value"=>$ShippingPrice
     *                                                                                                             ),
     *                                                                                     "TaxClass"      => array(
     *                                                                                                        "value"=>$ProductTaxClass
     *                                                                                                             ),
     *                                                                                    ),
    *                                                                "CartItemSalePrice" => $CartItemSalePrice
     *                                                              )
     *                                                 ),
     *                          "AddressesList"=> array(
     *                                                  "1" => array(//ShippingAddress
     *                                                                             "CountryId" => $sa_c_id,
     *                                                                             "StateId"   => $sa_s_id
     *                                                                            ),
     *                                                  "2" => array(//CustomerAddress
     *                                                                             "CountryId" => $ca_c_id,
     *                                                                             "StateId"   => $ca_s_id
     *                                                                            ),
     *                                                  "3" => array(//BillingAddress
     *                                                                             "CountryId" => $ba_c_id,
     *                                                                             "StateId"   => $ba_s_id
     *                                                                            )
     *                                                 )
     *                        );
     */
    function getTax($debug = false, $trace = false, $symbolic = false, $use_default_address_for_not_included_taxes = false)
    {
        $TaxNames = modApiFunc("Taxes", "getTaxNames");
        if ($debug)
        {
            $ProductsList  = $this->TaxDebug["ProductsList"];
            $CartSubtotal = $this->TaxDebug["CartSubtotal"];
            $OrderLevelShippingCost = $this->TaxDebug["OrderLevelShippingCost"];
            $TotalShippingCost = $OrderLevelShippingCost;
            foreach ($this->TaxDebug["ProductsList"] as $productInfo)
            {
                $TotalShippingCost+= $productInfo["Quantity_In_Cart"]*($productInfo["attributes"]["PerItemShippingCost"]["value"] +
                                                                       $productInfo["attributes"]["PerItemHandlingCost"]["value"]);
            }
            $ShippingMethod = $this->TaxDebug["ShippingMethod"];
            $AddressesList = $this->TaxDebug["AddressesList"];
        }
        else
        {
            $ProductsList = modApiFunc("Cart", "getCartContentExt");
            $CartSubtotal = modApiFunc("Cart", "getCartSubtotal");

            $ShippingMethod = modApiFunc("Checkout", "getChosenShippingModuleIdCZ");

            $TotalShippingCost = modApiFunc("Checkout", "getOrderPrice", "TotalShippingAndHandlingCost");
            $OrderLevelShippingCost = $TotalShippingCost -
                                      modApiFunc("Checkout", "getOrderPrice", "PerItemShippingCostSum") -
                                      modApiFunc("Checkout", "getOrderPrice", "PerItemHandlingCostSum");
            if ($OrderLevelShippingCost < 0)
            {
            	$OrderLevelShippingCost = 0;
            }

            $ShippingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo");
            $BillingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo");
            $StoreOwnerInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "storeOwnerInfo");

            //                          Checkout::storeOwnerInfo                isMet
            //                -               storeOwnerInfo          -                            ,
            //                      ?
            $store_owner_country = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_COUNTRY);
            $store_owner_state = modApiFunc('Configuration', 'getValue', SYSCONFIG_STORE_OWNER_STATE);
            $b_store_owner_address_correct = is_numeric($store_owner_country) && is_numeric($store_owner_state);
            $AddressesList = array(
                                   "0" => (!$b_store_owner_address_correct) ? null :
                                          array(//DefaultAddress (dad) - e.g. Store Owner Address
                                                "CountryId" => $store_owner_country,
                                                "StateId"   => $store_owner_state
                                               ),
                                   "1" => ($ShippingInfo["isMet"] == false)?
                                          ((!$b_store_owner_address_correct || !$use_default_address_for_not_included_taxes) ? null :
                                          array(//DefaultAddress (dad) - e.g. Store Owner Address
                                                "CountryId" => $store_owner_country,
                                                "StateId"   => $store_owner_state
                                               )):
                                          array(//ShippingAddress
                                                "CountryId" => isset($ShippingInfo["validatedData"]["Country"]["value"])? $ShippingInfo["validatedData"]["Country"]["value"]:0,
                                                "StateId"   => empty($ShippingInfo["validatedData"]["Statemenu"]["value"]) ? STATE_ID_ALL : $ShippingInfo["validatedData"]["Statemenu"]["value"]
                                               ),
                                   "2" => ($BillingInfo["isMet"] == false)?
                                          ((!$b_store_owner_address_correct || !$use_default_address_for_not_included_taxes) ? null :
                                          array(//DefaultAddress (dad) - e.g. Store Owner Address
                                                "CountryId" => $store_owner_country,
                                                "StateId"   => $store_owner_state
                                               )):
                                          array(//BillingAddress
                                                "CountryId" => isset($BillingInfo["validatedData"]["Country"]["value"])? $BillingInfo["validatedData"]["Country"]["value"]:0,
                                                "StateId"   => empty($BillingInfo["validatedData"]["Statemenu"]["value"]) ? STATE_ID_ALL : $BillingInfo["validatedData"]["Statemenu"]["value"]
                                               ),

                                   TAXES_STORE_OWNER_ADDRESS_ID . "" => ($StoreOwnerInfo["isMet"] == false)?
                                          ((!$b_store_owner_address_correct || !$use_default_address_for_not_included_taxes) ? null :
                                          array(//DefaultAddress (dad) - e.g. Store Owner Address
                                                "CountryId" => $store_owner_country,
                                                "StateId"   => $store_owner_state
                                               )):
                                          array(//StoreOwnerAddress
                                                "CountryId" => isset($StoreOwnerInfo["validatedData"]["Country"]["value"])? $StoreOwnerInfo["validatedData"]["Country"]["value"]:0,
                                                "StateId"   => empty($StoreOwnerInfo["validatedData"]["Statemenu"]["value"]) ? STATE_ID_ALL : $StoreOwnerInfo["validatedData"]["Statemenu"]["value"]
                                               )
                             /*,
                                   "3" => array(//CustomerAddress
                                                "CountryId" => $CustomerInfo["validatedData"]["Country"]["value"],
                                                "StateId"   => empty($CustomerInfo["validatedData"]["Statemenu"]["value"]) ? STATE_ID_ALL : $CustomerInfo["validatedData"]["Statemenu"]["value"]
                                               )*/
                                  );
        }

        if (sizeof($ProductsList)>0)
        {
            #Gets the Product Tax Class array
            $ProductTaxClassArray = array();
            #A products( of each type) array
            $productsQuantity = array();
            foreach ($ProductsList as $ProductInfo)
            {
                if(!in_array($ProductInfo["attributes"]["TaxClass"]["value"], $ProductTaxClassArray))
                {
                    $ProductTaxClassArray[] = ($ProductInfo["attributes"]["TaxClass"]["value"])? $ProductInfo["attributes"]["TaxClass"]["value"]:1;
                }
                $productsQuantity[$ProductInfo["CartID"]] = $ProductInfo["Quantity_In_Cart"];
            }/*
            if(!in_array(1, $ProductTaxClassArray))
            {
                $ProductTaxClassArray[] = 1;
            }*/
            #Gets an Address array
            $AddressArray = array("CountryId" => array(), "StateId" => array());
            foreach ($AddressesList as $AddressInfo)
            {
                if ($AddressInfo)
                {
                    if(!in_array($AddressInfo["CountryId"], $AddressArray["CountryId"]))
                    {
                        $AddressArray["CountryId"][] = $AddressInfo["CountryId"];
                    }
                    if(!in_array($AddressInfo["StateId"], $AddressArray["StateId"]))
                    {
                        $AddressArray["StateId"][] = $AddressInfo["StateId"];
                    }
                }
            }
            if(!in_array((int)0, $AddressArray["StateId"]))
            {
                $AddressArray["StateId"][] = (int)0;
            }
            if(sizeof($AddressArray["CountryId"]) == 0)
            {
                $AddressArray["CountryId"][] = (int)0;
            }
            #Gets a list of applicable tax rates
            $ApplicableTaxes = array();
            $TaxRatesList = $this->getApplicableTaxRates($ProductTaxClassArray, $AddressArray);
            if ($trace)
            {

                $TraceInfo = array(
                                    "ProductList" => $ProductsList
                                   ,"ProductTaxClassArray" => $ProductTaxClassArray
                                   ,"AddressesList"         => $AddressesList
                                   ,"TaxRatesList"         => $TaxRatesList
                                  );
                $this->addTraceInfo("1", $TraceInfo);
            }

            $Taxes = $this->getTaxes();
            foreach ($TaxRatesList as $TaxRateInfo)
            {
                $Taxes[$TaxRateInfo['TaxNameId']]["applicable"] = true;
            }
            if ($trace)
            {
                $TraceInfo = array(
                                    "TaxesArray" => $Taxes
                                  );
                $this->addTraceInfo("2", $TraceInfo);
            }
    /*
                          $TaxAmounts
        $TaxAmounts = array(
                            "products" => array(
                                                "ProdId1" = array(
                                                                 "TaxId1" => $amount1,
                                                                 "TaxId2" => $amount2,
                                                                 ...
                                                                 ),
                                                "ProdId2" = array(
                                                                 "TaxId1" => $amount3,
                                                                 "TaxId2" => $amount4,
                                                                 ...
                                                                 ),
                                               ),
                            "TaxSubtotalAmount" = array(
                                                       "TaxId1" => $amount1 + $amount3 + ...,
                                                       "TaxId2" => $amount2 + $amount4 + ...,
                                                        ...
                                                       ),
                            "TaxSubtotalAmountView" => array(), -                     Tax Display Options
                            "TaxTotalAmount" => sum(TaxSubtotalAmount)
                           );
    */

            $this->TaxAmounts = array(
                                        "products" => array(),
                                        "tax_on_shipping" => true,
                                        "TaxSubtotalAmount" => array(),
                                        "TaxSubtotalAmountView" => array(),
                                        "TaxTotalAmount" => (int)PRICE_N_A,//0
                                        "IncludedTaxTotalAmount" => (int)PRICE_N_A//0
                                     );
            #Calculate the tax
            foreach ($Taxes as $TaxId => $TaxInfo)
            {
                $this->TaxAmounts["TaxSubtotalAmount"][$TaxId] = (int)PRICE_N_A;//0;
                $retval = $this->calculateTax($Taxes, $TaxId, $TaxRatesList, $AddressesList, $ProductsList, $CartSubtotal, $OrderLevelShippingCost, $TotalShippingCost, $ShippingMethod, $debug, $trace, $symbolic);
                if ($retval == "fatal")
                {
                    return $this->TaxAmounts;
                }
            }
            foreach ($this->TaxAmounts["products"] as $prodId => $taxAmountInfo)
            {
                foreach ($taxAmountInfo as $taxId => $taxAmount)
                {
                    if (is_array($taxAmount))
                    {
                        continue;
                    }
                    if ($taxAmount == PRICE_N_A)
                    {
    //                    $this->TaxAmounts["TaxTotalAmount"] = (int)PRICE_N_A;
                        continue;
                    }
                    if ($this->TaxAmounts["TaxSubtotalAmount"][$taxId] == PRICE_N_A)
                    {
                        $this->TaxAmounts["TaxSubtotalAmount"][$taxId] = 0;
                    }
                    if ($this->TaxAmounts["IncludedTaxTotalAmount"] == PRICE_N_A)
                    {
                        $this->TaxAmounts["IncludedTaxTotalAmount"] = 0;
                    }
                    if ($this->TaxAmounts["TaxTotalAmount"] == PRICE_N_A)
                    {
                        $this->TaxAmounts["TaxTotalAmount"] = 0;
                    }
                    $this->TaxAmounts["TaxSubtotalAmount"][$taxId] += modApiFunc("Localization", "roundMonetaryUnit", $productsQuantity[$prodId]*$taxAmount);

                    if($TaxNames[$taxId]["included_into_price"] == "true")
                    {
                        $this->TaxAmounts["IncludedTaxTotalAmount"] += modApiFunc("Localization", "roundMonetaryUnit", $productsQuantity[$prodId]*$taxAmount);
                    }
                    $this->TaxAmounts["TaxTotalAmount"] += modApiFunc("Localization", "roundMonetaryUnit", $productsQuantity[$prodId]*$taxAmount);
                }
            }
        }
        else
        {
            $Taxes = $this->getTaxes();
            $TaxSubtotalAmount = array();
            foreach ($Taxes as $TaxId => $TaxInfo)
            {
                $TaxSubtotalAmount[$TaxId] = (int)PRICE_N_A;
            }
            $this->TaxAmounts = array(
                                        "products" => array(),
                                        "tax_on_shipping" => true,
                                        "TaxSubtotalAmount" => $TaxSubtotalAmount,
                                        "TaxSubtotalAmountView" => array(),
                                        "TaxTotalAmount" => (int)PRICE_N_A//0
                                     );
        }

        $replace = array();
        foreach ($this->TaxAmounts["TaxSubtotalAmount"] as $taxId => $taxAmount)
        {
            $replace["{".$taxId."}"] = $taxAmount;
        }

        $DisplayOptions = $this->getTaxDisplayOptionsList();
        foreach ($DisplayOptions as $DisplayOptionInfo)
        {
            if ($DisplayOptionInfo['tdoId'] != 3)
            {
                $_replace = $replace;
                if ($DisplayOptionInfo['tdoId'] == 1)
                {
                    foreach ($replace as $taxIdTag => $TaxAmount)
                    {
                        if (!(strpos($DisplayOptionInfo['Formula'], $taxIdTag) === false) && $TaxAmount != PRICE_N_A)
                        {
                            foreach ($_replace as $taxIdTag => $TaxAmount)
                            {
                                if ($TaxAmount == PRICE_N_A)
                                {
                                    $_replace[$taxIdTag] = 0;
                                }
                            }
                            break;
                        }
                    }
                }
                $DisplayOptionInfo['Formula'] = strtr($DisplayOptionInfo['Formula'], $_replace);
                if (strpos($DisplayOptionInfo['Formula'], sprintf("%d", PRICE_N_A)) === false)
                {
                    $TaxAmount = eval("return ".$DisplayOptionInfo['Formula'].";");
                }
                else
                {
                    $TaxAmount = (int)PRICE_N_A;
                }
                if (!($TaxAmount==PRICE_N_A && $DisplayOptionInfo['tdoId'] == 2))
                {
                    $this->TaxAmounts["TaxSubtotalAmountView"][] = array
                    (
                        'view' => prepareHTMLDisplay($DisplayOptionInfo['View'])
                       ,'value' => $TaxAmount
                    );

                }
            }
        }
        return $this->TaxAmounts;
    }

    /**
     *
     *
     * @param
     * @return
     */
    function excludeTaxRates($TaxRatesList, $condition)
    {
        $result = array();
        foreach ($TaxRatesList as $TaxRateInfo)
        {
            switch ($condition["entity"])
            {
                case "Tax":
                    if ($TaxRateInfo["TaxNameId"] == $condition["TaxNameId"])
                    {
                        $result[] = $TaxRateInfo;
                    }
                    break;
                case "TaxClass":
                    if ($TaxRateInfo["ProductTaxClassId"] == $condition["ProductTaxClassId"])
                    {
                        $result[] = $TaxRateInfo;
                    }
                    break;
            }
        }
        if ($condition["entity"] == "TaxClass" && sizeof($result) == 0)
        {
            foreach ($TaxRatesList as $TaxRateInfo)
            {
                if ($TaxRateInfo["ProductTaxClassId"] == 1)
                {
                    $result[] = $TaxRateInfo;
                }
            }
        }
        if ($condition["entity"] == "Address")
        {
            foreach ($TaxRatesList as $TaxRateInfo)
            {
                if ($TaxRateInfo["StateId"] == $condition["StateId"])
                {
                    $result[] = $TaxRateInfo;
                }
            }
            //                      ALL_STATES
            $all_states_present = false;
            foreach($result as $info)
            {
            	if($info["CountryId"] == $condition["CountryId"] &&
            	   $info["StateId"] == 0)
            	{
            		$all_states_present = true;
            		break;
            	}
            }
            if (!$all_states_present)
            {
                foreach ($TaxRatesList as $TaxRateInfo)
                {
                    if ($TaxRateInfo["CountryId"] == $condition["CountryId"] && $TaxRateInfo["StateId"] == 0)
                    {
                        $result[] = $TaxRateInfo;
                    }
                }
            }
        }
        //                                    ,       ALL_STATES.           ALL_STATES,               .
        if ($condition["entity"] == "State")
        {
            foreach ($TaxRatesList as $TaxRateInfo)
            {
                if ($TaxRateInfo["StateId"] == $condition["StateId"])
                {
                    $result[] = $TaxRateInfo;
                }
                //                  rate         StateId,               ALL_STATES
                if(empty($result))
                {
                    foreach ($TaxRatesList as $TaxRateInfo)
                    {
                        if ($TaxRateInfo["StateId"] == 0)
                        {
                            $result[] = $TaxRateInfo;
                        }
                    }
                }
            }
        }
        return $result;
    }

    /**
     *          ,                     (                  )                                      .
     *                                                ,                                            .
     *                      - ?                              $1   $10,       $1000            
     *                            .                                   .
     *            true,                                       , false -                .
     *                 true,              $factors                                    k   b,          :
     * k * $variable_name + b === $formula
     *
     *                                                                PRICE_N_A.           ,       
     *                  , ), (, +, -, *, $variable_name.
     */
    function isTaxFormulaLinear($formula, $tax_rate, $variable_name, &$factors)
    {
        //$factors = array("k" => NULL, "b" => NULL);
        $x1 = 1.0;
        $_formula = strtr($formula, array($variable_name => $x1));
        $y1 = eval("return ".$_formula.";");

        $x2 = 10.0;
        $_formula = strtr($formula, array($variable_name => $x2));
        $y2 = eval("return ".$_formula.";");

        $x3 = 1000.0;
        $_formula = strtr($formula, array($variable_name => $x3));
        $y3 = eval("return ".$_formula.";");

        $y3_linear = ($x3-$x1)*(($y2-$y1)/($x2-$x1)) + $y1;

        $one_cent = 0.01;
        $tax_rate = $tax_rate/100.0;
        if(abs($y3_linear-$y3) < $one_cent)
        {
            $factors["k"] = $tax_rate * ($y2-$y1)/($x2-$x1);
            $factors["b"] = $tax_rate * ($y1 - $x1 * (($y2-$y1)/($x2-$x1)));
            //       ,                         
            return true;
        }
        else
        {
            //                      .
            //                                                 _ _                    .
            return false;
        };
    }

    /**
     *                                              .
     *                     ,                          .
     *                                                                                  
     *        .  . .                                    :
     *     _ _         =     _   _        + k *     _   _        + b,
     *     k   b -      .
     *               
     *     _   _        = (    _ _         - b) / (1 + k)
     */
    function getPriceExcludingTaxes($price_including_taxes, $factors)
    {
        return (($price_including_taxes - $factors['b']) / (1.0 + $factors['k']));
    }

    /**
     *               $symbolic = true,                                   ,                {p_1} -
     *               .                                   _   _       ,                    
     *     _ _        .      ,      $symbolic = false,                                      -      ,
     *       ,                _   _       .
     * @param
     * @return
     */
    function calculateTax(&$Taxes, $TaxId, $TaxRatesList, $AddressesList, $ProductsList, $CartSubtotal, $OrderLevelShippingCost, $TotalShippingCost, $ShippingMethod, $debug, $trace, $symbolic)
    {
        global $application;
        $MessageResources = &$application->getInstance('MessageResources');

        $retval = "";
        if ($Taxes[$TaxId]["applicable"])
        {
            if ($Taxes[$TaxId]["status"] == "in_progress")
            {
//                $Taxes[$TaxId]["status"] = "na";
                if ($trace)
                {
                    $TaxInfo = $this->getTaxNameInfo($TaxId);
                    $TraceInfo = array(
                                       "TaxId" => $TaxId,
                                       "Message"      => $MessageResources->getMessage( new ActionMessage(array('TAX_CALCULATOR_WRN_009', $TaxInfo["Name"])))
                                      );
                    $this->addTraceInfo("6", $TraceInfo);
                }
                return "fatal";
            }
            if ($Taxes[$TaxId]["status"] == "calculated")
            {
                return;
            }
            $Taxes[$TaxId]["status"] = "in_progress";
            $_TaxRatesList = $this->excludeTaxRates($TaxRatesList, array("entity" => "Tax", "TaxNameId" => $TaxId));
            if ($trace)
            {
                $TaxInfo = $this->getTaxNameInfo($TaxId);
                $TraceInfo = array(
                                   "TaxId" => $TaxId
                                  ,"TaxName"      => $TaxInfo["Name"]
                                  ,"Address"      => $MessageResources->getMessage(sprintf("TAX_ADDRESS_NAME_%03d", $TaxInfo["AddressId"]))
                                  ,"TaxRatesList" => $_TaxRatesList
                                  );
                $this->addTraceInfo("3", $TraceInfo);
            }

            //                   ,          "                 ",                                    
            //       .                                        .                          (        
            //             Store Owner Address)                            (                   
            //  country_id, state_id),    "                ""                                       
            //                         .                                      "               
            //                    ",                                                 .                
            //                                      .         ,            Checkout CZ.
            //                                                 .                       ,          
            //            .

            //                        ,     "                "                                    
            //                                 .                     .         ,                      .

            if($Taxes[$TaxId]["needs_address"] == DB_TRUE &&
               $AddressesList[$Taxes[$TaxId]["address"]] === NULL)
            {
                //                        default address       -                .
                if($Taxes[$TaxId]["included_into_price"] === "true" &&
                   $AddressesList[0] !== NULL)
                {
                    $__TaxRatesList = $this->excludeTaxRates($_TaxRatesList,
                                                             array
                                                             (
                                                                 "entity" => "Address",
                                                                 "CountryId" => $AddressesList[0]["CountryId"],
                                                                 "StateId" => $AddressesList[0]["StateId"],
                                                             )
                                                            );
                }
                else
                {
                    //"                "           .                                                  ,
                    //              "                                                            "
                    //           .
                    //                                .
                    $__TaxRatesList = $this->excludeTaxRates($_TaxRatesList,
                                                             array
                                                             (
                                                                 "entity" => "Address",
                                                                 "CountryId" => NULL,
                                                                 "StateId" => NULL,
                                                             )
                                                            );
                }
            }
            else if($Taxes[$TaxId]["needs_address"] == DB_TRUE)
            {
                //                            .

                //                                        ,     "                  "      
                //                                    .
                //                        default address       -                .
                if($Taxes[$TaxId]["included_into_price"] === "true")
                {
                    if($AddressesList[0] !== NULL)
                    {
                        $__TaxRatesList = $this->excludeTaxRates($_TaxRatesList,
                                                                 array
                                                                 (
                                                                     "entity" => "Address",
                                                                     "CountryId" => $AddressesList[0]["CountryId"],
                                                                     "StateId" => $AddressesList[0]["StateId"],
                                                                 )
                                                                );
                    }
                    else
                    {
                        //                         .
                        //                       "                ."
                        //                             PRICE_N_A.
                        $__TaxRatesList = $this->excludeTaxRates($_TaxRatesList,
                                                                 array
                                                                 (
                                                                     "entity" => "Address",
                                                                     "CountryId" => NULL,
                                                                     "StateId" => NULL,
                                                                 )
                                                                );
                    }
                }
                else
                {
                    //      "            ".                                           .
                    $__TaxRatesList = $this->excludeTaxRates($_TaxRatesList,
                                                             array
                                                             (
                                                                 "entity" => "Address",
                                                                 "CountryId" => $AddressesList[$Taxes[$TaxId]["address"]]["CountryId"],
                                                                 "StateId" => $AddressesList[$Taxes[$TaxId]["address"]]["StateId"],
                                                             )
                                                            );
                }
            }
            else
            //$Taxes[$TaxId]["needs_address"] == DB_FALSE
            {
                $__TaxRatesList = $_TaxRatesList;
                //                                                .                                   .
            }

            if ($trace)
            {
                global $application;
                $MessageResources = &$application->getInstance('MessageResources');
                $TraceInfo = array(
                                   "TaxId" => $TaxId
                                  ,"Address"      => $MessageResources->getMessage(sprintf('TAX_ADDRESS_NAME_%03d', $Taxes[$TaxId]["address"]))
                                  ,"CountryId" => $this->TaxDebug["AddressesList"][$Taxes[$TaxId]["address"]]["CountryId"]
                                  ,"StateId" => $this->TaxDebug["AddressesList"][$Taxes[$TaxId]["address"]]["StateId"]
                                  ,"TaxRatesList" => $__TaxRatesList
                                  );
                $this->addTraceInfo("4", $TraceInfo);
            }

            foreach ($ProductsList as $ProductInfo)
            {
                $this->TaxAmounts["products"][$ProductInfo["CartID"]][$TaxId] = (int)PRICE_N_A;//0;
                /*
                if ($ProductInfo["attributes"]["TaxClass"]["value"] == TAX_CLASS_ID_NOT_TAXABLE)
                {
                    continue;
                }
                */
                $___TaxRatesList = $this->excludeTaxRates($__TaxRatesList, array("entity" => "TaxClass",
                                                               "ProductTaxClassId" => $ProductInfo["attributes"]["TaxClass"]["value"]));
                if ($trace)
                {
                    $ProdTaxClass = $this->getProductTaxClassInfo($ProductInfo["attributes"]["TaxClass"]["value"]);
                    $TraceInfo = array(
                                       "TaxId" => $TaxId
                                      ,"ProdInfo" => $ProductInfo
                                      ,"ProductTaxClass"      => $ProdTaxClass['value']
                                      ,"TaxRatesList" => $___TaxRatesList
                                      );
                    $this->addTraceInfo("5", $TraceInfo);
                }
                if (sizeof($___TaxRatesList) == 0)
                {
//                    $this->TaxAmounts["products"][$ProductInfo["ID"]][$TaxId] = 0;
//                    $Taxes[$TaxId]["status"] = "na";
                    if ($trace)
                    {
                        $TaxInfo = $this->getTaxNameInfo($TaxId);
                        $TraceInfo = array(
                                           "TaxId" => $TaxId,
                                           "Message"      => $MessageResources->getMessage( new ActionMessage(array('TAX_CALCULATOR_WRN_013', prepareHTMLDisplay($TaxInfo["Name"]), "Product ".$ProductInfo["CartID"])))
                                          );
                        $this->addTraceInfo("6", $TraceInfo);
                    }
                    continue;
                }

                //                  ALL_STATES                NEW_YORK,              .                 
                //    NEW_YORK -         .
                if($Taxes[$TaxId]["needs_address"] == DB_TRUE &&
                   isset($this->TaxDebug["AddressesList"][$Taxes[$TaxId]["address"]]) &&
                   isset($this->TaxDebug["AddressesList"][$Taxes[$TaxId]["address"]]["StateId"]) &&
                   $this->TaxDebug["AddressesList"][$Taxes[$TaxId]["address"]]["StateId"] != NULL &&
                   $this->TaxDebug["AddressesList"][$Taxes[$TaxId]["address"]]["StateId"] != 0 &&
                   is_numeric($this->TaxDebug["AddressesList"][$Taxes[$TaxId]["address"]]["StateId"])
                )
                {
                    $___TaxRatesList = $this->excludeTaxRates($___TaxRatesList, array("entity" => "State",
                                                                   "StateId" => $this->TaxDebug["AddressesList"][$Taxes[$TaxId]["address"]]["StateId"]));
                }

                if (sizeof($___TaxRatesList) > 1)
                {
//                    $this->TaxAmounts["products"][$ProductInfo["ID"]][$TaxId] = 0;
//                    $Taxes[$TaxId]["status"] = "na";
                    if ($trace)
                    {
                        $TaxInfo = $this->getTaxNameInfo($TaxId);
                        $TraceInfo = array(
                                           "TaxId" => $TaxId,
                                           "Message"      => $MessageResources->getMessage( new ActionMessage(array('TAX_CALCULATOR_WRN_010', prepareHTMLDisplay($TaxInfo["Name"]))))
                                          );
                        $this->addTraceInfo("6", $TraceInfo);
                    }
                    continue;
                }
                if ($___TaxRatesList[0]["Applicable"] == "false")
                {
                    continue;
                }
                //                                                        .
                $___TaxRatesList[0]["Formula"] = strtr($___TaxRatesList[0]["Formula"], array('{p_1}' => '<p_1>'));

                if (!$selected_sm = $this->getTaxSetting('SELECTED_SHIPPING_MODULES_LIST'))
                {
                    $selected_sm = "a:0:{}";
                }
                $selected_sm = unserialize($selected_sm);
                if (!in_array($ShippingMethod, $selected_sm))
                {
                    if ($TotalShippingCost == PRICE_N_A)
                    {
                        $___TaxRatesList[0]["Formula"] = strtr($___TaxRatesList[0]["Formula"], array('{p_2}' => PRICE_N_A));
                    }
                    elseif($TotalShippingCost == 0)
                    {
                        $___TaxRatesList[0]["Formula"] = strtr($___TaxRatesList[0]["Formula"], array('{p_2}' => 0));
                    }
                    else
                    {
                        $___TaxRatesList[0]["Formula"] = strtr($___TaxRatesList[0]["Formula"], array('{p_2}' => (($ProductInfo["attributes"]["PerItemShippingCost"]["value"])? $ProductInfo["attributes"]["PerItemShippingCost"]["value"]:0) + (($ProductInfo["attributes"]["PerItemHandlingCost"]["value"])? $ProductInfo["attributes"]["PerItemHandlingCost"]["value"]:0) + $OrderLevelShippingCost*$ProductInfo["CartItemSalePrice"]/$CartSubtotal));
                    }
                }
                else
                {
                    $this->TaxAmounts["tax_on_shipping"] = false;
                    $___TaxRatesList[0]["Formula"] = strtr($___TaxRatesList[0]["Formula"], array('{p_2}' => 0));
                }

                if (!isset($this->TaxAmounts["products"][$ProductInfo["CartID"]]["tax_rate_id"]))
                {
                    $this->TaxAmounts["products"][$ProductInfo["CartID"]]["tax_rate_id"] = array();
                }
                if ($trace)
                {
                    $AdditionalMessage = "";
                }
                while (!(strpos($___TaxRatesList[0]["Formula"], '{t_') === false))
                {
                    $pos = strpos($___TaxRatesList[0]["Formula"], '{t_');
                    $_taxId = substr($___TaxRatesList[0]["Formula"], $pos+3, strpos($___TaxRatesList[0]["Formula"], '}')-($pos+3));
                    if (!isset($this->TaxAmounts["products"][$ProductInfo["CartID"]][$_taxId]))
                    {
                        $this->TaxAmounts["products"][$ProductInfo["CartID"]][$_taxId] = 0;
                    }
                    if (!isset($this->TaxAmounts["products"][$ProductInfo["CartID"]]["tax_rate_id"][$_taxId]))
                    {
                        $this->TaxAmounts["products"][$ProductInfo["CartID"]]["tax_rate_id"][$_taxId] = 0;
                    }
                    $retval = $this->calculateTax($Taxes, $_taxId, $TaxRatesList, $AddressesList, $ProductsList, $CartSubtotal, $OrderLevelShippingCost, $TotalShippingCost, $ShippingMethod, $debug, $trace, $symbolic);
                    if ($retval == "fatal")
                    {
                        return $retval;
                    }
                    if ($this->TaxAmounts["products"][$ProductInfo["CartID"]][$_taxId] == PRICE_N_A)
                    {
                        $___TaxRatesList[0]["Formula"] = strtr($___TaxRatesList[0]["Formula"], array("{t_".$_taxId."}" => PRICE_N_A));
                    }
                    else
                    {
                        if(is_array($this->TaxAmounts["products"][$ProductInfo["CartID"]][$_taxId]))
                        {
                            $factors = $this->TaxAmounts["products"][$ProductInfo["CartID"]][$_taxId];
                            //                        .                                                 .
                            $___TaxRatesList[0]["Formula"] = strtr($___TaxRatesList[0]["Formula"], array("{t_".$_taxId."}" => $factors['k'] . " * <p_1> + " . $factors['b']));
                        }
                        else
                        {
                            $___TaxRatesList[0]["Formula"] = strtr($___TaxRatesList[0]["Formula"], array("{t_".$_taxId."}" => $this->TaxAmounts["products"][$ProductInfo["CartID"]][$_taxId]));
                        }
                    }
                    if ($trace)
                    {
                        $TaxInfo = $this->getTaxNameInfo($_taxId);
                        $AdditionalMessage.= $MessageResources->getMessage(new ActionMessage(array('TAX_CALCULATOR_WRN_012', prepareHTMLDisplay($TaxInfo["Name"]), modApiFunc("Localization", "format", $this->TaxAmounts["products"][$ProductInfo["CartID"]][$_taxId], "currency"), "Product ".$ProductInfo["CartID"])))."<br>";
                    }
                }
                if (strpos($___TaxRatesList[0]["Formula"], sprintf("%d", PRICE_N_A)) === false)
                {
                    if($symbolic === true)
                    {
                        //                                                  {p_1}.                               -
                        //                           ,                                _   _       ,        _ _        .
                        $factors = array
                        (
                            "k" => NULL,
                            "b" => NULL,
                        );
                        $b_is_linear = $this->isTaxFormulaLinear($___TaxRatesList[0]["Formula"], $___TaxRatesList[0]["Rate"], "<p_1>", $factors);
                        if($b_is_linear === false)
                        {
                            $this->TaxAmounts["products"][$ProductInfo["CartID"]][$TaxId] = TAX_NOT_LINEAR;
                            //TODO: report error.   CZ                                   .
                        }
                        else
                        {
                            $this->TaxAmounts["products"][$ProductInfo["CartID"]][$TaxId] = $factors;//SYMBOLIC_TAX_VALUE;
                        }
                    }
                    else
                    {
                        $___TaxRatesList[0]["Formula"] = strtr($___TaxRatesList[0]["Formula"], array('<p_1>' => $ProductInfo["CartItemSalePriceExcludingTaxes"]));
                        $this->TaxAmounts["products"][$ProductInfo["CartID"]][$TaxId] = $___TaxRatesList[0]["Rate"]*eval("return ".$___TaxRatesList[0]["Formula"].";")/100.00;
                    }
                }
                else
                {
                    $this->TaxAmounts["products"][$ProductInfo["CartID"]][$TaxId] = (int)PRICE_N_A;
                }
                $this->TaxAmounts["products"][$ProductInfo["CartID"]]["tax_rate_id"][$TaxId] = $___TaxRatesList[0]["Id"];
                if ($trace)
                {
                    $TaxInfo = $this->getTaxNameInfo($TaxId);
                    $TraceInfo = array(
                                       "TaxId" => $TaxId,
                                       "Message" => $AdditionalMessage.$MessageResources->getMessage(new ActionMessage(array('TAX_CALCULATOR_WRN_011', prepareHTMLDisplay($TaxInfo["Name"]), modApiFunc("Localization", "format", $this->TaxAmounts["products"][$ProductInfo["CartID"]][$TaxId], "currency"), $ProductInfo["Quantity_In_Cart"], modApiFunc("Localization", "format", ($this->TaxAmounts["products"][$ProductInfo["CartID"]][$TaxId]*$ProductInfo["Quantity_In_Cart"]), "currency"), "Product ".$ProductInfo["CartID"])))
                                      );
                    $this->addTraceInfo("6", $TraceInfo);
                }
            }
            if ($trace)
            {
                $TraceInfo = array("TaxId" => $TaxId);
                $this->addTraceInfo("7", $TraceInfo);
            }
            $Taxes[$TaxId]["status"] = "calculated";
        }
        return $retval;
    }

    /**
     *
     *
     * @param
     * @return
     */
    function getApplicableTaxRates($ProductTaxClassArray, $AddressArray)
    {
        global $application;

        $tables = $this->getTables();
        $tr = $tables['tax_rates']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($tr['id'],     'Id');
        $query->addSelectField($tr['c_id'],   'CountryId');
        $query->addSelectField($tr['s_id'],   'StateId');
        $query->addSelectField($tr['ptc_id'], 'ProductTaxClassId');
        $query->addSelectField($tr['tn_id'],  'TaxNameId');
        $query->addSelectField($tr['rate'],   'Rate');
        $query->addSelectField($tr['formula'],'Formula');
        $query->addSelectField($tr['applicable'],'Applicable');
        $query->WhereField($tr['ptc_id'], DB_IN, "(".implode(", ", $ProductTaxClassArray).")");
        $query->WhereAnd();
        $query->addWhereOpenSection();
        if(!empty($AddressArray["CountryId"]) && !empty($AddressArray["CountryId"][0]))
        {
        $query->addWhereOpenSection();
        $query->WhereField($tr['c_id'], DB_IN, "(".implode(", ", $AddressArray["CountryId"]).")");
            if(!empty($AddressArray["StateId"]) && !empty($AddressArray["StateId"][0]))
            {
        $query->WhereAnd();
        $query->WhereField($tr['s_id'], DB_IN, "(".implode(", ", $AddressArray["StateId"]).")");
            }
        $query->addWhereCloseSection();
        $query->WhereOr();
        }
        $query->addWhereOpenSection();
        //      ,                          .   -                                           (tax_names)           
        //             'needs_address',                               ,                (rates)                  
        //                         'tax_rates'              TAXES_ALL_COUNTRIES_ID        c_id.
        $query->WhereField($tr['c_id'], DB_EQ, TAXES_COUNTRY_NOT_NEEDED_ID);
        $query->addWhereCloseSection();
        $query->addWhereCloseSection();
        return $application->db->getDB_Result($query);
    }

    /**
     *
     *
     * @param
     * @return
     */
    function getTaxes()
    {
        global$application;

        $tables = $this->getTables();
        $tn = $tables['tax_names']['columns'];

        $query = &new DB_Select();
        $query->addSelectField($tn['id'],    'id');
        $query->addSelectField($tn['included_into_price'],  'included_into_price');
        $query->addSelectField($tn['name'],  'name');
        $query->addSelectField($tn['ta_id'], 'addressId');
        $query->addSelectField($tn['needs_address'], 'needs_address');
        $result = $application->db->getDB_Result($query);
        $retval = array();
        foreach ($result as $tax)
        {
            $taxInfo = array(
                            "included_into_price" => $tax["included_into_price"],
                            "needs_address" => $tax["needs_address"],
                            "name"          => $tax["name"],
                            "address"       => $tax["addressId"],
                            "applicable"    => false,
                            "status"        => "not_calculated",
                            "value"         => (int)PRICE_N_A//"0"
                            );
            $retval[$tax["id"]] = $taxInfo;
        }
        return $retval;
    }

    /**
     *
     *
     * @param
     * @return
     */
    function addTraceInfo($stage, $TraceInfo)
    {
        global $application;
        $MessageResources = &$application->getInstance('MessageResources');

        $TemplateContent = array();
        switch ($stage)
        {
            case "1":
                $TemplateContent["ProductTaxClassesList"] = "";
                foreach ($TraceInfo["ProductList"] as $ProductInfo)
                {
                    $ptcInfo = $this->getProductTaxClassInfo($ProductInfo["attributes"]["TaxClass"]["value"]);
                    $TemplateContent["ProductTaxClassesList"].= "<TR><TD>Product ".$ProductInfo["CartID"]."</TD><TD>".prepareHTMLDisplay($ptcInfo['value'])."</TD></TR>";
                }
                $TemplateContent["ProductTaxClassesList"].= "<TR><TD valign='top'><b>".$MessageResources->getMessage('TAX_CALCULATOR_TRACE_INFO_001_1')."</b></TD><TD><b>";
                $TaxClassArray = array();
                foreach ($TraceInfo["ProductTaxClassArray"] as $ProductTaxClassId)
                {
                    $ptcInfo = $this->getProductTaxClassInfo($ProductTaxClassId);
                    $TaxClassArray[] = prepareHTMLDisplay($ptcInfo['value']);
                }
                $TemplateContent["ProductTaxClassesList"].= implode("<br>", $TaxClassArray)."</b></td></tr>";
                $TemplateContent["AddressesList"] = "";
                $AddressArray = array();
                foreach ($TraceInfo["AddressesList"] as $key => $AddressInfo)
                {
                    if (!in_array(array($AddressInfo["CountryId"], 0), $AddressArray))
                    {
                        $AddressArray[] = array($AddressInfo["CountryId"], 0);
                    }
                    if (!in_array(array($AddressInfo["CountryId"], $AddressInfo["StateId"]), $AddressArray))
                    {
                        $AddressArray[] = array($AddressInfo["CountryId"], $AddressInfo["StateId"]);
                    }
                    $TemplateContent["AddressesList"].= "<tr><td>".$MessageResources->getMessage(sprintf("TAX_ADDRESS_NAME_%03d", $key))."</td><td>";
                    $CountryName = modApiFunc("Location", "getCountry", $AddressInfo["CountryId"]);
                    $TemplateContent["AddressesList"].= $CountryName.", ".modApiFunc("Location", "getState", $AddressInfo["StateId"])."</td></tr>";
                }
                $TemplateContent["AddressesList"].= "<tr><td valign='top'><b>".$MessageResources->getMessage('TAX_CALCULATOR_TRACE_INFO_002_1')."</b></td><td><b>";
                foreach ($AddressArray as $AddressInfo)
                {
                    $CountryName = modApiFunc("Location", "getCountry", $AddressInfo[0]);
                    $StateName = modApiFunc("Location", "getState", $AddressInfo[1]);
                    $TemplateContent["AddressesList"].= $CountryName.", ".(($StateName == $MessageResources->getMessage('STATE_ALL_OTHER'))? $MessageResources->getMessage('STATE_ALL_LABEL'):$StateName)."<br>";
                }
                $TemplateContent["AddressesList"].= "</b></td></tr>";
                $TemplateContent["TaxRatesListStage1"] = $this->outputTaxRatesList($TraceInfo["TaxRatesList"]);
                break;
            case '2':
                $TemplateContent["ApplicableTaxes"] = "";
                $TemplateContent["NotApplicableTaxes"] = "";
                foreach ($TraceInfo["TaxesArray"] as $TaxInfo)
                {
                    if ($TaxInfo["applicable"])
                    {
                        $TemplateContent["ApplicableTaxes"].= prepareHTMLDisplay($TaxInfo["name"])." (".$MessageResources->getMessage(sprintf('TAX_ADDRESS_NAME_%03d', $TaxInfo["address"])).")<BR>";
                    }
                    else
                    {
                        $TemplateContent["NotApplicableTaxes"].= prepareHTMLDisplay($TaxInfo["name"])." (".$MessageResources->getMessage(sprintf('TAX_ADDRESS_NAME_%03d', $TaxInfo["address"])).")<BR>";
                    }
                }
                break;
            case "3":
                if (!isset($this->TraceInfo["TaxRatesListStage3"]))
                {
                    $this->TraceInfo["TaxRatesListStage3"] = array();
                }
                if (!isset($this->TraceInfo["TaxName3"]))
                {
                    $this->TraceInfo["TaxName3"] = array();
                }
                $this->TraceInfo["TaxRatesListStage3"][$TraceInfo["TaxId"]] = $this->outputTaxRatesList($TraceInfo["TaxRatesList"]);
                $this->TraceInfo["TaxName3"][$TraceInfo["TaxId"]] = prepareHTMLDisplay($TraceInfo["TaxName"]);//." (".$TraceInfo["Address"].")";
                break;
            case "4":
                if (!isset($this->TraceInfo["TaxRatesListStage4"]))
                {
                    $this->TraceInfo["TaxRatesListStage4"] = array();
                }
                if (!isset($this->TraceInfo["Address4"]))
                {
                    $this->TraceInfo["Address4"] = array();
                }
                $CountryName = modApiFunc("Location", "getCountry", $TraceInfo["CountryId"]);
                $StateName = modApiFunc("Location", "getState", $TraceInfo["StateId"]);
                if ($StateName == $MessageResources->getMessage('STATE_ALL_OTHER'))
                {
                    $StateName = $MessageResources->getMessage('STATE_ALL_LABEL');
                    $country_state = $CountryName.", ".$StateName;
                }
                else
                {
                    $country_state = $CountryName.", ".$StateName."' or '".$CountryName.", ".$MessageResources->getMessage('STATE_ALL_LABEL');
                }
                $this->TraceInfo["TaxRatesListStage4"][$TraceInfo["TaxId"]] = $this->outputTaxRatesList($TraceInfo["TaxRatesList"]);
                $this->TraceInfo["Address4"][$TraceInfo["TaxId"]] = $TraceInfo["Address"]." - '".$country_state."'";
                break;
            case "5":
                if (!isset($this->TraceInfo["TaxRatesListStage5"]))
                {
                    $this->TraceInfo["TaxRatesListStage5"] = array();
                }
                if (!isset($this->TraceInfo["TaxRatesListStage5"][$TraceInfo["TaxId"]]))
                {
                    $this->TraceInfo["TaxRatesListStage5"][$TraceInfo["TaxId"]] = array();
                }
                $this->TraceInfo["TaxRatesListStage5"][$TraceInfo["TaxId"]][] = array("TaxRatesList" => $this->outputTaxRatesList($TraceInfo["TaxRatesList"]), "ProductTaxClass" => prepareHTMLDisplay($TraceInfo["ProductTaxClass"]), "ProdInfo" => $TraceInfo["ProdInfo"]);
                break;
            case "6":
                if (!isset($this->TraceInfo["Message"]))
                {
                    $this->TraceInfo["Message"] = array();
                }
                if (!isset($this->TraceInfo["Message"][$TraceInfo["TaxId"]]))
                {
                    $this->TraceInfo["Message"][$TraceInfo["TaxId"]] = array();
                }
                $this->TraceInfo["Message"][$TraceInfo["TaxId"]][] = $TraceInfo["Message"];
                break;
            case "7":
                if (!isset($this->TraceInfo["TaxCalculationOrder"]))
                {
                    $this->TraceInfo["TaxCalculationOrder"] = array();
                }
                if (!in_array($TraceInfo["TaxId"], $this->TraceInfo["TaxCalculationOrder"]))
                {
                    $this->TraceInfo["TaxCalculationOrder"][] = $TraceInfo["TaxId"];
                }
                break;
            default:
                break;
        }
        if (!$this->TraceInfo)
        {
            $this->TraceInfo = $TemplateContent;
        }
        else
        {
            $this->TraceInfo = array_merge($this->TraceInfo, $TemplateContent);
        }
    }

    function outputTaxRatesList($TaxRatesList)
    {
        global $application;
        $MessageResources = &$application->getInstance('MessageResources');
        $retval = "";
        $i = 0;
        foreach ($TaxRatesList as $TaxRateInfo)
        {
            $TaxRatesList[$i]['Country'] = modApiFunc("Location", "getCountry", $TaxRateInfo['CountryId']);
            $state = modApiFunc("Location", "getState", $TaxRateInfo['StateId']);
            $TaxRatesList[$i]['State'] = ($state == $MessageResources->getMessage('STATE_ALL_OTHER'))? "All":$state;
            $i++;
        }

        if (!function_exists('cmp'))
        {
            function cmp ($a, $b)
            {
                return strcmp($a["Country"]." ".$a["State"], $b["Country"]." ".$b["State"]);
            }
        }
        usort($TaxRatesList, "cmp");

        foreach ($TaxRatesList as $TaxRateInfo)
        {
            $TaxRateInfo['CountryState'] = $TaxRateInfo['Country'].", ".$TaxRateInfo['State'];
            $ProductTaxClass = $this->getProductTaxClassInfo($TaxRateInfo['ProductTaxClassId']);
            $TaxRateInfo['ProductTaxClass'] = prepareHTMLDisplay($ProductTaxClass['value']);
            $TaxRateInfo['Formula'] = $this->getTaxFormulaViewFull($TaxRateInfo['Id']);
            $retval.= "<tr><td>".$TaxRateInfo['CountryState']."</td><td>".$TaxRateInfo["ProductTaxClass"]."</td><td>".$TaxRateInfo["Formula"]."</td>";
        }
        return $retval;
    }

    function getTraceInfo()
    {
        return $this->TraceInfo;
    }

    /**
     * Returns tax formula priority.
     * See comments to the functions
     * isTaxFormula ontradictory()
     * and
     * isTaxFormulaCyclic().
     */
    function getTaxFormulaPriority($state_id, $tax_class_id)
    {
        return ((($state_id     == STATE_ID_ALL) ? 0 : 2) +
                (($tax_class_id == TAX_CLASS_ID_ANY) ? 0 : 1));
    }


    /**
     * Returns true, if tax-formulae are equivalent.
     * fals, otherwise.
     */
    function areTwoFormulaeEquivalent($tax_name_id_1
                                     ,$state_id_1
                                     ,$tax_class_id_1
                                     ,$tax_formula_priority_1

                                     ,$tax_name_id_2
                                     ,$state_id_2
                                     ,$tax_class_id_2
                                     ,$tax_formula_priority_2)
    {
        //         TAXES_STATE_NOT_NEEDED_ID                          .
        if($state_id_1 == TAXES_STATE_NOT_NEEDED_ID ||
           $state_id_2 == TAXES_STATE_NOT_NEEDED_ID)
        {
            return ( ($tax_name_id_1          == $tax_name_id_2)
                  && ($tax_class_id_1         == $tax_class_id_2)
                   );
        }
        else
        {
            return ( ($tax_name_id_1          == $tax_name_id_2)
                  && ($state_id_1             == $state_id_2)
                  && ($tax_class_id_1         == $tax_class_id_2)
                  && ($tax_formula_priority_1 == $tax_formula_priority_2)
                   );
        }
    }




// TODO!!!!                         !!!!!!

    /**
     * I.                                        tax        .                     ,
     *                                                                        .
     *                         ,                                                         .
     *
     * II.       .
     *
     * II.1                      .
     *
     *                                        TaxRates.                     :
     *
     *     1) tax_name
     *     2) apply_to
     *
     *     3) tax_class
     *     4) country
     *     5) state
     *
     *          apply_to                        tax_name,                                   
     *             ,                                 tax_name.
     *                                     ,                    tax_class, country   state
     *              .
     *
     * II.2                  .
     *                                                    .
     *
     *                                 ,              state                         
     *     ALL.                       "           "    N        ,                    
     *                                         ,                               . N -           
     *                     country.
     *                              tax_class.                              ANY.           
     *                       Q      ,     Q -                                            
     *     tax_class.
     *              ALL   ANY               ,                                                  .
     *
     *                 II.2.1:                                ,           state          ALL,  
     *         tax_class          ANY.
     *
     *                                   (           ALL     ANY)                               
     *                            (     ) -           II.2     .
     *
     *                                (                   ,                        tax_class),
     *                                     ALL  /    ANY,               priority (         )
     *                                         :
     *
     *        STATE   TAX CLASS  PRIORITY
     *     +---------+---------+
     *     |   ALL   |   ANY   |    0
     *     +---------+---------+
     *     |   ALL   |  CLASS  |    1
     *     +---------+---------+
     *     |  STATE  |   ANY   |    2
     *     +---------+---------+
     *     |  STATE  |  CLASS  |    3
     *     +---------+---------+
     *
     * III. "                  "       .
     *
     * III.1             "                "            .
     *              "                "            .
     *
     *                  III.1.1:
     *          tax-                                  ,                          VII.1.( 4).
     *
     *                          "                "            :
     *          Canada Quebec ANY PST = 0.01
     *          Canada Quebec ANY PST = 0.02
     *
     * IV. "           "       .
     *
     * IV.1             "           "       .
     *              "           "       .
     *
     *                                               
     *         tax_name,
     *         tax_class,
     *         country,
     *         state      
     *                                     -                         .                        
     *                   .
     *
     *                 VI.1.1:
     *            tax                 "         ",                        VIII.1.( 6)          .
     *
     *                         "     ":
     *         PST = ProductPrice + GST
     *         GST = PST
     *      . .    PST,    GST                                 .
     *
     *                             ,                      tax_name_1      ,
     *                        tax_name_2
     *     ( . . tax_name_2          apply_to     tax_name_1),
     *                              ,      ,                    tax_name_2
     *     ( . . tax_name_1          apply_to     tax_name_2).
     *
     * IV.2           (                     )               .
     *
     *              ,                                                            .
     *
     * IV.3           (                     )               .
     *
     *              ,                                                               .
     *
     * V.         
     *
     * V.1                       "           "       ?
     *
     *                                                     ,                  "           "       .
     *                                                :
     *         1)                 .
     *         2)                .
     *         3)                 .
     *
     * VI.        
     *                                                    ,
     *                                                    ,                     
     *    "           "       .
     *
     * VI.1        1.
     *                       .
     *
     *                 V.1:                                        tax_name_new          
     *     tax-                  "           ",                                     
     *                                              tax_name_new.
     *     (                  )
     *
     *                                   V.1                  ,                   
     *                                                                        
     *                                             ("        " ANY   ALL)  
     *                                                                         
     *     isTaxFormulaContradictoryOrCyclic ( new_formula ),     new_formula -
     *                                          .                          
     *                                                    -                         
     *     (               )                    "           "       .  . .                    .
     *
     *                   (               )               .
     *
     * VI.2        2.
     *                     .
     *                                           "           "       .
     *            VI.2.1:
     *                           
     *                    
     *                   s_1, s_2
     *                   (id)         tn_1, tn_2, tn_3
     *                    
     *             1) tn_1 =={s_1)==> tn_2
     *             2) tn_2 =={s_1}==> tn_3
     *             3) tn_2 =={s_2}==> tn_3
     *             4) tn_3 =={ALL}==> ShippingCost
     *             5) tn_2 =={ALL}==> tn_1
     *
     *                              (2)                 tn_1 ==> tn_2 ==> tn_1     s_1.
     *
     *                            ,                                  (VI.1).         -
     *                         ,                                                       
     *                  ,                         ,                                 
     *             .
     *
     * VI.3        3.
     *                      .                                                        .
     *     FIXME: TODO:        .
     *
     * VII.          isTaxFormulaContradictory ( new_formula )
     *             
     *        1)                                                                    
     *
     * VII.1 isTaxFormulaContradictory ( new_formula )
     *
     *                  :
     *        new_formula -                     .                 ,                   I.1
     *                   :
     *        true -                                        new_formula           
     *                      tax-       (                   )                            
     *            "            ".                  .
     *        false -                                        new_formula           
     *                      tax-                                "            ".  . .
     *                               .
     *
     *             (          ,                   ):
     *
     *    ( 1)            tax_rates                    ,                             
     *                . (   II.2)                            priority           
     *                             .
     *    ( 2)                ,         
     *             tax_name
     *
     *             tax_class
     *             country
     *             state
     *
     *             priority
     *
     *                                                   new_formula
     *    ( 3)             ( 2)        ,    new_formula                        
     *         -                            "             "         .
     *        (new_formula is contradictory).
     *                false.
     *                      true.
     *
     *        FIXME: TODO:                  "                     " (           
     *                                                    ).
     *                false.
     *
     * VIII.          isTaxFormulaCyclic ( new_formula )
     *             
     *        1)                                       "           " tax-      .
     *
     * VIII.1 isTaxFormulaCyclic ( new_formula )
     *    //  isTaxFormulaSetCyclic ( list of formulae, source tax name id )
     *
     *                  :
     *        new_formula -                     .                 ,                   I.1
     *        !!!WARNING!!!               ,                                              
     *                  tax-       i.e. isTaxFormulaContradictory ( new_formula ) == false
     *
     *                   :
     *        true -                                        new_formula           
     *                      tax-       (                   )                            
     *            "           ".                  .
     *        false -                                        new_formula           
     *                      tax-                                "           ".  . .
     *                               .
     *
     *             (          ,                   ):
     *
     *    ( 1)            tax_rates                    ,                             
     *                . (   II.2)                            priority           
     *                             .
     *    ( 2)                ,         
     *             tax_class
     *             country
     *             state
     *                                                   new_formula
     *    ( 3)               ( 2)                           new_formula
     *    ( 4)          ( 3)                                                   
     *
     *             tax_name
     *
     *             tax_class
     *             country
     *             state
     *
     *             priority
     *
     *         (             )!                                .
     *    ( 5)           
     *
     *             tax_class
     *             country
     *             state
     *
     *                           .
     *                      
     *
     *            tax_name
     *            apply_to
     *            priority
     *
     *         "         "    priority.                      tax_name   
     *                               ,                                     
     *           .                           .           -                 .
     *    ( 6)              
     *
     *             tax_name
     *             apply_to
     *
     *                                                 tax-      .          
     *                        tax_name.        -      tax_name_1 -> tax_name_2,
     *                             apply_to. E.g.              :
     *
     *             tax_name = tax_name_1
     *             apply_to = tax_name_2, tax_name_3, tax_name_5
     *
     *                                        
     *             tax_name_1
     *             tax_name_2
     *             tax_name_3
     *             tax_name_5
     *
     *                                
     *             tax_name_1 -> tax_name_2
     *             tax_name_1 -> tax_name_3
     *             tax_name_1 -> tax_name_5
     *
     *    ( 7)
     *                        V.1                                          
     *                 new_tax_name (         tax_name             new_formula).
     *                          ,                            (Depth First Search)
     *                    new_tax_name         ( 6).
     *
     *                                -   
     *                     false.            new_formula                         
     *             "           " tax-      .                    .
     *               -
     *                     true.         new_formula               .
     *
     *                   .
     *
     * IX.            .
     */

// TODO!!!!                         !!!!!!
    /**
     * I.  Administrator is trying to add a new tax-formula. It is necessary
     *     to check, whether at the same time formulae cyclicity occurrs during
     *     tax calculations.If such occurrs, then the formula is false and
     *     can not be added.
     *
     * II. Data.
     *
     * II.1 Database structure.
     *
     *     Use the TaxRates table to check. It consists of the fields:
     *
     *     1) tax_name
     *     2) apply_to
     *
     *     3) tax_class
     *     4) country
     *     5) state
     *
     *     The field apply_to contains a list of other tax_name, whose values
     *     are used to calculate the tax tax_name.
     *     Check only those strings, whose values tax_class, country and state
     *     match.
     *
     * II.2 Tax priority.
     *      The semantics of some special values in formulae.
     *
     *     What gets it complicated, is that the field state can take the value
     *     ALL. In this case, the string is divided into N strings. Each of them
     *     contains a specified state from the database, all other fields match.
     *     N is a number of states in the country country.
     *     The same is with tax_class. It can take the value ANY. Then the string
     *     must be divided into Q strings. Q is a number of all possible
     *     tax_class values in the system.
     *     The values ALL and ANY are used to set various priority to different
     *     taxes.
     *
     *     Definition II.2.1: A formula is prime, if state is not equal to ALL, and
     *         tax_class is not equal to ANY.
     *
     *     To get a list of prime formulae (strings) from formulae, which contain
     *     ALL or ANY, see II.2 above.
     *
     *     To each prime string containing a specified state and the defined value
     *     tax_class and taken from the ALL and/or ANY string, the priority is
     *     assigned, according to the following table:
     *
     *        STATE   TAX CLASS  PRIORITY
     *     +---------+---------+
     *     |   ALL   |   ANY   |    0
     *     +---------+---------+
     *     |   ALL   |  CLASS  |    1
     *     +---------+---------+
     *     |  STATE  |   ANY   |    2
     *     +---------+---------+
     *     |  STATE  |  CLASS  |    3
     *     +---------+---------+
     *
     * III. Formulae contradiction.
     *
     * III.1 The definition of two contradictory formulae.
     *       An example of two contradictory formulae.
     *
     *      The definition III.1.1:
     *      Two tax-formulae are called contradictory, if item VII.1.( 4)
     *      is fulfilled.
     *
     *      An informal example of two contradictory formulae:
     *          Canada Quebec ANY PST = 0.01
     *          Canada Quebec ANY PST = 0.02
     *
     * IV. A formulae cyclicity.
     *
     * IV.1 The definition of formulae cyclicity.
     *      An example of formulae cyclicity.
     *
     *     If several strings have similar fields
     *         tax_name,
     *         tax_class,
     *         country,
     *         state
     *     and they have the same priority at the same time, this is an error.
     *     Such cases shouldn't exist in the table.
     *
     *     Definition VI.1.1:
     *     The tax-formulae list is cyclic, if a graph in item VIII.1.( 6)
     *     contains a cycle.
     *
     *     An informal example of a cycle:
     *         PST = ProductPrice + GST
     *         GST = PST
     *     i.e. neither PST, nor GST can't be determined in this example.
     *
     *     Such situation occurs,when to determine tax_name_1,
     *      tax_name_2 should be determined first
     *     (i.e. tax_name_2 is included in apply_to for tax_name_1),
     *     and it itself needs tax_name_2 to be determined
     *     (i.e. tax_name_1 is included in apply_to for tax_name_2).
     *
     * IV.2 A formula table invariant (a required feature).
     *
     *      At any moment no cyclic formula exists in the table.
     *
     * IV.3 A formula table invariant (a required feature).
     *
     *     At any moment no contradictory formula exists in the table.
     *
     * V. A problem.
     *
     * V.1 When can a formulae cyclicity occur?
     *
     *     At any table change it should be checked, whether a formulae cyclicity
     *     occurrs.
     *     The table can be changed in three ways:
     *         1) To add a formula.
     *         2) To delete a formula.
     *         3) To change a formula.
     *
     * VI. The problem solution.
     *    An algorithm to check the existing of the formulae cyclicity.
     *    Such checkings should be done every time the formulae cyclicity
     *    may occur.
     *
     * VI.1 The first way.
     *     Adding a formula.
     *
     *     Statement V.1: If adding a formula for the tax_name_new tax
     *     a formulae cyclicity occurrs in the tax formula table, then it must
     *     occur during defining a formula for the tax_name_new tax.
     *     (without any proof)
     *
     *     According to statement V.1, to check the fact, that when adding a
     *     new formula no formulae cyclicity occurrs, it is necessary to divide
     *     the new formula into prime ones ("        " ANY   ALL) and check
     *     each of them by the algorithm isTaxFormulaContradictoryOrCyclic
     *     ( new_formula ), where new_formula is one of the specified prime
     *     formulae. If the algorithm reports an error to even one of
     *     prime formulae, then a new added non-prime formula creates a
     *     formulae cyclicity. So it can not be added.
     *
     *     Otherwise the non-prime formula can be added.
     *
     * VI.2 The second way.
     *     Deleting a formula.
     *     The deleting a formula can create a formulae cyclicity.
     *     Example VI.2.1:
     *         one tax class
     *         one country
     *         two states s_1, s_2
     *         three tax ids tn_1, tn_2, tn_3
     *         five formulae
     *             1) tn_1 =={s_1)==> tn_2
     *             2) tn_2 =={s_1}==> tn_3
     *             3) tn_2 =={s_2}==> tn_3
     *             4) tn_3 =={ALL}==> ShippingCost
     *             5) tn_2 =={ALL}==> tn_1
     *
     *      the deleting of rule (2) will create a cycle tn_1 ==> tn_2 ==> tn_1 for s_1.
     *
     *      Check the way it is done in item (VI.1). The difference is that a new
     *     formula is not added to the list of all the formulae, that satisfy
     *     the address and the class of the taxes, but is deleted the one, which
     *     is checked on deleting.
     *
     * VI.3 The third way.
     *     Changing a formula. It is equal to deletig an old formula and adding
     *     a new one.
     *     FIXME: TODO: to do.
     *
     * VII. The algorithm isTaxFormulaContradictory ( new_formula )
     *    Checks
     *        1) if the formula is contradictory to the one that has already
     *           existed in the database.
     *
     * VII.1 isTaxFormulaContradictory ( new_formula )
     *
     *    Input data:
     *        new_formula - a prime formula. It consists of fields, described in item I.1
     *    Output data:
     *        true if adding the prime formula new_formula to the current number of
     *           tax-formulae (the database table) will not create a contradiction.
     *           It can be added.
     *        false if adding the prime formula new_formula to the current number
     *           tax-formulae will create a contradiction. So it can't be added.
     *
     *    The algorithm (simplified, non-optimized):
     *
     *    ( 1) Select all the formulae from the table tax_rates, divide them into
     *         the prime formulae. (See item II.2) The priority for each of them
     *         will be calculated at the same time.
     *    ( 2) Select formulae, whose values
     *             tax_name
     *
     *             tax_class
     *             country
     *             state
     *
     *             priority
     *
     *         match the values in the formula new_formula.
     *    ( 3) If list ( 2) is not empty, then new_formula can't be added.
     *         It will be contradictory to the equivalent formula.
     *        (new_formula is contradictory).
     *        Return false.
     *        Return true otherwise.
     *
     *        FIXME: TODO: give the definition to the equivalent formula (list
     *        five fields to compare by).
     *        Return false.
     *
     * VIII.The algorithm isTaxFormulaCyclic ( new_formula )
     *    Checks
     *        1) if adding this formula to the base will create a tax-formulae
     *            cycle.
     *
     * VIII.1 isTaxFormulaCyclic ( new_formula )
     *    //  isTaxFormulaSetCyclic ( list of formulae, source tax name id )
     *
     *    Input data:
     *        new_formula - a prime formula. It consists of fields, described in item I.1
     *        !!!WARNING!!! It is well known, that its adding will not create
     *        contradictions in the tax-formula table i.e. isTaxFormulaContradictory
     *        ( new_formula ) == false
     *
     *    Output data:
     *        true if adding the prime formula new_formula to the current number of
     *           tax formulae (the database table) will not create a formulae
     *           cyclicity. It can be added.
     *        false if adding the prime formula new_formula to the current number
     *           tax formulae will create a formulae cyclicity. So it can't be added.
     *
     *    The algorithm (simlified, non-optimized):
     *
     *    ( 1) Select all the formulae from the table tax_rates, divide them into
     *         the prime formulae. (See item II.2) The priority for each of them
     *         will be calculated at the same time.
     *    ( 2) Select formulae, whose values
     *             tax_class
     *             country
     *             state
     *         match the values in the formula new_formula.
     *    ( 3) Add the formula new_formula to the selected in item ( 2) formulae.
     *    ( 4) In list ( 3) can't exist two formulae with the same values
     *
     *             tax_name
     *
     *             tax_class
     *             country
     *             state
     *
     *             priority
     *
     *         ( i.e equivalent ones)! It is specified in the item "input data".
     *    ( 5) Then the fields
     *
     *             tax_class
     *             country
     *             state
     *
     *         can be skipped.
     *         The remaining fields are
     *
     *            tax_name
     *            apply_to
     *            priority
     *
     *        Delete the priority. For each value tax_name of all given
     *        in the list, select only one formula that contains it with the
     *        max priority. Delete the rest of them from the list.
     *    ( 6) The remaining fields are
     *
     *             tax_name
     *             apply_to
     *
     *         Create a directed graph of tax-formulae dependences. Vertexes are
     *         the tax_name values. Arcs are the pairs tax_name_1 -> tax_name_2,
     *         created from apply_to. E.g. if values are:
     *
     *             tax_name = tax_name_1
     *             apply_to = tax_name_2, tax_name_3, tax_name_5
     *
     *         then there will be four vertexes in the graph
     *             tax_name_1
     *             tax_name_2
     *             tax_name_3
     *             tax_name_5
     *
     *         and three directed arcs
     *             tax_name_1 -> tax_name_2
     *             tax_name_1 -> tax_name_3
     *             tax_name_1 -> tax_name_5
     *
     *    ( 7)
     *         According to statement V.1, check the cycle existance in
     *         the vertex new_tax_name (value tax_name for formula new_formula).
     *         It can be done using Depth First Search
     *         from the vertex new_tax_name in item ( 6).
     *
     *         If the cycle will be found then
     *             return false. Adding new_formula will create a
     *             tax-formula cyclicity. It can't be added.
     *         Return true
     *             otherwise. The formula new_formula can be added.
     *
     *    The end of the algorithm.
     *
     * IX. The comments.
     */
    function isTaxFormulaContradictory($_tax_name_id,
                                       $_formula,

                                       $_tax_class_id,
                                       $_country_id,
                                       $_state_id,
                                       $_tax_formula_priority
                                      )
    {
        //VII.1.( 2)
        $rates = $this->getTaxRatesList($_country_id, $_state_id, $_tax_class_id, $_tax_name_id);
//SELECT tax_rates.tax_rate_id Id, tax_rates.country_id c_id, tax_rates.state_id s_id, tax_rates.tax_rate Rate, tax_rates.tax_formula Formula,
//  product_tax_classes.product_tax_class_name ProductTaxClass, product_tax_classes.product_tax_class_id tax_class_id,
//  tax_names.tax_name TaxName, tax_names.tax_name_id tax_name_id,
//FROM tax_rates
//   LEFT  JOIN product_tax_classes ON product_tax_classes.product_tax_class_id = tax_rates.product_tax_class_id
//   LEFT  JOIN tax_names ON tax_names.tax_name_id = tax_rates.tax_name_id
//  WHERE   '1'
// AND tax_rates.country_id = '13'
// AND ( tax_rates.state_id = '1' OR tax_rates.state_id = '0' )
// AND ( product_tax_classes.product_tax_class_id = '2' OR product_tax_classes.product_tax_class_id = '0' )
// AND tax_names.tax_name_id = '1'
        //VII.1.( 3)
        foreach($rates as $rate)
        {
            //VII.1.( 1)
            $tax_formula_priority = $this->getTaxFormulaPriority($rate['s_id'], $rate['tax_class_id']);
            if($this->areTwoFormulaeEquivalent($_tax_name_id
                                              ,$_state_id
                                              ,$_tax_class_id
                                              ,$_tax_formula_priority

                                              ,$_tax_name_id
                                              ,$_state_id
                                              ,$_tax_class_id
                                              ,$tax_formula_priority))
            {
                $contradictory_formula_id = $rate['Id'];
                return $contradictory_formula_id;
            }
        }
        return false;
    }


    /**
     * Returns
     *     true if the addition of the specified tax-formula will contradict to
     *         the already existed formula,
     *     false otherwise.
     *     the difference from isTaxFormulaContradictory is that the optional
     *     parameter is passed, $_tax_rate_id - editted formula id.
     *     It should be cosidered as deleted one.
     */
    function isTaxFormulaEdidingContradictory(
                                       $tax_rate_id,
                                       $_tax_name_id,
                                       $_formula,

                                       $_tax_class_id,
                                       $_country_id,
                                       $_state_id,
                                       $_tax_formula_priority
                                      )
    {
        //VII.1.( 2)
        $rates = $this->getTaxRatesList($_country_id, $_state_id, $_tax_class_id, $_tax_name_id);
        //VII.1.( 3)
        foreach($rates as $rate)
        {
            //"Delete a formula".
            if($rate['Id'] == $tax_rate_id)
            {
                continue;
            }

            //VII.1.( 1)
            $tax_formula_priority = $this->getTaxFormulaPriority($rate['s_id'], $rate['tax_class_id']);
            if($this->areTwoFormulaeEquivalent($_tax_name_id
                                              ,$_state_id
                                              ,$_tax_class_id
                                              ,$_tax_formula_priority

                                              ,$_tax_name_id
                                              ,$_state_id
                                              ,$_tax_class_id
                                              ,$tax_formula_priority))
            {
                $contradictory_formula_id = $rate['Id'];
                return $contradictory_formula_id;
            }
        }
        return false;
    }

    /**
     * Returns
     *     true, if the deleting of the specified tax-formula will create
     *         tax-formulae cyclicity,
     *     false otherwise.
     */
    function doesDeletingTaxFormulaCreateCycle($tax_rate_id)
    {
        //Example of cyclicity when changing NotApplicable rule.
        //   Example VI.2.2:
        //       one tax class
        //       one country
        //       two atates s_1, s_2
        //       two tax ids tn_1, tn_2
        //       four formulae
        //       1) tn_1 =={s_1) NotApp
        //       2) tn_1 =={s_2} NotApp
        //       3) tn_1 =={ALL} ==> tn_2
        //       4) tn_2 =={ALL} ==> tn_1
        //
        //       the deleting of the rule
        //       will create a cycle tn_1 ==> tn_2 ==> tn_1 for s_1.
        //

        $tax_rate_info = modApiFunc("Taxes", "getTaxRateInfo", $tax_rate_id);

        //VIII.1.( 2)
        $rates = $this->getTaxRatesList($tax_rate_info['CountryId']
                                       ,$tax_rate_info['StateId']
                                       ,$tax_rate_info['ProductTaxClassId']);
        //VIII.1.( 5)
        //  Save a formula with the gratest priority for each $tax_name_id,
        //  specified in this address.
        $tax_name_id__to__formula = array();

        foreach($rates as $rate)
        {
            //"Delete a formula".
            if($rate['Id'] == $tax_rate_id)
            {
                continue;
            }

            //VIII.1.( 1)
            // If a formula with such $tax_name_id has already been added to the graph,
            // and if the next occurence has a greater priority than the previous one,
            // replace the old occurence with a current one.
            $tax_formula_priority = $this->getTaxFormulaPriority($rate['s_id'], $rate['tax_class_id']);
            if(!key_exists($rate['tax_name_id'], $tax_name_id__to__formula) ||
               $tax_name_id__to__formula[$rate['tax_name_id']]['tax_formula_priority'] < $tax_formula_priority
              )
            {
                $tax_name_id__to__formula[$rate['tax_name_id']] = array('tax_formula_priority' => $tax_formula_priority
                                                                       ,'formula' => $rate['Formula']
                                                                       ,'formula_id' => $rate['Id']
                                                                       ,'applicable' => $rate['Applicable']
                                                                       );
            }
        }

        //Remove "Not Applicable" rates.
        foreach($tax_name_id__to__formula as $key => $info)
        {
            //"Not Applicable" formula
            if($info['applicable'] == "false")
            {
                unset($tax_name_id__to__formula[$key]);
                continue;
            }
        }
        return $this->isTaxFormulaSetCyclic($tax_name_id__to__formula, $tax_rate_info['TaxNameId']);
    }

    /**
     * Returns
     *     true, if the addition of the specified tax-formula will create
     *         a tax-formulae cyclicity,
     *     false otherwise.
     */
    function doesAddingTaxFormulaCreateCycle($_tax_name_id,
                                $_formula,

                                $_tax_class_id,
                                $_country_id,
                                $_state_id,
                                $_tax_formula_priority,
                                $_applicable)
    {
        //Note about NotApplicable tax-rules.
        //May be in such case the cycle will not be created.
///        $_tax_formula_priority = $this->getTaxFormulaPriority($_state_id, $_tax_class_id);
        //VIII.1.( 2)
        $rates = $this->getTaxRatesList($_country_id, $_state_id, $_tax_class_id);
        //VIII.1.( 5)
        //  Save a formula with the gratest priority for each $tax_name_id,
        //  specified in this address.
        $tax_name_id__to__formula = array();
        $tax_name_id__to__formula[$_tax_name_id] = array('tax_formula_priority' => $_tax_formula_priority
                                                        ,'formula' => $_formula
                                                        ,'formula_id' => TAX_FORMULA_ID_UNKNOWN
                                                        ,'applicable' => $_applicable ? "true" : "false"
                                                        );

        foreach($rates as $rate)
        {
            //VIII.1.( 1)
            // If a formula with such $tax_name_id has already been added to the graph,
            // and if the next occurence has a greater priority than the previous one,
            // replace the old occurence with a current one.
            $tax_formula_priority = $this->getTaxFormulaPriority($rate['s_id'], $rate['tax_class_id']);
            if(!key_exists($rate['tax_name_id'], $tax_name_id__to__formula) ||
               $tax_name_id__to__formula[$rate['tax_name_id']]['tax_formula_priority'] < $tax_formula_priority
              )
            {
                $tax_name_id__to__formula[$rate['tax_name_id']] = array('tax_formula_priority' => $tax_formula_priority
                                                                       ,'formula' => $rate['Formula']
                                                                       ,'formula_id' => $rate['Id']
                                                                       ,'applicable' => $rate['Applicable']
                                                                       );
            }
        }

        //Remove "Not Applicable" rates.
        foreach($tax_name_id__to__formula as $key => $info)
        {
            //"Not Applicable" formula
            if($info['applicable'] == "false")
            {
                unset($tax_name_id__to__formula[$key]);
                continue;
            }
        }
        return $this->isTaxFormulaSetCyclic($tax_name_id__to__formula, $_tax_name_id);
    }

    /**
     * Returns
     *     true, if the editing of the specified tax-formula will create
     *         a tax-formulae cyclicity,
     *     false otherwise.
     */
    function doesEditingTaxFormulaCreateCycle($tax_rate_id,
                                $_tax_name_id,
                                $_formula,

                                $_tax_class_id,
                                $_country_id,
                                $_state_id,
                                $_tax_formula_priority,
                                $_applicable)
    {
        //Example of cyclicity when changing NotApplicable rule.
        //   Example VI.3.2: changing from Not_Applicable to non-Not_Applicable:
        //        one tax class
        //        one country
        //        two states s_1, s_2
        //        two tax ids tn_1, tn_2
        //        two formulae
        //       1) tn_1 =={s_1) NotApp
        //       2) tn_2 =={s_1} ==> tn_1
        //
        //       the changing of the rule (1) for
        //          tn_1 =={s_1} ==> tn_2
        //       will create a cycle tn_1 ==> tn_2 ==> tn_1 for s_1.

///        $_tax_formula_priority = $this->getTaxFormulaPriority($_state_id, $_tax_class_id);
        //VIII.1.( 2)
        $rates = $this->getTaxRatesList($_country_id, $_state_id, $_tax_class_id);
        //VIII.1.( 5)
        //  Save a formula with the gratest priority for each $tax_name_id,
        //  specified in this address.
        $tax_name_id__to__formula = array();
        //"Add a formula". A new variant.
        $tax_name_id__to__formula[$_tax_name_id] = array('tax_formula_priority' => $_tax_formula_priority
                                                        ,'formula' => $_formula
                                                        ,'formula_id' => TAX_FORMULA_ID_UNKNOWN
                                                        ,'applicable' => $_applicable ? "true" : "false"
                                                        );

        foreach($rates as $rate)
        {
            //"Delete a formula". It is its old variant.
            if($rate['Id'] == $tax_rate_id)
            {
                continue;
            }

            //VIII.1.( 1)
            // If a formula with such $tax_name_id has already been added to the graph,
            // and if the next occurence has a greater priority than the previous one,
            // replace the old occurence with a current one.
            $tax_formula_priority = $this->getTaxFormulaPriority($rate['s_id'], $rate['tax_class_id']);
            if(!key_exists($rate['tax_name_id'], $tax_name_id__to__formula) ||
               $tax_name_id__to__formula[$rate['tax_name_id']]['tax_formula_priority'] < $tax_formula_priority
              )
            {
                $tax_name_id__to__formula[$rate['tax_name_id']] = array('tax_formula_priority' => $tax_formula_priority
                                                                       ,'formula' => $rate['Formula']
                                                                       ,'formula_id' => $rate['Id']
                                                                       ,'applicable' => $rate['Applicable']
                                                                       );
            }
        }

        //Remove "Not Applicable" rates.
        foreach($tax_name_id__to__formula as $key => $info)
        {
            //"Not Applicable" formula.
            if($info['applicable'] == "false")
            {
                unset($tax_name_id__to__formula[$key]);
                continue;
            }
        }

        $TaxRateInfo = $this->getTaxRateInfo($tax_rate_id);
        $deletion_error = $this->isTaxFormulaSetCyclic($tax_name_id__to__formula, $TaxRateInfo['TaxNameId']);
        if($deletion_error === false)
        {
            $adding_error = $this->isTaxFormulaSetCyclic($tax_name_id__to__formula, $_tax_name_id);
            return $adding_error;
        }
        else
        {
            return $deletion_error;
        }
    }

    function isTaxFormulaSetCyclic($tax_name_id__to__formula, $source_tax_name_id)
    {
        loadCoreFile('tax_formula_translator.php');
        //VIII.1.( 6)
        //Create a graph. Vertexes are $tax_name_id. Arcs are directed relations
        //  between vertexes, taken from tax-formulae.
        $tax_names = modApiFunc("Taxes", "getTaxNamesList");
        //Graph vertex:
        $V = array();
        //Graph arcs:
        $ADJ = array();
        $ADJinfo = array();
        foreach($tax_names as $tax_name)
        {
            $V[] = (int)$tax_name["Id"];
            $ADJ[(int)$tax_name["Id"]] = array();
            $ADJinfo[(int)$tax_name["Id"]] = array();
        }

        //Graph arcs:
        //In the graph arcs is stored additional information: which tax formula contains
        //  this arc. It is necessary to show, which formulae the cycle (not arcs)
        //  consists of.

        foreach($tax_name_id__to__formula as $vertex_id => $vertex_info)
        {
//            //Add a vertex, if it still doesn't exist. There should be no
//            //iterations.
//            if(!in_array($vertex_id, $V))
//            {
//                $V[] = $vertex_id;
//            }

            //Add all arcs.
            //Parse the formula.
            $trans = new TaxRatesTranslator($vertex_info['formula']);
            $trans->parse();
            $ADJ[$vertex_id] = $trans->getTaxList();
            $ADJinfo[$vertex_id] = array("formula_id" => $vertex_info['formula_id']);
        }
        loadCoreFile('directed_graph.php');
        $graph = new DirectedGraph($V, $ADJ);
        if($graph->hasCycleFromGivenSource($source_tax_name_id, $cycle))
        {
            //It's necessary to restore formulae, which in this case
            // (i.e. depending on state and tax_class) match
            // specified arcs in the graph.
            $cycle_with_tax_info = array();

            //Suppose cycle is correct ring
            $previous_vertex_in_cycle = $cycle[sizeof($cycle)-1]['tax_name_id'];
            $i = 0;
            for(;$i < sizeof($cycle); $i++)
            {
                $vertex = $cycle[$i];

                $vertex_with_tax_info = array("tax_name_id" => $vertex,
                                              "formula_id" => $ADJinfo[$vertex]['formula_id'],
                                              "child_tax_name_id" => $previous_vertex_in_cycle);

                $cycle_with_tax_info[] = $vertex_with_tax_info;

                $previous_vertex_in_cycle = $vertex;
                //formula_id in this case formula_id is a formula id, which
                //is used up to the next vertex in the cycle.
            }
            $cycle = $cycle_with_tax_info;
            return $cycle_with_tax_info;//true;
        }
        else
        {
            return false;
        }
    }

    function areTaxNamesValid($formula)
    {
        return true;

/*        $trans = new TaxRatesTranslator($formula);
        $trans->parse();
        $FormulaTaxNames = $trans->getTaxList();
        $DBTaxNames = modApiFunc('Taxes', 'getTaxNamesList');
        foreach($FormulaTaxNames as $FormulaTaxNameId)
        {
        //FIXME -                $DBTaxNames                    
        //                                 ,                     ,
        //                       getTaxNamesList()
            if(!in_array($DBTaxNames, $FormulaTaxNameId))
            {
                return false;
            }
        }
        return true;
*/
    }

    function areProductNamesValid($formula)
    {
        //FIXME: to check. See areTaxNamesValid($formula)
        return true;
    }

    function getConst($name)
    {
    	return constant($name);
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */
    var $TaxNamesList;
    var $CostList;

    /**
     * Error data, e.g. to be passed for mapping from Action to View.
     */
     var $ErrorData;
     //E.g. "contradictory formula" id, or "cyclic formula" cycle info.

    /**#@-*/
}
?>