<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Tools Module, Backup View
 *
 * @package Tools
 * @author Alexey Florinsky
 */
class Backup
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * AvactisHomeNews constructor
     */
    function Backup()
    {
        $this->havePermission = modApiFunc("Users", "havePermission", ADMIN_OPTION_BACKUP, modApiFunc("Users", "getCurrentUserID"));
    }

    /**
     *
     */
    function outputBackupFilesList()
    {
        if (!$this->havePermission)
        {
            $retval = modApiFunc('TmplFiller', 'fill', "tools/backup/","item_no_permission.tpl.html", array());
            for ($i=1; $i<10; $i++)
            {
                $retval.= modApiFunc('TmplFiller', 'fill', "tools/backup/","item_empty.tpl.html", array());
            }
            return $retval;
        }

        global $application;
        $retval = "";

        $directory = $application->getAppIni('PATH_SYSTEM_DIR')."backup/";
        $n = 0;
        $backup_list = array();
        if ($dir = dir($directory))
        {
            while ($file = $dir->read())
            {
                if (is_dir($directory . $file) && $file!="." && $file!="..")
                {
                    if (file_exists($directory . $file . "/dump.sql"))
//                    if ( substr($file, strrpos($file, '.')+1) == "sql")
                    {
                        $request=&new Request();
                        $request->setView('Downdoad');
                        $request->setKey('file', $directory . $file . "/dump.sql");
                        $DownloadLink = $request->getURL();

                        $request=&new Request();
                        $request->setView('AdminBackupInfo');
                        $request->setAction('SetCurrentBackupFile');
                        $request->setKey('file', $file);
                        $InfoLink = $request->getURL();

//                        $backup_name = substr($file, 0, strrpos($file, '.'));
                        $backup_info = _parse_ini_file($directory.$file."/info/backup.ini");
                        $this->_Template_Contents = array(
                                                          'BackupFileName' => $file
                                                         ,'DownloadLink' => $DownloadLink
                                                         ,'InfoLink' => $InfoLink
                                                         ,'BackupFileDate' => modApiFunc("Localization", "timestamp_date_format", $backup_info['backup_end_time'])." ". modApiFunc("Localization", "timestamp_time_format", $backup_info['backup_end_time'])
                                                         ,'BackupFileSize' => modApiFunc("Localization", "num_format", ($backup_info['sql_file_size']/1024))." Kb"
                                                         ,'BackupImageFilesSize' => modApiFunc("Localization", "num_format", ($backup_info['img_dir_size']/1024))." Kb"
                                                         ,'N' => $n
                                                         );
                        $backup_list[] = $this->_Template_Contents;
                        $n++;
                    }
                }
            }
            $dir->close();
        }
        for ($i=(sizeof($backup_list)-1); $i>=0; $i--)
        {
            $this->_Template_Contents = $backup_list[$i];
            $application->registerAttributes($this->_Template_Contents);
            $retval.= modApiFunc('TmplFiller', 'fill', "tools/backup/","item.tpl.html", array());
        }
        if ($n == 0)
        {
            $retval.= modApiFunc('TmplFiller', 'fill', "tools/backup/","item_na.tpl.html", array());
        }
        if ($n <10)
        {
            for ($i=$n+1; $i<10; $i++)
            {
                $retval.= modApiFunc('TmplFiller', 'fill', "tools/backup/","item_empty.tpl.html", array());
            }
        }

        return $retval;
    }

    function outputWarnings()
    {
        global $application;
        $MessageResources = &$application->getInstance('MessageResources');
        $Warnings = "";
        if (modApiFunc("Tools", "isBackupFolderNotWritable"))
        {
            $this->BackupFolderWarning = true;
            $this->_Template_Contents = array(
                                              'WarningMessage' => $MessageResources->getMessage(new ActionMessage(array('SETUP_WARNING_BACKUP_FOLDER_IS_NOT_WRITABLE', modApiFunc("Tools", "getBackupDir"))))
                                             );
            $application->registerAttributes($this->_Template_Contents);
            $Warnings.= modApiFunc('TmplFiller', 'fill', "tools/backup/","warnings.tpl.html", array());
        }
        if (modApiFunc("Catalog", "isImageFolderNotWritable"))
        {
            $this->ImagesFolderWarning = true;
            $this->_Template_Contents = array(
                                              'WarningMessage' => $MessageResources->getMessage(new ActionMessage(array('SETUP_WARNING_IMAGE_FOLDER_IS_NOT_WRITABLE', modApiFunc("Catalog", "getImagesDir"))))
                                             );
            $application->registerAttributes($this->_Template_Contents);
            $Warnings.= modApiFunc('TmplFiller', 'fill', "tools/backup/","warnings.tpl.html", array());
        }
        return $Warnings;
    }

    /**
     *
     */
    function output()
    {
        global $application;

        $request=&new Request();
        $request->setView('AdminBackupCreate');
        //$request->setAction('DBStat');
        $Backup_Create_Link = $request->getURL();

        $request=&new Request();
        $request->setView('AdminBackupDelete');
        $request->setAction('SetCurrentBackupFile');
        $request->setKey('file', '');
        $DeleteFormAction = $request->getURL();

        $request=&new Request();
        $request->setView('Downdoad');
        $request->setKey('directory', 'backup');
        $request->setKey('file', '');
        $DownloadFormAction = $request->getURL();

        $request=&new Request();
        $request->setView('AdminBackupRestore');
        $request->setAction('DBStat');//SetRestoreFile');
        $request->setKey('BackupFile', '');
        $RestoreFormAction = $request->getURL();

        $template_contents = array(
                                   "Items" => $this->outputBackupFilesList()
                                  ,"Warnings" => $this->outputWarnings()
                                  ,"Backup_Create_Link" => $Backup_Create_Link
                                  ,"DeleteFormAction" => $DeleteFormAction
                                  ,"DownloadFormAction" => $DownloadFormAction
                                  ,"RestoreFormAction" => $RestoreFormAction
                                  ,"BackupFolderWarning" => ($this->BackupFolderWarning? "display: none;":"")
                                  ,"ImagesFolderWarning" => ($this->ImagesFolderWarning? "display: none;":"")
                                  ,"OpenComment" => $this->havePermission? "":"<!--"
                                  ,"CloseComment" => $this->havePermission? "":"-->"
                                  );
        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return modApiFunc('TmplFiller', 'fill', "tools/backup/","container.tpl.html", array());
    }

    function getTag($tag)
    {
        global $application;
        $value = null;
        if (array_key_exists($tag, $this->_Template_Contents))
        {
            $value = $this->_Template_Contents[$tag];
        }
        return $value;
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $BackupFolderWarning = false;

    var $ImagesFolderWarning = false;

    /**#@-*/

}
?>