<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2007, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php
//define('INCORRECT_LOGIN_TIME_COUNT', 5);
//define('LOGIN_BLOCK_TIME', 10);
define('LOGIN_DELTA_TIME', 10);

define("ADMIN_OPTION_QUANTITY", 3); //Commented by Girin according to the Task ASC-82
define("ADMIN_OPTION_EDIT_ADMINS", 1);
define("ADMIN_OPTION_NOTIF", 2);
define("ADMIN_OPTION_BACKUP", 4);

//define("ADMIN_OPTION_NOTIF_LOW_LEVEL", 2);
//define("ADMIN_OPTION_NOTIF_NEW_ORDER", 4);
//define("ADMIN_OPTION_NOTIF_ORDER_STATUS_CHANGE", 8);


/**
 * Class Users is a module, which works on accounts in the admin zone and
 * in the customer zone.
 * ???
 *
 * @todo finish the functions on this page
 * @author Alexander Girin
 * @access public
 * @package Users
 */
class Users
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * A Users class constructor.
     *
     * @todo ???
     */
    function Users()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources');

        $this->IncorrectLoginTimeCountArray = array(3 => "3", 5 => "5", 10 =>"10", 20 => "20");
        $this->LoginBlockTimeArray = array(5    => $this->MessageResources->getMessage("SIGN_IN_TIMEOUT_001")
                                          ,10   => $this->MessageResources->getMessage("SIGN_IN_TIMEOUT_002")
                                          ,15   => $this->MessageResources->getMessage("SIGN_IN_TIMEOUT_003")
                                          ,30   => $this->MessageResources->getMessage("SIGN_IN_TIMEOUT_004")
                                          ,60   => $this->MessageResources->getMessage("SIGN_IN_TIMEOUT_005")
                                          ,120  => $this->MessageResources->getMessage("SIGN_IN_TIMEOUT_006")
                                          ,300  => $this->MessageResources->getMessage("SIGN_IN_TIMEOUT_007")
                                          ,600  => $this->MessageResources->getMessage("SIGN_IN_TIMEOUT_008")
                                          ,1440 => $this->MessageResources->getMessage("SIGN_IN_TIMEOUT_009")
                                          );
        $this->LoginDeltaTimeArray = array("10"   => $this->MessageResources->getMessage("SIGN_IN_DELTA_TIME_001")
                                          ,"20"   => $this->MessageResources->getMessage("SIGN_IN_DELTA_TIME_002")
                                          ,"30"   => $this->MessageResources->getMessage("SIGN_IN_DELTA_TIME_003")
                                          ,"60"   => $this->MessageResources->getMessage("SIGN_IN_DELTA_TIME_004")
                                          ,"120"  => $this->MessageResources->getMessage("SIGN_IN_DELTA_TIME_005")
                                          ,"180"  => $this->MessageResources->getMessage("SIGN_IN_DELTA_TIME_006")
                                          );
    }

    /**
     * Gets the "incorrect logins count" array.
     *
     * @return
     */
    function getIncorrectLoginTimeCountArray()
    {
        return $this->IncorrectLoginTimeCountArray;
    }

    /**
     * Gets the "time of system lockups" array.
     *
     * @return
     */
    function getLoginBlockTimeArray()
    {
        return $this->LoginBlockTimeArray;
    }

    /**
     * @todo describe the function Users->install.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Users::getTables() instead of $this->getTables()
     */

    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources');

        $tables = Users::getTables();           #the array of the Catalog module tables
        $query = &new DB_Table_Create($tables);

        # Dump data for table 'attribute_groups'
        $table = 'admin';                       #the name of the filled table
        $columns = $tables[$table]['columns'];  #the array of field names of the table

        $query = &new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue('Admin', $columns['firstname']);
        $query->addInsertValue('Name', $columns['lastname']);
        $query->addInsertValue('admin@localhost', $columns['email']);
        $query->addInsertValue('21232f297a57a5a743894a0e4a801fc3', $columns['password']);
        $query->addInsertValue('d41d8cd98f00b204e9800998ecf8427e', $columns['old_pass']);
        $query->addInsertExpression($query->fNow(), $columns['created']);
        $query->addInsertValue('0000-00-00', $columns['modified']);
        $query->addInsertValue('0000-00-00', $columns['logdate']);
        $query->addInsertValue('0', $columns['lognum']);
        $query->addInsertValue('false', $columns['remember_email']);
        $query->addInsertValue('15', $columns['options']);
        $application->db->getDB_Result($query);
    }

    /**
     * @todo describe the function Users->install.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Users::getTables() instead of $this->getTables()
     */
    function uninstall()
    {

    }

    /**
     * Returns meta description of database tables, specified for storing Users data.
     *
     * @return array tables meta info
     */
    function getTables()
    {
        $tables = array ();

        $admin = 'admin';
        $tables[$admin] = array();
        $tables[$admin]['columns'] = array
            (
                'id'                => 'admin.admin_id'
               ,'firstname'         => 'admin.admin_firstname'
               ,'lastname'          => 'admin.admin_lastname'
               ,'email'             => 'admin.admin_email_address'
               ,'password'          => 'admin.admin_password'
               ,'old_pass'          => 'admin.admin_old_password'
               ,'created'           => 'admin.admin_created'
               ,'modified'          => 'admin.admin_modified'
               ,'logdate'           => 'admin.admin_logdate'
               ,'lognum'            => 'admin.admin_lognum'
               ,'remember_email'    => 'admin.admin_remember_email'
               ,'options'           => 'admin.admin_options'
            );
        $tables[$admin]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'firstname'         => DBQUERY_FIELD_TYPE_CHAR50
               ,'lastname'          => DBQUERY_FIELD_TYPE_CHAR50
               ,'email'             => DBQUERY_FIELD_TYPE_CHAR50
               ,'password'          => DBQUERY_FIELD_TYPE_CHAR50
               ,'old_pass'          => DBQUERY_FIELD_TYPE_CHAR50
               ,'created'           => DBQUERY_FIELD_TYPE_DATE . ' default \'0000-00-00\''
               ,'modified'          => DBQUERY_FIELD_TYPE_DATE . ' default \'0000-00-00\''
               ,'logdate'           => DBQUERY_FIELD_TYPE_DATE . ' default \'0000-00-00\''
               ,'lognum'            => DBQUERY_FIELD_TYPE_INT
               ,'remember_email'    => DBQUERY_FIELD_TYPE_CHAR5
               ,'options'           => DBQUERY_FIELD_TYPE_INT
            );
        $tables[$admin]['primary'] = array
            (
                'id'
            );
        $tables[$admin]['indexes'] = array
            (
            );

        $admin_ip = 'admin_ip';
        $tables[$admin_ip] = array();
        $tables[$admin_ip]['columns'] = array
            (
                'id'                => 'admin_ip.admin_ip_id'
               ,'a_id'              => 'admin_ip.admin_id'
               ,'address'           => 'admin_ip.admin_ip_address'
               ,'count'             => 'admin_ip.admin_ip_incorrect_login_count'
               ,'time'              => 'admin_ip.admin_ip_last_login_time'
            );
        $tables[$admin_ip]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'a_id'              => DBQUERY_FIELD_TYPE_INT
               ,'address'           => DBQUERY_FIELD_TYPE_CHAR20
               ,'count'             => DBQUERY_FIELD_TYPE_INT
               ,'time'              => DBQUERY_FIELD_TYPE_INT
            );
        $tables[$admin_ip]['primary'] = array
            (
                'id'
            );
        $tables[$admin_ip]['indexes'] = array
            (
                'IDX_ai' => 'a_id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**
     * Restores the module state.
     */
    function loadState()
    {
        if(modApiFunc('Session', 'is_Set', 'currentUserID'))
        {
            $uid = modApiFunc('Session', 'get', 'currentUserID');
            $this->setCurrentUserID($uid);
        }
        else
        {
            $this->currentUserId = NULL;
        }
        if(modApiFunc('Session', 'is_Set', 'selectedUserID'))
        {
            $uid = modApiFunc('Session', 'get', 'selectedUserID');
            $this->setSelectedUserID($uid);
        }
        else
        {
            $this->selectedUserId = NULL;
        }
        if(modApiFunc('Session', 'is_Set', 'deleteAdminMembersID'))
        {
            $array_id = modApiFunc('Session', 'get', 'deleteAdminMembersID');
            $this->setDeleteAdminMembersID($array_id);
        }
        else
        {
            $this->deleteAdminMembersID = array();
        }
        if(modApiFunc('Session', 'is_Set', 'currentUserPasswordUpdate'))
        {
            $uid = modApiFunc('Session', 'get', 'currentUserPasswordUpdate');
            $this->currentUserPasswordUpdate = true;
        }
        else
        {
            $this->currentUserPasswordUpdate = NULL;
        }
        if(modApiFunc('Session', 'is_Set', 'showEditButtonInInfo'))
        {
            $this->showEditButtonInInfo = modApiFunc('Session', 'get', 'showEditButtonInInfo');
        }
        else
        {
            $this->showEditButtonInInfo = true;
        }
    }

    /**
     * Saves the module state.
     */
    function saveState()
    {
        if ($this->currentUserID != NULL)
        {
            modApiFunc('Session', 'set', 'currentUserID', $this->currentUserID);
        }
        if ($this->selectedUserID != NULL)
        {
            modApiFunc('Session', 'set', 'selectedUserID', $this->selectedUserID);
        }
        if (sizeof($this->deleteAdminMembersID) != 0)
        {
            modApiFunc('Session', 'set', 'deleteAdminMembersID', $this->deleteAdminMembersID);
        }
        modApiFunc('Session', 'set', 'currentUserPasswordUpdate', $this->currentUserPasswordUpdate);
        modApiFunc('Session', 'set', 'showEditButtonInInfo', $this->showEditButtonInInfo);
    }

    /**
     * Sets up a current user.
     */
    function setCurrentUserID($uid)
    {
        $this->currentUserID = $uid;
    }

    /**
     * Unsets the current user.
     */
    function unsetCurrentUserID()
    {
        modApiFunc('Session', 'un_Set', 'currentUserID');
        $this->currentUserID = NULL;
    }

    /**
     * Gets a current user ID.
     */
    function getCurrentUserID()
    {
        return $this->currentUserID;
    }

    /**
     * Gets the account info by email.
     *
     * @param string $email admin e-mail
     * @return array the account info
     */
    function getAcountInfoByEmail($email)
    {
        global $application;

        $tables = $this->getTables();
        $columns = $tables['admin']['columns'];
        $query = &new DB_Select();
        $query->AddSelectField($columns['id'], 'id');
        $query->AddSelectField($columns['email'], 'email');
        $query->AddSelectField($columns['password'], 'password');
        $query->AddSelectField($columns['old_pass'], 'old_password');
        $query->WhereValue($columns['email'], DB_EQ, $email);
        $acountInfo = $application->db->getDB_Result($query);
        return $acountInfo;
    }

    /**
     * Gets the account info by id.
     *
     * @param string $email admin e-mail
     * @return array the account info
     */
    function getAcountInfoById($uid)
    {
        global $application;

        $tables = $this->getTables();
        $columns = $tables['admin']['columns'];
        $query = &new DB_Select();
        $query->AddSelectField($columns['id'], 'id');
        $query->AddSelectField($columns['email'], 'email');
        $query->AddSelectField($columns['password'], 'password');
        $query->AddSelectField($columns['old_pass'], 'old_password');
        $query->WhereValue($columns['id'], DB_EQ, $uid);
        $acountInfo = $application->db->getDB_Result($query);
        return $acountInfo;
    }

    /**
     * Updates the admin account info.
     *
     * @param integer $uid -  admin id
     * @param string $email admin e-mail
     * @param string $password admin password
     * @return array the account info
     */
    function updateAcountInfo($uid, $email, $password, $need_update = false)
    {
        global $application;
        $tables = $this->getTables();
        $table = 'admin';
        $columns = $tables[$table]['columns'];

        $query = &new DB_Update($table);
        $query->addUpdateValue($columns['email'], $email);
        $query->addUpdateValue($columns['password'], $password);
        if ($need_update)
        {
            $query->addUpdateValue($columns['old_pass'], md5(""));
        }
        else
        {
            $query->addUpdateValue($columns['old_pass'], $password);
        }
        $query->addUpdateExpression($columns['modified'], $query->fNow());
        $query->WhereValue($columns['id'], DB_EQ, $uid);
        return $application->db->getDB_Result($query);
    }

    /**
     * Gets information on removed ip address from the database,                       login to AdminZone
     *
     * @param string $ip - ip address
     * @return array
     */
    function getIpInfo($ip)
    {
        global $application;
        $tables = $this->getTables();
        $table = 'admin_ip';
        $columns = $tables[$table]['columns'];

        $query = &new DB_Select();
        $query->addSelectField($columns['id'], 'id');
        $query->addSelectField($columns['a_id'], 'a_id');
        $query->addSelectField($columns['address'], 'address');
        $query->addSelectField($columns['count'], 'count');
        $query->addSelectField($columns['time'], 'time');
        $query->WhereValue($columns['address'], DB_EQ, $ip);
        return $application->db->getDB_Result($query);
    }

    /**
     * Logs the data about correct login in the admin area to the database.
     *
     * @param integer $uid - admin id
     * @return
     */
    function correctLogin($uid)
    {
        global $application;
        $tables = $this->getTables();
        $table = 'admin_ip';
        $columns = $tables[$table]['columns'];

        $ip = $_SERVER['REMOTE_ADDR'];
        $result = $this->getIpInfo($ip);
        if (sizeof($result)==0)
        {
            $query = &new DB_Insert($table);
            $query->addInsertValue($uid, $columns['a_id']);
            $query->addInsertValue($ip, $columns['address']);
            $query->addInsertValue(0, $columns['count']);
            $query->addInsertValue(time(), $columns['time']);
            $application->db->getDB_Result($query);
        }
        else
        {
            $query = &new DB_Update($table);
            $query->addUpdateValue($columns['a_id'], $uid);
            $query->addUpdateValue($columns['address'], $ip);
            $query->addUpdateValue($columns['count'], 0);
            $query->addUpdateValue($columns['time'], time());
            $query->WhereValue($columns['address'], DB_EQ, $ip);
            $application->db->getDB_Result($query);
        }

        $table = 'admin';
        $columns = $tables[$table]['columns'];

        $query = &new DB_Update($table);
        $query->addUpdateExpression($columns['logdate'], $query->fNow());
        $query->addUpdateExpression($columns['lognum'], '('.$columns['lognum'].'+1)');
        $query->WhereValue($columns['id'], DB_EQ, $uid);
        $application->db->getDB_Result($query);
    }

    /**
     * Logs the data about incorrect login in the admin area to the database.
     *
     * @param integer $uid - admin id
     * @return
     */
    function incorrectLogin()
    {
        global $application;
        $tables = $this->getTables();
        $table = 'admin_ip';
        $columns = $tables[$table]['columns'];

        $ip = $_SERVER['REMOTE_ADDR'];
        $result = $this->getIpInfo($ip);
        if (sizeof($result)==0)
        {
            $query = &new DB_Insert($table);
            $query->addInsertValue($ip, $columns['address']);
            $query->addInsertValue(1, $columns['count']);
            $query->addInsertValue(time(), $columns['time']);
            $application->db->getDB_Result($query);
        }
        else
        {
            $count = $result[0]['count']+1;
            if ((time()-$result[0]['time'])>(LOGIN_DELTA_TIME*60))
            {
                $count = 1;
            }
            if ($count>=modApiFunc("Configuration", "getValue", "store_signin_count"))
            {
                modApiFunc("Session", "set", "AdminZoneIsBlocked", true);
                $this->letterAboutBlockAdminZone();
            }
            $query = &new DB_Update($table);
            $query->addUpdateValue($columns['address'], $ip);
            $query->addUpdateValue($columns['count'], $count);
            if ($count == 1)
            {
                $query->addUpdateValue($columns['time'], time());
            }
            $query->WhereValue($columns['address'], DB_EQ, $ip);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * Generates a new user password.
     *
     * @param string $email -  user e-mail
     * @return array
     */
    function generateNewAdminPassword($email)
    {
        global $application;
        $tables = $this->getTables();
        $table = 'admin';
        $columns = $tables[$table]['columns'];

        $newPassword = '';
        for ($i=0; $i<8; $i++)
        {
            $symbol = '';
            do
            {
                $symbol = chr(rand(48, 122));
            }
            while (!ereg("[0-9a-zA-Z]", $symbol));
            $newPassword.= $symbol;
        }

        $query = &new DB_Update($table);
        $query->addUpdateValue($columns['password'], md5($newPassword));
        $query->addUpdateExpression($columns['modified'], $query->fNow());
        $query->WhereValue($columns['email'], DB_EQ, $email);
        $application->db->getDB_Result($query);

        $this->letterAboutNewPassword($email, $newPassword);
    }

    /**
     * Prepares a letter for admin about blocking the admin area.
     *
     * @todo paste e-mail addresses from config
     */
    function letterAboutBlockAdminZone()
    {
        $email_text = modApiFunc('TmplFiller', 'fill', "./../letters/","block_admin_zone.tpl.txt",
                                                      array(
                                                            "IP_ADDRESS" => $_SERVER['REMOTE_ADDR']
                                                           ,"COUNT"      => modApiFunc("Configuration", "getValue", "store_signin_count")
                                                           ,"ACCESS_TIME"=> $this->LoginDeltaTimeArray[LOGIN_DELTA_TIME]
                                                           ,"TIME"       => $this->LoginBlockTimeArray[modApiFunc("Configuration", "getValue", "store_signin_timeout")]
                                                           )
                                );
        $email_subj = modApiFunc('TmplFiller', 'fill', "./../letters/","block_admin_zone_subj.tpl.txt",
                                                      array(
                                                            "IP_ADDRESS" => $_SERVER['REMOTE_ADDR']
                                                           )
                                );
        loadCoreFile('htmlMimeMail.php');
        $mail = new htmlMimeMail();
        $mail->setText($email_text);
        $mail->setSubject($email_subj);
        $from_email = modApiFunc("Configuration", "getValue", SYSCONFIG_STORE_OWNER_EMAIL);
        if (!$this->isValidEmail($from_email))
        {
            $from_email = "avactis@localhost";
        }
        $to_email = modApiFunc("Configuration", "getValue", SYSCONFIG_STORE_OWNER_SITE_ADMINISTRATOR_EMAIL);
        if (!$this->isValidEmail($to_email))
        {
            $to_email = "avactis@localhost";
        }
        $store_name = modApiFunc("Configuration", "getValue", SYSCONFIG_STORE_OWNER_NAME);
        if ($store_name == "" || $store_name == "enter")
        {
            $store_name = "Avactis Shopping Cart Software";
        }
        $from = $store_name." <".$from_email.">";
        $mail->setFrom($from);
        $mail->setCc($from);
        return $mail->send(array($to_email));
    }

    /**
     * Prepares a letter to a user about changing his password.
     *
     * @todo paste e-mail addresses from config
     */
    function letterAboutNewPassword($email, $password)
    {
        $email_text = modApiFunc('TmplFiller', 'fill', "./../letters/","new_admin_password.tpl.txt",
                                                      array(
                                                            "Email"    => $email
                                                           ,"Password" => $password
                                                           )
                                );

        $email_subj = modApiFunc('TmplFiller', 'fill', "./../letters/","new_admin_password_subj.tpl.txt",
                                                      array()
                                );

        loadCoreFile('htmlMimeMail.php');
        $mail = new htmlMimeMail();
        $mail->setText($email_text);
        $mail->setSubject($email_subj);
        $from_email = modApiFunc("Configuration", "getValue", SYSCONFIG_STORE_OWNER_EMAIL);
        if (!$this->isValidEmail($from_email))
        {
            $from_email = "avactis@localhost";
        }
        $store_name = modApiFunc("Configuration", "getValue", SYSCONFIG_STORE_OWNER_NAME);
        if ($store_name == "" || $store_name == "enter")
        {
            $store_name = "Avactis Shopping Cart Software";
        }
        $from = $store_name." <".$from_email.">";
        $mail->setFrom($from);
        $mail->setCc($from);
        return $mail->send(array($email));
    }

    /**
     * Checks, if AdminZone is blocked or not.
     *
     * @todo paste e-mail addresses from config
     */
    function isBlocked()
    {
        $ip = $_SERVER['REMOTE_ADDR'];
        $result = $this->getIpInfo($ip);
        if (sizeof($result)!=0)
        {
            if ($result[0]['count']>=modApiFunc("Configuration", "getValue", "store_signin_count")&&(time()<($result[0]['time']+modApiFunc("Configuration", "getValue", "store_signin_timeout")*60)))
            {
                return true;
            }
        }
        return false;
    }

    /**
     * Sets up a current zone.
     */
    function setZone($zone)
    {
        $this->zone = $zone;
    }

    /**
     * Gets a current zone.
     */
    function getZone()
    {
        return $this->zone;
    }

    /**
     * Checks, whether a user has a login or not.
     */
    function isUserSignedIn()
    {
        if ($this->getCurrentUserID()!=NULL)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    /**
     * Checks, whether the email matches regular expressions.
     *
     * @param string $email - admin email
     * @return boolean true, if the email matches, false otherwise
     */
    function isValidEmail($email)
    {
        $retval = true;
        if (!eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,10})$", $email))
        {
            $retval=false;
        }
        return $retval;
    }

    /**
     * Checks, whether an e-mail address exists in the database.
     *
     * @param string $email - email address
     * @param integer $uid - user id
     * @return true, if it exists, false otherwise
     */
    function isEmailExists($email, $uid)
    {
        global $application;
        $tables = $this->getTables();
        $table = 'admin';
        $a = $tables[$table]['columns'];

        $query = &new DB_Select();
        $query->addSelectField($a['id'], 'id');
        $query->WhereValue($a['email'], DB_EQ, $email);
        $query->WhereAnd();
        $query->WhereValue($a['id'], DB_NEQ, $uid);
        $result = $application->db->getDB_Result($query);
        if (sizeof($result) == 0)
        {
            return false;
        }
        return true;
    }

    /**
     * Sets up a flag, that indicates the changing of the admin zone access
     * password.
     *
     * @return
     */
    function setPasswordUpdate()
    {
        $this->currentUserPasswordUpdate = true;
    }

    /**
     * Unsets the flag, that indicates the changing of the admin zone access
     * password.
     *
     * @return
     */
    function unsetPasswordUpdate()
    {
        $this->currentUserPasswordUpdate = NULL;
    }

    /**
     * Returns the flag value, that indicates the changing of the admin zone access
     * password.
     *
     * @return
     */
    function getPasswordUpdate()
    {
        return $this->currentUserPasswordUpdate;
    }

    /**
     *
     *
     * @todo
     * @param
     * @return
     */
    function getAdminMembersList()
    {
        global $application;
        $tables = $this->getTables();
        $a = $tables["admin"]["columns"];

        $query = new DB_Select();
        $query->addSelectField($a['id'], 'id');
        $query->addSelectField($a['firstname'], 'firstname');
        $query->addSelectField($a['lastname'], 'lastname');
        $query->addSelectField($a['email'], 'email');
        $query->addSelectField($a['lognum'], 'lognum');
        $query->addSelectField($a['logdate'], 'logdate');
        $query->addSelectField($a['created'], 'created');
        $query->addSelectField($a['modified'], 'modified');
        return $application->db->getDB_Result($query);
    }

    /**
     * Gets the selected user id.
     */
    function getSelectedUserID()
    {
        return $this->selectedUserID;
    }

    /**
     * Sets up the selected user id.
     */
    function setSelectedUserID($uid)
    {
        $this->selectedUserID = $uid;
    }

    /**
     * Unsets the selected user id.
     */
    function unsetSelectedUserID()
    {
        modApiFunc('Session', 'un_Set', 'selectedUserID');
        $this->selectedUserID = NULL;
    }

    /**
     *  Gets the selected user id.
     */
    function getShowEditButtonInInfo()
    {
        return $this->showEditButtonInInfo;
    }

    /**
     *  Sets up the selected user id.
     */
    function setShowEditButtonInInfo($val)
    {
        $this->showEditButtonInInfo = $val;
    }

    /**
     * Gets an array of selected admins id to delete.
     */
    function getDeleteAdminMembersID()
    {
        return $this->deleteAdminMembersID;
    }

    /**
     * Sets up an array of selected admins id to delete.
     */
    function setDeleteAdminMembersID($array_id)
    {
        $this->deleteAdminMembersID = array();
        foreach ($array_id as $id)
        {
            $id += 0;
            if (is_int($id)&&$id!=0)
            {
                $this->deleteAdminMembersID[] = $id;
            }
        }
    }

    /**
     * Unsets the array of selected admins id to delete.
     */
    function unsetDeleteAdminMembersID()
    {
        modApiFunc('Session', 'un_Set', 'deleteAdminMembersID');
        $this->deleteAdminMembersID = NULL;
    }


    /**
     * Gets detailed user info.
     *
     * @todo
     * @param
     * @return
     */
    function getUserInfo($uid)
    {
        global $application;
        $tables = $this->getTables();
        $a = $tables["admin"]["columns"];
        $query = new DB_Select();
        $query->addSelectField($a['id'], 'id');
        $query->addSelectField($a['firstname'], 'firstname');
        $query->addSelectField($a['lastname'], 'lastname');
        $query->addSelectField($a['email'], 'email');
        $query->addSelectField($a['lognum'], 'lognum');
        $query->addSelectField($a['logdate'], 'logdate');
        $query->addSelectField($a['created'], 'created');
        $query->addSelectField($a['modified'], 'modified');
        $query->addSelectField($a['options'], 'options');
        $query->WhereValue($a['id'], DB_EQ, $uid);
        $user_info = $application->db->getDB_Result($query);

        if (sizeof($user_info)==1)
        {
            $user_info = $user_info[0];
            $user_info["permissions"] = array();
            for ($i=1; $i<pow(2,ADMIN_OPTION_QUANTITY); $i*=2)
            {
                $option = array(
                                "id"    => $i
                               ,"value" => $user_info['options'] & $i
                               ,"name"  => $this->MessageResources->getMessage(sprintf('ADMIN_OPTION_NAME_%03d',$i))
                               ,"descr" => $this->MessageResources->getMessage(sprintf('ADMIN_OPTION_DESCR_%03d',$i))
                               );
                $user_info["permissions"][] = $option;
            }
        }
        return $user_info;
    }

    /**
     *
     *
     * @todo
     * @param
     * @return
     */
    function addAdmin($firs_name, $last_name, $e_mail, $password, $options, $need_update)
    {
        global $application;
        $tables = $this->getTables();

        $a = $tables['admin']['columns'];

        $query = &new DB_Insert('admin');
        $query->addInsertValue($firs_name, $a['firstname']);
        $query->addInsertValue($last_name, $a['lastname']);
        $query->addInsertValue($e_mail, $a['email']);
        $query->addInsertValue($password, $a['password']);
        if ($need_update)
        {
            $query->addInsertValue(md5(""), $a['old_pass']);
        }
        else
        {
            $query->addInsertValue($password, $a['old_pass']);
        }
        $query->addInsertExpression($query->fNow(), $a['created']);
//        $query->addInsertValue('0000-00-00', $a['modified']);
//        $query->addInsertValue('0000-00-00', $a['logdate']);
        $query->addInsertValue('0', $a['lognum']);
        $query->addInsertValue('false', $a['remember_email']);
        $admin_options = 0;
        for ($i=1; $i<=sizeof($options); $i++)
        {
            $admin_options += $options[$i]? pow(2, ($i-1)):0;
        }
        $query->addInsertValue($admin_options, $a['options']);
        $application->db->getDB_Result($query);
    }

    /**
     *
     *
     * @todo
     * @param
     * @return
     */
    function updateAdmin($id, $firs_name, $last_name, $e_mail, $options)
    {
        global $application;
        $tables = $this->getTables();

        $a = $tables['admin']['columns'];

        $query = &new DB_Update('admin');
        $query->addUpdateValue($a['firstname'], $firs_name);
        $query->addUpdateValue($a['lastname'], $last_name);
        $query->addUpdateValue($a['email'], $e_mail);
        $query->addUpdateExpression($a['modified'], $query->fNow());
        $admin_options = 0;
        for ($i=1; $i<=sizeof($options); $i++)
        {
            $admin_options += $options[$i]? pow(2, ($i-1)):0;
        }
        $query->addUpdateValue($a['options'], $admin_options);
        $query->WhereValue($a['id'], DB_EQ, $id);
        $application->db->getDB_Result($query);
    }

    /**
     * Deletes admins from the database.
     *
     * @param array $array_id - admin id array to delete
     * @return
     */
    function deleteAdmins($array_id)
    {
        if (!is_array($array_id))
        {
            return;
        }
        global $application;
        $tables = $this->getTables();

        $a = $tables['admin']['columns'];
        $query = &new DB_Delete('admin');
        $query->WhereField($a['id'], DB_IN, "(".implode(", ", $array_id).")");
        $application->db->getDB_Result($query);
    }

    /**
     *
     *
     * @todo
     * @param
     * @return
     */
    function getOptionsList()
    {
        $options = array();
        for ($i=1; $i<pow(2,ADMIN_OPTION_QUANTITY); $i*=2)
        {
            $option = array(
                            "id"    => $i
                           ,"name"  => $this->MessageResources->getMessage(sprintf('ADMIN_OPTION_NAME_%03d',$i))
                           ,"descr" => $this->MessageResources->getMessage(sprintf('ADMIN_OPTION_DESCR_%03d',$i))
                           );
            $options[] = $option;
        }

        return $options;
    }

    function getOptionsQuantity()
    {
        return ADMIN_OPTION_QUANTITY;
    }

    /**
     *
     */
    function havePermission($permission, $uid)
    {
        global $application;
        $tables = $this->getTables();
        $a = $tables["admin"]["columns"];
        $query = new DB_Select();
        $query->addSelectField($a['options'], 'options');
        $query->WhereValue($a['id'], DB_EQ, $uid);
        $result = $application->db->getDB_Result($query);
        $retval = false;
        if (sizeof($result) == 1)
        {
            $retval = $result[0]["options"] & $permission;
        }
        return $retval;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Current Zone - AdminZone or CustomerZone.
     */
    var $zone;

    /**
     * Current User ID
     */
    var $currentUserID = NULL;

    /**
     * Selected User ID.
     */
    var $selectedUserID;

    var $deleteAdminMembersID = array();

    /**
     * Current User Need to change the password.
     */
    var $currentUserPasswordUpdate = NULL;

    /**
     * The array of max count of logins , after which the login is temporary blocked.
     */
    var $IncorrectLoginTimeCountArray;

    /**
     * The array of delta time, during which logins are performed.
     */
    var $LoginDeltaTimeArray;

    /**
     * The array of delta time, during which the login is blocked.
     */
    var $LoginBlockTimeArray;
    /**#@-*/
}
?>